using System;

namespace OhymosNet
{

    /// <summary>
    /// <a href = "OhymosNet.OhTime.html">OhTime</a>IuWFNgɃANZXC^[tF[XłB<p/>
    /// Interface to access an <a href = "OhymosNet.OhTime.html">OhTime</a> object.
    /// <p/>
    /// </summary>
    /// <remarks>
    /// ԂύXȂ\bh܂Ƃ߂Ă܂B<p/>
    /// Interface to access an OhTime object which does not change
    /// the state of the object.
    /// </remarks>
	public interface IOhTimePointImmutable
	{
		/// <summary> 
        /// ̔N̑b擾܂B<p/>
        /// Gets the OneYearInSec field.
		/// 
		/// </summary>
		/// <returns> a <var>long</var> value<p/>
        /// ̔N̑b
		/// </returns>
		long OneYearInSec{	get;}
		
        /// <summary> 
        /// 
        /// N擾܂B<p/>
        /// Gets the year field.
		/// 
		/// </summary>
		/// <returns> an <var>int</var> value<p/>
        /// N
		/// </returns>
        int Year { get;}
		
		/// <summary> 
        /// Nn̕b擾܂B<p/>
        /// Gets the tsec field.
		/// 
		/// </summary>
		/// <returns> a <var>long</var> value<p/>
        /// Nn̕b
		/// </returns>
		long Tsec{get;}
		
		/// <summary> 
        /// b̒[擾܂B<p/>
        /// Gets the frac field.
		/// 
		/// </summary>
		/// <returns> a <var>double</var> value<p/>
        /// b̒[
		/// </returns>
        double Frac { get;}
		
		/// <summary> 
        /// ̔zi{NAAAAAb}jԂ܂B<p/>
        /// Converts the current OhTimePoint object to the Calendar array.
        /// </summary>
        /// <remarks>
        /// ̔zɂ͕b̒[͊܂܂ȂƂɒӂĂB<p/>
        /// Take care the fractional part of time which is expressed in
        /// seconds is not included.
        /// 
        /// </remarks>
		/// <returns> an <var>int[]</var> value<p/>
        /// ̔z
		/// </returns>
		int[] toCalendarArray();
		
		/// <summary> 
        /// J_[Ԃ܂B<p/>
        /// Returns the CalendaString to which this object
		/// corresponds.  
		/// 
		/// 
        /// 
		/// </summary>
        /// <remarks>
        /// ݂̃IuWFNg 
        /// 2003 N11111b0.0ȂA"20030101010101 0.0" 
        /// Ԃ܂B<p/>
        /// For example, this method returns
        /// "20030101010101 0.0" for 2003 January 1st, 01:01:01 0.0
        /// </remarks>
        /// 
		/// <returns> a <var>String</var> value<p/>
        /// \
		/// </returns>
		String toCalendarString();
		
		/// <summary> 
        /// ݂̃IuWFNgƓԂ Object ^̐VKIu
        /// WFNg쐬ĕԂ܂B
        /// <p/>
        /// Gets a deep copy of the current object
		/// 
		/// </summary>
		/// <returns> an <var>Object</var> value<p/>
        /// 
		/// </returns>
		Object Clone(); // ȂHH
		
		/// <summary> 
        /// Ɏw肵IuWFNg OhTimePointImmutable IuWF
        /// NgłāAA݂ OhTimePointImmutable IuWFN
        /// gƓԂł邩eXg܂B<p/>
        /// Tests if the class of the specified Object implements
		/// the OhTimePointImmutable interface and if the time point
		/// expressed by this object is equal to the time point 
		/// expressed by 'arg'.
		/// </summary>
		/// <param name="arg">an <var>Object</var> value<p/>
        /// rΏۂ̃IuWFNg
		/// </param>
		/// <returns> a <var>boolean</var> value<p/>
		/// </returns>
		bool Equals(Object arg);
		
		/// <summary> 
        ///  'aObj'  OhTimePointImmutable C^[tF[X
        /// NX̃IuWFNgłāAA݂ 
        /// IuWFNgƂ̎ԍ 'aEps' 菬eXg܂B
        /// <p/>
        /// 
        /// Tests if the class of the specified Object 'aObj'
		/// implements the OhTimePointImmutable interface and if the
		/// time differenc between the time point expressed by this
		/// object and the time point expressed by 'anObj' is less than
		/// 'anEps'<p/>
		/// </summary>
		/// <param name="aObj">an <var>Object</var> value<p/>
        /// rIuWFNg
		/// </param>
		/// <param name="aEps">a <var>double</var> value<p/>
        /// w肷鎞ԍ
		/// </param>
		/// <returns> a <var>boolean</var> value<p/>
		/// </returns>
		bool equals(Object aObj, double aEps);

        /// <summary> 
        /// OhTimePointImmutableNX̃IuWFNg
        /// ̃IuWFNgr܂B
        /// </summary>
        /// <param name="aT">an <var>Object</var> value<p/>
        /// rIuWFNg
        /// </param>
        /// <returns> an <var>int</var> value<p/>.
        /// </returns>
        int CompareTo(IOhTimePointImmutable aT);
    }
}