/// Class to allign texts. </(#)>
/// Modified by Naoto Ohshima. Date:2007/11/26 15:06:45
/// Last Update : 2008/02/26 12:07:25
using System;
using System.Text;

namespace OhymosNet
{
	
	/// <summary> 
    /// ̃Jij̊Jnʒu𑵂邽߂̃NXłB<p/>
    /// Class to allign texts.
	/// </summary>
	/// <remarks>
    /// <a href="OhymosNet.OhAllignText.html">OhAllignText</a>́A̂悤ɃJ̊Jnʒu𑵂
	/// o񂪂Ƃɗp܂B<p/>
	/// <br/>
	/// shiiba     michiharu    old<p/>
	/// <br/>
	/// z tabpos ɁA̍ŏ̈ʒuZbg܂B̗ł΁A
	/// <code>
	/// int[] tabpos = { 2, 9, 19 };
    /// </code>
	/// ĂāA
	/// <code>
	/// AllignText line = new AllignText(tabpos);
    /// </code>
	/// Ƃ܂B
	/// 
	/// ܂Ƃ߂āA
	/// <code>
	/// OhAllignText line = new OhAllignText(new int[] {0, 9, 19});
    /// </code>
	/// ̂悤ɏĂ\܂B̌A
	/// <code>
	/// line.clear();
	/// line.put("shiiba");
	/// line.nextColumn();
	/// line.put("michiharu");
	/// line.nextColumn();
	/// line.put("old");
	/// System.Console.WriteLine(line.toString());
	/// 
	/// line.clear();
	/// line.put("tachikawa");
	/// line.nextColumn();
	/// line.put("yasuto");
	/// line.nextColumn();
	/// line.put("middle");
    /// System.Console.WriteLine(line.toString());
    /// </code>
	/// ̂悤Ɏgp܂B
	/// </remarks>
	public class OhAllignText
	{
		private StringBuilder _line;
		private int[] _tabpos;
		private int _ntab;
		private int _column;
		private int _lasttab;
		
		private const int TABWIDTH = 8;
		
		/// <summary> Creates a new <code>OhAllignText</code> instance.
		/// 
		/// </summary>
		public OhAllignText()
		{
			_line = new System.Text.StringBuilder();
			_tabpos = null;
			_ntab = 0;
			_lasttab = 0;
			clear();
		}
		
        /// <summary>
        /// ^ũ|WVw肵āAOhAllignText̐VCX^X𐶐܂B
        /// </summary>
        /// <param name="tabpos"></param>
		public OhAllignText(int[] tabpos)
		{
			_tabpos = new int[tabpos.Length];
			Array.Copy(tabpos, 0, _tabpos, 0, tabpos.Length);
			_line = new System.Text.StringBuilder();
			_ntab = _tabpos.Length;
			_lasttab = _tabpos[_tabpos.Length - 1];
			clear();
		}
		
        /// <summary>
        /// 
        /// </summary>
		public virtual void  clear()
		{
			_column = 0;
			if (_line.Length > 0)
			{
				_line.Remove(0, _line.Length);
			}
			if (_ntab > 0)
			{
				for (int i = 0; i < _tabpos[0]; i++)
					_line.Append(" ");
			}
		}
		
        /// <summary>
        /// sԂ܂B
        /// </summary>
        /// <returns>a <var>string</var> value</returns>
		public override String ToString()
		{
			return _line.ToString();
		}
		
        /// <summary>
        /// ݂̃^uʒustr܂B
        /// </summary>
        /// <param name="str">a <var>string</var> value</param>
		public void  put(String str)
		{
			_line.Append(str);
		}
		
        /// <summary>
        /// ̃JɈړ܂B
        /// </summary>
		public void  nextColumn()
		{
			int tpos = 0;
			_column += 1;
			if (_column < _ntab)
			{
				tpos = _tabpos[_column];
			}
			else
			{
				tpos = _lasttab + (_column - _ntab) * TABWIDTH;
			}
			_line.Append(" ");
			int pos = _line.Length;
			while (pos < tpos)
			{
				_line.Append(" ");
				++pos;
			}
		}
	} // OhAllignText
}