/// OhCannotGetDataError; OHyMoS.NET error exception class. 
/// Made from "OhError.java" by Ohshima.
/// Modified and tested by Naoto Ohshima. Date:2007/10/05 13:06:25
/// Last Update:2008/02/26 11:35:50
using System;
using System.Text;
using System.IO;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary> 
	/// OHyMoS.NET ̗ONXłB
	/// <p/>
	/// OhCannotGetDataError;<p/>
	/// 
	/// OHyMoS.NET error exception class.
	/// Error is a derived class of the Exception class. <p/>
    /// </summary>
    /// <remarks>
    /// ifȂǂŁAf[^擾łȂł̗O𓊂悤ɂ܂B<p/>
    /// O𓊂ɂ̓RXgN^OhCannotGetDataErrorIuWFNg𐶐A
    /// throw܂BāA\bhA͌Ăяo\bh
    /// catch悤ɂ܂B<p/>
    /// ȉɗ܂B<p/>
	/// 
	/// The example of the creation method of an error message is as follows.
	/// <example>
	/// <code>
	/// .....
	/// if(some error status was detected) 
    /// {
	///     throw new OhCannotGetDataError("Already exits \"_dataPackArray\".", oPrintString("\t"));
	/// }
	/// .....
    /// </code></example>
    /// </remarks>
	[Serializable]
	public class OhCannotGetDataError:Exception
	{
		// @begin{field} -------------------------------------------------------
		
		/// <summary> <japanese>
		/// G[bZ[WłB
		/// </japanese>
		/// <p/>
		/// Error message.
		/// 
		/// </summary>
		protected internal String _errorMessage;

        private String _errorMessage1;
        private String _errorMessage2;
		
		// @end{field} ---------------------------------------------------------
		
		
		// @begin{constructor} -------------------------------------------------
		
		/// <summary> <japanese>
		/// G[bZ[W aErrorMessage1 RXgN^łB
		/// </japanese>
		/// 
		/// </summary>
		/// <param name="aErrorMessage1">a <code>String</code> value
		/// </param>
		public OhCannotGetDataError(String aErrorMessage1):base(aErrorMessage1)
		{
			_errorMessage1 = aErrorMessage1;
		}
		
		/// <summary> <japanese>
		/// 1sڂ aErrorMessage1A2sڂ aErrorMessage2 ̃G[bZ[WRXgN^łB
		/// </japanese>
		/// 
		/// </summary>
		/// <param name="aErrorMessage1">a <code>String</code> value
		/// </param>
		/// <param name="aErrorMessage2">a <code>String</code> value
		/// </param>
		public OhCannotGetDataError(String aErrorMessage1, String aErrorMessage2)
            :base(aErrorMessage1+Environment.NewLine+aErrorMessage2)
		{
            _errorMessage1 = aErrorMessage1;
            _errorMessage2 = aErrorMessage2;
		}
		
		// @end{constructor} ---------------------------------------------------

        // @begin{property} -----------------------------------------------------

        /// <summary> <japanese>
        /// G[bZ[W _errorMessage 擾܂B
        /// </japanese>
        /// <p/>
        /// <ul>
        /// get: a <var>String</var> value
        /// </ul>
        /// </summary>
        public override string Message
        {
            get { return base.Message; }
        }
        // @end{property} -------------------------------------------------------

		
		// @begin{methods} -----------------------------------------------------

		/// <summary> <japanese>
		/// G[bZ[W _errorMessage ̊es̐擪ɈɂƂ aPrefix tԂ܂B
		/// </japanese>
		/// <p/>
		/// Returns the message which is made by adding 'aPrefix' before each line of the message
		/// that was given when the exception object was thrown.
		/// 
		/// </summary>
		/// <param name="aPrefix">a <code>String</code> value
		/// </param>
		/// <returns> a <code>String</code> value
		/// </returns>
        public String what(String aPrefix)
        {
            try
            {
                if (_errorMessage2 == null)
                {
                    _errorMessage = aPrefix + _errorMessage1;
                }
                else
                {
                    _errorMessage = aPrefix + _errorMessage1 + Environment.NewLine + aPrefix + _errorMessage2;
                }
                throw new ArgumentException();
            }

            catch (ArgumentException e)
            {
                Console.WriteLine(e.StackTrace);
            }
            
            return _errorMessage;
        }
		
		// @end{methods} -------------------------------------------------------
	} // OhCannotGetDataError
}