/// <(#)>  OhDataPackDouble; class to express datapacks of type double. </(#)>
/// <summary>                        Make "OhDataPackDouble.java" from "ohp_tmp.h", "ohp_tmp.cpp" by Satoh.
/// </summary> Modified and tested by Naoto Ohshima. Date:2007/10/09 3:27:17
///            Last update : 2007/11/03 18:05:20
using System;
using System.IO;
using OhymosNet;

namespace OhymosNet
{

    /// <summary>
    /// f[^l double ^̃f[^pbN\NXłB
    /// 
    /// ̃NX <a href="OhymosNet.OhDataPack.html">OhDataPack</a> pĂ܂B
    /// <p/>
    /// OhDataPackDouble;<br/>
    /// 
    /// OhDataPackDouble is a class of datapacks of type double. <p/>
    /// 
    /// It extends <a href="OhymosNet.OhDataPack.html">OhDataPack</a> class. <p/>
    /// </summary>
    /// <remarks>
    /// double^̃f[^pbNƂ́Af[^L^double^̃f[^lƂ̑ĝƂ܂B<p/>
    /// OhTimePoint^̃f[^L^double^̃f[^lA܂̓f[^pbN񂩂
    /// OhDataPack^̃IuWFNg𐶐Af[^pbNƂ܂B<p/>
    /// 
    /// A datapack of type double is a pair of data of data time and
    /// data of type double.<p/>
    /// </remarks>
    public class OhDataPackDouble : OhDataPack, ICloneable
    {

        // @begin{field} -----------------------------------------------------

        /// <summary> 
        /// double ^̃f[^i[郁oϐłB
        /// 
        /// </summary>
        private double _dataValue;

        // @end{field} -------------------------------------------------------


        // @begin{constructors} ----------------------------------------------

        /// <summary> 
        /// ftHgRXgN^łB
        /// f[^l0.0ɂȂ܂B
        /// 
        /// 
        /// </summary>
        public OhDataPackDouble()
        {
            _dataValue = 0.0;
        }

        /// <summary> 
        /// f[^l aDataValueAf[^L^ aDataTime  OhDataPackDouble 쐬܂B
        /// 
        /// 
        /// </summary>
        /// <param name="aDataTime">an <var>OhTimePoint</var> value
        /// f[^L^
        /// </param>
        /// <param name="aDataValue">a <var>double</var> value
        /// f[^l
        /// </param>
        public OhDataPackDouble(IOhTimePointImmutable aDataTime, double aDataValue)
        {
            _dataTime.copy(aDataTime); 
            _dataValue = aDataValue;
        }

        /// <summary> 
        /// _dataStr Ɋi[Ăf[^pbN񂩂f[^pbN̒lǂݎA
        /// _dataTime, _dataValue Ɋi[ꂽ OhDataPackDouble 𐶐܂B
        /// 
        /// 
        /// </summary>
        /// <param name="aDataStr">a <var>String</var> value<br/>
        /// f[^pbN̕
        /// </param>
        public OhDataPackDouble(String aDataStr)
        {
            OhStringReader sr;
            double dataValue = 0.0;
            try
            {
                sr = new OhStringReader(aDataStr);

                _dataTime.Year = Int32.Parse(sr.readWord());
                _dataTime.Tsec = Int64.Parse(sr.readWord());
                _dataTime.Frac = Double.Parse(sr.readWord());
                dataValue = Double.Parse(sr.readWord());
            }
            catch (IOException e)
            {
                Console.WriteLine(e.StackTrace);
            }
            catch (FormatException e)
            {
                Console.WriteLine(e.StackTrace);
            }
            _dataValue = dataValue;
        }

        // @end{constructors} ------------------------------------------------  

        // @begin{properties} --------------------------------------------------  
        /// <summary> 
        /// _dataValue 擾܂B
        /// 
        /// <br/>
        /// Gets the data value.
        /// <ul>
        /// <li>get : a <var>double</var> value </li>
        /// </ul>
        /// </summary>
        ///
        public double DataValue
        {
            get
            {
                return _dataValue;
            }
        }

        /// <summary> 
        /// f[^ľ^ double 𕶎 "double" ƂĎ擾܂B
        /// 
        /// <p/>
        /// Returns the data type "double".
        /// <ul>
        /// <li>get : a <var>string</var> "double" </li>
        /// </ul>
        /// </summary>
        /// 
        public override String DataType
        {
            get { return "double"; }
        }

        // @end{property} ----------------------------------------------------  

        // @begin{implemention of abstract methods} ---------------------------------------------------  

        // 0. copy method.

        

        /// <summary>
        /// f[^pbNȈՃtH[}bgŃt@Cɏo܂B
        /// 
        /// ȈՃtH[}bgƂ́A_year, _tsec, _frac, _dataValue 󔒂ŋ؂Ĉsɏo܂B
        /// 
        /// <example>
        /// 2003 38600 0.3 3
        /// </example>
        /// 
        /// </summary>
        /// <param name="sw">a <var>StreamWriter</var> value
        /// oXg[
        /// </param>
        public override void dpack2Ofile(StreamWriter sw)
        {
            sw.Write(_dataTime.Year + " " + _dataTime.Tsec + " " + _dataTime.Frac + " " + DataValue);
        }

        /// <summary> 
        /// f[^pbNptH[}bgŃt@Cɏo܂B
        /// 
        /// ptH[}bgƂ́A_year, _tsec, _dataValue ̂ꂼijʂł̂
        /// ЂƂsďo܂B
        /// 
        /// <example>
        /// (2003)
        /// (38600)
        /// (0.3)
        /// (3)
        /// </example>
        /// 
        /// 
        /// </summary>
        /// <param name="sw">a <var>StreamWriter</var> value
        /// oXg[
        /// </param>
        public override void dpack2File(StreamWriter sw)
        {
            sw.Write("(" + _dataTime.Year + ")" + NEWLINE);
            sw.Write("(" + _dataTime.Tsec + ")" + NEWLINE);
            sw.Write("(" + _dataTime.Frac + ")" + NEWLINE);
            sw.Write("(" + _dataValue + ")" + NEWLINE);
        }

        // @end{implemention of abstract methods} -----------------------------------------------------

        // @begin{methods} -------------------------------------------

        /// <summary> Returns a deep copy of the current OhDataPackDouble object<p/>
        /// 
        /// 
        /// ݂ OhDataPackDouble IuWFNg̃N[ ([Rs[) 
        /// Ԃ܂B
        /// 
        /// 
        /// </summary>
        /// <returns> an <var>Object</var> value
        /// </returns>
        public override Object Clone()
        {
            OhDataPackDouble dp = new OhDataPackDouble(_dataTime, _dataValue);
            return dp;
        }


        /// <summary> Multiplies the parameter aFactor to the instance variable
        /// _dataValue.<p/>
        /// 
        /// 
        ///  aFactor ̒lCX^Xϐ _dataValue Ɋ|܂B
        /// 
        /// 
        /// </summary>
        /// <param name="aFactor">a <var>double</var> value
        /// </param>
        public virtual void multiply(double aFactor)
        {
            _dataValue *= aFactor;
        }

        /// <summary> Returns the string expression of this object
        /// 
        /// </summary>
        /// <returns> a <var>String</var> value
        /// </returns>
        public override String ToString()
        {
            return _dataTime.ToString() + " " + _dataValue;
        }
		
    } // OhDataPackDouble
}