// OhDataPackInt; class to express datapacks of type int. </(#)>
// Made from "OhDataPackInt.java" by Ohshima.
// Modified and tested by Naoto Ohshima. Date:2007/10/09 3:27:17
// Last update : 2008/02/26 12:13:32
using System;
using System.IO;
using OhymosNet;

namespace OhymosNet
{
    /// <summary>
    /// f[^l int ^̃f[^pbN\NXłB
    /// 
    /// ̃NX <a href="OhymosNet.OhDataPack.html">OhDataPack</a> pĂ܂B
    /// <p/>
    /// OhDataPackInt;<br/>
    /// 
    /// OhDataPackInt is a class of datapacks of type int. <p/>
    /// 
    /// It extends <a href="OhymosNet.OhDataPack.html">OhDataPack</a> class. <p/>
    /// </summary>
    /// <remarks>
    /// int^̃f[^pbNƂ́Af[^L^int^̃f[^lƂ̑ĝƂ܂B<p/>
    /// OhTimePoint^̃f[^L^int^̃f[^lA܂̓f[^pbN񂩂
    /// OhDataPack^̃IuWFNg𐶐Af[^pbNƂ܂B<p/>
    /// 
    /// A datapack of type int is a pair of data of data time and
    /// data of type int.<p/>
    /// </remarks>
    public class OhDataPackInt : OhDataPack, ICloneable
    {

        // @begin{field} -----------------------------------------------------

        /// <summary> <japanese>
        /// int ^̃f[^i[郁oϐłB
        /// </japanese>
        /// </summary>
        private int _dataValue;

        // @end{field} -------------------------------------------------------


        // @begin{constructors} ----------------------------------------------

        /// <summary> <japanese>
        /// ftHgRXgN^łB
        /// </japanese>
        /// 
        /// </summary>
        public OhDataPackInt()
        {
            _dataValue = 0;
        }

        /// <summary> <japanese>
        /// f[^l aDataValueAf[^L^ aDataTime  OhDataPackInt 쐬܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <param name="aDataTime">an <var>OhTimePoint</var> value
        /// </param>
        /// <param name="aDataValue">a <var>int</var> value
        /// </param>
        public OhDataPackInt(IOhTimePointImmutable aDataTime, int aDataValue)
        {
            _dataTime.copy(aDataTime);
            _dataValue = aDataValue;
        }

        /// <summary> <japanese>
        /// _dataStr Ɋi[Ăf[^pbN񂩂f[^pbN̒lǂݎA
        /// _dataTime, _dataValue Ɋi[ꂽ OhDataPackInt 𐶐܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <param name="aDataStr">a <var>String</var> value<br/>
        /// f[^pbN̕łB
        /// </param>
        public OhDataPackInt(String aDataStr)
        {
            OhStringReader sr;
            int dataValue = 0;
            try
            {
                sr = new OhStringReader(aDataStr);

                _dataTime.Year = Int32.Parse(sr.readWord());
                _dataTime.Tsec = Int64.Parse(sr.readWord());
                _dataTime.Frac = Double.Parse(sr.readWord());
                dataValue = Int32.Parse(sr.readWord());
            }
            catch (IOException e)
            {
                Console.WriteLine(e.StackTrace);
            }
            catch (FormatException e)
            {
                Console.WriteLine(e.StackTrace);
            }
            _dataValue = dataValue;
        }

        // @end{constructors} ------------------------------------------------  

        // @begin{properties} --------------------------------------------------  
        /// <summary> <japanese>
        /// _dataValue 擾܂B
        /// </japanese>
        /// <br/>
        /// Gets the data value.
        /// <ul>
        /// <li>get : a <var>int</var> value </li>
        /// </ul>
        /// </summary>
        ///
        public int DataValue
        {
            get
            {
                return _dataValue;
            }
        }

        /// <summary> <japanese>
        /// f[^ľ^ int 𕶎 "int" ƂĎ擾܂B
        /// </japanese>
        /// <p/>
        /// Returns the data type "int".
        /// <ul>
        /// <li>get : a <var>string</var> "int" </li>
        /// </ul>
        /// </summary>
        /// 
        public override String DataType
        {
            get { return "int"; }
        }

        // @end{property} ----------------------------------------------------  

        // @begin{implemention of abstract methods} ---------------------------------------------------  

        // 0. copy method.

        /// <summary> <japanese>
        /// f[^pbNȈՃtH[}bgŃt@Cɏo܂B
        /// 
        /// ȈՃtH[}bgƂ́A_year, _tsec, _dataValue 󔒂ŋ؂Ĉsɏo܂B
        /// 
        /// <pre>
        /// [EXAMPLE]  2003 38600 3
        /// </pre>
        /// </japanese>
        /// 
        /// </summary>
        /// <param name="sw">a <var>StreamWriter</var> value
        /// </param>
        public override void dpack2Ofile(StreamWriter sw)
        {
            sw.Write(_dataTime.Year + " " + _dataTime.Tsec + " " + _dataTime.Frac + " " + DataValue);
        }

        /// <summary> <japanese>
        /// f[^pbNptH[}bgŃt@Cɏo܂B
        /// 
        /// ptH[}bgƂ́A_year, _tsec, _dataValue ̂ꂼijʂł̂
        /// ЂƂsďo܂B
        /// 
        /// <pre>
        /// [EXAMPLE]  (2003)
        /// (38600)
        /// (3)
        /// </pre>
        /// </japanese>
        /// 
        /// </summary>
        /// <param name="sw">a <var>StreamWriter</var> value
        /// </param>
        public override void dpack2File(StreamWriter sw)
        {
            sw.Write("(" + _dataTime.Year + ")" + NEWLINE);
            sw.Write("(" + _dataTime.Tsec + ")" + NEWLINE);
            sw.Write("(" + _dataTime.Frac + ")" + NEWLINE);
            sw.Write("(" + _dataValue + ")" + NEWLINE);
        }

        // @end{implemention of abstract methods} -----------------------------------------------------

        // @begin{methods} -------------------------------------------

        /// <summary> Returns a deep copy of the current OhDataPackInt object<p/>
        /// 
        /// <japanese>
        /// ݂ OhDataPackInt IuWFNg̃N[ ([Rs[) 
        /// Ԃ܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <returns> an <var>Object</var> value
        /// </returns>
        public override Object Clone()
        {
            OhDataPackInt dp = new OhDataPackInt(_dataTime, _dataValue);
            return dp;
        }


        /// <summary> Multiplies the parameter aFactor to the instance variable
        /// _dataValue.<p/>
        /// 
        /// <japanese>
        ///  aFactor ̒lCX^Xϐ _dataValue Ɋ|܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <param name="aFactor">a <var>double</var> value
        /// </param>
        public virtual void multiply(double aFactor)
        {
            _dataValue *= (int)aFactor;
        }

        /// <summary> Returns the string expression of this object
        /// 
        /// </summary>
        /// <returns> a <var>String</var> value
        /// </returns>
        public override String ToString()
        {
            return _dataTime.ToString() + " " + _dataValue;
        }

    } // OhDataPackInt
}