/// <(#)>  OhInputPort; abstract class to express input ports. </(#)>
/// <summary>  Modified by Naoto Ohshima. Date:2007/11/07 16:42:18
///             Last update : 2008/02/26 20:35:36
/// </summary>
using System;
using System.IO;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary> 
    /// {^͒[qf\NXłBۃNXłB
    /// ̃NX<a href = "OhymosNet.OhSendPort.html">OhSendPort</a>pĂ܂B
    /// 
	/// <p/>
    /// The OhInputPort class is an abstract class for creating input
    /// ports for a total system.
    /// It extends <a href = "OhymosNet.OhSendPort.html">OhSendPort</a> class.<p/>
    /// </summary>
    /// <remarks>
    /// Šn̓͒[q쐬邽߂̊NXłB <p/>
    /// ۃNXłB <p/>
	/// {^͒[q́AŠn̓͒[q쐬邽߂̒ۃNX
	/// łB[ÚÃNXpđŠn̓͒[q̃f
	/// 쐬ĂB{^͒[q̃NX錾ł́A[U
	/// ׂ͒[q̊{dl߂Ă܂B܂A̎
	/// ͎Oɗpӂł@\`Ă܂B<p/>
	/// 
	/// Šnf́Å{^͒[q̃NXpă[U
	/// 쐬͒[qʂăf[^肷̂ƂĐ݌v
	/// ܂B<p/>
	/// 
	/// Šn̓ɑ΂ē͒[q̓f[^󂯂Ƃ
	/// ƂӖł́A͒[q́A{^vff̎M[qɎ
	/// ܂ASʂ̂̂ƍl悢łB<p/>
	/// 
	/// Šnf́At@CóAf[^x[XóAL[
	/// {[h́ACRT o͂ȂǁAXGȃf[^̓o͂ɑΉ
	/// ΂Ȃ܂BŠnf́AGȃf[^n
    /// Ɏ荞ގ́AS <a href = "OhymosNet.OhDataPack.html">OhDataPack</a>^̃f[^ɕϊ
	/// Ȃ΂Ȃ܂B܂AV~[VʂV~[
    /// Vs҂ɒ񋟂鎞́A<a href = "OhymosNet.OhDataPack.html">OhDataPack</a>^Œ~ς
	/// f[^V~[Vs҂̖]ރf[^`ɕϊ
	/// ΂Ȃ܂B̂悤ȃf[^̕ϊɊւ̓ÍA
	/// [U쐬͒[qEo͒[qōsȂƂɂAŠn
	/// f̕ł́A͒[qEo͒[q̎葱ő삷邱
	/// ɂ܂BȂ킿A͒[qEo͒[q́A̒^Iȏ
	/// ƊȌƂ̒邱ƂɂȂ܂B<p/>
    /// <br/>
    /// 
    /// This is the base class from which the user creates his own
    /// input port models. <p/>
    /// 
    /// </remarks>
    public abstract class OhInputPort:OhSendPort
	{
		// @begin {abstract methods} ---------------------------------
		
		// 1. Connection function.
		
		/// <summary> 
        /// ̓f[^pbÑf[^ľ^𕶎ƂĕԂ܂B<p/>
        /// 
        /// ۃ\bhłB<p/>
        /// </summary>
        /// <remarks>
        /// Returns the string which shows data type treated by the
		/// current input-port. Because this is pure virtual, the
		/// function must be defined in derived classes from this
		/// class.
		/// 
		/// <example>
		/// public String DataType { get{ return "double"; }
        /// </example>
		/// 
		/// We call the string returned by this funcion "dataType".
		/// 
		/// 
		/// <p/>
        /// </remarks>
		public abstract override String DataType { get;}
		
		// 2. Input data sending function.
		
		/// <summary> 
        /// ̓f[^͒[qɋL܂B<p/>
        /// 
        /// ۃ\bhłB<p/><br/>
        /// 
        /// Sending input data. 
        /// </summary>
        /// <remarks>
        /// e͒[qŁA̓f[^f[^pbN쐬A
        /// f[^pbN𑗐M郁\bh`ĉB<p/>
        /// 
        /// With each input terminal, Please create a data pack from
		/// input data, and define the function which sends a data
		/// pack.
        /// </remarks>
		public abstract void  inputData();
		
		// @end {abstract methods} -----------------------------------
		
		
		// @begin{initialization} ------------------------------------
		
		/// <summary> 
        /// qłB<p/>
        /// Initialization.
		/// 
		/// </summary>
		/// <param name="aPortName">a <var>String</var> value<p/>
        /// IuWFNg
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
        /// IuWFNgԍ
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void init(String aPortName, int aPortNum)
		{
			base.init(aPortName, aPortNum);
		}

		
		// @end{initialization} --------------------------------------
		
		
		// @begin {constructors} -------------------------------------
		
		/// <summary> 
        /// ftHgRXgN^łB
        /// Creates a new default <var>OhInputPort</var> instance.
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public OhInputPort():base()
		{
			_className = "OhInputPort";
		}
				
		/// <summary>
        /// IuWFNgAIuWFNgԍw肵 <var>OhInputPort</var> 
        /// ̃CX^X𐶐܂B<p/>
        /// Creates a new <var>OhInputPort</var> instance.
		/// 
		/// </summary>
		/// <param name="aPortName">a <var>String</var> value<p/>
        /// IuWFNg
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
        /// IuWFNgԍ
		/// </param>
		public OhInputPort(String aPortName, int aPortNum):base()
		{
			_className = "OhInputPort";
			_objectName = aPortName;
			_objectNumber = aPortNum;
		}
		
		// @end {constructors} ---------------------------------------
		
		
		// @begin {methods} ------------------------------------------
		
		// input data sending function
		
		/// <summary> 
        /// <p/>
        /// Calculation request message.  
        /// </summary>
        /// 
		/// <remarks>
		/// t@C͌vZ@\Ȃ̂ŁAvZvĂǂ傤
		/// ܂B
        /// KO <a href="OhCannotGetDataError.html">OhCannotGetDataError</a> 
        /// 𓊂܂B
        /// 
        /// Since there is no calculation
        /// function in the OhInputPort class, even if a calculation
        /// request is received, it cannot be carried out.  So the
        /// OhInputPort object throws the OhCannotGetDataError object
        /// when it receives the calReq() message.
        /// </remarks>
        /// <exception cref="OhCannotGetDataError">if an error occurs
		/// </exception>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  calReq()
		{
			throw new OhCannotGetDataError("");
		}
		
		// @end {methods} --------------------------------------------
	} // OhInputPort
}