/// <(#)>  OhObject; class to express a object </(#)>
/// <summary> Modified and Tested by Naoto Ohshima. Date:2007/10/11 0:55:28
///           Last update : 2008/02/26 20:56:28
/// </summary>
using System;
using System.IO;
using System.Text;
using OhymosNet;

namespace OhymosNet
{
    /// <summary>
    /// {^f\NXłB <p/>
    /// OHyMoS.NET ̗vfAŠnA[qɊւNX
    /// SĊ{^f̃NX OhObject pč쐬܂B<p/>
    /// 
    /// Base class of almost OHyMoS.NET classes. <p/>
    /// </summary>
    /// <remarks>
    /// NX OhObject ł́A
    /// 
    /// <ul>
    /// <li>IuWFNg̖O    : _className, _objectName, _objectNumber</li>
    /// <li>IuWFNg̏L  : _owner</li>
    /// </ul>
    /// 
    /// LA
    /// 
    /// <ul>
    /// <li>IuWFNg̔r@\</li>
    /// <li>L҂̐ݒ@\</li>
    /// <li>IuWFNg̏o͋@\</li>
    /// </ul>
    /// 
    /// `܂B<p/>
    /// 
    /// OHyMoS.NET ̃NX͑SĊ{^f̃NX OhObject pč쐬܂B<p/>
    /// 
    /// OHyMoS.NET ̃[ÚAʂ̓NX OhObject pč쐬ꂽ
    /// <a href="OhymosNet.OhElement.html">OhElement</a>  <a href="OhymosNet.OhSendPort.html">OhSendPort</a> ȂǁA
    /// NX OhObject ̉ʂ̃NXpă[UKvƂNX쐬Ώ\łāA
    /// NX OhObject 𒼐ڌpăNX쐬邱Ƃ͂Ȃł傤B<p/>
    /// 
    /// NX OhObject ́Aoϐ
    /// 
    /// <ul>
    /// <li>String _className;   //; NX</li>
    /// <li>String _objectName;  //; IuWFNg</li>
    /// <li>int _objectNumber;   //; IuWFNgԍ</li>
    /// <li>Object _owner;       //; Object ^ɃLXgꂽL</li>
    /// </ul>
    /// 
    /// Ă܂B
    /// OHyMoS.NET ̃NX͑SĊ{^ OhObject pč쐬̂ŁA
    /// OHyMoS.NET ̑SẴCX^X̃oϐĂ邱ƂɂȂ܂B<p/>
    /// 
    /// _className ́AehNXƂɋʂ̕ɐݒ肵ĉB
    /// Ⴆ΁AhNX ABC ł̓RXgN^
    /// 
    /// <pre>
    /// _className = "ABC";
    /// </pre>
    /// 
    /// Ɛݒ肵܂B<p/>
    /// 
    /// _objectName, _objectNumber ɂ́ÃIuWFNgg̖OƔԍ
    /// <a href="OhymosNet.OhObjectConstructor2.html">OhObject(String, int)</a>
    /// ܂
    /// <a href="OhymosNet.OhObject.init.html">init(String, int)</a>
    /// Őݒ肵܂B
    /// dݒ͂ł܂B<p/>
    /// 
    /// vO}I _objectName, _objectNumber ݒ肵ĂȂƂ́A
    /// _objectName  nullA_objectNumber  -1 ɐݒ肳Ă܂B<p/>
    /// 
    /// yȒPȗz
    /// 
    /// <code>
    /// public class Yahoo : OhObject
    /// {
    /// 
    ///     public Yahoo():base() 
    ///     {
    ///         _className = "Yahoo";
    ///     }
    /// 
    ///     public Yahoo(String aObjName, int aObjNum):base() 
    ///     {
    ///         _className = "Yahoo";
    ///         init(aObjName, aObjNum);
    ///     }
    /// .
    /// .
    /// .
    /// }
    /// </code>
    /// 
    /// _owner ɂ́AL҂ <a href="OhymosNet.OhObject.Owner.html">Owner{get; set;}</a> 
    /// ݒ肵܂B
    /// IuWFNg`IuWFNgãoϐłꍇAua`̏LҁvƌĂт܂B
    /// Ⴆ΁A
    /// 
    /// <ul>
    /// <li>M[q`vffãoϐłꍇB</li>
    /// <li>vff`nfãoϐłꍇB</li>
    /// </ul>
    /// 
    /// ̃oϐpāA
    /// 
    /// <ul>
    /// <li> IuWFNg̔r@\</li>
    /// <li> L҂̐ݒ@\</li>
    /// <li> IuWFNg̏o͋@\</li>
    /// </ul>
    /// 
    /// Ȃǂ`Ă܂B
    /// 
    /// <br/>
    /// 
    /// Base class of all OHyMoS.NET classes. <p/>
    /// 
    /// An element of type Object has four basic fields: _owner, _className, _objectName, _objectNumber.
    /// 
    /// <dl>
    /// <dt> Definition of "_owner".</dt>
    /// <dd> When an object A has an object B as its field, A is called the owner of B.</dd>
    /// 
    /// The field "owner", a type Object,
    /// is the pointer to the owner of the current object.
    /// <br/>
    /// 
    /// <dt> Definition of "_className"</dt>
    /// <dd> _className stores the name of the class.</dd> <br/>
    /// For example, "_className" of an object of the class Object is "Object".
    /// 
    /// <dt> Definition of "_objectName"</dt>
    /// <dd> _objectName stores the name of the objcet.</dd> <br/>
    /// User descides the name of each object.
    /// 
    /// <dt> Definition of "_objectNumber"</dt>
    /// <dd> _objectNumber stores the identification number.</dd>
    /// </dl>
    /// 
    /// _objectName and _objectNumber are used to identify OHyMoS.NET elements owned by an OHyMoS.NET element.
    /// Suppose an OHyMoS.NET element A owns OHyMoS.NET elements e1, e2, ..., eN,
    /// elements e1, e2, ..., eN should be able to be identified by the pair, _objectName and _objectNumber.
    /// 
    /// 
    /// </remarks>
   public class OhObject
    {
	    // @begin{fields} -------------------------------------------------------
		
		/// <summary> 
		/// NX\łB
		/// 
		/// <p/>
		/// '_className' stores the class name.
		/// 
		/// </summary>
		protected internal String _className;
		
		/// <summary> 
		/// IuWFNg\łB
		/// 
		/// <p/>
		/// '_objetcName' stores the object name.
		/// 
		/// </summary>
		protected internal String _objectName;
		
		/// <summary> 
		/// IuWFNgԍ\intlłB
		/// 
		/// <p/>
		/// '_objectNumber' stores the object number.
		/// 
		/// </summary>
		protected internal int _objectNumber;
		
		/// <summary> 
		/// L҂\IuWFNgłB
		/// 
		/// <p/>
		/// The "owner" of the current object casted to type <var>Object</var>.
		/// 
		/// </summary>
		protected internal OhObject _owner;
		
		/// <summary> 
		/// OS ɈˑȂsR[h\łB
		/// 
		/// <p/>
		/// New line.
		/// 
		/// </summary>
		protected internal static String NEWLINE = Environment.NewLine;
		
		// @end{fields} ---------------------------------------------------------


        // @begin{initialization} ----------------------------------------------

        /// <summary>
        /// IuWFNgAIuWFNgԍ܂B<p/>
        /// Initialization.<p/>
        /// <remarks>
        /// ̓Iɂ́A aObjName, aObjNum  _objectName, _objectNumber ɐݒ肵܂B
        /// ܂A_objectName ݒς݂̎́AdݒƔfAG[bZ[W\܂B
        /// ̏ꍇA_objectName, _objectNumber ύX܂B
        /// RXgN^̒`AyуftHgRXgN^ŐIuWFNg̏ɗp܂B
        /// </remarks>
        /// <p/>
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="aObjName">a <var>String</var> value
        /// </param>
        /// <param name="aObjNum">an <var>int</var> value
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public virtual void  init(String aObjName, int aObjNum)
		{
			// System.out.println(aObjName);
			if (aObjName == null)
			{
				throw new ArgumentException(oPrintString("\t"));
			}
			
			if (_objectName != null)
			{
				throw new OhError( "Error in OhObject.init(): " + "Tried to set objectName twice." + NEWLINE 
                                 + "\tYou called init(\"" + aObjName + "\"), " + aObjNum + ")" + NEWLINE 
                                 + "\tfor the OhObject instance:" + NEWLINE + oPrintString("\t\t"));
			}
			
			_objectName = aObjName;
			_objectNumber = aObjNum;
		}

        // @end{initialization} ------------------------------------------------
		
		
        // @begin{constructors} ------------------------------------------------

        /// <summary> 
        /// ftHgRXgN^łB
        /// oϐȉ̒ʂ菉܂B
        /// <pre>
        /// E_className    : "OhObject"
        /// E_objectName   : null
        /// E_objectNumber : -1
        /// E_owner        : null
        /// </pre>
        /// 
        /// 
        /// </summary>
        public OhObject()
        {
            _className = "OhObject";
            _objectName = null;
            _objectNumber = -1;
            _owner = null;
        }


        /// <summary> 
        /// Ɏw肳ꂽoϐ OhObject 쐬܂B
        /// <a href="OhObject.html#init(java.lang.String, int)">OhObject.init(String, int)</a>  aObjNum, aObjNum nA
        /// oϐȉ̒ʂ菉܂B<br/>
        /// </summary>
        /// 
        /// <remarks>
        /// _className ͊ehNX̃RXgN^ŁÃNX̃NXɏ܂B
        /// <pre>
        /// E_className    : "OhObject"
        /// E_objectName   : aObjName
        /// E_objectNumber : aObjNum
        /// E_owner        : null
        /// </pre>
        /// </remarks>
        /// <param name="aObjName">a <var>String</var> value
        /// </param>
        /// <param name="aObjNum">an <var>int</var> value
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public OhObject(String aObjName, int aObjNum)
        {
            _className = "OhObject";
            _objectName = null;
            _objectNumber = -1;
            _owner = null;

            init(aObjName, aObjNum);
        }

        // @end{constructors} --------------------------------------------------
	
        // @begin{properties}----------------------------------------------------
		/// <summary> 
		/// NX擾܂B
		/// 
		/// <p/>
		/// Gets the class name.
        /// <ul>
        /// <li>get: a <var>String</var> value. NX</li>
        /// </ul>
		/// </summary>
		
		public String ClassName
		{
			get
			{
				return _className;
			}
			
		}
		/// <summary> 
		/// IuWFNg擾܂B
		/// 
		/// <p/>
		/// Gets the object name.
        /// <ul>
        /// <li>get: a <var>String</var> value. IuWFNg</li>
        /// </ul>
		/// </summary>
		
		public String ObjectName
		{
			get
			{
				return _objectName;
			}
			
		}
		/// <summary> 
		/// IuWFNgԍ擾܂B
		/// 
		/// <p/>
		/// Gets the object number.
        /// <ul>
        /// <li>get: a <var>int</var> value. IuWFNgԍ</li>
        /// </ul>
		/// </summary>
		
		public int ObjectNumber
		{
			get
			{
				return _objectNumber;
			}
			
		}
		/// <summary> <p/>
		/// L҂擾Eݒ肵܂B^Object^ɂȂ܂B<br/>
        /// Gets and sets the owner of the current object casted to type Object. 
        /// </summary>
        /// 
        /// <remarks>
        /// ݒ肳 value Ƃ͈قȂIuWFNgłɏL҂ƂĐݒ肳Ăꍇ́A
        /// V value L҂ɐݒ肹ɁA
        /// O <a href="OhError.html">OhError</a> ܂B
		/// 
        /// <br/>
        /// When already a different object has been registerd as the owner,
        /// you cannot set the new owner.
        /// If this case happens, this method throws <a href="OhError.html">OhError</a> exception.
        /// <p/>
		/// 
        /// <ul>
        /// <li>get : a <var>OhObject</var> value. L </li>
        /// <li>set : a <var>OhObject</var> value  L</li>
        /// </ul></remarks>
        /// 
		public OhObject Owner
		{
			get
			{
				return _owner;
			}
			
			set
			{
				//; (*6)
				if (value == null)
				{
                        throw new ArgumentException(oPrintString("\t"));
				}
				
				if (_owner != null && _owner != value)
				{
                     string str = _owner.oPrintString("    first : ")
                                + value.oPrintString("    next  : ")
                                + cPrintString("    ");
                                 
                       throw new OhError("\"owner\" has already been set.", str);
                }
				_owner = value;
			}
		}
		/// <summary> 
		/// ōL҂擾܂B
		/// 
		/// <p/>
		/// Gets the top owner of the receiver.
        /// <ul>
        /// <li>get: a <var>Object</var> value. ōLҖ</li>
        /// </ul>
		/// </summary>
		
		public OhObject TopOwner
		{
			get
			{
				//; (*5)
				OhObject top = this;
				OhObject parent = _owner;
				
				while (parent != null)
				{
					top = parent;
					parent = top.Owner;
				}
				return top;
			}
		}
		/// <summary> 
		/// L҂̏擾܂B<br/>
        /// </summary>
        /// <remarks>
        /// L҂̏擾܂B<br/>
        /// Ⴆ
        /// <ul>
        /// <li>IuWFNg:Kyoto,     IuWFNgԍ:1</li>
        /// <li>IuWFNg:Sakyo,     IuWFNgԍ:2</li>
        /// <li>IuWFNg:Ginkaku,   IuWFNgԍ:3</li>
        /// </ul>
        /// ł
        /// <ul>
        /// <li>KyotoSakyȍL  (Sakyo.Owner = Kyoto)</li>
        /// <li>SakyoGinkakȕL(Ginkaku.Owner = Sakyo)</li>
        /// </ul>
        /// ŁÃ݂IuWFNgGinkakułƂ܂B̏ꍇo͂<p/>
        /// <code>
        /// KyotoQ1/SakyoQ2/GinkakuQ3
        /// </code>
        /// ƂȂ܂B<p/>
        /// _owner  null̏ꍇ "" Ԃ܂B
        ///@
        /// <br/>
        /// 
        ///
		/// 
		/// <p/>
        /// This method returns a string which specifies the object uniquely. <p/>
		/// 
		/// The string which AbsName returns will be created by concatenating
		/// 
		/// <code>
		/// 
		/// "absolute name of the owner"
		/// "/"
		/// _objectName
		/// "__"
		/// _objectNumber.
		/// 
		/// </code>
		/// 
		/// When _owner == NULL, "absolute name of the owner" is taken as "". <p/>
		/// 
		/// <EXAMPLE>
		/// 
		/// Assume that the absolute name of the owner is "/total_sytetem__0",
		/// _objectName of the current object is "elm_t",
		/// and _objectNumber is 0,
		/// then "absname" is
		/// 
		/// <code>
		/// 
		/// /total_system__0/elm_t__0
		/// 
		/// </code></EXAMPLE><br/>
		/// <ul>
        /// <li>get: a <var>String</var> value. Lҏ</li>
        /// </ul>
        /// </remarks>
        /// 
		public String AbsName
		{
			get
			{
				//; (*2)
				StringBuilder absName = new StringBuilder("");
				
				if (_owner == null)
				{
					absName = absName.Append("");
				}
				else
				{
					absName = absName.Append(((OhObject) _owner).AbsName);
					//;   ((OhObject)_owner).AbsName;  owner ̏ʂɂȂB
				}
				
				absName = absName.Append("/");
				absName = absName.Append(_objectName);
				absName = absName.Append("__");
				absName = absName.Append(((Int32) _objectNumber).ToString());
				
				return absName.ToString();
			}
			
		}

        // @begin{properties}----------------------------------------------------
		
		// @begin{methods} -----------------------------------------------------
		
		
		// 1. function about a name
		
		/// <summary>
		/// NXAIuWFNgAIuWFNgԍɊւIuWFNg̔rsȂ܂B<p/>
        /// </summary>
        /// <remarks>
		/// ̃\bh́A_className, _objectName, _objectNumber 
		/// aClassName, aObjName, aObjNum Ɉvꍇ true Ԃ܂B
		/// ǂꂩPłvȂ̂ false Ԃ܂B
		/// 
		/// <p/>
		/// If the current object is same as class name, object name, and object number given by the arguments,
		/// this method returns true.
		/// Otherwise, false.
        /// </remarks>
		/// 
		/// 
		/// <param name="aClassName">a <var>String</var> value<p/>
        /// rΏۂ̃NX
		/// </param>
        /// <param name="aObjName">a <var>String</var> value. <p/>
        /// rΏۂ̃IuWFNg
		/// </param>
        /// <param name="aObjNum">an <var>int</var> value. <p/>
        /// rΏۂ̃IuWFNgԍ 
		/// </param>
        /// <returns> a <var>bool</var> value. <p/>
		/// </returns>
		public bool objCompare(String aClassName, String aObjName, int aObjNum)
		{
			if ((_objectName.Equals(aObjName)) && (_objectNumber == aObjNum) && (_className.Equals(aClassName)))
				return true;
			
			return false;
		}
		
		
		/// <summary> 
		/// IuWFNgAIuWFNgԍɊւIuWFNg̔rsȂ܂B<p/>
        /// 
        /// </summary>
        /// <remarks>
		/// ̃\bh́A_objectName, _objectNumber 
		/// aObjName, aObjNum Ɉvꍇ true Ԃ܂B
		/// ꂩPłvȂ̂ false Ԃ܂B
        /// </remarks>
		/// <p/>
        /// 
		/// If the current object is same as object name and object number as those given as the arguments,
		/// this method returns true.
		/// Otherwise, false.
		/// 
		/// 
		/// 
		/// <param name="aObjName">a <var>String</var> value. rΏۂ̃IuWFNg
		/// </param>
		/// <param name="aObjNum">an <var>int</var> value. rΏۂ̃IuWFNgԍ
		/// </param>
		/// <returns> a <var>bool</var> value.
		/// </returns>
		public bool objCompare(String aObjName, int aObjNum)
		{
			if ((_objectName.Equals(aObjName)) && (_objectNumber == aObjNum))
				return true;
			
			return false;
		}
		
		
		/// <summary>
		/// NXAIuWFNgAIuWFNgԍAL҂ɊւIuWFNg̔rsȂ܂B<p/>
        /// </summary>
        /// <remarks>
		/// ̃\bh́A_className, _objectName, _objectNumber, _owner 
		/// ׂ aObj ƈvꍇ true Ԃ܂B
		/// ǂꂩPłvȂ̂ false Ԃ܂B
		/// ܂AaObj  null ̏ꍇ false Ԃ܂B
		/// 
		/// <p/>
        /// 
		/// If the current object is same class name, object name, object number, and owner which aObj has,
		/// this method returns true.
		/// Otherwise, false.
        /// </remarks>
		/// 
		/// 
		/// <param name="aObj">an <var>OhObject</var> value. rΏۂ̃IuWFNg
		/// </param>
		/// <returns> a <var>bool</var> value 
		/// </returns>
		public bool objCompare(OhObject aObj)
		{
			if (aObj == null)
				return false;
			
			if ((aObj.ObjectName.Equals(_objectName)) && (aObj.Owner == _owner) && (aObj.ObjectNumber == _objectNumber) && (aObj.ClassName.Equals(_className)))
				return true;
			
			return false;
		}
		
		
		
		
		// 3. Information output function
		
		
		/// <summary> 
		/// IuWFNg(L҂̏܂܂Ȃ)o͂܂B
        /// </summary>
        /// <remarks>
		/// <p/>
		/// Print "aHead", _className, _objectName, _objectNumer to aSw. <p/>
		/// 
		/// 
		/// 
		/// <code>
		///   Yahoo a("yahoo", 0);
		///   a.cPrint(aSw, "+");
		/// </code>
		/// prints to aSw
		/// <code>
		/// +Yahoo yahoo 0
		/// </code>
        /// </remarks>
		/// 
		/// <param name="aSw">a <var>StreamWriter</var> value. o͐StreamWriterIuWFNg
		/// </param>
		/// <param name="aHead">a <var>String</var> value. sɕt镶
		/// </param>
		public virtual void  cPrint(StreamWriter aSw, String aHead)
		{
			//; (*3)
			aSw.Write(aHead + _className + " " + _objectName + " " + _objectNumber + NEWLINE);
		}

        /// <summary>
        /// \bh cPrint ̃I[o[[hłB
        /// </summary>
        /// <param name="aSw">a <var>StreamWriter</var> value. o͐StringWriterIuWFNg
        /// </param>
        /// <param name="aHead">a <var>String</var> value. sɕt镶
        /// </param>
        public virtual void cPrint(StringWriter aSw, String aHead)
        {
            //; (*3)
            aSw.Write(aHead + _className + " " + _objectName + " " + _objectNumber + NEWLINE);
        }

        /// <summary> Returns the String aHead + _className + " " +
        /// _objectName + " " + _objectNumer + NEWLINE<p/>
        /// 
        /// 
        /// <pre>
        /// |  Yahoo a("yahoo", 0);
        /// |  a.cPrintString(aSw, "+");
        /// 
        /// returns 
        /// 
        /// +Yahoo yahoo 0
        /// </pre>
        /// 
        /// </summary>
        /// <param name="aHead">a <code>String</code> value
        /// </param>
        public virtual String cPrintString(String aHead)
        {
            String str = aHead + _className + " " + _objectName + " " + _objectNumber + NEWLINE;
            return str;
        }

		/// <summary> 
		/// IuWFNg(L҂̏܂)o͂܂B
        /// <br/></summary>
        /// 
        /// <remarks>
        /// Ⴆ
        /// <ul>
        /// <li>NX:City,   IuWFNg:Kyoto,   IuWFNgԍ:1</li>
        /// <li>NX:Ward,   IuWFNg:Sakyo,   IuWFNgԍ:2</li>
        /// <li>NX:Temple, IuWFNg:Ginkaku, IuWFNgԍ:3</li>
        /// </ul>
        /// ł
        /// <ul>
        /// <li>KyotoSakyȍL  (Sakyo.Owner = Kyoto)</li>
        /// <li>SakyoGinkakȕL(Ginkaku.Owner = Sakyo)</li>
        /// </ul>
        /// ŁÃ݂IuWFNgGinkakułƂ܂B<p/>
        /// ̂ƂAGinkaku.oPrint(sw, "+ ")Ƃꍇ̏o͂<p/>
        /// <code>
        /// + Temple Ginkaku 3
        /// +    _owner > Ward Sakyo 2
        /// +    _owner >> City Kyoto 1
        /// </code>
        /// ƂȂ܂B
		/// 
		/// <p/>
		/// Trace back the object's ancestry, that is, prints all the ancesters to aSw as far as an ancester exists.
		/// "aHead" is printed before the ancestry. <p/>
		/// <br/>
		/// EXAMPLE
		/// 
		/// <code>
		///   Yahoo a("yahoo", 0);
		///   Yahoo b("yahoobb", 1);
		///   b.Owner = a;
		///   StringWriter aSw;
		///   b.oPrint(aSw, "+ ");
		/// </code>
		/// prints to aSw as follows
		/// <code>
		///   + Yahoo yahoobb 1
		///   +     owner > Yahoo yahoo 0
		/// </code>
		/// 
        /// </remarks>
        /// <param name="aSw">a <var>StreamWriter</var> value<p/> o͐StreamWriterIuWFNg
		/// </param>
        /// <param name="aHead">a <var>String</var> value<p/> sɕt镶
		/// </param>
        public virtual void oPrint(StreamWriter aSw, String aHead)
        {
            //; (*4)
            aSw.WriteLine( aHead + " " + objectInfo());
            OhObject obj;
            int i = 0;
            for (obj = Owner; obj != null; obj = obj.Owner)
            {
                aSw.Write(aHead + "  _owner ");
                for (int k = ++i; i > 0; i--)
                    aSw.Write(">");

                aSw.WriteLine("  " + obj.objectInfo());
            }
        }

        /// <summary>
        /// \bh oPrint ̃I[o[[hłBoPrintStringŎgpĂ܂B
        /// </summary>
        /// <param name="aSw">a <var>StringWriter</var> value. o͐StringWriterIuWFNg
        /// </param>
        /// <param name="aHead">a <var>String</var> value. sɕt镶
        /// </param>
        public virtual void oPrint(StringWriter aSw, String aHead)
        {
            //; (*4)
            aSw.WriteLine( aHead + "  " + objectInfo());
            OhObject obj;

            int i = 0;
            for (obj = Owner; obj != null; obj = obj.Owner)
            {
                aSw.Write(aHead + "  _owner ");
                for (int k = ++i; i > 0; i--)
                    aSw.Write(">");

                aSw.WriteLine("  " + obj.objectInfo());
            }
        }

        /// <summary> 
        /// IuWFNg(L҂̏܂)Ԃ܂B<p/>
        /// 
        /// Returns a message string which contains the information
        /// about the OhObject object itself and its owner sequence.
        /// </summary>
        /// <remarks>
        /// Y OhObject Ƃ̏Ln ( OhObject  owner k
        /// ĂĂłn) ̏𕶎 (s) ɂĕԂ܂B
        /// aHead ́A̕s̊̕es̑Oɕt镶łB
        /// </remarks>
        /// <param name="aHead">a <var>String</var> value
        /// </param>
        /// <returns> a <var>String</var> value
        /// </returns>
        public virtual String oPrintString(String aHead)
        {
            StringWriter sw = new StringWriter();
            oPrint(sw, aHead);
            String str = sw.ToString();
            sw.Close();
            return str;
        }

        /// <summary> 
        /// NXAIuWFNgAIuWFNgԍɂĂ̏
        /// ƂĕԂ܂B<p/>
        /// 
        /// Returns a String which contains the information about of
        /// _className, _objectName, and _objectNumber.
        /// 
        /// </summary>
        /// <returns> a <code>String</code> value
        /// </returns>
        public virtual String objectInfo()
        {
            return _className + " " + _objectName + " " + _objectNumber;
        }

        /// <summary> 
        /// IuWFNg̏L֌WԂ܂B<p/>
        /// Returns a String representation of this object.
        /// 
        /// 
        /// <p/>
        /// YIuWFNgoA_owner Ɋi[ĂIuWF
        /// NgHA_owner  null ɂȂ܂ł̃IuWFNǧn
        /// āAeIuWFNg _ className, _objectName,
        /// _objectNumber ̏sɏs̕Ԃ܂B
        /// <p/>
        /// 
        /// (Ql) OhObject obj  toString() ɑ΂ĕԂs
        /// ̊es̍sɃ^uɂ́A<br/>
        /// 
        /// <pre>
        /// Pattern p = Pattern.compile("^", Pattern.MULTILINE);
        /// Matcher matcher = p.matcher(obj.toString());
        /// String output = matcher.replaceAll("\t");
        /// </pre>
        /// 
        /// ̂悤ɂ܂Boutput ړI̕łB
        /// 
        /// 
        /// </summary>
        /// <returns> a <code>String</code> value
        /// </returns>
        public override String ToString()
        {
            StringBuilder str = new StringBuilder();
            str.Append(" " + objectInfo() + NEWLINE);
            OhObject obj;
            for (obj = _owner; obj != null; obj = obj.Owner)
            {
                str.Append("  _owner > " + obj.objectInfo() + NEWLINE);
            }
            return str.ToString();
        }


        /// <summary> 
        /// YNX̂ɂĂ̏Ԃ܂B<p/>
        /// Returns the information string about this class.
        /// </summary>
        /// <remarks>
        /// <ul>
        /// For ports, this method returns the information about
        /// classname;
        /// <li>datatype it carries.</li>
        /// </ul><br/>
        /// 
        /// For element, this method returns the information about
        /// classname;
        /// <ul>
        /// <li>list of port name, port numbers</li>
        /// <li>list of parameters</li>
        /// <li>formats which are used for reading parameter values</li>
        /// <li>list of state variables</li>
        /// <li>formats which are used for reading iniitial states.</li>
        /// </ul></remarks>
        /// <returns> a <code>String</code> value
        /// </returns>
        public virtual String basicInfo()
        {
            return "No basic info is given for " + _className + ".";
        }
		
		// @end{methods} -------------------------------------------------------
	} // OhObject
}