// <(#)>  OhOption; Declaration of OHyMoS.NET option variables. </(#)>
/// <summary> 
/// modified by Naoto Ohshima. Date: 2007/7/12 17:46:35
///                            Last Update: 2007/08/04 15:46:59 
/// </summary>
using System;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary>
	/// OHyMoS.NETɂV~[VŜ̃IvV\NXłB<p/>
    /// OhOption;
    /// 
    /// OhymosOption treats specification of general options for simulation.
    /// </summary>
    /// <remarks>
	/// OHyMoS.NETɂV~[VŜɊւIvV̎w舵܂B
	/// IvV́ÃNX̃oϐ̒lŎw肵܂B
	/// ̓Iɂ́A<p/>
	/// 
	/// <ul>
	/// <li> <a href="TimeControl.html">TimeControl</a> ɊւIvV</li>
	/// </ul>
	/// 
	/// 舵Ă܂B<p/>
	/// 
	/// ftHg̃IvV́A<p/>
	/// 
	/// <ul>
	/// <li> <a href="TimeControl.html">TimeControl</a> _tc = TimeControl.GO_BEYOND_TERMINAL_TIME;</li>
	/// <dd>  ԖڕW𒴂ČvZB</dd>
	/// <li> boolean _useWinP = false;</li>
	/// </ul>
	/// 
	/// ̂悤Ɏw肳Ă܂B<p/>
	/// 
	/// ܂ÃNX singlton NXłB
	/// OhOption  singlton 擾ɂ́A
	/// 
	/// <code>
	/// OhOption.Default;
	/// </code>
	/// 
	/// Ƃ܂B<p/>
	/// 
	/// <a href="OhymosNet.OhTotalSystem.setOhymosNetOption.html">OhTotalSystem.setOhymosNetOption()</a> ̗͂łāA
	/// vOs[UC^NeBuɃIvVw肷郁\bhłB
	/// 
    /// </remarks>
	public class OhOption
	{
        /// <summary> <japanese>
        /// OHyMoS.NETIvṼVOgłB
        /// </japanese>
        /// <p>
        /// The singlton of the OHyMoS.NET option.
        /// </p>
        /// </summary>
        private static OhOption instance = null;

        /// <summary> <japanese>
        /// GUI ̎gpɊւIvVłB<p>
        /// 
        /// ftHǵA
        /// 
        /// <pre>
        /// _useWinP = false;
        /// </pre>
        /// 
        /// Ȃ킿AGUI gpȂ悤ɐݒ肳Ă܂B
        /// </p>
        /// </japanese>
        /// <p>
        /// Option about use of GUI.
        /// </p>
        /// </summary>
        protected internal bool _useWinP = false;

        /// <summary> <japanese>
        /// <a href="TimeControl.html">TimeControl</a> ɊւIvVłB<p/>
        /// 
        /// ftHǵA
        /// 
        /// <pre>
        /// _tc = TimeControl.GO_BEYOND_TERMINAL_TIME;
        /// </pre>
        /// 
        /// Ȃ킿AԖڕW𒴂ČvZ悤ɐݒ肳Ă܂B<p/>
        /// </japanese>
        /// <p/>
        /// Option about <a href="TimeControl.html">TimeControl</a>.
        /// 
        /// </summary>
        
        protected internal TimeControl _tc = TimeControl.GO_BEYOND_TERMINAL_TIME;
        
        /// <summary> Creates a new default <code>OhOption</code> instance.
        /// 
        /// </summary>
        protected internal OhOption() : base()
        {
        }
        
       
		/// <summary> <japanese>
		/// OHyMoS.NETIvṼVOg擾܂BNX\bhłB
		/// </japanese>
		/// 
		/// </summary>
		/// <returns> an <code>OhOption</code> value
		/// </returns>
        /// Modified by Naoto Ohshima.
        /// OHyMoS.NETIvṼVOg擾vpeBłB
        public static OhOption Default
        {
            get
            {
                if (instance == null)
                {
                    instance = new OhOption();
                }
                return instance;
            }
        }

		
		/// <summary> <japanese>
		/// GUI ̎gpɊւIvṼvpeBłB
        ///  
		/// GUI gpȂꍇ falseAGUI gpꍇ true Ԃ܂B
		/// 
		/// 
		/// GUI ̎gpɊւIvVݒ肵܂B<p>
		/// 
		/// ftHgł GUI gpȂ悤ɐݒ肳Ă̂ŁA
		/// <c>UserWinP = true</c>Ɛݒ肷
		/// GUI gp[hɂȂ܂B</p>
		/// </japanese>
		/// 
		/// </summary>
		///
		virtual public bool UseWinP
		{
            get { return _useWinP; }
			set	{ _useWinP = value; }
		}

		/// <summary> <japanese>
		/// <a href="TimeControl.html">TimeControl</a> ɊւIvVԂ܂B <p>
		/// 
		/// ԖڕW𒴂ČvZꍇ
		/// <a href="TimeControl.html#GO_BEYOND_TERMINAL_TIME">TimeControl.GO_BEYOND_TERMINAL_TIME</a>A
		/// ԖڕW𒴂ɌvZꍇ
		/// <a href="TimeControl.html#DO_NOT_GO_BEYOND_TERMINAL_TIME">TimeControl.DO_NOT_GO_BEYOND_TERMINAL_TIME</a> 
		/// Ԃ܂B</p>
		/// </japanese>
		/// 
		/// </summary>
		/// <returns> a <code>TimeControl</code> value
		/// </returns>
		/// <summary> <japanese>
		/// <a href="TimeControl.html">TimeControl</a> ɊւIvVݒ肵܂B<p/>
		/// 
		/// ftHgł͒ԖڕW𒴂ČvZ悤ɐݒ肳Ă̂ŁA
		///  aTc 
		/// <a href="TimeControl.html#DO_NOT_GO_BEYOND_TERMINAL_TIME">TimeControl.DO_NOT_GO_BEYOND_TERMINAL_TIME</a> 
		/// w肵ĂƒԖڕW𒴂ɌvZ悤ɐݒ肳܂B
		/// </japanese>
		/// 
		/// </summary>
		/// 
		public virtual TimeControl TimeControlOption
		{
			get	{ return _tc; }
			set { _tc = value; }
		}

		
	} // OhOption
}