// Receive port model class "OhOutputFile" for output files. 
// Last update : 2008/02/26 21:13:37 
using System;
using System.IO;
using System.Collections;
using System.Text;
using OhymosNet;
namespace OhymosNet
{
    /// <summary> 
    /// o̓t@CpM[qf\NXłBۃNXłB
    /// ̃NX<a href = "OhymosNet.OhOutputPort.html">OhOutputPort</a>
    /// pĂ܂B<p/>
    /// OhOutputFile;
    /// Model for output ports which receive datapacks and print them in a file.
    /// It extends <a href = "OhymosNet.OhOutputPort.html">OhOutputPort</a> class.<p/>
    /// </summary>
    /// <remarks>
    /// ŠnŎMf[^pbNt@CɋL^܂B<p/>
    /// 
    /// ۃNXłB
    /// <a href="OhymosNet.OhOutputFileDouble.html">OhOutputFileDouble</a>,
    /// <a href="OhymosNet.OhOutputFileInt.html">OhOutputFileInt</a>,
    /// <a href="OhymosNet.OhOutputFilelong.html">OhOutputFileLong</a>,
    /// <a href="OhymosNet.OhOutputFileFloat.html">OhOutputFileFloat</a>,
    /// NXh܂B
    /// <p/>
    /// t@C̓IuWFNgi<a href="OhymosNet.OhObject._objectName.html">OhObject._objectName</a>j
    /// ƂĕێAMf[^pbNt@Cɏo@\񋟂܂B
    /// 
    /// Class OhOutputFile stores "output file name" in
    /// <a href="OhymosNet.OhObject._objectName.html">OhObject._objectName</a>.
    /// Methods to output received datapacks to the output file are defined as its methods.
    /// </remarks>
	public abstract class OhOutputFile:OhOutputPort
	{
        // @begin{fields} --------------------------------------------

        /// <summary> The maximum length of an output data string.<p/>
        /// 
        /// 
        /// o̓f[^̍ő咷łB<p/>
        /// The maximum length of an output data string.
        /// </summary>
        /// <remarks>
        /// ̒́ÃIuWFNg̃RXgN^Ŏw肵
        /// łB
        /// </remarks>
        protected internal int _lineLength;

        /// <summary> 
        /// ŏIo̓f[^̃f[^L^łB
        /// 
        /// <p/>
        /// Data record time of the last output data.
        /// 
        /// </summary>
        protected internal IOhTimePointImmutable _lastDataTime;

        /// <summary> 
        /// t@CɏoRgłB
        /// 
        /// <p/>
        /// The comment string written out to a file.
        /// 
        /// </summary>
        protected internal String _commentString;

        // @end{fields} ----------------------------------------------
		
        // @begin{property}---------------------------------------------------

		/// <summary> 
		/// o̓f[^̍ő咷 _lineLength 擾܂B<p/>
        /// Gets "_lineLength".
        /// </summary>
        /// <remarks>
		/// ̒́ÃIuWFNg̃RXgN^Ŏw肵̂łB
		/// 
		/// <p/>
        /// </remarks>
		public virtual int LineLength
		{
			get
			{
				return _lineLength;
			}
			
		}
		/// <summary> 
		/// ŏIo̓f[^̃f[^L^ _lastDataTime 擾܂B
		/// 
		/// <p/>
		/// Returns "_lastDataTime".
		/// 
		/// </summary>
		/// <returns> an <var>OhTimePoint</var> value<p/>
		/// </returns>
		public virtual IOhTimePointImmutable LastDataTime
		{
			get
			{
				return _lastDataTime;
			}
			
		}
		/// <summary> 
        /// t@CɏoRg _commentString 
        /// ݒ肵܂B<p/>
        /// Copys the string <b>aCmt</b> to the field
		/// <b>_commentString</b>. 
        /// </summary>
        /// <remarks>
        /// _commentString ɐݒ肵́A
		/// (Ref "#writeHeader()") sƂɏo̓t@Cɏo
		/// ܂B
		/// 
		/// <p/>
        /// The string copied to
        /// <b>_commentString</b>
        /// will be printed out into the output file, while the method
        /// (Ref "#writeHeader()") is executed. See the source code of
        /// (Ref "#writeHeader()").
        /// </remarks>
        public virtual String CommentString
		{
			set
			{
				_commentString = value;
			}
			
		}
		/// <summary> 
		/// f[^Kv擾܂B<p/>
        /// Gets necessary data time.
        /// </summary>
        /// <remarks>
		/// M̑M[q NecessaryTimeFrom ȍ~
		/// NecessaryTimeTo ȑÕf[^pbNȂ悤Ɏw
		/// 邽߂ɒ`܂B<p/>
		/// <p/>
        /// </remarks>
		/// <returns> an <var>OhTimePointImmutable</var> value<p/>
        /// f[^Kv
		/// </returns>
		override public IOhTimePointImmutable NecessaryTimeFrom
		{
			get
			{
				return _lastDataTime;
			}
			
		}
		/// <summary> 
		/// f[^KvԂ܂B<p/>
        /// Gets necessary data time.
        /// </summary>
        /// <remarks>
		/// M̑M[q getNecessaryTimeFrom() ȍ~
		/// getNecessaryTimeTo ȑÕf[^pbNȂ悤Ɏw
		/// 邽߂ɒ`܂B<p/>
        /// </remarks>
        /// 
		/// <returns> an <var>OhTimePointImmutable</var> value<p/>
        /// f[^Kv
		/// </returns>
		override public IOhTimePointImmutable NecessaryTimeTo
		{
			get
			{
				return new OhTimePoint(2100, 0);
			}
			
		}

        // @begin{property}---------------------------------------------------
		
		
		// @begin {abstract property and methods} ---------------------------------
		
		// 1. Connection function.

        /// <summary> 
        /// o̓f[^pbÑf[^ľ^𕶎ƂĕԂ܂B<p/>
        /// 
        /// ۃ\bhłB<p/>
        /// 
        /// This is an abstract method.  Returns a string which
        /// expresses the type of datapacks received by this object.<p/>
        /// 
        /// 
        /// 
        /// <p/>
        /// 
        /// </summary>
        /// <returns> a <var>String</var> value<p/>
        /// </returns>
        public abstract override String DataType { get;}
		
		
		// 2. The write-in function of output files.
		
		
		// @end{abstract methods} ------------------------------------
		
		
		// @begin{initialization} ------------------------------------
		
		/// <summary> 
        /// IuWFNg(t@C)Ao̓f[^̍ő咷
        /// (_lineLength)AIuWFNgԍ 0 ɐݒ肵܂B
        /// <p/>
        /// Sets (Ref "OhObject#_objectName") to aFileName and 
		/// (Ref "#_lineLength") to aLineLength. 
        /// </summary>
        /// <remarks>
		/// (Ref "#_lineLength")  0 傫ĂȂA
		/// dݒƔf OhError O𑗏o܂B
		/// (Ref "#_lineLength")  
		/// 0 ȉȂ΁A(Ref "#_lineLength")  aLineLength ɐݒ肵
		/// B
        /// <p/>
        /// 
        /// _objectName is
        /// used also for specifying the output file name into which
        /// the receiving object write data.<p/>
        /// </remarks>
		/// <param name="aFileName">a <var>String</var> value<p/>
		/// </param>
		/// <param name="aLineLength">an <var>int</var> value<p/>
		/// </param>
		public override void  init(String aFileName, int aLineLength)
		{
			if (aLineLength < 0)
			{
				throw new ArgumentException("Invalid value<p/> of aLineLength " + aLineLength + NEWLINE + oPrintString(" > "));
			}
			
			if (aLineLength == 0)
				aLineLength = 128;
			
			base.init(aFileName, 0);
			if (_lineLength > 0)
			{
				throw new OhError("'_lineLength' has been already set.",oPrintString(" > "));
			}
			_lineLength = aLineLength;
		}


        /// <summary> w肳ꂽt@CIuWFNgɋLAo̓f[^
        /// ̍ő咷(_lineLength) 128 ɁAIuWFNgԍ 0 
        /// ɐݒ肵܂B<p/>
        /// Sets the argument string to the object name.<p/>
		/// </summary>
		/// <param name="aFileName">a <var>String</var> value<p/>
		/// </param>
		/// <returns> a <var>boolean</var> value<p/>
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  init(String aFileName)
		{
			base.init(aFileName, 0);
			if (_lineLength > 0)
			{
				//; _lineLength  0 傫ꍇAdݒƔf 
				//; OhError IuWFNgX[܂B
				throw new OhError("'_lineLength' has been already set.",oPrintString(" > "));
			}
			_lineLength = 128;
		}

       
		// @end{initialization} --------------------------------------
		
		
		// @begin{constructors} --------------------------------------
		
		/// <summary> 
		/// ftHgRXgN^łB<p/>
        /// </summary>
        /// <remarks>
		/// ftHgRXgN^
        /// <a href="OhOutputFile.html#init(String, int)">OhOutputFile.init(String, int)</a> 
		/// s܂B̌ʁAȉ̐ݒƂȂ܂B<p/>
		/// 
		/// <dl>
		/// <li> _objectName        : null</li>
		/// <li> _objectNumber      : -1</li>
		/// <li> _lineLength        : -1</li>
		/// </dl>
		/// 
		/// <p/>
		/// ̑̃oϐɑ΂鏈͈RXgN^Ɠ
		/// łB
        /// ̏ꍇA<a href="OhOutputFile.html#init(String, int)">OhOutputFile.init(String, int)</a> 
		/// păoϐĉB
        /// </remarks>
		public OhOutputFile():base()
		{
			_lineLength = - 1;
			
			_className = "OhOutputFile";
			_commentString = null;
			_lastDataTime = OhTimePoint.OhTimePointMin;
		}


        /// <summary> 
        /// IuWFNgit@CjAo̓f[^̍ő咷(_lineLength)w肵A
        /// V<var>OhOutputFile</var>CX^X𐶐܂B 
        /// </summary>
        /// <remarks>
        /// NX <a href="OhOutputPort.html">OhOutputPort</a> ̃ftHgRXgN^pA
        /// <a href="OhOutputFile.html#init(java.lang.String, int)">OhOutputFile.init(String, int)</a>
        /// pāA
        /// oϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhOutputFile"</li>
        /// <li> _objectName        : aFileName</li>
        /// <li> _objectNumber      : 0</li>
        /// <li> _lineLength        : aLineLength</li>
        /// <li> _lastDataTime      : <a href="OhTimePoint.html#OhTimePointMin">OhTimePoint.OhTimePointMin</a></li>
        /// <li> _commentString     : null</li>
        /// </dl>
        /// 
        /// </remarks>
		/// <param name="aFileName">a <var>String</var> value<p/>
		/// </param>
		/// <param name="aLineLength">an <var>int</var> value<p/>
		/// </param>
		public OhOutputFile(String aFileName, int aLineLength):base()
		{
			_lineLength = - 1;
			
			_className = "OhOutputFile";
			_commentString = null;
			_lastDataTime = OhTimePoint.OhTimePointMin;
			
			init(aFileName, aLineLength);
		}


        /// <summary> 
        /// IuWFNgit@Cjw肵āA
        /// V<var>OhOutputPort</var>CX^X𐶐܂B 
        /// </summary>
        /// <remarks>
        /// NX <a href="OhOutputPort.html">OhOutputPort</a> ̃ftHgRXgN^pA
        /// <a href="OhOutputFile.html#init(java.lang.String)">OhOutputFile.init(String)</a> pāA
        /// oϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhOutputFile"</li>
        /// <li> _objectName        : aFileName</li>
        /// <li> _objectNumber      : 0</li>
        /// <li> _lineLength        : -1</li>
        /// <li> _lastDataTime      : <a href="OhTimePoint.html#OhTimePointMin">OhTimePoint.OhTimePointMin</a></li>
        /// <li> _commentString     : null</li>
        /// </dl>
        /// 
        /// </remarks>
		/// <param name="aFileName">a <var>String</var> value<p/>
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public OhOutputFile(String aFileName):base()
		{
			_lineLength = - 1;
			
			_className = "OhOutputFile";
			_commentString = null;
			_lastDataTime = OhTimePoint.OhTimePointMin;
			
			init(aFileName);
		}
		
		// @end{constructors} ----------------------------------------
		
		
		// @begin{methods} -------------------------------------------
		
		
		// 1. Connection function.
		
		// 2. The write-in function of output files.
		
		
		/// <summary> 
		/// o̓f[^݂܂B<p/>
        /// Writes a header part to output file. 
        /// </summary>
        /// <remarks>
		/// o̓t@C̃wb_ƂāA^f[^pbN𑗐MĂ
		/// M[qɊւL܂B<p/>
		/// 
		/// CommentStringŐݒ肵񂪏o܂B
		/// o̓f[^ӖĂ邩APʂ͉Ȃǂo
		/// B<p/>
		/// 
		/// ܂Af[^Ԍ^z̒l\܂B<p/>
		/// 
		/// <example>
		/// <pre><var>
		/// # tplkin.oa 
		/// # -------------------------------------------------------
		/// #   OhSendDouble sp 0 
		/// #       _owner > PowerLawKinematicWave stream 0
		/// #       _owner >> OhScfTotalSystem totalSystem 0
		/// # -------------------------------------------------------
		/// # Year Sec Frac Discharge(m**3/sec)
		/// # DataConnectionType = 0:BROKENLINE 1:STEP 2:PULSE 3:NOINTP  
		/// #&amp; dctVec 1  0
        /// </var></pre>
        /// </example>
        /// 
		/// wb_ɂ͍s # ݁ARgAEĝŁA
		/// ̏o̓t@CĂѓ̓t@CƂėp邱Ƃł܂B<p/>
		/// 
		/// o̓t@CI[vłȂƗO𑗏o܂B<p/>
		/// 
		/// wb_ύXꍇ́AhNXōĒ`ĉB<p/>
		/// 
		/// 
		/// <p/>
		/// 
		/// The header contains <p/>
		/// <ul>
		/// <li> file name</li>
		/// <li> information about the send port which sends data to
		/// this port</li>
		/// <li> "_commentString if the "commentString" of the send
		/// port is not null</li>
		/// </ul>
		/// <p/>
		/// If the output file cannot be opened, this method throws an
		/// exception of type (Ref "OhError").
        /// </remarks>
		/// <returns> a <var>boolean</var> value<p/>
		/// </returns>
		/// <exception cref="IOException">if an error occurs
		/// </exception>
		public virtual bool writeHeader()
		{
			//; (*2)
			
			StreamWriter sw = null;
			
			try
			{
				sw = new StreamWriter(_objectName);
			}
			catch (IOException e)
			{
                e = new IOException("Output file does not found.");
				throw e;
			}
			
			sw.AutoFlush = true;
			
			sw.Write("# " + _objectName + " " + NEWLINE + "# ");
			
			for (int k = 0; k < 70; k++)
				sw.Write("-");
			
			sw.Write(NEWLINE);
			
			((OhObject) _sender).oPrint(sw, "#   ");
			
			sw.Write("# ");
			
			for (int k = 0; k < 70; k++)
				sw.Write("-");
			
			sw.Write(NEWLINE);
			
			if (_commentString != null)
				sw.Write("# " + _commentString + NEWLINE);
			
			String senderCom = ((OhSenderPort) _sender).CommentString;
			
			if (senderCom != null)
				sw.Write("# " + senderCom + NEWLINE); //; aho
			
			ArrayList dctVec = ((OhSenderPort) _sender).DctVec;
			
			int n = dctVec.Count;
			
			sw.Write("# DataConnectionType = ");
			
			for (int i = 0; i < DataConnectionTypeOption.NumOfDCT; i++)
			{
				sw.Write(i + ":" + DataConnectionTypeOption.getDctTypeStr(i) + " ");
			}
			
			sw.Write(NEWLINE + "#& dctVec " + n + " ");
			
			for (int i = 0; i < n; i++)
			{
				sw.Write(" " + ((DataConnectionType) dctVec[i]));
			}
			
			sw.Write(NEWLINE);
			sw.Write(NEWLINE);
			
			sw.Close();
			
			return true;
		}

        /// <summary> 
        /// o̓f[^Ps̍쐬s܂B<p/>
        /// 
        /// Writes the content of datapack aDataPack into the area to
        /// which aStr points. 
        /// </summary>
        /// <remarks>
        /// o̓t@CPsɂ́AP̃f[^pbÑf[^eLq
        /// ܂B<p/>
        /// The space which aStr points to must be
        /// large enough to store the content of the datapack. <p/>
        /// 
        /// Since this is an abstract method, implementation of this
        /// function is compulsory in derived classes.
        /// </remarks>
        /// <param name="aStr">a <var>String</var> value<p/>
        /// </param>
        /// <param name="aDataPack">an <var>OhDataPack</var> value<p/>
        /// </param>
        //public virtual string toStringDataLine(String aStr, OhDataPack aDataPack)
        //{
        //    aDataPack.dpack2Ofile(

		
		/// <summary> 
		/// o̓f[^݂܂B<p/>
        /// Writing of output data.
        /// </summary>
        /// <remarks>
		/// ܂Ao̓t@C _objectName J܂iȂꍇ͍쐬܂jB
        /// t@C݂ꍇAt@C͏㏑܂B
        /// <p/>
		/// 
		/// ɁAMf[^pbNz _dataPackArray ̐擪Ɋi[
		/// Ăf[^pbN珇Ԃ
        /// <a href="OhymosNet.OhOutputFile.makeStringData.html">makeStringData</a>
        /// păf[^쐬Ao̓t@
		/// CɋL܂B<p/> 
        /// 
        /// Ӂ <p/>
		/// 
		/// Mf[^pbN͂̃\bh̒Ŏ擾܂B
		/// f OhOutputFile ͎M[q̔hfłāA
		/// f[^pbNXgbN@\͂܂B
		/// 
		/// <p/>
        /// </remarks>
		/// <exception cref="IOException">if an error occurs
		/// </exception>
		public override void outputData()
		{
			//; (*3)
			
			OhArrayList dpArray = new OhArrayList();
			OhArrayList[] dpArrayArray = new OhArrayList[]{dpArray};
			
			int numOfDps = 0;
			int[] numOfDpsArray = new int[]{numOfDps};
			
			getDataPackArray(dpArrayArray, numOfDpsArray);
			
			dpArray = dpArrayArray[0];
			numOfDps = numOfDpsArray[0];
			
			// _dataPackArray is not updated.
			//
			if (((OhDataPack) dpArray[numOfDps - 1]).DataTime.CompareTo(_lastDataTime) <= 0)
				return ;
			
			String buffer = "";
			
			/* initial output */
			
			if (_lastDataTime == OhTimePoint.OhTimePointMin)
				writeHeader();
			
			StreamWriter sw = null;
			
			try
			{
				sw = new StreamWriter(_objectName,true,Encoding.Default);
			}
			catch (IOException e)
			{
				throw e;
			}
			
			if (((OhDataPack) dpArray[0]).DataTime.CompareTo(OhTimePoint.OhTimePointMin) == 0)
			{
                ((OhDataPack)dpArray[0]).dpack2Ofile(sw);
				sw.Write(buffer + NEWLINE);
			}
			
			
			int k = 0;
			
			for (k = 0; k < numOfDps; k++)
			{
				if (((OhDataPack) dpArray[k]).DataTime.CompareTo(_lastDataTime) > 0)
					break;
			}
			
			for (; k < numOfDps; k++)
			{
                ((OhDataPack)dpArray[k]).dpack2Ofile(sw);
				sw.Write(buffer + NEWLINE);
			}
			
			sw.Close();
			
			_lastDataTime = ((OhDataPack) dpArray[numOfDps - 1]).DataTime;
			
			reduceDataPackStock();
		}
		
		
		// 3. Information output function.
		
		/// <summary> 
		/// IuWFNg(L҂̏܂܂Ȃ)o͂܂B<p/>
        /// Outputs an object information.
        /// </summary>
        /// <remarks>
		/// o̓t@CƂ̒[q̎MM[q̏
		/// Xg[ aSwijɏo͂܂B
        /// </remarks>
		/// 
		/// <param name="aSw">a <var>StreamWriter</var> value<p/>
        /// IuWFNgo͂Xg[
		/// </param>
		/// <param name="aHead">a <var>String</var> value<p/>
        /// Rg
		/// </param>
		public override void  cPrint(StreamWriter aSw, String aHead)
		{
			aSw.Write(aHead + "OhInputFile : " + _className + "<" + DataType + "> " + _objectName + " " + NEWLINE);
		}
		
		
		/// <summary> 
		/// IuWFNg(L҂̏܂)o͂܂B<p/>
        /// Outputs an object information.
        /// The information includes the "_owner"'s information.
        /// </summary>
        /// <remarks>
		/// o̓t@CƂ̒[q̎MM[q̏
		/// Xg[ aSwijɏo͂܂B
        /// </remarks>
		/// <param name="aSw">a <var>PrintWriter</var> value<p/>
        /// IuWFNgo͂Xg[
		/// </param>
		/// <param name="aHead">a <var>String</var> value<p/>
        /// Rg
		/// </param>
		public override void  oPrint(StreamWriter aSw, String aHead)
		{
			//; (*5)
			cPrint(aSw, aHead);
			
			if (_sender == null)
				return ;
			
			// Makes the header when outputting the information on the
			// input port.
			//
			String newHead = aHead + "  output < ";
			
			((OhObject) _sender).oPrint(aSw, newHead);
		}
		
		// @end{methods} ---------------------------------------------
	} // OhOutputFile
}