/// <(#)>  OhOutputFileDouble </(#)>
using System;
using System.IO;
using System.Text;
using OhymosNet;

namespace OhymosNet
{

    /// <summary> 
    /// f[^l double ^łf[^pbNt@CɋL^o͒[q\NXłB <p/>
    /// ̃NX<a href = "OhymosNet.OhOutputFile.html">OhOutputFile</a>
    /// pĂ܂B
    /// <p/>
    /// OhOutputFileDouble;
    /// 
    /// OhOutputFileDouble is a class of output ports
    /// which receive datapacks of type double and print them in a file. 
    /// It extends <a href ="OhymosNet.OhOutputFile.html">OhOutputFile</a> class.<p/>
    /// </summary>
    /// <remarks>
    /// OhOutputFileDoubledouble^̃f[^M̂ŁA
    /// <a href="OhymosNet.OhSendDouble.html">OhSendDouble</a>,
    /// <a href="OhymosNet.OhRelayDouble.html">OhRelayDouble</a>, 
    /// <a href="OhymosNet.OhInputFileDouble.html">OhInputFileDouble</a>.
    /// Ɛڑ邱Ƃł܂B
    /// <br/><br/>
    /// OhOutputFileDouble receives double data.
    /// OhOutputFileDouble can be connected with
    /// <a href="OhymosNet.OhSendDouble.html">OhSendDouble</a>,
    /// <a href="OhymosNet.OhRelayDouble.html">OhRelayDouble</a>, and 
    /// <a href="OhymosNet.OhInputFileDouble.html">OhInputFileDouble</a>.
    /// </remarks>
	public class OhOutputFileDouble:OhOutputFile
	{
		// @begin{initialization} ------------------------------------
		
		// @end{initialization} --------------------------------------
		
		
		// @begin{constructors} --------------------------------------
		
		/// <summary> 
        /// ftHgRXgN^łB
        /// Creates a new default <var>OhOutputFileDouble</var> instance.
		/// 
		/// </summary>
        /// <remarks>
        /// ftHgRXgN^
        /// NX <a href="OhOutputFile.html">OhOutputFile</a> ̃ftHgRXgN^s܂B
        /// ̌ʁAȉ̐ݒƂȂ܂B<p/>
        /// 
        /// <dl>
        /// <li> _objectName        : null</li>
        /// <li> _objectNumber      : -1</li>
        /// <li> _lineLength        : -1</li>
        /// </dl>
        /// 
        /// <p/>
        /// ̑̃oϐɑ΂鏈͈RXgN^ƓłB
        /// ̏ꍇA
        /// <a href="OhOutputFileDouble.html#init(java.lang.String, int)">OhOutputFileDouble.init(String, int)</a> 
        /// păoϐĉB
        /// </remarks>
		public OhOutputFileDouble():base()
		{
			_className = "OhOutputFileDouble";
		}
		
		
		/// <summary> 
        /// IuWFNgio̓t@CjAo̓f[^̍ő咷(_lineLength)w肵A
        /// V<var>OhOutputFileDouble</var>CX^X𐶐܂B<p/> 
        /// Creates a new <var>OhOutputFileDouble</var> instance.
		/// 
		/// </summary>
        /// <remarks>
        /// NX̃RXgN^
        /// <a href="OhOutputFile.html#OhOutputFile(java.lang.String, int)">OhOutputFile.OhOutputFile(String, int)</a>
        /// păoϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhOutputFileDouble"</li>
        /// <li> _objectName        : aFileName</li>
        /// <li> _objectNumber      : 0</li>
        /// <li> _lineLength        : aLineLength</li>
        /// <li> _lastDataTime      : <a href="OhTimePoint.html#OhTimePointMin">OhTimePoint.OhTimePointMin</a></li>
        /// <li> _commentString     : null</li>
        /// </dl>
        /// </remarks>
		/// <param name="aFileName">a <var>String</var> value<p/>
		/// </param>
		/// <param name="aLineLength">an <var>int</var> value<p/>
		/// </param>
		public OhOutputFileDouble(String aFileName, int aLineLength):base(aFileName, aLineLength)
		{
			_className = "OhOutputFileDouble";
		}
		
		/// <summary> 
        /// IuWFNgio̓t@Cjw肵A
        /// V<var>OhOutputFileDouble</var>CX^X𐶐܂B <p/>
        /// Creates a new <var>OhOutputFileDouble</var> instance.
		/// 
		/// </summary>
        /// <remarks>
        /// NX̃RXgN^
        /// <a href="OhOutputFile.html#OhOutputFile(java.lang.String, int)">OhOutputFile.OhOutputFile(String, int)</a>
        /// păoϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhOutputFileDouble"</li>
        /// <li> _objectName        : aFileName</li>
        /// <li> _objectNumber      : 0</li>
        /// <li> _lineLength        : 128</li>
        /// <li> _lastDataTime      : <a href="OhTimePoint.html#OhTimePointMin">OhTimePoint.OhTimePointMin</a></li>
        /// <li> _commentString     : null</li>
        /// </dl>
        /// </remarks>
		/// <param name="aFileName">a <var>String</var> value<p/>
		/// </param>
		public OhOutputFileDouble(String aFileName):base(aFileName, 128)
		{
			_className = "OhOutputFileDouble";
		}
		
		// @end{constructors} ----------------------------------------
		
		
		// @begin{methods} -------------------------------------------
		
		// 1. Connection function.
		
		/// <summary> Returns the datapack type, "double", which expresses the
		/// type of data to be received.
		/// 
		/// </summary>
		/// <returns> a <var>String</var> value<p/>
		/// </returns>
		public override String DataType
		{
            get { return "double"; }
		}
		
		
		// 2. The write-in function of output files.
		
		/// <summary> Nothing is treated.
		/// 
		/// </summary>
		/// <param name="aStr">a <var>String</var> value<p/>
		/// </param>
		/// <param name="aDataPack">an <var>Object</var> value<p/>
		/// </param>
        //public override void  makeStringData(String aStr, OhDataPack aDataPack)
        //{
        //}
		
        // Ē`KvH
		
		/// <summary> Though this method is defined in the base class
		/// (Ref "OhOutputFile")
		/// it is redifined in
		/// (Ref "OhOutputFileDouble")
		/// 
		/// 
		/// <p/>
		/// o̓f[^̏ <p/>
		/// 
		/// ܂Ao̓t@C _objectName ǉ[hŃI[vA
		/// I[vłȂꍇ return ܂B<p/>
		/// 
		/// ɁAMf[^pbNz _dataPackArray ̐擪Ɋi[
		/// Ăf[^pbN珇Ԃ
		/// (Ref "OhDataPackDouble#dpack2Ofile(PrintWriter)") p
		/// o̓t@CɋL܂B<p/>  <p/>
		/// 
		/// Mf[^pbN͂̃\bh̒Ŏ擾܂Bf 
		/// OhOutputFile ͎M[q̔hfłāAf[^pbN
		/// XgbN@\͂܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="IOException">if an error occurs
		/// </exception>
        //public override void  outputData()
        //{
			
        //    OhArrayList dpArray = new OhArrayList();
        //    OhArrayList[] dpArrayArray = new OhArrayList[]{dpArray}; //; For work.
			
        //    int numOfDps = 0;
        //    int[] numOfDpsArray = new int[]{numOfDps}; //; For work.
			
        //    getDataPackArray(dpArrayArray, numOfDpsArray);
			
        //    dpArray = dpArrayArray[0];
        //    numOfDps = numOfDpsArray[0];
			
			
        //    // _dataPackArray is not updated.
        //    //
        //    if (((OhDataPack) dpArray[numOfDps - 1]).getDataTime().compareTo(_lastDataTime) <= 0)
        //        return ;
			
			
        //    /* first time output */
			
        //    if (_lastDataTime == OhTimePoint.OhTimePointMin)
        //        writeHeader();
			
        //    ////////////////////////////////////////////////
        //    // Additional writing.
        //    //
        //    // 
        //    // ݗpo̓t@C̒ǉI[vB
        //    // 
        //    //
        //    StreamWriter bw = null;
			
        //    try
        //    {
        //        //UPGRADE_WARNING: ȂƂ 1 ̎A^[Qbg R[h 2 ȏgp܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1181'"
        //        //UPGRADE_TODO: RXgN^ 'java.io.FileWriter.FileWriter' ́ÄقȂ 'System.IO.StreamWriter' ɕϊ܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1073_javaioFileWriterFileWriter_javalangString_boolean'"
        //        //UPGRADE_TODO: Class 'java.io.FileWriter' ́ÄقȂ 'System.IO.StreamWriter' ɕϊ܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1073_javaioFileWriter'"
        //        bw = new StreamWriter(new StreamWriter(_objectName, true, Text.Encoding.Default).BaseStream, new StreamWriter(_objectName, true, Text.Encoding.Default).Encoding);
        //    }
        //    catch (IOException e)
        //    {
        //        throw e;
        //    }
			
			
        //    StreamWriter pw = new StreamWriter(bw.BaseStream, bw.Encoding);
			
        //    if (((OhDataPack) dpArray[0]).getDataTime().compareTo(OhTimePoint.OhTimePointMin) == 0)
        //    {
        //        ((OhDataPack) dpArray[0]).dpack2Ofile(pw);
        //        pw.Write(NEWLINE);
        //    }
			
			
        //    int k = 0;
			
        //    // Skip the data which have been output.
        //    //
        //    for (k = 0; k < numOfDps; k++)
        //    {
        //        if (((OhDataPack) dpArray[k]).getDataTime().compareTo(_lastDataTime) > 0)
        //            break;
        //    }
			
			
        //    /* output the data */
			
        //    for (; k < numOfDps; k++)
        //    {
        //        ((OhDataPack) dpArray[k]).dpack2Ofile(pw);
        //        pw.Write(NEWLINE);
        //    }
			
        //    //UPGRADE_NOTE: \bh 'java.io.PrintWriter.close' ɑ .NET ̏ăX[ꂽÓAقȂ\܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1099'"
        //    pw.Close();
			
        //    _lastDataTime = ((OhDataPack) dpArray[numOfDps - 1]).getDataTime();
			
        //    reduceDataPackStock();
        //}
		
        /// <summary>
        /// NXAf[^^Ȃǂ̊{𕶎ƂĕԂ܂B
        /// </summary>
        /// <returns>
        /// a <var>String</var> value<p/>
        /// NX̊{
        /// </returns>
		public override String basicInfo()
		{
			return "classname: " + _className + NEWLINE 
                 + "not an abstact class" + NEWLINE 
                 + "datatype it records: " + DataType;
		}
		
		// @end{methods} ---------------------------------------------
	} // OhOutputFileDouble
}