// OhOutputPort; base class for creating output ports. 
// Last update : 2008/02/26 21:42:54 
using System;
using OhymosNet;

namespace OhymosNet
{

    /// <summary>
    /// {^o͒[qf\NXłB
    /// ۃNXłB
    /// ̃NX<a href = "OhymosNet.OhReceivePort.html">OhReceivePort</a>
    /// pĂ܂B<p/>
    /// OhOutputPort;
    /// 
    /// Base class for creating output ports. <p/>
    /// This is a abstract class.
    /// It extends <a href = "OhymosNet.OhReceivePort.html">OhReceivePort</a> class.
    /// </summary>
    /// <remarks>
    /// Šn̏o͒[q쐬邽߂̊NXłB <p/>
    /// ۃNXłB<p/>
    /// 
    /// {^o͒[q́AŠn̏o͒[q쐬邽߂̒ۃNXłB
    /// [ÚÃNXpđŠn̏o͒[q̃f쐬ĂB
    /// {^o͒[q̃NX錾ł́A[Uׂo͒[q̊{dl߂Ă܂B
    /// ܂A̎ł͎Oɗpӂł@\`Ă܂B<p/>
    /// 
    /// Šnf́Å{^o͒[q̃NXpă[U쐬
    /// o͒[qʂăf[^[Uɒ񋟂̂ƂĐ݌vĂ܂B<p/>
    /// 
    /// o͒[qo̓f[^[Uɗ^ƂӖł́A
    /// o͒[q́A{^vff̑M[qɎĂ܂ASʂ̂̂
    /// l悢łB<p/>
    /// 
    /// Šnf́At@CóAf[^x[XóAL[{[h́A
    /// CRT o͂ȂǁAXGȃf[^̓o͂ɑΉȂ΂Ȃ܂B
    /// Šnf́AGȃf[^n̓Ɏ荞ގ́A
    /// S <a href="OhymosNet.OhDataPack.html">OhDataPack</a> ^̃f[^ɕϊȂ΂Ȃ܂B
    /// ܂AV~[VʂV~[Vs҂ɒ񋟂鎞́A
    /// <a href="OhymosNet.OhDataPack.html">OhDataPack</a> ^Œ~ςĂf[^
    /// V~[Vs҂̖]ރf[^`ɕϊȂ΂Ȃ܂B
    /// ̂悤ȃf[^̕ϊɊւ̓ÍA
    /// [U쐬͒[qEo͒[qōsȂƂɂA
    /// Šnf̕ł́A͒[qEo͒[q̎葱ő삷邱Ƃɂ܂B
    /// Ȃ킿A͒[qEo͒[q́A
    /// ̒^IȏƊȌƂ̒邱ƂɂȂ܂B
    /// </remarks>
    public abstract class OhOutputPort:OhReceivePort
	{
		// @begin {abstract methods} -------------------------------------------
		
		// 1. Connection function.
		
		/// <summary> 
        /// o̓f[^pbÑf[^ľ^𕶎ƂĕԂ܂B<p/>
        /// Returns a string which expresses the type of datapacks
        /// received by the current object.
        /// </summary>
        /// <remarks>
        /// ۃvpeBłBhNXŒ`ĂB<p/>
        /// 
        ///  This is a abstract
		/// method. This function must be defined in derived classes.
        /// </remarks>
		/// <returns> a <var>String</var> value<p/>
		/// </returns>
        public abstract override String DataType { get;}
		
		
		// 2. The function which outputs receiving data.
		
		/// <summary> 
        /// ŠnŎMf[^pbNA
        /// [U̖]ތ`ɕϊđŠnOɏo͂܂B<p/>
        /// Gets datapacks from the sender and output it.
        /// </summary>
        /// <remarks>
        /// ۃ\bhłB<p/>
        /// 
        /// eo͒[qŎMf[^pbN쐬A
        /// f[^o͂郁\bh`ĉB<p/>
		/// This is an abstract method declaration.
		/// It must be implemented in subclasses which extend
		/// this (Ref "OhOutputPort") class.
        /// </remarks>
		public abstract void  outputData();
		
		// @end {abstract methods} ---------------------------------------------
		
		
		// @begin{initialization} ----------------------------------------------
		
		/// <summary> 
        /// IuWFNgAIuWFNgԍ܂B<p/>
        /// Initialization.
		/// 
		/// </summary>
		/// <param name="aPortName">a <var>String</var> value<p/>
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
		/// </param>
		public override void  init(String aPortName, int aPortNum)
		{
			base.init(aPortName, aPortNum);
		}

        
		// @end{initialization} ------------------------------------------------
		
		
		// @begin {constructors} -----------------------------------------------
		
		/// <summary> 
        /// ftHgRXgN^łB<p/>
        /// Creates a new default <var>OhOutputPort</var> instance.
        /// </summary>
        /// <remarks>
        /// ftHgRXgN^
        /// <a href="OhOutputPort.html#init(java.lang.String, int)">OhOutputPort.init(String, int)</a>
        /// s܂B
        /// ̌ʁAȉ̐ݒƂȂ܂B<p/>
        /// 
        /// <dl>
        /// <li> _objectName        : null</li>
        /// <li> _objectNumber      : -1</li>
        /// </dl>
        /// 
        /// <p/>
        /// ̑̃oϐɑ΂鏈͈RXgN^ƓłB
        /// ̏ꍇA
        /// <a href="OhOutputPort.html#init(java.lang.String, int)">OhOutputPort.init(String, int)</a>
        /// păoϐĉB
        /// </remarks>
		public OhOutputPort():base()
		{
			_className = "OhOutputPort";
		}
		
		/// <summary> 
        /// IuWFNgAIuWFNgԍw肵āA
        /// V<var>OhOutputPort</var>CX^X𐶐܂B<p/>
        /// Creates a new <var>OhOutputPort</var> instance.
		/// 
		/// </summary>
        /// <remarks>NX <a href="OhReceivePort.html">OhReceivePort</a> ̃ftHgRXgN^pA
        /// <a href="OhOutputPort.html#init(java.lang.String, int)">OhOutputPort.init(String, int)</a>
        /// pāA
        /// oϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhOutputPort"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _sender            : null</li>
        /// </dl>
        /// </remarks>
		/// <param name="aPortName">a <var>String</var> value<p/>
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
		/// </param>
		public OhOutputPort(String aPortName, int aPortNum):base()
		{
			_className = "OhInputPort";
			init(aPortName, aPortNum);
		}
		
		// @end {constructors} -------------------------------------------------
	} // OhOutputPort
}