// OhPort; class to express a port </(#)>
// Made "OhPort.java" by Ohshima.
// Modified and tested by Naoto Ohshima. Date:2007/10/16 16:45:53
// Last update : 2008/02/26 21:46:03
using System;
using System.IO;
using OhymosNet;

namespace OhymosNet
{

    /// <summary>
    /// {^[qf\NXłB <p/>
    /// [q쐬邽߂̊ƂȂ钊ۃNXłB
    /// ̃NX<a href ="OhymosNet.OhObject.html">OhObject</a>
    /// pĂ܂B<p/>
    /// OhPort; <p/>
    /// OhPort is the base class from which all port classes are derived. 
    /// It extends <a href ="OhymosNet.OhObject.html">OhObject</a> class.<p/>
    /// </summary>
    /// 
    /// <remarks>
    /// NX OhPort ́ASĂ̒[qf̊NXłB
    /// [qׂ{Iȃ\bh`Ă܂B
    /// \bḧꕔ́ÃNXł͒`^Aۃ\bhɂȂĂ܂B
    /// <br/>
    /// <p/>
    /// We call an object of class OhPort or classes inherited from class Port a "port". <br/>
    /// In ohymosj, a port is used for sending and/or receiving datapacks. <p/>
    /// 
    /// Basic methods which a port should have are declared. <br/>
    /// Parts of those basic methods are declared as pure virtual.
    /// 
    /// </remarks>
    public abstract class OhPort : OhObject
    {
        // @begin{properties} ---------------------------------------------

        /// <summary> <japanese>
        /// ŌẪf[^̋L^擾܂B
        /// </japanese>
        /// <p/>
        /// This method returns the oldest data time.
        /// 
        /// </summary>
        /// <returns> an <var>OhTimePointImmutable</var> value
        /// </returns>
        public abstract IOhTimePointImmutable OldestDataTime { get;}
        /// <summary> <japanese>
        /// ŐṼf[^̋L^擾܂B
        /// </japanese>
        /// <p/>
        /// This method returns the updated data time.
        /// 
        /// </summary>
        /// <returns> an <var>OhTimePointImmutable</var> value
        /// </returns>
        public abstract IOhTimePointImmutable NewestDataTime { get;}
        /// <summary> <japanese>
        /// f[^pbŇ擾܂B
        /// </japanese>
        /// <p/>
        /// This method returns the number of data packs.
        /// 
        /// </summary>
        /// <returns> an <var>int</var> value
        /// </returns>
        public abstract int NumberOfDataPacks { get;}
        /// <summary> <japanese>
        /// f[^Kv擾܂B<p/>
        /// 
        /// getNecessaryTimeFrom f[^L^f[^pbŃA
        /// <a href="OhPort.html#reduceDataPackStock()">OhPort.reduceDataPackStock()</a>
        /// ɂ܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <returns> an <var>OhTimePointImmutable</var> value
        /// </returns>
        public abstract IOhTimePointImmutable NecessaryTimeFrom { get;}
        /// <summary> <japanese>
        /// f[^Kv擾܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <returns> an <var>OhTimePointImmutable</var> value
        /// </returns>
        public abstract IOhTimePointImmutable NecessaryTimeTo { get;}
        
        /// <summary>
        /// f[^̌^擾܂B<p/>
        /// ۃ\bhłB<p/>
        /// 
        /// Gets data Type.<p/>
        /// Abstract method. <p/>
        /// </summary>
        /// <remarks>
        /// 
        /// ̃\bh̎́A
        /// <a href="OhSendDouble.html">OhSendDouble</a>,
        /// <a href="OhInputFileDouble.html">OhInputFileDouble</a>,
        /// <a href="OhRelayDouble.html">OhRelayDouble</a>,
        /// <a href="OhReceiveDouble.html">OhReceiveDouble</a>,
        /// <a href="OhOutputFileDouble.html">OhOutputFileDouble</a>
        /// ŗ^邱Ƃɂ܂B
        /// int, long, float ɂĂlłB
        /// 
        /// Ⴆ΁AMf[^ int Ȃ "int" Ԃ悤ɒ`܂B
        ///
        /// <p/>
        /// 
        /// 
        /// This method gets string DataType which shows the type of datapacks treated by the port. <p/>
        /// Because this method is declared as abstract,
        /// in a derived class of class OhPort
        /// the definition of this method must be given by a programmer.
        /// </remarks>
        /// 
        /// 
        /// <returns> a <var>String</var> value
        /// </returns>
        public abstract String DataType{ get;}
        // @end{properties} ---------------------------------------------


        // @begin{abstract methods} ---------------------------------------------


        /// <summary> 
        /// vZƑO̊mFsȂ܂B <p/>
        /// ۃ\bhłB <p/>
        /// 
        /// Confirm whether all connection work has been done successfully or not. <p/>
        /// An abstract method.<p/>
        /// </summary>
        /// <remarks>
        /// ڑƌAvZƑO̊mFɗp܂B
        /// ڑƂIAvZƂɐiނƂłꍇ true ԂA
        /// ڑƂIĂȂꍇ false Ԃ܂B
        /// 
        /// 
        /// <p/>
        /// In class <a href="OhPort.html">OhPort</a>,
        /// which is an abstract class, method areYouReady() is an abstract method.
        /// </remarks>
        /// 
        /// <returns> a <var>bool</var> value
        /// <pre>
        /// <ul>
        /// <li>true   ڑƂIĂB</li>
        /// <li>false  ڑƂIĂȂB</li>
        /// </ul></pre>
        /// </returns>
        public abstract bool areYouReady();


        // 1. Function for acquiring datapacks.

        /// <summary> 
        /// f|^pbN̔z񃊃Xgݒ肵܂B<p/>
        /// ۃ\bhłB<p/>
        /// 
        /// This method makes data pack array.<p/>
        /// Abstract method.
        /// </summary>
        /// <remarks>
        /// ۂɂ́A
        /// _dataPackArray ̗vf _numberOfDataPacks ɐݒ肷邾łB
        /// </remarks>
        public abstract void setDataPackArray();


        /// <summary>
        /// 擾\f[^pbN̊mFsȂ܂B<p/>
        /// ۃ\bhłB<p/>
        /// 
        /// Comfirm whether be able to get data pack.
        /// </summary>
        /// <remarks>
        /// canYouGetData(OhTimePoint aTFrom, OhTimePoint aTTo) , aTFrom ȑOA
        /// aTTo ȍ~܂ł̃f[^pbN̒[q擾\Ȃ΁A
        /// true ԂAs\Ȃ false Ԃ悤ɊehNXŒ`܂B
        /// 
        /// <pre>
        /// ARGUMENT:
        /// <ul>
        /// <li>EaTFrom    aTFrom ȑÕf[^pbN擾\ł邱ƂmFB</li>
        /// <li>EaTTo      aTTo ȍ~܂ł̃f[^pbN擾\ł邱ƂmFB</li>
        /// RETURN:
        /// <li>EYES       aTFrom ȑO aTTo ȍ~܂ł̃f[^pbN擾\ȏꍇB</li>
        /// t ɂf[^擾\ȏꍇ:
        /// <li>ENO        aTFrom ȑO aTTo ȍ~܂ł̃f[^pbN擾s\ȏꍇB</li>
        /// </ul></pre>
        /// 
        /// <p/>
        /// Inquire whether the invoking port can get data from "aTFrom" to "aTTo".
        /// 
        /// </remarks>
        /// <param name="aTFrom">an <var>OhTimePointImmutable</var> value
        /// </param>
        /// <param name="aTTo">an <var>OhTimePointImmutable</var> value
        /// </param>
        /// <returns> a <var>bool</var> value
        /// </returns>
        public abstract bool canYouGetData(IOhTimePointImmutable aTFrom, IOhTimePointImmutable aTTo);


        /// <summary>
        /// f[^pbN̔z񃊃Xg擾(M)܂B<p/>
        /// 
        /// Get a datapack array.
        /// </summary>
        /// <remarks>
        /// hNXɂāAf[^pbNz擾郁\bh`܂B
        /// aDpArray ɂ̓f[^pbNzi[AaNumOfDp ɂ́AaDpArray ̗vfi[܂B
        /// </remarks>
        /// 
        /// <param name="aDpArray">an <var>OhArrayList[]</var> value
        /// </param>
        /// <param name="aNumOfDp">an <var>int[]</var> value
        /// </param>
        public abstract void getDataPackArray(OhArrayList[] aDpArray, int[] aNumOfDp);


        /// <summary>
        /// wɂf[^pbN擾(M)܂B<p/>
        /// Get datapacks by specifing the datatime.
        /// </summary>
        /// <remarks>
        /// hNXɂāAw肵ăf[^pbN擾郁\bh`܂B<p/>
        /// 
        /// aFormer ɂ́Af[^L^ aDataTime ȑO aDataTime ɍł߂^f[^pbN擾Ai[܂B<br/>
        /// aLater ɂ́Af[^L^ aDataTime ȍ~ aDataTime ɍł߂^f[^pbN擾Ai[܂B<p/>
        /// 
        /// aFlag ͎擾̃[hI邽߂̃IvVŁAL̒ʂłB
        /// 
        /// <pre><dl>
        /// <dt>E"b"</dt>    
        /// <dd>aFormer, aLater ̗K擾<p/>
        /// 擾łȂꍇ́AƂ NULL ɐݒ肷B</dd>
        /// <dt>E"f"</dt>       
        /// <dd>aLater 擾łȂĂAaFormer ̂ݎ擾B<p/>
        /// aLater 擾łȂꍇANULL ɐݒ肷B</dd>
        /// <dt>E"l"</dt>       
        /// <dd>aFormer 擾łȂĂAaLater ̂ݎ擾B<p/>
        /// aFormer 擾łȂꍇANULL ɐݒ肷B</dd>
        /// <dt>Ȇ</dt>    
        /// <dd>aFormer, aLater ̂ȂƂ擾B<p/>
        /// 擾łȂ̂ NULL ɐݒ肷B</dd>
        /// </dl></pre>
        /// 
        /// aFlag ̃ftHgĺA "b" łB<p/>
        /// ܂A  aLater nȂꍇ́A aFlag  f Ƃ aFormer ̂ݎ擾A
        ///  aFormer nȂꍇ́A aFlag  l Ƃ aLater ̂ݎ擾܂B<p/>
        /// 
        /// f[^L^x aDataTime łf[^pbN^Ăꍇ́A
        /// aFormer, aLater Ƃi[܂B<p/>
        /// 
        /// 𖞂f[^pbN擾łȂꍇAaFormer, aLater  null ɐݒ肳܂B<p/>
        /// 
        /// f[^擾łꍇ́Atrue Ԃ܂B
        /// </remarks>
        /// <param name="aFormer">an <var>Object[]</var> value
        /// </param>
        /// <param name="aDataTime">an <var>OhTimePoint</var> value
        /// </param>
        /// <param name="aLater">an <var>Object[]</var> value
        /// </param>
        /// <param name="aMode">a <var>char</var> value
        /// </param>
        /// <returns> a <var>bool</var> value
        /// </returns>
        public abstract bool getDataPack(Object[] aFormer, OhTimePoint aDataTime, Object[] aLater, char aMode);


        /// <summary>
        /// svf[^pbN܂B<p/>
        /// </summary>
        /// <remarks>
        /// ̒[qŎ擾\ȃf[^pbN̂A
        /// getNecessaryTimeFrom() f[^L^f[^pbN悤A
        /// hNXŒ`܂B
        ///</remarks>
        public abstract void reduceDataPackStock();

        /// <summary>
        /// f[^x[Xp[q̏qłB<p/>
        /// T[oAf[^x[XAe[uAIuWFNgԍ܂B
        /// </summary>
        /// <param name="aServerName"></param>
        /// <param name="aDBName"></param>
        /// <param name="aTableName"></param>
        /// <param name="aPortNum"></param>
        //public abstract void init(string aServerName, string aDBName, string aTableName, int aPortNum);

        // @end{abstract methods} ----------------------------------------------


        // @begin{initialization} ----------------------------------------------

        /// <summary> <japanese>
        /// IuWFNgAIuWFNgԍ܂B<p/>
        /// 
        /// RXgN^Ŏgp܂B
        /// </japanese>
        /// <p/>
        /// Initialization.
        /// 
        /// </summary>
        /// <param name="aPortName">a <var>String</var> value
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value
        /// </param>
       /// <exception cref="OhError">if an error occurs
        /// </exception>
        public override void init(String aPortName, int aPortNum)
        {
            base.init(aPortName, aPortNum);
        }

        /// <summary>
        /// IuWFNgAIuWFNgԍAǂݍރXg[aSrw肵܂B
        /// ̏q̓f[^x[X̓͒[qŗpA
        /// <a href = "OhymosNet.OhInputDB.init.html">OhInputDB.init(string, int, OhStreamReader)</a>
        /// Ē`Ă܂B
        /// </summary>
        /// <param name="aPortName"></param>
        /// <param name="aPortNum"></param>
        /// <param name="aSr"></param>
        public virtual void init(String aPortName, int aPortNum, OhStreamReader aSr)
        {
            base.init(aPortName, aPortNum);
        }

        // @end{initialization} ------------------------------------------------


        // @begin{constructors} -------------------------------------------------

        /// <summary> 
        /// ftHgRXgN^łB
        /// oϐ܂B<p/>
        /// Creates a new default <var>OhPort</var> instance.
        /// </summary>
        /// <remarks>
        /// ̓Iɂ̓oϐȉ̒ʂ菉܂B
        /// <pre><ul>
        /// <li>E_className    : "OhPort"</li>
        /// <li>E_objectName   : null</li>
        /// <li>E_objectNumber : -1</li>
        /// <li>E_owner        : null</li>
        /// </ul></pre>
        /// </remarks>
        /// 
        /// 
        public OhPort()
            : base()
        {
            _className = "OhPort";
        }

        /// <summary>
        /// Ɏw肳ꂽoϐ OhPort 쐬܂B<p/>
        /// Creates a new default <var>OhPort</var> instance.
        /// </summary>
        /// <remarks>
        /// ̓Iɂ<a href="OhPort.html#init(java.lang.String, int)">OhPort.init(String, int)</a>
        ///  aObjNum, aObjNum nAoϐȉ̒ʂ菉܂B
        /// <pre>
        /// <ul>
        /// <li>E_className    : "OhPort"</li>
        /// <li>E_objectName   : aObjName</li>
        /// <li>E_objectNumber : aObjNum</li>
        /// <li>E_owner        : null</li>
        /// </ul>
        /// </pre>
        /// </remarks>
        /// 
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// [q
        /// </param>
        /// <param name="aPortNumber">an <var>int</var> value<p/>
        /// [qԍ
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public OhPort(String aPortName, int aPortNumber)
            : base()
        {
            _className = "OhPort";
            init(aPortName, aPortNumber);
        }

        // @end{constructors} ---------------------------------------------------


        // @begin{methods} ------------------------------------------------------

        /// <summary>
        /// M[qo^܂B<p/>
        /// 
        /// Sets the sender.
        /// </summary>
        /// <remarks>
        /// ̃NX̔hNXł́A
        /// OhPort ^̑M[q̃AhX aSender ƂĎ󂯂ƂA
        /// aSender 𑗐MƂĐݒ肷悤ɒ`ĂB
        /// ݒłȂG[bZ[Wo͂悤ɐݒ肵ĂƗǂł傤B<p/>
        /// 
        /// ̃\bh́AG[bZ[Wo͂܂B
        /// hNXŁAsetSender() Ē`Ȃꍇ́AꂪAdefault ̒`ɂȂ܂B
        /// 
        /// <p/>
        /// 
        /// 
        /// There is only one sender for each receiver.
        /// This method returns whether it succeeded or not. <p/>
        /// 
        /// Although a default definition is given in the Port class,
        /// a programmer must give his own definitions in derived classes.
        /// </remarks>
        /// 
        /// <param name="aSender">an <var>OhPort</var> value
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public virtual void setSender(OhPort aSender)
        {
            //; (*1)
           
            StringWriter sw = new StringWriter();
            oPrint(sw, " > ");

            if (aSender != null)
                aSender.oPrint(sw, " >   sender > ");

            String str = sw.ToString();
            sw.Close();
           
            throw new OhError("This Port cannot set sender. ", str);
        }


        /// <summary>
        /// M[qo^܂B<p/>
        /// </summary>
        /// <remarks>
        /// Register a receiver of this port.
        /// ̃NX̔hNXł́A
        /// Object ^ɃLXgꂽM[q̃AhX aReceiver ƂĎ󂯂ƂA
        /// aReceiver 𑗐MƂēo^悤ɒ`ĂB
        /// o^łȂG[bZ[Wo͂悤ɐݒ肵ĂƗǂł傤B<p/>
        /// 
        /// ̃\bh́AG[bZ[Wo͂܂B
        /// hNXŁAregisterReceiver() Ē`Ȃꍇ́AꂪAdefault ̒`ɂȂ܂B
        /// 
        /// <p/>
        /// 
        /// 
        /// There may be more than one receiver for a sender port.
        /// This method returns whether it suceeded or not. <p/>
        /// 
        /// Although a default definition is given here,
        /// a programmer must give his own definitions in derived classes.
        /// </remarks>
        /// 
        /// <param name="aReceiver">an <var>OhObject</var> value
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public virtual void registerReceiver(OhObject aReceiver)
        {
            //; (*2)
            StringWriter sw = new StringWriter();
            oPrint(sw, " > ");

            if (aReceiver != null)
                aReceiver.oPrint(sw, " >   receiver > ");

            String str = sw.ToString();
            sw.Close();
          
            throw new OhError("This Port cannot register receiver. ", str);
        }


        /// <summary> 
        /// [q̐ڑƂ̏Iуf[^MJn̂߂̏ƂsȂ܂B<p/>
        /// 
        /// Finish registration of receivers and count the number of receivers.
        /// </summary>
        /// <remarks>
        /// ̃NX̔hNXŁA[q̐ڑƂ̏IƂ̎d̏s悤`܂B<p/>
        /// 
        ///  true As false Ԃ܂B
        /// ̃\bh́AG[bZ[Wo͌ false Ԃ܂B<p/>
        /// 
        /// <a href="OhReceivePort.html">OhReceivePort</a> ł́AڑƌsȂׂ͓ɂ܂B
        ///  true Ԃ悤ɒ`܂B<p/>
        /// 
        /// <a href="OhSendPort.html">OhSendPort</a> ł́A̎M[qɃf[^𑗐M邱Ƃ̂ŁA
        /// M port Xg _bufferList Ɏ^Ă܂B
        /// ŏIIɂ́AXgɓo^ꂽM port z _receiversArray Ɉڂւ܂B
        /// ̍Ƃ <a href="OhSenderPort.html#doSwitch()">OhSenderPort.doSwitch()</a> Ŏs܂
        /// i<a href="OhSendPort.html">OhSendPort</a> ́A
        /// <a href="OhSenderPort.html">OhSenderPort</a> ̔hNXjB<p/>
        /// 
        /// ̌AڑIāAvZn߂܂B
        /// ̎A_dataPackArray ̏܂B
        /// Ȃ킿A_numberOfDataPacks ̒l -1  0 ɐݒ肵܂B<p/>
        /// 
        /// 
        /// In a derived class, do work which finishes connection operations.
        /// </remarks>
        /// 
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public virtual void doSwitch()
        {
            //;(*3)
            throw new OhError("This Port cannot switch. ", oPrintString(" > "));
        }

        /// <summary>
        /// vZv󂯂܂B<p/>
        /// 
        /// Request of calculation.
        /// </summary>
        /// <remarks>
        /// vZv󂯕t郁\bhłB
        /// z\bhłāANX <var>OhPort</var> ł͉Ȃ悤ɒ`Ă܂B<p/>
        /// 
        /// <var>OhPort</var> ̔hNXł̂悤ɒ`Ă܂B
        /// 
        /// <ol>
        /// <li> <a href="OhSendPort.html#calReq()">OhSendPort.calReq()</a> ́A
        ///  <a href="OhSendPort.html">OhSendPort</a> LĂvfɌvZv]܂B</li>
        /// <li> <a href="OhRelayPort.html#calReq()">OhRelayPort.calReq()</a> ́A
        ///  <a href="OhRelayPort.html">OhRelayPort</a> Ƀf[^𑗐MĂ[qɌvZv]܂B</li>
        /// <li> <a href="OhReceivePort.html#calReq()">OhReceivePort.calReq()</a> ́A
        ///  <a href="OhReceivePort.html">OhReceivePort</a> Ƀf[^𑗐MĂ[qɌvZv]܂B</li>
        /// </ol>
        /// <p/>
        /// 
        /// 
        /// Transfer the request to a element which does actual caluculation work or ports
        /// which send datapack to the current port.
        /// </remarks>
        /// 
        /// <exception cref="OhCannotGetDataError">if an error occurs
        /// </exception>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public virtual void calReq()
        {
        }


        // 1. Function for acquiring datapacks.

        /// <summary>
        /// f[^pbN̎^mF܂B<p/>
        /// </summary>
        /// <remarks>
        /// ̃\bh́AaT() ɂf[^擾\mF郁\bhłB
        /// ̃NX̓̒ۃ\bhĂяoĂ܂B
        /// 
        /// <p/>
        /// Inquire whether the invoking port can get data at <a href="OhTimePoint.html">OhTimePoint</a> "aT".
        /// </remarks>
        /// 
        /// <param name="aT">an <var>OhTimePoint</var> value
        /// </param>
        /// <returns> a <var>bool</var> value
        /// </returns>
        public virtual bool canYouGetData(OhTimePoint aT)
        {
            return canYouGetData(aT, aT); // Abstract method call.
        }


        /// <summary>
        /// wɂf[^pbN𑗐M(擾)܂B<p/>
        /// </summary>
        /// <remarks>
        /// hNXɂāAw肵ăf[^pbN擾郁\bh`܂B
        /// ̃NX̓̒ۃ\bhĂяoĂ܂B<p/>
        /// 
        /// aFormer ɂ́Af[^L^ aDataTime ȑO aDataTime ɍł߂^f[^pbN擾Ai[܂B<p/>
        /// 
        /// f[^L^x aDataTime łf[^pbN^Ăꍇ́A
        /// aFormer ɂi[܂B<p/>
        /// 
        /// 𖞂f[^pbN擾łȂꍇAaFormer  null ɐݒ肳܂B<p/>
        /// 
        /// f[^擾łꍇ́Atrue Ԃ܂B
        ///
        /// </remarks>
        /// 
        /// <param name="aFormer">an <var>Object[]</var> value
        /// </param>
        /// <param name="aDataTime">an <var>OhTimePoint</var> value
        /// </param>
        /// <returns> a <var>bool</var> value
        /// </returns>
        public virtual bool getDataPack(Object[] aFormer, OhTimePoint aDataTime)
        {
            Object[] dummy = new Object[] { null };
            return getDataPack(aFormer, aDataTime, dummy, 'f'); // Abstract method call.
        }


        /// <summary>
        /// wɂf[^pbN𑗐M(擾)܂B
        /// </summary>
        /// <remarks>
        /// hNXɂāAw肵ăf[^pbN擾郁\bh`܂B
        /// ̃NX̓̒ۃ\bhĂяoĂ܂B<p/>
        /// 
        /// aLater ɂ́Af[^L^ aDataTime ȍ~ aDataTime ɍł߂^f[^pbN擾Ai[܂B<p/>
        /// 
        /// f[^L^x aDataTime łf[^pbN^Ăꍇ́A
        /// aLater ɂi[܂B<p/>
        /// 
        /// 𖞂f[^pbN擾łȂꍇAaLater  null ɐݒ肳܂B<p/>
        /// 
        /// f[^擾łꍇ́Atrue Ԃ܂B
        /// </remarks>
        /// 
        ///
        /// <param name="aDataTime">an <var>OhTimePoint</var> value
        /// </param>
        /// <param name="aLater">an <var>Object[]</var> value
        /// </param>
        /// <returns> a <var>bool</var> value
        /// </returns>
        public virtual bool getDataPack(OhTimePoint aDataTime, Object[] aLater)
        {
            Object[] dummy = new Object[] { null };
            return getDataPack(dummy, aDataTime, aLater, 'l'); // Abstract method call.
        }


        // 2. Object information output function.

        /// <summary> <japanese>
        /// IuWFNgo͂܂B
        /// </japanese>
        /// 
        /// </summary>
        /// <param name="aSw">a <var>StreamWriter</var> value
        /// </param>
        /// <param name="aHead">a <var>String</var> value
        /// </param>
        public override void cPrint(StreamWriter aSw, String aHead)
        {
            base.cPrint(aSw, aHead);
            //aSw.Write(aHead + _className + " " + _objectName + " " + _objectNumber + NEWLINE);
        }


        /// <summary>
        /// ڑo͂܂B<p/>
        /// </summary>
        /// <remarks>
        /// hNXŐڑ\悤`܂B
        /// ̃NXł́AG[bZ[Wo͂܂B
        ///</remarks>
        /// 
        /// 
        /// <param name="aSw">a <var>StreamWriter</var> value
        /// </param>
        /// <param name="aHead">a <var>String</var> value
        /// </param>
        public virtual void printConnection(StreamWriter aSw, String aHead)
        {
            oPrint(aSw, aHead);
            aSw.WriteLine(aHead + "    This port is not connected." );
        }
        
        // 3. addition

        /// <summary>
        /// [q쐬܂B<p/>
        /// Creates a port which has the class name specified by the argument.
        /// </summary>
        /// <remarks>
        /// ɁA[qf\NXType^^ƁA
        /// ̒[qf̃IuWFNg𐶐܂B<p/>
        /// NXType^擾ɂ
        /// NX̃tl[OhymosNet.OhSampleƂ
        /// <code>
        /// Type.GetType("OhymosNet.OhSample");
        /// </code>
        /// ̂悤ɂ܂B<p/>
        /// 
        /// w肳ꂽNX͖O OhymosNet ɑ̂Ƃ܂B
        /// <p/>
        /// <example><code>
        /// // NX̊܂܂AZu
        /// OhAssembly a ;
        /// 
        /// // ^NX
        /// string className = "Storage";
        /// 
        /// // NX^擾
        /// Type t = a.GetType("OhymosNet." + className );
        /// OhPort p = OhPort.create("OhSendDouble");
        /// </code></example>
        /// </remarks>
        /// 
        /// 
        /// <param name="aType">a <var>Type</var> value
        /// </param>
        /// <returns> an <var>OhPort</var> value
        /// </returns>
        public static OhPort create(Type aType)
        {
            OhPort port = null;
            port = (OhPort)Activator.CreateInstance(aType);
            return port;
        }

        // end{methods} --------------------------------------------------------
    } // OhPort
}