//  OhReceiveDouble; class to express a port which receive double data. </(#)>
//                        Made from "OhReceiveDouble.java" by Ohshima.
//                           Last update : 2008/02/27 11:47:33
// 
using System;
using System.IO;
using System.Collections;
using OhymosNet;

namespace OhymosNet
{


    /// <summary> 
    /// f[^l double ^̃f[^pbNMM[q\NXłB<p/>
    /// ̃NX<a href="OhymosNet.OhReceivePort.html">OhReceivePort</a> pĂ܂B
    /// <p/>
    /// 
    /// OhReceiveDouble;
    /// 
    /// OhReceiveDouble is the base class to express a port which receive double data.
    /// It extends <a href="OhymosNet.OhReceivePort.html">OhReceivePort</a> class.
    /// 
    /// </summary>
    public class OhReceiveDouble : OhReceivePort
    {
        // @begin{initialization} ----------------------------------------------

        /// <summary> 
        /// IuWFNgiM[qjAIuWFNgiM[qjԍ܂B
        /// 
        /// <p/>
        /// Initialization.
        /// 
        /// </summary>
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public override void init(String aPortName, int aPortNum)
        {
            base.init(aPortName, aPortNum);
        }

        // @end{initialization} ------------------------------------------------

        // @begin {constructors} -----------------------------------------------

        /// <summary> 
        /// ftHgRXgN^łB<p/>
        /// Creates a new <var>OhReceiveDouble</var> instance.
        /// </summary>
        /// <remarks>
        /// ftHgRXgN^
        /// <a href="OhReceiveDouble.html#init(String, int)">OhReceiveDouble.init(String, int)</a> s܂B
        /// ̌ʁAȉ̐ݒƂȂ܂B<p/>
        /// 
        /// <dl>
        /// <li> _objectName        : null</li>
        /// <li> _objectNumber      : -1</li>
        /// </dl>
        /// 
        /// <p/>
        /// ̑̃oϐɑ΂鏈͈RXgN^ƓłB
        /// ̏ꍇA<a href="OhReceiveDouble.html#init(String, int)">OhReceiveDouble.init(String, int)</a> 
        /// păoϐĉB
        /// </remarks>
        public OhReceiveDouble()
            : base()
        {
            _className = "OhReceiveDouble";
        }

        /// <summary>
        /// M[qƎM[qԍw肵āA
        /// <var>OhReceiveDouble</var> NX̃CX^X𐶐܂B<p/>
        /// Creates a new <var>OhReceiveDouble</var> port instance by
        /// specifying the port name and the port number.
        /// </summary>
        /// <remarks>
        /// NX̃RXgN^
        /// <a href="OhReceivePort.html#OhReceivePort.OhReceivePort(String, int)">OhReceivePort.OhReceivePort(String, int)</a>
        /// ̃RXgN^păoϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhReceiveDouble"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _sender            : null</li>
        /// </dl>
        /// </remarks>
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
        /// </param>
        /// <param name="aPortNumber">an <var>int</var> value<p/>
        /// M[q
        /// </param>
        public OhReceiveDouble(String aPortName, int aPortNumber)
            : base(aPortName, aPortNumber)
        {
            _className = "OhReceiveDouble";
        }

        // @end {constructors} -------------------------------------------------

        // @begin {property} -------------------------------------------------
        /// <summary> 
        /// Mf[^pbÑf[^ľ^ double \ "double" Ԃ܂B
        /// 
        /// <p/>
        /// Returns the data pack type which expresses the type of data to be received.
        /// 
        /// </summary>
        /// <returns> a <var>String</var> value<p/>
        /// </returns>
        public override String DataType
        {
            //; (*5)
            get { return "double"; }
        }
        // @end {property} -------------------------------------------------


        // @begin {methods} ----------------------------------------------------


        /// <summary> 
        /// f[^Ԍ^w肵āA aT ɂf[^l擾܂B
        /// 
        /// <p/>
        /// Returns data value<p/> at time t.
        /// This data connection type is brokenline or step or pulse.
        /// 
        /// </summary>
        /// <param name="aT">an <var>OhTimePoint</var> value<p/>
        /// 擾f[^l̃f[^L^
        /// </param>
        /// <param name="aDctVec">a <var>ArryaList</var> value<p/>
        /// f[^Ԕz񃊃Xg
        /// </param>
        /// <returns> a <var>double</var> value<p/>
        /// </returns>
        public double getData(OhTimePoint aT, ArrayList aDctVec)
        {
            //; (*1-1)
            double dataValue = 0L;

            OhArrayList dataPackArray = null;
            int numberOfDataPacks = 0;

            OhArrayList[] dataPackArrayArray = new OhArrayList[] { dataPackArray }; //; Array for work.
            int[] numberOfDataPacksArray = new int[] { numberOfDataPacks };

            int ip = 0;

            getDataPackArray(dataPackArrayArray, numberOfDataPacksArray);

            dataPackArray = dataPackArrayArray[0];
            numberOfDataPacks = numberOfDataPacksArray[0];

            if (numberOfDataPacks <= 0)
            {
                throw new OhError("Error in Get_Data", oPrintString(" >"));
            }

            OhTimePoint ta = new OhTimePoint();
            ta.copy(((OhDataPackDouble)dataPackArray[0]).DataTime);
            OhTimePoint tb = new OhTimePoint();
            tb.copy(((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataTime);

            // Ԃ񂢂Ȃ

            //if (aT.CompareTo(ta) <= 0)
            //{
            //    // aT <= ta ?
            //    return ((OhDataPackDouble) dataPackArray[0]).DataValue;
            //}

            //if (aT.CompareTo(tb) >= 0)
            //{
            //    // aT >= tb ?
            //    return ((OhDataPackDouble) dataPackArray[numberOfDataPacks - 1]).DataValue;
            //}

            DataConnectionType dataConnectionType = (DataConnectionType)aDctVec[0];

            if (dataConnectionType == DataConnectionType.BROKENLINE)
            {
                if (aT.CompareTo(ta) <= 0)
                {
                    dataValue = ((OhDataPackDouble)dataPackArray[0]).DataValue;
                }
                else if (aT.CompareTo(tb) >= 0)
                {
                    dataValue = ((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataValue;
                }
                else
                {
                    int ip1 = 0;
                    int ip2 = numberOfDataPacks - 1;

                    OhTimePoint t1 = new OhTimePoint();
                    t1.copy(((OhDataPackDouble)dataPackArray[ip1]).DataTime);

                    OhTimePoint t2 = new OhTimePoint();
                    t2.copy(((OhDataPackDouble)dataPackArray[ip2]).DataTime);

                    while (ip2 - ip1 > 1)
                    {
                        ip = (ip2 + ip1) / 2;
                        OhTimePoint tp = new OhTimePoint();
                        tp.copy(((OhDataPackDouble)dataPackArray[ip]).DataTime);

                        if (tp.CompareTo(aT) < 0)
                        {
                            ip1 = ip;
                            t1.copy(tp);
                        }
                        else if (tp.CompareTo(aT) > 0)
                        {
                            ip2 = ip;
                            t2.copy(tp);
                        }
                        else
                        {
                            return ((OhDataPackDouble)dataPackArray[ip]).DataValue;
                        }
                    }

                    double y1 = ((OhDataPackDouble)dataPackArray[ip1]).DataValue;

                    if (ip1 == ip2)
                    {
                        return y1;
                    }

                    double y2 = ((OhDataPackDouble)dataPackArray[ip2]).DataValue;

                    OhTimePoint aTBackUp = new OhTimePoint();
                    aTBackUp.copy(aT);
                    //;     v = ((aT-t1)*y2                  + (t2-aT)*y1)                  / (t2-t1);
                    dataValue = ((OhTimePoint.sub(aTBackUp, t1).toDouble() * y2 + OhTimePoint.sub(t2, aTBackUp).toDouble() * y1)
                                / OhTimePoint.sub(t2, t1).toDouble());
                }
            }
            else if (dataConnectionType == DataConnectionType.STEP)
            {
                if (aT.CompareTo(ta) <= 0)
                {
                    dataValue = ((OhDataPackDouble)dataPackArray[0]).DataValue;
                }
                else if (aT.CompareTo(tb) >= 0)
                {
                    dataValue = ((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataValue;
                }
                else
                {
                    int ip1 = 0;
                    int ip2 = numberOfDataPacks - 1;

                    OhTimePoint t1 = new OhTimePoint();
                    t1.copy(((OhDataPackDouble)dataPackArray[ip1]).DataTime);

                    OhTimePoint t2 = new OhTimePoint();
                    t2.copy(((OhDataPackDouble)dataPackArray[ip2]).DataTime);

                    while (ip2 - ip1 > 1)
                    {
                        ip = (ip2 + ip1) / 2;

                        OhTimePoint tp = new OhTimePoint();
                        tp.copy(((OhDataPackDouble)dataPackArray[ip]).DataTime);

                        if (tp.CompareTo(aT) < 0)
                        {
                            ip1 = ip;
                            t1.copy(tp);
                        }
                        else if (tp.CompareTo(aT) > 0)
                        {
                            ip2 = ip;
                            t2.copy(tp);
                        }
                        else
                        {
                            return ((OhDataPackDouble)dataPackArray[ip]).DataValue;
                        }
                    }
                    dataValue = ((OhDataPackDouble)dataPackArray[ip2]).DataValue;
                }
            }
            else if (dataConnectionType == DataConnectionType.PULSE)
            {
                if (aT.CompareTo(ta) <= 0)
                {
                    dataValue = 0L;
                }
                else if (aT.CompareTo(tb) >= 0)
                {
                    dataValue = 0L;
                }
                else
                {
                    int ip1 = 0;
                    int ip2 = numberOfDataPacks - 1;

                    OhTimePoint t1 = new OhTimePoint();
                    t1.copy(((OhDataPackDouble)dataPackArray[ip1]).DataTime);

                    OhTimePoint t2 = new OhTimePoint();
                    t2.copy(((OhDataPackDouble)dataPackArray[ip2]).DataTime);

                    while (ip2 - ip1 > 1)
                    {
                        ip = (ip2 + ip1) / 2;

                        OhTimePoint tp = new OhTimePoint();
                        tp.copy(((OhDataPackDouble)dataPackArray[ip]).DataTime);

                        if (tp.CompareTo(aT) < 0)
                        {
                            ip1 = ip;
                            t1.copy(tp);
                        }
                        else if (tp.CompareTo(aT) > 0)
                        {
                            ip2 = ip;
                            t2.copy(tp);
                        }
                        else
                        {
                            return ((OhDataPackDouble)dataPackArray[ip]).DataValue;
                        }
                    }
                    if (aT.CompareTo(t1) == 0)
                    {
                        dataValue = ((OhDataPackDouble)dataPackArray[ip1]).DataValue;
                    }
                    else if (aT.CompareTo(t2) == 0)
                    {
                        dataValue = ((OhDataPackDouble)dataPackArray[ip2]).DataValue;
                    }
                    else
                    {
                        dataValue = 0L;
                    }
                }
            }
            else
            {
                throw new OhError("Illegal data_connection_type.", oPrintString("> "));
            }

            return dataValue;
        }




        /// <summary> 
        ///  aT ɂf[^l擾܂B
        /// f[^l̕Ԃ͐܂Ƃ܂B
        /// 
        /// <p/>
        /// Returns the data value<p/> at time t.
        /// This data connection type is brokenline.
        /// 
        /// </summary>
        /// <param name="aT">an <var>OhTimePoint</var> value<p/>
        /// 擾f[^l̃f[^L^
        /// </param>
        /// <returns> a <var>double</var> value<p/>
        /// f[^l
        /// </returns>
        public double getData(OhTimePoint aT)
        {
            //; (*1-2)
            double dataValue = 0L;

            OhArrayList dataPackArray = null;
            int numberOfDataPacks = 0;

            OhArrayList[] dataPackArrayArray = new OhArrayList[] { dataPackArray }; //; Array for work.
            int[] numberOfDataPacksArray = new int[] { numberOfDataPacks };

            int ip = 0;

            getDataPackArray(dataPackArrayArray, numberOfDataPacksArray);

            dataPackArray = dataPackArrayArray[0];
            numberOfDataPacks = numberOfDataPacksArray[0];


            if (numberOfDataPacks <= 0)
            {
                throw new OhError("Error in Get_Data", oPrintString(" >"));
            }

            OhTimePoint ta = new OhTimePoint();
            ta.copy(((OhDataPackDouble)dataPackArray[0]).DataTime);

            OhTimePoint tb = new OhTimePoint();
            tb.copy(((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataTime);


            if (aT.CompareTo(ta) <= 0)
            {
                // aT <= ta ?
                return ((OhDataPackDouble)dataPackArray[0]).DataValue;
            }

            if (aT.CompareTo(tb) >= 0)
            {
                // aT >= tb ?
                return ((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataValue;
            }

            int ip1 = 0;
            int ip2 = numberOfDataPacks - 1;

            OhTimePoint t1 = new OhTimePoint();
            t1.copy(((OhDataPackDouble)dataPackArray[ip1]).DataTime);

            OhTimePoint t2 = new OhTimePoint();
            t2.copy(((OhDataPackDouble)dataPackArray[ip2]).DataTime);

            while (ip2 - ip1 > 1)
            {
                ip = (ip2 + ip1) / 2;

                OhTimePoint tp = new OhTimePoint();
                tp.copy(((OhDataPackDouble)dataPackArray[ip]).DataTime);

                if (tp.CompareTo(aT) < 0)
                {
                    ip1 = ip;
                    t1.copy(tp);
                }
                else if (tp.CompareTo(aT) > 0)
                {
                    ip2 = ip;
                    t2.copy(tp);
                }
                else
                {
                    return ((OhDataPackDouble)dataPackArray[ip]).DataValue;
                }
            }

            double y1 = ((OhDataPackDouble)dataPackArray[ip1]).DataValue;

            if (ip1 == ip2)
            {
                return y1;
            }

            double y2 = ((OhDataPackDouble)dataPackArray[ip2]).DataValue;

            OhTimePoint aTBackUp = new OhTimePoint();
            aTBackUp.copy(aT);
            //;     v = ((aT-t1)*y2                  + (t2-aT)*y1)                  / (t2-t1);
            dataValue = (((OhTimePoint.sub(aTBackUp, t1).toDouble() * y2 + OhTimePoint.sub(t2, aTBackUp).toDouble() * y1))
                        / OhTimePoint.sub(t2, t1).toDouble());


            return dataValue;
        }



        /// <summary> 
        /// f[^Ԍ^w肵āA aT ɂf[^l擾Adouble ^z aDataValue ̑vfɊi[܂B
        /// 
        /// <p/>
        /// Set the data value<p/> at time t to reference aDataValue[0].
        /// 
        /// </summary>
        /// <param name="aT">an <var>OhTimePoint</var> value<p/>
        /// 擾f[^l̃f[^L^
        /// </param>
        /// <param name="aDataValue">a <var>double[]</var> value<p/>
        /// f[^li[double^z
        /// </param>
        /// <param name="aDctVec">a <var>ArrayList</var> value<p/>
        /// f[^Ԕz񃊃Xg
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public void setData(OhTimePoint aT, double[] aDataValue, ArrayList aDctVec)
        {
            //; (*4-1)
            aDataValue[0] = getData(aT, aDctVec);
        }


        /// <summary> 
        ///  aT ɂf[^l擾Adouble ^z aDataValue ̑vfɊi[܂B
        /// f[^l̕Ԃ͐܂Ƃ܂B
        /// 
        /// <p/>
        /// Set the data value<p/> at time t to reference aDataValue[0].
        /// This data connection type is brokenline.
        /// 
        /// </summary>
        /// <param name="aT">an <var>OhTimePoint</var> value<p/>
        /// 擾f[^l̃f[^L^
        /// </param>
        /// <param name="aDataValue">a <var>double[]</var> value<p/>
        /// f[^li[double^z
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public void setData(OhTimePoint aT, double[] aDataValue)
        {
            //; (*4-2)
            aDataValue[0] = getData(aT);
        }



        /// <summary> 
        /// f[^Ԍ^w肵āA aT1 玞 aT2 ܂ł̐ϕlԂ܂B
        /// 
        /// <p/>
        /// Returns the integrated value<p/> from time aT1 till time aT2.
        /// aT1 should be less than or equal to t2. <p/>
        /// </summary>
        /// <remarks>
        /// When data connection type is Pulse, the value<p/> summed from aT1 till
        /// aT2 will be returned. The pulse at time aT1 is not contained in the
        /// sum, and the pulse at time aT2 is contained in the sum.
        /// </remarks>
        /// 
        /// <param name="aT1">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aT2">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aDctVec">a <var>Vector</var> value<p/>
        /// </param>
        /// <returns> a <var>double</var> value<p/>
        /// </returns>
        public double getDataSum(OhTimePoint aT1, OhTimePoint aT2, ArrayList aDctVec)
        {
            //(*3-1)
            double sum = 0L;

            if (aT1.CompareTo(aT2) == 0)
            {
                return sum;
            }

            if (aT1.CompareTo(aT2) > 0)
            {
                OhTimePoint aT3 = aT1;
                aT1 = aT2;
                aT2 = aT3;
            }


            OhArrayList dataPackArray = null;
            int numberOfDataPacks = 0;

            OhArrayList[] dataPackArrayArray = new OhArrayList[] { dataPackArray }; //; Array for work.
            int[] numberOfDataPacksArray = new int[] { numberOfDataPacks };

            int ip = 0;

            getDataPackArray(dataPackArrayArray, numberOfDataPacksArray);

            dataPackArray = dataPackArrayArray[0];
            numberOfDataPacks = numberOfDataPacksArray[0];

            if (numberOfDataPacks <= 1)
            {
                throw new OhError("Error in Get_Data", oPrintString(" >"));
            }


            IOhTimePointImmutable ta = ((OhDataPackDouble)dataPackArray[0]).DataTime;
            IOhTimePointImmutable tb = ((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataTime;

            if (aT1.CompareTo(ta) < 0 || aT2.CompareTo(tb) > 0)
            {
                // ta <= aT1 and aT2 <= tb, right?
                throw new ArgumentException("Illegal aT1 or aT2.");
            }

            DataConnectionType dataConnectionType = (DataConnectionType)aDctVec[0];

            if (dataConnectionType == DataConnectionType.BROKENLINE)
            {
                double y = 0L;
                double ya = 0L;
                double yb = 0L;
                int ipa = 0;
                int ipb = numberOfDataPacks - 1;

                while (ipb - ipa > 1)
                {
                    ip = (ipa + ipb) / 2;

                    IOhTimePointImmutable tp = ((OhDataPackDouble)dataPackArray[ip]).DataTime;

                    if (tp.CompareTo(aT1) < 0)
                    {
                        ipa = ip;
                        ta = tp;
                    }
                    else if (tp.CompareTo(aT1) > 0)
                    {
                        ipb = ip;
                        tb = tp;
                    }
                    else
                    {
                        ipb = ip;
                        ipa = ip - 1;
                        tb = tp;

                        ta = ((OhDataPackDouble)dataPackArray[ipa]).DataTime;
                        break;
                    }
                }


                ya = ((OhDataPackDouble)dataPackArray[ipa]).DataValue;
                yb = ((OhDataPackDouble)dataPackArray[ipb]).DataValue;

                if (ipa == ipb)
                {
                    y = ya;
                }
                else
                {
                    y = ((OhTimePoint.sub(aT1, ta).toDouble() * yb + (OhTimePoint.sub(tb, aT1).toDouble() * ya))
                        / (OhTimePoint.sub(tb, ta).toDouble()));
                }

                IOhTimePointImmutable t = aT1;
                ip = ipb;
                IOhTimePointImmutable ts = tb;
                double ys = yb;

                while (ts.CompareTo(aT2) < 0)
                {
                    sum += ((y + ys) * OhTimePoint.sub(ts, t).toDouble() / 2);
                    t = ts;
                    y = ys;
                    ip++;

                    ts = ((OhDataPackDouble)dataPackArray[ip]).DataTime;
                    ys = ((OhDataPackDouble)dataPackArray[ip]).DataValue;
                }

                ys = ((y * OhTimePoint.sub(ts, aT2).toDouble() + ys * OhTimePoint.sub(aT2, t).toDouble())
                        / OhTimePoint.sub(ts, t).toDouble());
                sum += ((y + ys) * OhTimePoint.sub(aT2, t).toDouble() / 2);
            }
            else if (dataConnectionType == DataConnectionType.STEP)
            {
                int ipa = 0;
                int ipb = numberOfDataPacks - 1;

                while (ipb - ipa > 1)
                {
                    ip = (ipa + ipb) / 2;

                    IOhTimePointImmutable tp = ((OhDataPackDouble)dataPackArray[ip]).DataTime;

                    if (tp.CompareTo(aT1) < 0)
                    {
                        ipa = ip;
                        ta = tp;
                    }
                    else if (tp.CompareTo(aT1) > 0)
                    {
                        ipb = ip;
                        tb = tp;
                    }
                    else
                    {
                        ipb = ip;
                        ipa = ip - 1;
                        tb = tp;
                        break;
                    }
                }

                IOhTimePointImmutable tn = tb;
                ip = ipb;

                double yn = ((OhDataPackDouble)dataPackArray[ip]).DataValue;
                IOhTimePointImmutable ts = aT1;

                while (tn.CompareTo(aT2) < 0)
                {
                    sum += (yn * OhTimePoint.sub(tn, ts).toDouble());
                    ts = tn;
                    ip++;

                    tn = ((OhDataPackDouble)dataPackArray[ip]).DataTime;
                    yn = ((OhDataPackDouble)dataPackArray[ip]).DataValue;
                }

                if (aT2.CompareTo(tn) <= 0)
                {
                    sum += (yn * OhTimePoint.sub(aT2, ts).toDouble());
                }
            }
            else if (dataConnectionType == DataConnectionType.PULSE)
            {
                int ipa = 0;
                int ipb = numberOfDataPacks - 1;

                while (ipb - ipa > 1)
                {
                    ip = (ipa + ipb) / 2;

                    IOhTimePointImmutable tp = ((OhDataPackDouble)dataPackArray[ip]).DataTime;

                    if (tp.CompareTo(aT1) < 0)
                    {
                        ipa = ip;
                        ta = tp;
                    }
                    else if (tp.CompareTo(aT1) > 0)
                    {
                        ipb = ip;
                        tb = tp;
                    }
                    else
                    {
                        ipb = ip + 1;
                        break;
                    }
                }

                IOhTimePointImmutable tn;
                double yn = 0L;

                for (; ip < numberOfDataPacks; ip++)
                {
                    tn = ((OhDataPackDouble)dataPackArray[ip]).DataTime;
                    yn = ((OhDataPackDouble)dataPackArray[ip]).DataValue;

                    if (tn.CompareTo(aT2) > 0)
                        break;

                    sum += yn;
                }
            }
            else
            {
                throw new ArgumentException("Illegal data_connection_type.");
            }

            return sum;
        }


        /// <summary> 
        ///  aT1 玞 aT2 ܂ł̐ϕlԂ܂B
        /// f[^l̕Ԃ͐܂Ƃ܂B
        /// 
        /// <p/>
        /// Gets sum data whose data connection type is brokenline.
        /// 
        /// </summary>
        /// <param name="aT1">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aT2">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <returns> a <var>double</var> value<p/>
        /// </returns>
        public double getDataSum(OhTimePoint aT1, OhTimePoint aT2)
        {
            //(*3-2)
            double sum = 0L;

            if (aT1.CompareTo(aT2) == 0)
            {
                return sum;
            }

            if (aT1.CompareTo(aT2) > 0)
            {
                OhTimePoint aT3 = aT1;
                aT1 = aT2;
                aT2 = aT3;
            }


            OhArrayList dataPackArray = null;
            int numberOfDataPacks = 0;

            OhArrayList[] dataPackArrayArray = new OhArrayList[] { dataPackArray }; //; Array for work.
            int[] numberOfDataPacksArray = new int[] { numberOfDataPacks };

            int ip = 0;

            getDataPackArray(dataPackArrayArray, numberOfDataPacksArray);

            dataPackArray = dataPackArrayArray[0];
            numberOfDataPacks = numberOfDataPacksArray[0];

            if (numberOfDataPacks <= 1)
            {
                throw new OhError("Error in Get_Data", oPrintString(" >"));
            }

            OhTimePoint ta = new OhTimePoint();
            ta.copy(((OhDataPackDouble)dataPackArray[0]).DataTime);

            OhTimePoint tb = new OhTimePoint();
            tb.copy(((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataTime);

            if (aT1.CompareTo(ta) < 0 || aT2.CompareTo(tb) > 0)
            {
                // ta <= aT1 and aT2 <= tb, right?
                throw new ArgumentException("Illegal aT1 or aT2.");
            }

            double y = 0L;
            double ya = 0L;
            double yb = 0L;
            int ipa = 0;
            int ipb = numberOfDataPacks - 1;

            while (ipb - ipa > 1)
            {
                ip = (ipa + ipb) / 2;

                OhTimePoint tp = new OhTimePoint();
                tp.copy(((OhDataPackDouble)dataPackArray[ip]).DataTime);

                if (tp.CompareTo(aT1) < 0)
                {
                    ipa = ip;
                    ta.copy(tp);
                }
                else if (tp.CompareTo(aT1) > 0)
                {
                    ipb = ip;
                    tb.copy(tp);
                }
                else
                {
                    ipb = ip;
                    ipa = ip - 1;
                    tb.copy(tp);

                    ta.copy(((OhDataPackDouble)dataPackArray[ipa]).DataTime);

                    break;
                }
            }

            ya = ((OhDataPackDouble)dataPackArray[ipa]).DataValue;
            yb = ((OhDataPackDouble)dataPackArray[ipb]).DataValue;

            if (ipa == ipb)
            {
                y = ya;
            }
            else
            {
                y = ((OhTimePoint.sub(aT1, ta).toDouble() * yb + OhTimePoint.sub(tb, aT1).toDouble() * ya)
                    / OhTimePoint.sub(tb, ta).toDouble());
            }

            OhTimePoint t = new OhTimePoint();
            t.copy(aT1);

            ip = ipb;

            OhTimePoint ts = new OhTimePoint();
            ts.copy(tb);

            double ys = yb;

            while (ts.CompareTo(aT2) < 0)
            {
                sum += ((y + ys) * OhTimePoint.sub(ts, t).toDouble() / 2);

                t.copy(ts);

                y = ys;
                ip++;

                ts.copy(((OhDataPackDouble)dataPackArray[ip]).DataTime);
                ys = ((OhDataPackDouble)dataPackArray[ip]).DataValue;
            }

            ys = ((y * OhTimePoint.sub(ts, aT2).toDouble() + ys * OhTimePoint.sub(aT2, t).toDouble())
                / OhTimePoint.sub(ts, t).toDouble());
            sum += ((y + ys) * OhTimePoint.sub(aT2, t).toDouble() / 2);

            return sum;
        }




        /// <summary> 
        ///  aT ɂpXf[^l double ^z aDataValue Ɋi[܂B
        /// 
        /// <p/>
        /// Gets pulse data.
        /// 
        /// </summary>
        /// <param name="aT">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aDataValue">a <var>double[]</var> value<p/>
        /// </param>
        /// <returns> a <var>boolean</var> value<p/>
        /// </returns>
        public bool canYouGetPulseData(OhTimePoint aT, double[] aDataValue)
        {
            //(*2)

            OhArrayList dataPackArray = null;
            int numberOfDataPacks = 0;

            OhArrayList[] dataPackArrayArray = new OhArrayList[] { dataPackArray }; //; Array for work.
            int[] numberOfDataPacksArray = new int[] { numberOfDataPacks };

            int ip = 0;

            getDataPackArray(dataPackArrayArray, numberOfDataPacksArray);

            dataPackArray = dataPackArrayArray[0];
            numberOfDataPacks = numberOfDataPacksArray[0];


            if (numberOfDataPacks <= 0)
                return false;

            OhTimePoint ta = new OhTimePoint();
            ta.copy(((OhDataPackDouble)dataPackArray[0]).DataTime);

            OhTimePoint tb = new OhTimePoint();
            tb.copy(((OhDataPackDouble)dataPackArray[numberOfDataPacks - 1]).DataTime);


            if (aT.CompareTo(ta) < 0 || aT.CompareTo(tb) > 0)
                return false;

            OhTimePoint tn = new OhTimePoint();
            OhTimePoint tp = new OhTimePoint();
            double yn = 0L;
            double yp = 0L;

            tn.copy(ta);
            yn = ((OhDataPackDouble)dataPackArray[0]).DataValue;

            if (aT.CompareTo(tn) == 0)
            {
                aDataValue[0] = yn;
                return true;
            }

            bool hit = false;

            for (ip = 1; ip < numberOfDataPacks; ip++)
            {
                tp.copy(tn);
                yp = yn;

                tn.copy(((OhDataPackDouble)dataPackArray[ip]).DataTime);
                yn = ((OhDataPackDouble)dataPackArray[ip]).DataValue;

                if (tn.CompareTo(aT) > 0)
                {
                    hit = false;
                    break;
                }
                else if (tn.CompareTo(aT) == 0)
                {
                    aDataValue[0] = yn;
                    hit = true;
                    break;
                }
            }
            return hit;
        }




        /// <summary> 
        /// f[^Ԍ^w肵āA aT1 ɂf[^lƎ aT2 ɂf[^l̕ϒlԂ܂B
        /// 
        /// <p/>
        /// Gets mean data.
        /// 
        /// </summary>
        /// <param name="aT1">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aT2">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aDctVec">a <var>Vector</var> value<p/>
        /// </param>
        /// <returns> a <var>double</var> value<p/>
        /// </returns>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public double getMeanData(OhTimePoint aT1, OhTimePoint aT2, ArrayList aDctVec)
        {
            //(*6)
            if (aT2.CompareTo(aT1) == 0)
            {
                return getData(aT2, aDctVec);
            }
            else
            {
                return getDataSum(aT1, aT2, aDctVec) / (OhTimePoint.sub(aT2, aT1).toDouble());
            }
        }




        /// <summary> 
        ///  aT1 ɂf[^lƎ aT2 ɂf[^l̕ϒlԂ܂B
        /// f[^l̕Ԃ͐܂Ƃ܂B
        /// 
        /// <p/>
        /// Gets mean data whose data connection type is brokenline.
        /// 
        /// </summary>
        /// <param name="aT1">an <var>OhTimePoint</var> value<p/><p/>
        ///  aT1 ɂf[^l
        /// </param>
        /// <param name="aT2">an <var>OhTimePoint</var> value<p/><p/>
        ///  aT2 ɂf[^l
        /// </param>
        /// <returns> a <var>double</var> value<p/>
        /// </returns>
        public double getMeanData(OhTimePoint aT1, OhTimePoint aT2)
        {
            //(*6)
            if (aT2.CompareTo(aT1) == 0)
            {
                return getData(aT2);
            }
            else
            {
                return getDataSum(aT1, aT2) / (OhTimePoint.sub(aT2, aT1).toDouble());
            }
        }

        // @end {methods} ------------------------------------------------------
    } // OhReceiveDouble
}