/// <(#)>  OhRelayPort; class to express relay ports. </(#)>
using System;
using System.Text;
using System.Collections;
using System.IO;
using OhymosNet;

namespace OhymosNet
{

    /// <summary> 
    /// <p/>
    /// {^p[qf\NXłB
    /// ۃNXłB
    /// ̃NX<a href ="OhymosNet.OhSenderPort.html">OhSenderPort</a>pĂ܂B
    /// <p/>
    /// The OhRelayPort class is a model of relay ports. 
    /// It extends <a href ="OhymosNet.OhSenderPort.html">OhSenderPort</a> class.<p/>
    /// </summary>
    /// <remarks>
    /// NX OhRelayPort ł́A
    /// 
    /// <ul>
    /// <li> f[^pbNM[q : _sender</li>
    /// </ul>
    /// 
    /// LA
    /// 
    /// <ul>
    /// <li> M[qƂ̐ڑ@\</li>
    /// <li> M[qƂ̐ڑ@\</li>
    /// </ul>
    /// 
    /// `܂B<p/>
    /// M[qƂ́A̒p[qɃf[^𑗂Ă鑤̒[qłB
    /// M[qƂ́A̒p[q瑗f[^󂯂Ƃ鑤̒[qłB<p/>
    /// 
    /// OhRelayPort ɐڑł鑗M[q͂PłB
    /// OhRelayPort ɂ͕̑M[qڑł܂B
    /// 
    /// 
    /// <p/>
    /// 
    /// 
    /// The OhRelayPort has a instance variable "_sender".
    /// "_sender" is used to store the sender
    /// which sends data packs to the current port. <p/>
    /// 
    /// Member functions for
    /// 
    /// <ul>
    /// <li> Connecting the current port with the port which sends data packs to the current port</li>
    /// <li> Connecting the current port with the port which receives data packs from the current port</li>
    /// </ul>
    /// 
    /// are defined. <p/>
    /// 
    /// Only one port can be connected to the port for receiving data packs.
    /// More than one ports can be connected to the ports
    /// which sending data packs.
    /// 
    /// </remarks>
	public abstract class OhRelayPort:OhSenderPort
	{
        // @begin {instance variable or static variable} -------------

        /// <summary> 
        /// <a href="OhSenderPort.html">OhSenderPort</a> ^ɃLXgꂽM[qłB
        /// Kvȃf[^pbŃAڑł _sender 擾܂B
        /// 
        /// <p/>
        /// The sender which sends data packs to this OhRelayPort casted to type OhSenderPort.
        /// 
        /// </summary>
        protected internal OhSenderPort _sender;

        // @end {instance variable or static variable} ---------------

        // @begin {abstract methods} ---------------------------------

        /// <summary> 
        /// pf[^pbÑf[^ľ^\擾܂B<p/>
        /// Gets the string which shows the type of data packs
        /// which are treated by this OhRelayPort. <p/>
        /// </summary>
        /// 
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃ\bhłB<p/>
        /// 
        ///  OhRelayPort łۃ\bhƂĂ܂B
        /// OhRelayPort ̔hNXŒpf[^pbN^\擾悤ɕK`ĉB<p/>
        /// 
        /// Ⴆ΁Apf[^pbN^ "double" ^łhNXł́A
        /// 
        /// <pre><var>
        /// public String DataType
        /// {
        ///     get {return "double";}
        /// }
        /// </var></pre>
        /// 
        /// ̂悤ɒ`܂B<p/>
        /// 
        /// ڑɂ́Aڑ[qƂ̒[q̃f[^pbN^v邱ƂmF܂B
        /// 
        /// <p/>
        /// 
        /// 
        /// In derived classes of this class OhRelayPort,
        /// this funstion should be defined so that it returnts the datapack type string.
        /// </remarks>
        public abstract override String DataType{get;}

        // @end {abstract methods} -----------------------------------


        // @begin{initialization} ------------------------------------

        /// <summary> 
        /// IuWFNgAIuWFNgԍ܂B
        /// 
        /// RXgN^Ŏgp܂B<p/>
        /// 
        /// Initialization.
        /// 
        /// </summary>
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/>
        /// </param>
        /// <returns> a <var>boolean</var> value<p/>
        /// </returns>
        public override void init(String aPortName, int aPortNum)
        {
            base.init(aPortName, aPortNum);
        }

        // @end{initialization} --------------------------------------


        // @begin {constructors} -------------------------------------

        /// <summary> 
        /// ftHgRXgN^łB
        /// Creates a new default <var>OhRelayPort</var> instance.
        /// </summary>
        /// <remarks>
        /// ftHgRXgN^
        /// <a href="OhRelayPort.html#init(String, int)">OhRelayPort.init(String, int)</a> s܂B
        /// ̌ʁAȉ̐ݒƂȂ܂B<p/>
        /// 
        /// <dl>
        /// <li> _objectName        : null</li>
        /// <li> _objectNumber      : -1</li>
        /// </dl>
        /// 
        /// <p/>
        /// ̑̃oϐɑ΂鏈͈RXgN^ƓłB
        /// ̏ꍇA<a href="OhRelayPort.html#init(String, int)">OhRelayPort.init(String, int)</a> 
        /// păoϐĉB<p/>
        /// </remarks>
        public OhRelayPort()
            : base()
        {
            _sender = null;
            _className = "OhRelayPort";
        }


        /// <summary> 
        /// IuWFNgip[qjAIuWFNgip[qjԍw肵āA
        /// <var>OhRelayPort</var>NX̐VCX^X𐶐܂B
        /// Creates a new <var>OhRelayPort</var> instance.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̃ftHgRXgN^pA
        /// <a href="OhRelayPort.html#init(String, int)">OhRelayPort.init(String, int)</a> pāA
        /// oϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhRelayPort"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _sender            : null</li>
        /// <li> _bufferList        : ɊmۂBiڑƗpj</li>
        /// <li> _receiverArray     : null</li>
        /// <li> _numberOfReceivers : -1</li>
        /// </dl>
        /// </remarks>
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// p[q
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/>
        /// p[qԍ
        /// </param>
        public OhRelayPort(String aPortName, int aPortNum)
            : base()
        {
            _sender = null;
            _className = "OhRelayPort";
            _objectName = aPortName;
            _objectNumber = aPortNum;
        }

        // @end {constructors} ---------------------------------------
		
        // @begin {property}--------------------------------------------------
		/// <summary> 
        /// ŌẪf[^̋L^擾܂B<p/>
        /// 
        /// Gets the oldest data time of the data stocked in the
		/// sender.
		/// 
		/// </summary>
		/// <returns> an <var>OhTimePointImmutable</var> value<p/>
		/// </returns>
		override public IOhTimePointImmutable OldestDataTime
		{
			get
			{
				return _sender.OldestDataTime;
			}
			
		}
		/// <summary> 
        /// ŐṼf[^̋L^擾܂B<p/>
        /// Gets the newest data time of the data stocked in the
		/// sender.
		/// 
		/// </summary>
		/// <returns> an <var>OhTimePoint</var> value<p/>
		/// </returns>
		override public IOhTimePointImmutable NewestDataTime
		{
			get
			{
				return _sender.NewestDataTime;
			}
			
		}

		/// <summary> 
        /// f[^pbŇ(_numberOfDataPacks)擾܂B<p/>
        /// 
        /// Gets the number of data packs which stored in the
		/// sender.
		/// 
		/// </summary>
		/// <returns> an <var>int</var> value<p/>
		/// </returns>
		override public int NumberOfDataPacks
		{
			get
			{
				return _sender.NumberOfDataPacks;
			}
			
		}

        /// <summary> 
        /// M[q̃f[^Ԍ^擾܂B<p/>
        /// Gets the data connection type of the "_sender".
        /// 
        /// </summary>
        /// <returns> a <var>ArryaList</var> value<p/>
        /// </returns>
        public override ArrayList DctVec
        {
            get { return _sender.DctVec; }
            set { _sender.DctVec = value; }
        }
        /// <summary> 
        /// M[q̃f[^pbNz񃊃Xg擾܂B
        /// Gets the datapack array.
        /// </summary>
        public override OhArrayList DataPackArray
        {
            get { return _sender.DataPackArray; }
        }
		
        // @end {property}--------------------------------------------------
		
		// @begin {methods} ------------------------------------------

        /// <summary> 
        /// M[qݒ肵܂B<p/>
        /// Sets the sender of this OhRelayPort to aSender (arg). <p/>
        /// </summary>
        /// <remarks>
        /// M[q _sender  aSender ɐݒ肵܂B<p/>
        /// 
        /// L̏ꍇ̓G[bZ[W\܂B<p/>
        /// 
        /// <ul>
        /// <li> aSender  null ̏ꍇB</li>
        /// <li> ̒[q̑M[q _sender ݒς݂̏ꍇB</li>
        /// <li> ̒[q aSender Ńf[^pbN^قȂꍇB</li>
        /// </ul>
        /// 
        /// [ACCIDENT]
        /// EaSender  <a href="OhPort.html">OhPort</a> ^ϐi[ĂȂꍇB
        /// 
        /// <p/>
        /// 
        /// 
        /// [in] aSender - the sender casted to OhPort. <p/>
        /// 
        /// Returns "true" if the setting was successfull.
        /// For the following cases, it returns "false". <p/>
        /// 
        /// <ul>
        /// <li> aSender is null.</li>
        /// <li> already the sender has been set.</li>
        /// <li> the type of datapacks which "aSender" treats is different from
        /// that of datapacks which this ports treats.</li>
        /// </ul>
        /// </remarks>
        /// 
        /// <param name="aSender">an <var>OhPort</var> value<p/>
        /// M[q
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public override void setSender(OhPort aSender)
        {
            if (aSender == null)
            {
                throw new ArgumentNullException("\"aSender\"(argument) is null." + oPrintString(" > "));
            }

            if (_sender != null)
            {
                StringWriter sw = new StringWriter();
                _sender.cPrint(sw, " >    connected to  : ");
                aSender.cPrint(sw, " >    connecting to  : ");
                String str = sw.ToString();
                sw.Close();
                throw new OhError("_sender has already been set." + NEWLINE + str);
            }

            // Gets the datapack type which this port receives, and the
            // datapack type which "aSender" receives.
            //
            String sType = aSender.DataType;
            String rType = DataType;

            if (!sType.Equals(rType))
            {
                throw new OhError("data pack type of this port and that of " + "\"aSender\" are different." + NEWLINE 
                    + aSender.oPrintString(" > s > ") + oPrintString(" > "));
            }

            _sender = (OhSenderPort)aSender;


        }
		// 1. connection facility



        /// <summary> 
        /// vZƑO̊mFsȂ܂B<p/>
        /// Reports whether this OhRelayPort is ready or not.
        /// </summary>
        /// <remarks>
        /// f[^pbN𒆌p\ȏԂł邱ƂmF܂B
        /// _sender ݒ肳Ă _sender f[^pbN𒆌pł܂B
        /// _numberOfReceivers  0 ȏȂ _receiverArray ݒς݂ŁA
        /// M[qɃf[^pbN𑗐Mł܂B
        /// 
        /// <p/>
        /// 
        /// When "_sender" and "_numberOfReceivers" have been defined,
        /// it returns true, otherwise it returns false.
        /// </remarks>
		/// <returns> a <var>boolean</var> value<p/>
        /// <pre>
        /// Etrue --> _sender, _receiverArray ݒς݂̏ꍇB
        /// Efalse -> _sender, _receiverArray ̏ȂƂݒ̏ꍇB
        /// </pre>
        /// </returns>
		public override bool areYouReady()
		{
			return ((_sender != null) && (_numberOfReceivers >= 0))?true:false;
		}
		
		
		// 2. relay facility of data packs

        /// <summary> 
        /// f|^pbN̔z񃊃Xgݒ肵܂B <p/>
        /// Orders the sender to create a data pack array.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃ\bhłB
        /// _sender Ƀf[^pbNzݒ肷悤߂܂B
        /// 
        /// <p/>
        /// </remarks>
		public override void  setDataPackArray()
		{
			_sender.setDataPackArray();
		}

        /// <summary> 
        /// p[qւ̌vZv͑M[qɓ]܂B
        /// 
        /// <p/>
        /// The calculation request to a relay port is transmitted to a send port.
        /// 
        /// </summary>
        /// <exception cref="OhCannotGetDataError">if an error occurs
        /// </exception>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public override void calReq()
        {
            _sender.calReq();
        }


        /// <summary> 
        /// f[^pbNz񃊃Xg擾(M)܂B<p/>
        /// Get datapack array aDpArray (arg) and the number of datapacks aNumOfDp (arg) from the sender. <p/>
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃ\bhłB<p/>
        /// 
        /// M[q _sender f[^pbNzM܂B<p/>
        /// 
        ///  aDpArray ̑vfɂ Object ^ɃLXgꂽ
        /// <a href="OhDataPack.html">OhDataPack</a> ^ϐ̔z񂪊i[A
        /// aNumOfDp ̑vfɂ aDpArray ̗vfi[܂B<p/>
        /// 
        /// ̃\bh́AM[q getDataPackArray Ăяo܂B
        /// ɂAM[qŃf[^pbNzMł܂B<p/>
        /// 
        ///[ACCIDENT]
        /// EڑO _sender  null ̏ꍇB<p/>
        /// ĩ\bh͌vZɕpɂɗp\̂Ŋ _sender  null łȂƂmF܂łBj
        /// E_sender  <a href="OhPort.html">OhPort</a> ^ȊO̕ϐi[ĂꍇB
        /// 
        /// </remarks>
		/// <param name="aTFrom">an <var>OhTimePoint</var> value<p/>
        /// pf[^pbNzvfɊi[
		/// </param>
		/// <param name="aTTo">an <var>OhTimePoint</var> value<p/>
        /// aDpArray ̗vfvfɊi[
		/// </param>
		/// <returns> a <var>boolean</var> value<p/>
		/// </returns>
		public override bool canYouGetData(IOhTimePointImmutable aTFrom, IOhTimePointImmutable aTTo)
		{
			return _sender.canYouGetData(aTFrom, aTTo);
		}

        /// <summary> 
        /// f[^pbNz񃊃Xg擾(M)܂B<p/>
        /// Get datapack array aDpArray (arg) and the number of datapacks aNumOfDp (arg) from the sender. <p/>
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃ\bhłB<p/>
        /// 
        /// M[q _sender f[^pbNzM܂B<p/>
        /// 
        ///  aDpArray ̑vfɂ Object ^ɃLXgꂽ
        /// <a href="OhDataPack.html">OhDataPack</a> ^ϐ̔z񂪊i[A
        /// aNumOfDp ̑vfɂ aDpArray ̗vfi[܂B<p/>
        /// 
        /// ̃\bh́AM[q getDataPackArray Ăяo܂B
        /// ɂAM[qŃf[^pbNzMł܂B<p/>
        /// 
        /// [ACCIDENT]
        /// EڑO _sender  null ̏ꍇB<p/>
        /// ĩ\bh͌vZɕpɂɗp\̂Ŋ _sender  null łȂƂmF܂łBj
        /// E_sender  <a href="OhPort.html">OhPort</a> ^ȊO̕ϐi[ĂꍇB
        /// </remarks>
        /// 
		/// <param name="aDpArray">an <var>OhArrayList[]</var> value<p/>
        /// pf[^pbNzvfɊi[
		/// </param>
		/// <param name="aNumOfDp">an <var>int[]</var> value<p/>
        /// aDpArray ̗vfvfɊi[
		/// </param>
		public override void  getDataPackArray(OhArrayList[] aDpArray, int[] aNumOfDp)
		{
			_sender.getDataPackArray(aDpArray, aNumOfDp);
		}


        /// <summary> 
        /// wɂf[^pbN擾(M)܂B<p/>
        /// Gets two datapacks aFormer and aLater.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃ\bhłB<p/>
        /// 
        /// w肵 _sender f[^pbNM܂B<p/>
        /// 
        /// aFormer ɂ́Af[^L^ _dataTime ȑO _dataTime ɍł߂^f[^pbNMAi[܂B<p/>
        /// 
        /// aLater ɂ́Af[^L^ _dataTime ȍ~ _dataTime ɍł߂^f[^pbNMAi[܂B<p/>
        /// 
        /// aFlag ͎擾̃[hI邽߂̃IvVŁAL̒ʂłB<p/>
        /// 
        /// <pre>
        /// E"b"       aFormer, aLater ̗KMB<p/>
        ///             MłȂꍇ́AƂ null ɐݒ肷B<p/>
        /// E"f"       aLater MłȂĂAaFormer ̂ݎMB<p/>
        ///             aLater MłȂꍇAnull ɐݒ肷B<p/>
        /// E"l"       aFormer MłȂĂAaLater ̂ݎ擾B<p/>
        ///             aFormer MłȂꍇAnull ɐݒ肷B<p/>
        /// Ȇ    aFormer, aLater ̂ȂƂ擾B<p/>
        ///             MłȂ̂ null ɐݒ肷B<p/>
        /// </pre>
        /// 
        /// aFlag ̃ftHgĺA "b" łB<p/>
        /// ܂A  aLater nȂꍇ́A aFlag  f Ƃ aFormer ̂ݎMA
        ///  aFormer nȂꍇ́A aFlag  l Ƃ aLater ̂ݎM܂B<p/>
        /// 
        /// f[^L^x _dataTime łf[^pbN^Ăꍇ́A
        /// aFormer, aLater Ƃi[܂B<p/>
        /// 
        /// 𖞂f[^pbN擾łȂꍇAaFormer, aLater  null ɐݒ肳܂B<p/>
        /// 
        /// f[^pbN擾łꍇ́Atrue Ԃ܂B
        /// 
        /// ̃\bh͑M[q
        /// getDataPack(Object[], OhTimePoint, Object[], char) Ăяo܂B
        /// ɂ著M[qŃf[^pbNMł܂B
        /// 
        /// <p/>
        /// 
        /// aFormer is the newest datapack before time_dataTime.
        /// aLater is the oldest datapack after time _dataTime.
        /// aMode specifies the option <p/>
        /// 
        /// <ul>
        /// <li> "b" -- get both of aFormer and aLater</li>
        /// <li> "f" -- get aFormer at least</li>
        /// <li> "l" -- get aLater at least</li>
        /// </ul>
        /// <p/>
        /// 
        /// When the datapack(s) specified by aMode can be got,
        /// it returns "true", otherwise "false". <p/>
        /// 
        /// [out] aFormer --- pointer to a datapack
        /// [in]  _dataTime - specified time
        /// [out] aLater ---- pointer to a datapack
        /// [in]  aMode ----- option to get pointers to datapacks
        /// </remarks>
        /// 
		/// <param name="aFormer">an <var>Object[]</var> value<p/>
        /// dataTime ȑO _dataTime ɍł߂^f[^pbNvfɊi[
		/// </param>
		/// <param name="_dataTime">an <var>OhTimePoint</var> value<p/>
        /// w莞 [sec]B̎ɍł߂f[^L^^f[^pbNMB
		/// </param>
		/// <param name="aLater">an <var>Object[]</var> value<p/>
        /// _dataTime ȍ~ _dataTime ɍł߂^f[^pbNvfɊi[B
		/// </param>
		/// <param name="aMode">a <var>char</var> value<p/>
        /// f[^pbN̎Mw肷tOB
		/// </param>
		/// <returns> a <var>boolean</var> value<p/>
        /// <pre>
        /// Etrue --> w̃f[^pbNMłꍇB
        /// Efalse -> _dataPackArray  null ̏ꍇB
        ///            w̃f[^pbNMłȂꍇB
        /// </pre>
        /// </returns>
		public override bool getDataPack(Object[] aFormer, OhTimePoint _dataTime, Object[] aLater, char aMode)
		{
			return _sender.getDataPack(aFormer, _dataTime, aLater, aMode);
		}


        /// <summary> 
        /// wɂf[^pbN擾(M)܂B<p/>
        /// By all means, Get two datapacks aFormer and aLater.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃ\bhłB<p/>
        /// 
        /// w肵 _sender f[^pbNM܂B<p/>
        /// 
        /// aFormer ɂ́Af[^L^ _dataTime ȑO _dataTime ɍł߂^f[^pbNMAi[܂B<p/>
        /// 
        /// aLater ɂ́Af[^L^ _dataTime ȍ~ _dataTime ɍł߂^f[^pbNMAi[܂B<p/>
        /// 
        /// aFormer, aLater ̗KM܂B
        /// MłȂꍇ́AƂ null ɐݒ肳܂B
        /// 
        /// f[^L^x _dataTime łf[^pbN^Ăꍇ́A
        /// aFormer, aLater Ƃi[܂B<p/>
        /// 
        /// f[^pbN擾łꍇ́Atrue Ԃ܂B
        /// 
        /// ̃\bh͑M[q
        /// getDataPack(Object[], OhTimePoint, Object[], char) Ăяo܂B
        /// ɂ著M[qŃf[^pbNMł܂B
        /// 
        /// 
        /// </remarks>
		/// <param name="aFormer">an <var>Object[]</var> value<p/>
        /// _dataTime ȑO _dataTime ɍł߂^f[^pbNvfɊi[B
		/// </param>
		/// <param name="_dataTime">an <var>OhTimePoint</var> value<p/>
        /// w莞 [sec]B
        /// ̎ɍł߂f[^L^^f[^pbNMB
		/// </param>
		/// <param name="aLater">an <var>Object[]</var> value<p/>
        /// _dataTime ȍ~ _dataTime ɍł߂^f[^pbNvfɊi[B
		/// </param>
		/// <returns> a <var>boolean</var> value<p/>
        /// <pre>
        /// Etrue --> w̃f[^pbNMłꍇB
        /// Efalse -> _dataPackArray  null ̏ꍇB
        ///            w̃f[^pbNMłȂꍇB
        /// </pre></returns>
		public virtual bool getDataPack(Object[] aFormer, OhTimePoint _dataTime, Object[] aLater)
		{
			return _sender.getDataPack(aFormer, _dataTime, aLater, 'b');
		}


        /// <summary> 
        /// svf[^pbN܂B<p/>
        /// Forwards the message "reduceDataPackStock()" to the sender.
        /// </summary>
        /// <remarks>
        /// M[q _sender ɕsvf[^pbN悤w܂B<p/>
        /// 
        /// ̒p[q _owner ŌvZIɗpAsv܂B<p/>
        /// 
        /// ̃\bh͑M[q
        /// getDataPack(Object[], OhTimePoint, Object[], char) Ăяo܂B
        /// ɂ著M[qŃf[^pbNMł܂B
        /// 
        /// <p/>
        /// </remarks>
		public override void  reduceDataPackStock()
		{
			_sender.reduceDataPackStock();
		}
		
		
		
		// 3. information output function.
		
		/// <summary> Prints the information about connection of this
		/// Relay_port. This function is used for debugging.
		/// 
		/// 
		/// <p/>
		/// ڑ̏óB
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <var>PrintWriter</var> value<p/>
		/// </param>
		/// <param name="aHead">a <var>String</var> value<p/>
		/// </param>
		public override void  printConnection(StreamWriter aPw, String aHead)
		{
			oPrint(aPw, aHead);
			
			
			if (_sender == null)
			{
				aPw.Write(aHead + "\tNot connected to sender." + NEWLINE);
				return ;
			}
			
			StringBuilder sb = new StringBuilder("");
			if (aHead != null)
				sb.Append(aHead);
			sb.Append("Connected > ");
			String str = sb.ToString();
			((OhObject) _sender).oPrint(aPw, str);
			
			if (_numberOfReceivers <= 0)
			{
				aPw.Write(aHead + "\tNot connected to receiver." + NEWLINE);
			}
			else
			{
				for (int k = 0; k < _numberOfReceivers; k++)
					((OhObject) _receiverArray[k]).oPrint(aPw, str);
			}
		}
		
		/// <summary> 
        /// ڑo͂܂B <p/>
        /// 
        /// Prints the information about connection of this
		/// Relay_port. This function is used for debugging.
		/// </summary>
		/// <param name="aSw">a <var>StreamWriter</var> value<p/>
		/// </param>
		public virtual void  printConnection(StreamWriter aSw)
		{
			oPrint(aSw, "    ");
			
			if (_sender == null)
			{
				aSw.Write("    \tNot connected to sender." + NEWLINE);
				return ;
			}
			
			StringBuilder sb = new StringBuilder("    ");
			sb.Append("Connected > ");
			String str = sb.ToString();
			((OhObject) _sender).oPrint(aSw, str);
			
			if (_numberOfReceivers <= 0)
			{
				aSw.Write("    \tNot connected to receiver." + NEWLINE);
			}
			else
			{
				for (int k = 0; k < _numberOfReceivers; k++)
					((OhObject) _receiverArray[k]).oPrint(aSw, str);
			}
		}
		
		// @end {methods} --------------------------------------------
	} // OhRelayPort
}