/// <(#)>  OhSendDouble; a port which sends datapacks of type double. </(#)>
using System;
using System.IO;
using System.Collections;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary> 
    /// double ^̃f[^pbN𑗐M鑗M[q̃NXłB 
    /// ̃NX<a href="OhymosNet.OhSendPort.html">OhSendPort</a>
    /// pĂ܂B<p/>
    /// The OhSendDouble class is a base class to express ports which
	/// send double data.
    /// It extends <a href="OhymosNet.OhSendPort.html">OhSendPort</a> class.
    /// </summary>
    public class OhSendDouble:OhSendPort
	{
		
		// @begin{initialization} ------------------------------------

        /// <summary> <japanese>
        /// IuWFNgiM[qjAIuWFNgiM[qjԍA
        /// f[^̕Ԃ͐܂ɐݒ肵܂B
        /// ̓Iɂ́A
        /// _dctVec ̑vf
        /// <a href="DataConnectionType.html#BROKENLINE">DataConnectionType.BROKENLINE</a> i[܂B
        /// </japanese>
        /// <p/>
        /// Initialization.
        /// 
        /// </summary>
		/// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
		/// </param>
        /// <exception cref="OhError">łɏĂꍇ
        /// </exception>
        public override void init(String aPortName, int aPortNum)
		{
			base.init(aPortName, aPortNum);
		}

        /// <summary> <japanese>
        /// IuWFNgiM[qjAIuWFNgiM[qjԍA
        /// f[^Ԍ^z񃊃Xg܂B
        /// </japanese>
        /// <p/>
        /// Initialization.
        /// 
        /// </summary>
		/// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
		/// </param>
		/// <param name="aDctVec">a <var>ArrayList</var> value<p/>
        /// f[^Ԍ^z񃊃Xg
		/// </param>
        /// <exception cref="OhError">łɏĂꍇ
        /// </exception>
        public override void init(String aPortName, int aPortNum, ArrayList aDctVec)
		{
			base.init(aPortName, aPortNum, aDctVec);
		}
		
		/// <summary> 
        /// IuWFNgiM[qjAIuWFNgiM[qjԍA
        /// f[^Ԍ^w肵ăf[^Ԍ^z񃊃Xg܂B
        /// 
        /// Initialization.
		/// 
		/// </summary>
		/// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
		/// M[qԍ
        /// </param>
		/// <param name="aDct">a <var>DataConnectionType</var> value<p/>
        /// f[^Ԍ^
		/// </param>
        /// <exception cref="OhError">łɏĂꍇ
		/// </exception>
		public void  init(String aPortName, int aPortNum, DataConnectionType aDct)
		{
			base.init(aPortName, aPortNum);
			_dctVec = ArrayList.Synchronized(new ArrayList());
			_dctVec.Add(aDct);
		}
		
		// @end{initialization} --------------------------------------
		
		
		// @begin {constructors} -------------------------------------
		
		/// <summary> 
        /// ftHgRXgN^łB<p/>
        /// Creates a new default <var>OhSendDouble</var> instance.
        /// </summary>
        /// <remarks>
        /// ftHgRXgN^
        /// <a href="OhSendDouble.html#init(String, int)">OhSendDouble.init(String, int)</a> s܂B
        /// ̌ʁAȉ̐ݒƂȂ܂B<p/>
        /// 
        /// <dl>
        /// <li> _objectName        : null</li>
        /// <li> _objectNumber      : -1</li>
        /// <li> _dctVec            : null</li>
        /// </dl>
        /// 
        /// <p/>
        /// ̑̃oϐɑ΂鏈͈RXgN^ƓłB
        /// ̏ꍇA<a href="OhSendDouble.html#init(String, int)">OhSendDouble.init(String, int)</a> 
        /// păoϐĉB
        /// </remarks>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
		public OhSendDouble():base()
		{
			_className = "OhSendDouble";
		}
		
		/// <summary> 
        /// IuWFNgiM[qjAIuWFNgiM[qjԍw肵āA
        /// OhSendDouble NX̃CX^X𐶐܂B<p/>
        /// Creates a new <var>OhSendDouble</var> instance.
		/// </summary>
        /// <remarks>
        /// NX̃RXgN^
        /// <a href="OhSendPort.html#OhSendPort.OhSendPort(String, int)">OhSendPort.OhSendPort(String, int)</a>
        /// ̃RXgN^păoϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhSendDouble"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _bufferList        : ɊmۂBiڑƗpj</li>
        /// <li> _receiverArray     : null</li>
        /// <li> _numberOfReceivers : -1</li>
        /// <li> _dataPackArray     : null</li>
        /// <li> _numberOfDataPacks : -1</li>
        /// <li> _dctVec            : null</li>
        /// </dl>
        /// </remarks>
		/// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public OhSendDouble(String aPortName, int aPortNum):base(aPortName, aPortNum)
		{
			_className = "OhSendDouble";
		}

        /// <summary> 
        /// IuWFNgiM[qjAIuWFNgiM[qjԍA
        /// f[^Ԍ^z񃊃Xgw肵āA
        /// OhSendDouble NX̃CX^X𐶐܂B<p/>
        /// Creates a new <var>OhSendDouble</var> instance.
        /// </summary>
        /// <remarks>
        /// NX̃RXgN^
        /// <a href="OhSendPort.html#OhSendPort.OhSendPort(String, int)">OhSendPort.OhSendPort(String, int)</a>
        /// ̃RXgN^păoϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhSendDouble"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _bufferList        : ɊmۂBiڑƗpj</li>
        /// <li> _receiverArray     : null</li>
        /// <li> _numberOfReceivers : -1</li>
        /// <li> _dataPackArray     : null</li>
        /// <li> _numberOfDataPacks : -1</li>
        /// <li> _dctVec            : aDctVec</li>
        /// </dl>
        /// </remarks>
		/// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
		/// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
		/// </param>
		/// <param name="aDctVec">a <var>ArrayList</var> value<p/>
		/// f[^Ԍ^z񃊃Xg
        /// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public OhSendDouble(String aPortName, int aPortNum, ArrayList aDctVec):base(aPortName, aPortNum, aDctVec)
		{
			_className = "OhSendDouble";
		}

        /// <summary> 
        /// IuWFNgiM[qjAIuWFNgiM[qjԍA
        /// f[^Ԍ^w肵āA
        /// OhSendDouble NX̃CX^X𐶐܂B<p/>
        /// Creates a new <var>OhSendDouble</var> instance.
        /// </summary>
        /// <remarks>
        /// NX̃RXgN^
        /// <a href="OhSendPort.html#OhSendPort.OhSendPort(String, int)">OhSendPort.OhSendPort(String, int)</a>
        /// ̃RXgN^păoϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhSendDouble"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _bufferList        : ɊmۂBiڑƗpj</li>
        /// <li> _receiverArray     : null</li>
        /// <li> _numberOfReceivers : -1</li>
        /// <li> _dataPackArray     : null</li>
        /// <li> _numberOfDataPacks : -1</li>
        /// <li> _dctVec            : aDctŎw肵Ԍ^̔z񃊃Xg</li>
        /// </dl>
        /// </remarks>
        /// <param name="aPortName">a <var>String</var> value<p/>
		/// M[q
        /// </param>
		/// <param name="aPortNum">an <var>int</var> value<p/>
		/// M[qԍ
        /// </param>
		/// <param name="aDct">a <var>DataConnectionTyper</var> value<p/>
		/// f[^Ԍ^
        /// </param>
		public OhSendDouble(String aPortName, int aPortNum, DataConnectionType aDct):base(aPortName, aPortNum)
		{
			_dctVec = ArrayList.Synchronized(new ArrayList());
			_dctVec.Add(aDct);
			_className = "OhSendDouble";
		}
		
		// @end {constructors} ---------------------------------------

        // @begin {property}----------------------------------------------------
        /// <summary> 
        /// f[^Ԍ^w肵܂B<p/>
        /// Sets the data connection type.
        /// </summary>
        /// <remarks>
        /// f[^Ԍ^w肵܂Bf[^Ԍ^zw肷Kv
        /// ܂BŎw肵f[^Ԍ^IuWFNgz
        /// \bhŐċL܂B<p/>
        /// 
        /// f[^Ԍ^̓RXgN^init\bhłwł܂B<br/>
        /// 
        /// Sets the data connection type. You can specify the data
        /// connection type directly and do not need give a data
        /// connection type vector.<p/>
        /// </remarks>
        public virtual DataConnectionType DataConnectionType
        {
            set
            {
                _dctVec = ArrayList.Synchronized(new ArrayList());
                _dctVec.Add(value);
            }

        }
        // @end {property}----------------------------------------------------

		// @begin {methods} ------------------------------------------
		
		// 1. function for sending data.
		
		/// <summary> 
        /// Mf[^pbÑf[^ľ^ double \ "double" 擾܂B
        /// <p/>
        /// Gets the data pack type which expresses the type of data to be received.
		/// 
		/// </summary>
		public override String DataType
		{
            get { return "double"; }
		}
		
		
		/// <summary> 
        /// ɂƂ aT, aValue 
        /// <a href="OhDataPackDouble.html">OhDataPackDouble</a> ^f[^pbN쐬A
        /// <a href="OhSendPort.html#dataPackStock(Object)">OhSendPort.dataPackStock(Object)</a> p
        /// M[qɑM܂B<p/>
        /// 
        /// Send data whose data time and data value are <b>aT</b> and
		/// <b>aValue</b>, respectively.
		/// </summary>
        /// 
		/// <param name="aT">an <var>OhTimePointImmutable</var> value<p/>
        /// f[^
		/// </param>
		/// <param name="aValue">a <var>double</var> value<p/>
        /// f[^l
		/// </param>
		public virtual void  sendData(IOhTimePointImmutable aT, double aValue)
		{
			dataPackStock(new OhDataPackDouble(aT, aValue));
		}
		
		/// <summary> 
        /// ɂƂ aDataStr ŕ\ꂽf[^pbN
        /// <a href="OhDataPackDouble.html">OhDataPackDouble</a> ^f[^pbN쐬A
        /// <a href="OhSendPort.html#dataPackStock(Object)">OhSendPort.dataPackStock(Object)</a> p
        /// M[qɑM܂B<p/>
        /// Send data of type double whose value<p/> is stored in the
		/// String specified.
        /// </summary>
        /// <example><code>
		/// sendByString("2003 10 0.0 1.5");
        /// </code></example>
		/// 
		/// <param name="aDataStr">a <var>String</var> value<p/>
        /// f[^
		/// </param>
		public override void  sendByString(String aDataStr)
		{
			dataPackStock(new OhDataPackDouble(aDataStr));
		}
		
		/// <summary> 
        /// ̃|[g̃NXƃf[^^Ɋւ𕶎ɂĕ
        /// ܂B<p/>
        /// Returns the basic info about this port class such as
        /// classname and datatype it carries.
        /// </summary>
        /// <remarks>
        /// słAŌ̍sɂ͍sR[h
        /// B
        /// 
        /// The string returned contains multiple lines, but the last line does not contain 
		/// line-end character.
        /// </remarks>
		/// 
		/// <returns> a <var>String</var> value<p/>
        /// ̃|[gɊւ
		/// </returns>
		public override String basicInfo()
		{
			return "classname: " + _className + NEWLINE + "datatype it carries: " + DataType;
		}
		
		// @end {methods} --------------------------------------------
	} // OhSendDouble
}