// OhSendPort; class to express a send port. </(#)>
//                  Made from "OhSendPort.java" by Ohshima.
//                  Last update : 2008/02/27 12:08:02
using System;
using System.IO;
using System.Collections;
using OhymosNet;

namespace OhymosNet
{

    /// <summary>
    /// {^M[qf\NXłB
    /// ۃNXłB
    /// ̃NX<a href="OhymosNet.OhSenderPort.html">OhSenderPort</a>
    /// pĂ܂B<p/>
    /// Abstract class for creating send ports.
    /// It extends <a href="OhymosNet.OhSenderPort.html">OhSenderPort</a> class.<p/>
    /// </summary>
    /// <remarks>
    /// 
    /// {^M[qf OhSendPort `Ă܂B
    /// {^M[qf͒ۃNXłB<p/>
    /// {^M[qf OhSendPort ́AŎĂf[^𑗐M[qłA
    /// f[^𑗐M[q
    /// <a href="OhSenderPort.html">OhSenderPort</a>
    /// ̈łB
    /// ʂ̒[qf[^𑗐M[q͒p[q
    /// <a href="OhRelayPort.html">OhRelayPort</a>
    /// łB<p/>
    /// 
    /// NX OhSendPort ł́A
    /// 
    /// <ul>
    /// <li> Mf[^pbN : _dataPackArray, _numberOfDataPacks</li>
    /// </ul>
    /// 
    /// LA
    /// 
    /// <ul>
    /// <li> f[^pbN^ёM@\</li>
    /// </ul>
    /// 
    /// `܂B<p/>
    /// 
    /// OhSendPort ̑M@\́ANX
    /// <a href="OhSenderPort.html">OhSenderPort</a>
    /// Œ`ς݂łB
    /// OhSendPort ɂ́ȂM[qڑ邱Ƃł܂B
    /// 
    ///
    /// 
    /// <p/>
    /// 
    /// OhSendPort;
    /// 
    /// Abstract class for creating send ports. <p/>
    /// 
    /// Fields _dataPackArray, _numberOfDataPacks and some methods to store datapacks are defined.
    /// 
    /// </remarks>
    /// 
    /// <author>  <a href="mailto:satoh@wr.kuciv.kyoto-u.ac.jp">satoh</a>
    /// </author>
    /// <version>  $Revision: 1.76 $ $Date: 2004/03/08 17:03:02 $
    /// </version>
    public abstract class OhSendPort : OhSenderPort
    {

        // @begin {fields} ----------------------------------------------

        /// <summary> 
        /// f[^pbNMp̔z񃊃XgłB<p/>
        /// An array for sending datapacks.
        /// </summary>
        /// <remarks>
        /// _dataPackArray wzɂ́AObject ^ɃLXgꂽ^f[^pbNi[܂B
        /// 
        /// <p/>
        /// </remarks>
        protected internal OhArrayList _dataPackArray;

        /// <summary> 
        /// _dataPackArray ̗vfłB
        /// 
        /// <p/>
        /// The number of elements stored in "_dataPackArray".
        /// 
        /// </summary>
        protected internal int _numberOfDataPacks;

        /// <summary> 
        /// f[^pbNی삷邩(true)ۂ(false)̃tOłB
        /// 
        /// <p/>
        /// This field is designed to use to control the protect mode of past "_dataPack".
        /// 
        /// </summary>
        protected internal bool _protectPastDataFlag;

        /// <summary> 
        /// ̑M[qf[^̃f[^Ԍ^xNgłB<p/>
        /// 
        ///  OhSendPort NXf[^̃f[^Ԍ^xNg
        /// oϐƂċL܂B 
        /// 
        /// <p/>
        /// Data connection type vector of data provided this OhSendPort.
        /// 
        /// </summary>
        protected internal ArrayList _dctVec;

        // @end {fields} -------------------------------------------------------

        // @begin{initialization} ----------------------------------------------

        /// <summary> 
        /// IuWFNgiM[qjAIuWFNgiM[qjԍA
        /// f[^̕Ԃ͐܂ɐݒ肵܂B<p/>
        /// Initialization.
        /// </summary>
        /// <remarks>
        /// ̓Iɂ́A
        /// _dctVec ̑vf
        /// <a href="DataConnectionType.html#BROKENLINE">DataConnectionType.BROKENLINE</a> i[܂B
        /// </remarks>
        /// 
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
        /// </param>
       public override void init(String aPortName, int aPortNum)
        {
            _dctVec = new ArrayList();
            _dctVec.Add(DataConnectionType.BROKENLINE);

            base.init(aPortName, aPortNum);
        }


        /// <summary> 
        /// IuWFNgiM[qjAIuWFNgiM[qjԍA
        /// f[^Ԍ^xNg܂B
        /// 
        /// <p/>
        /// Initialization.
        /// 
        /// </summary>
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
        /// </param>
        /// <param name="aDctVec">a <var>Vector</var> value<p/>
        /// f[^Ԍ^xNg
        /// </param>
        public virtual void init(String aPortName, int aPortNum, ArrayList aDctVec)
        {
            _dctVec = aDctVec;

            base.init(aPortName, aPortNum);
        }

        // @end{initialization} ------------------------------------------------


        // @begin {constructors} -----------------------------------------------

        /// <summary> 
        /// ftHgRXgN^łB
        /// </summary>
        /// <remarks>
        /// ftHgRXgN^
        /// <a href="OhSendPort.html#init(String, int)">OhSendPort.init(String, int)</a> s܂B
        /// ̌ʁAȉ̐ݒƂȂ܂B<p/>
        /// 
        /// <dl>
        /// <li> _objectName        : null</li>
        /// <li> _objectNumber      : -1</li>
        /// <li> _dctVec            : null</li>
        /// </dl>
        /// 
        /// <p/>
        /// ̑̃oϐɑ΂鏈͈RXgN^ƓłB
        /// ̏ꍇA<a href="OhSendPort.html#init(String, int)">OhSendPort.init(String, int)</a> 
        /// păoϐĉB
        /// </remarks>
        public OhSendPort()
            : base()
        {
            _dataPackArray = null;
            _numberOfDataPacks = -1;
            _protectPastDataFlag = false;

            _className = "OhSendPort";
            _commentString = null;
        }

        /// <summary> 
        /// M[qƑM[qԍw肵āA<var>OhSendPort</var> ̃CX^X𐶐܂B<p/>
        /// Creates a new <var>OhSendPort</var> instance.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̃ftHgRXgN^pA
        /// <a href="OhSendPort.html#init(String, int)">OhSendPort.init(String, int)</a> pāA
        /// oϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhSendPort"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _bufferList        : ɊmۂBiڑƗpj</li>
        /// <li> _receiverArray     : null</li>
        /// <li> _numberOfReceivers : -1</li>
        /// <li> _dataPackArray     : null</li>
        /// <li> _numberOfDataPacks : -1</li>
        /// <li> _dctVec            : DataConnectionType.BROKENLINE</li>
        /// </dl>
        /// </remarks>
        /// 
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/>
        /// M[qԍ
        /// </param>
        public OhSendPort(String aPortName, int aPortNum)
            : base()
        {
            _dataPackArray = null;
            _numberOfDataPacks = -1;
            _protectPastDataFlag = false;

            _className = "OhSendPort";
            _commentString = null;

            _dctVec = new ArrayList();
            _dctVec.Add(DataConnectionType.BROKENLINE);

            _objectName = aPortName;
            _objectNumber = aPortNum;
        }

        /// <summary> 
        /// M[qƑM[qԍAf[^Ԍ^xNgw肵āA<var>OhSendPort</var> ̃CX^X𐶐܂B<p/>
        /// Creates a new <var>OhSendPort</var> instance.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̃ftHgRXgN^pA
        /// <a href="OhSendPort.html#init(String, int)">OhSendPort.init(String, int)</a> pāA
        /// oϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <dl>
        /// <li> _className         : "OhSendPort"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _bufferList        : ɊmۂBiڑƗpj</li>
        /// <li> _receiverArray     : null</li>
        /// <li> _numberOfReceivers : -1</li>
        /// <li> _dataPackArray     : null</li>
        /// <li> _numberOfDataPacks : -1</li>
        /// <li> _dctVec            : aDctVec</li>
        /// </dl>
        /// 
        /// </remarks>
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// M[q
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/><p/>
        /// M[qԍ
        /// </param>
        /// <param name="aDctVec">a <var>Vector</var> value<p/>
        /// f[^Ԍ^xNg
        /// </param>
        public OhSendPort(String aPortName, int aPortNum, ArrayList aDctVec)
            : base()
        {
            _dataPackArray = null;
            _numberOfDataPacks = -1;
            _protectPastDataFlag = false;

            _dctVec = aDctVec;

            _className = "OhSendPort";
            _commentString = null;

            _objectName = aPortName;
            _objectNumber = aPortNum;
        }

        // @end {constructors} -------------------------------------------------



        // @begin {properties}--------------------------------------------------------
        /// <summary> 
        /// ŌẪf[^̋L^Ԃ܂B
        /// 
        /// <p/>
        /// Returns the oldest data time.
        /// 
        /// </summary>
        /// <returns> an <var>OhTimePointImmutable</var> value<p/>
        /// </returns>
        override public IOhTimePointImmutable OldestDataTime
        {
            get
            {
                //; (*3)
                if (_numberOfDataPacks <= 0)
                    return OhTimePoint.OhTimePointMin;

                return (((OhDataPack)_dataPackArray[0]).DataTime);
            }

        }
        /// <summary> 
        /// ŐṼf[^̋L^Ԃ܂B
        /// 
        /// <p/>
        /// Returns the newest data time.
        /// 
        /// </summary>
        /// <returns> an <var>OhTimePointImmutable</var> value<p/>
        /// </returns>
        override public IOhTimePointImmutable NewestDataTime
        {
            get
            {
                //; (*4)
                if (_numberOfDataPacks <= 0)
                    return OhTimePoint.OhTimePointMax;

                return (((OhDataPack)_dataPackArray[_numberOfDataPacks - 1]).DataTime);
            }

        }
        /// <summary> 
        /// f[^pbŇ(_numberOfDataPacks)Ԃ܂B
        /// 
        /// <p/>
        /// Returns the number of data packs which stored in the sender.
        /// 
        /// </summary>
        /// <returns> an <var>int</var> value<p/><p/>
        /// </returns>
        override public int NumberOfDataPacks
        {
            get
            {
                //; (*5)
                return _numberOfDataPacks;
            }

        }

        /// <summary> 
        /// _protectPastDataFlag ݒ肵܂B
        /// f[^pbNȂꍇ true ɐݒ肵ĂB
        /// 
        /// <p/>
        /// Sets "_protectPastDataFlag".
        /// 
        /// </summary>
        public virtual bool ProtectPastDataFlag
        {
            set
            {
                _protectPastDataFlag = value;
            }
        }

        /// <summary> 
        /// f[^Ԍ^xNg擾Eݒ肵܂B
        /// <p/>
        /// Gets or sets the data connection type vector.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃvpeBłB
        /// ̃NXŎ܂B<p/>
        /// 
        ///  This function is decleared abstract method in <a href="OhSenderPort.html">OhSenderPort</a>.
        /// Implemented in this class. 
        /// </remarks>
        public override ArrayList DctVec
        {
            get { return _dctVec;}
            set { _dctVec = value;}
        }

        /// <summary>
        /// f[^pbNi[ꂽz񃊃Xg擾܂B<p>
        /// Gets the datapack array.
        /// </p>
        /// </summary>
        public override OhArrayList DataPackArray
        {
            get { return _dataPackArray; }
        }

        /// <summary> 
        /// f[^̌^Ԃ܂B<p/>
        /// Gets the string which shows the type of the datapack sent by the current port.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhSenderPort.html">OhSenderPort</a> ̒ۃvpeBłB
        /// ̃NX OhSendPort łۃvpeBƂĂ܂B
        /// 
        /// <p/>
        /// </remarks>
        public abstract override String DataType { get;}


        // @end {properties}--------------------------------------------------------

        // @begin {abstract methods} -------------------------------------------
        
        // 2. Recording and sending function of datapacks.

        /// <summary> 
        /// f[^pbN̍쐬ю^sȂ܂B <p/>
        /// /// A data pack is created and recorded from the data character sequence
        /// stored in "aDstr".
        /// </summary>
        /// <remarks>
        /// ۃ\bhłB
        /// aDstr (arg) Ɋi[ꂽf[^񂩂f[^pbN쐬A^܂B
        /// </remarks>
        /// <param name="aDstr">a <var>String</var> value<p/>
        /// f[^
        /// </param>
        public abstract void sendByString(String aDstr);

        // @end {abstract methods} ---------------------------------------------

        // @begin {methods} ----------------------------------------------------

        // 1. Connection function.

        
        /// <summary> 
        /// [q̐ڑƂ̏Iуf[^MJn̂߂̏ƂsȂ܂B
        /// </summary>
        /// 
        /// <remarks>
        /// ̓Iɂ́A_receiverArray ̍쐬 _dataPackArray ̏sȂ܂B<p/>
        /// 
        /// ̃\bh͈ȉs܂B<p/>
        /// 
        /// <ol>
        /// <li> MM[qz _dataPackArray 쐬B</li>
        /// <li> MM[q̐ _numberOfReceivers ɐݒ肷B</li>
        /// <li> _dataPackArray ̃mۂB</li>
        /// <li> _numberOfDataPacks ̒l -1  0 ɕύXB</li>
        /// </ol>
        /// <p/>
        /// 
        /// ܂A
        /// <a href="OhSenderPort.html#doSwitch()">OhSenderPort.doSwitch()</a>
        /// s܂B̓Iɂ́A_receiverArray 쐬܂B<p/>
        /// 
        ///  ɁA_dataPackArray  new 邱Ƃɂ胁mۂA
        /// _numberOfDataPacks ̒l -1  0 ɕϊ܂B
        /// <p/>
        /// <br/>
        /// rōƂɎsƁAOhError IuWFNg throw ܂B
        /// 
        /// <p/>
        /// <br/>
        /// Preparation of "_dataPackArray".
        /// That is, "_numberOfDataPacks" is set as 0 from -1.
        /// </remarks>
        /// <exception cref="OhError">
        /// _receivePortArray 쐬ς݁A܂
        /// _dataPackArray 쐬ς݂̂̏ꍇ
        /// </exception>
        public override void doSwitch()
        {
            //; (*1)
            base.doSwitch();
            if ((_numberOfDataPacks >= 0) || (_dataPackArray != null))
            {
                throw new OhError("Already exists \"_dataPackArray\".", oPrintString(" > "));
            }

            _dataPackArray = new OhArrayList();
            _numberOfDataPacks = 0;
        }


        /// <summary> 
        /// vZƑO̊mFsȂ܂B<p/>
        /// Checks before calculation.
        /// </summary>
        /// <remarks>
        /// NX
        /// <a href="OhSenderPort.html">OhSenderPort</a>
        /// ̒ۃ\bhłB<p/>
        /// 
        /// f[^pbN𑗐M\ȏԂł邱ƂmF܂B
        /// _receiverArray 쐬ς݂ŁAf[^pbN^p _bufferList ݂΁A
        /// f[^pbN^AMł܂B
        /// </remarks>
        /// 
        /// <returns> a <var>bool</var> value<p/>
        /// <pre>
        /// Etrue  _sender  null ŁAf[^pbN^p _bufferList ݂ꍇ
        ///         _sender ݒ肳Ăꍇ
        /// Efalse _sender  null ŁAf[^pbN^p _bufferList ݂Ȃꍇ
        /// </pre>
        /// </returns>
        public override bool areYouReady()
        {
            if (base.areYouReady() == true)
                return true;

            return false;
        }


        /// <summary> 
        /// M[q̏L҂ɌvZv`܂B<p/>
        /// iM[q̏L҂͗vffł邱ƂɒӁj
        /// <p/>
        /// Transer the calculation request to the owner.
        /// 
        /// </summary>
        /// <exception cref="OhCannotGetDataError">if an error occurs
        /// </exception>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public override void calReq()
        {
            ((OhElement)_owner).calReq();
        }


        // 2. Recording and sending function of datapacks.

        /// <summary> 
        /// f[^pbN^܂B<p/>
        /// Stocks "aDataPack".
        /// </summary>
        /// <remarks>
        /// ŐV̎^f[^pbN aDataPack (arg) ̃f[^L^rA
        /// aDataPack ̕V aDataPack  _dataPackArray Ɏ^܂B<p/>
        /// 
        /// ̏ꍇ aDataPack ̕Âꍇ aDataPack ^܂B
        /// 
        /// ႦΕsAfsvȏꍇȂǂ͔hNXōĒ`ĉB
        /// 
        /// <p/>
        /// Stocks "_bufferList" if the data time of "aDataPack" is newer
        /// than the data time of the newest datapack stored in "_bufferList".
        /// Otherwise the "_bufferList" is not included into "_bufferList".
        /// </remarks>
        /// <param name="aDataPack">an <var>Object</var> value<p/>
        /// Mf[^pbN
        /// </param>
        public virtual void dataPackStock(OhDataPack aDataPack)
        {
            //; (*2)
            if ((_dataPackArray.Count > 0) 
                && (((OhDataPack)aDataPack).DataTime.CompareTo(((OhDataPack)_dataPackArray.LastElement).DataTime) <= 0))
                return;

            _dataPackArray.Add(aDataPack);

            setDataPackArray(); 
        }


        /// <summary> 
        /// f|^pbN̔z񃊃Xgݒ肵܂i_dataPackArray ̗vf _numberOfDataPacks ɐݒ肵܂jB<p/>
        /// Makes data pack array.
        /// 
        /// </summary>
        /// <remarks>
        /// NX
        /// <a href="OhSenderPort.html">OhSenderPort</a>
        /// ̒ۃ\bhłB<p/>
        /// 
        /// ۂɂ́A
        /// _dataPackArray ̗vf _numberOfDataPacks ɐݒ肷邾łB
        /// </remarks>
        /// <p/>
        /// 
        public override void setDataPackArray()
        {
            _numberOfDataPacks = _dataPackArray.Count;
        }


        /// <summary> 
        /// f[^^̊mFsȂ܂B<p/>
        /// Checks the data time recorded.
        /// </summary>
        /// <remarks>
        /// NX
        /// <a href="OhSenderPort.html">OhSenderPort</a>
        /// ̒ۃ\bhłB
        /// ̃NX OhSendPort Ŏ܂B<p/>
        /// 
        /// aTFrom ȑO aTTo ȍ~܂ł̃f[^pbN^Ăꍇ true ԂA
        /// ^ĂȂꍇ false Ԃ܂B<p/>
        /// 
        /// ܂A_dataPackArray Ɏ^Ăꍇ true Ԃ܂B
        /// ^ĂȂꍇ́AX _bufferList Ɏ^Ă邩ׁA
        /// _bufferList Ɏ^Ă _dataPackArray XV true Ԃ܂B
        /// ^ĂȂꍇ false Ԃ܂B
        /// </remarks>
        /// <pre>
        /// [ARGUMENT]
        /// [RETURN]
        /// Etrue ---> aTFrom ȑO aTTo ȍ~܂ł̃f[^pbN^ĂꍇB
        /// Efalse --> aTFrom ȑO aTTo ȍ~܂ł̃f[^pbN^ĂȂꍇB
        /// </pre>
        /// 
        /// <p/>
        /// <param name="aTFrom">an <var>OhTimePointImmutable</var> value<p/>
        /// aTFrom ȑOf[^pbN^Ă邱ƂmFB
        /// </param>
        /// <param name="aTTo">an <var>OhTimePointImmutable</var> value<p/><p/>
        /// aTTo ȍ~܂Ńf[^pbN^Ă邱ƂmFB
        /// </param>
        /// <returns> a <var>bool</var> value<p/><p/>
        /// </returns>
        public override bool canYouGetData(IOhTimePointImmutable aTFrom, IOhTimePointImmutable aTTo)
        {
            //; (*8)
            if (_numberOfDataPacks <= 0)
                return false;

            if ((((OhDataPack)_dataPackArray[_numberOfDataPacks - 1]).DataTime.CompareTo(aTTo) < 0) 
                || (((OhDataPack)_dataPackArray[0]).DataTime.CompareTo(aTFrom) > 0))
            {
                return false;
            }

            return true;
        }


        /// <summary> 
        /// f[^pbN̔z񃊃Xg𑗐M(擾)܂B<p/>
        /// Sends(Gets) the datapack array.
        /// </summary>
        /// <remarks>
        /// NX
        /// <a href="OhSenderPort.html">OhSenderPort</a>
        /// ̒ۃ\bhłB<p/>
        /// 
        /// Ƀoϐ _dataPackArray, _numberOfDataPacks i[܂B
        /// 
        /// </remarks>
        /// <param name="aDpArray">an <var>OhArrayList[]</var> value<p/>
        /// </param>
        /// <param name="aNumOfDp">an <var>int[]</var> value<p/>
        /// </param>
        public override void getDataPackArray(OhArrayList[] aDpArray, int[] aNumOfDp)
        {
            //; (*12)
            aNumOfDp[0] = _numberOfDataPacks;
            aDpArray[0] = _dataPackArray;
        }


        /// <summary> 
        /// w肵ăf[^pbN𑗐M(擾)܂B<p/>
        /// Sends the datapacks at the appointed "datatime".
        /// </summary>
        /// <remarks>
        /// NX
        /// <a href="OhSenderPort.html">OhSenderPort</a>
        /// ̒ۃ\bhłB<p/>
        /// 
        /// _sender  null łȂꍇA_sender  getDataPack() s܂B
        /// ̎A͂̂܂ܓn܂B<p/>
        /// 
        /// _sender  null ̏ꍇA_dataPackArray Ĉȉ̏sȂ܂B<p/>
        /// 
        /// aFormer ɂ́Af[^L^ _dataTime ȑO _dataTime ɍł߂
        /// ^f[^pbN擾Ai[܂B<p/>
        /// 
        /// aLater ɂ́Af[^L^ _dataTime ȍ~ _dataTime ɍł߂
        /// ^f[^pbN擾Ai[܂B<p/>
        /// 
        /// f[^L^x _dataTime łf[^pbN^Ăꍇ́A
        /// aFormer, aLater Ƃi[܂B<p/>
        /// 
        /// 𖞂f[^pbN擾łȂꍇAaFormer, aLater  null ɐݒ肳܂B<p/>
        /// 
        /// aMode ͎擾[hI邽߂̃IvVŁAL̒ʂłB<p/>
        /// 
        /// <ul>
        /// <li> 'b' ----> aFormer, aLater ̗K擾B擾łȂꍇ͗Ƃ null ɐݒ肷B</li>
        /// <li> 'f' ----> aFormer K擾BaLater 擾łȂĂ aFormer ̂ݎ擾B</li>
        /// <li> 'l' ----> aLater K擾BaFormer 擾łȂĂ aLater ̂ݎ擾B</li>
        /// <li> ̑ -> aFormer, aLater ̏ȂƂ擾B</li>
        /// </ul>
        /// <p/>
        /// 
        /// aMode ̃ftHgl 'b' łB
        /// d`̂ŁA
        ///  aLater nȂꍇ aMode  'f' Ƃ aFormer ݂̂擾A
        ///  aFormer nȂꍇ aMode  'l' Ƃ aLater ݂̂擾܂B
        /// </remarks>
        /// 
        /// <param name="aFormer">an <var>Object[]</var> value<p/>
        /// </param>
        /// <param name="_dataTime">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aLater">an <var>Object[]</var> value<p/>
        /// </param>
        /// <param name="aMode">a <var>char</var> value<p/>
        /// </param>
        /// <returns> a <var>bool</var> value<p/>
        /// </returns>
        public override bool getDataPack(Object[] aFormer, OhTimePoint _dataTime, Object[] aLater, char aMode)
        {
            //; (*6-1)
            if (_numberOfDataPacks <= 0) //f[^pbNȂꍇ
            {
                aFormer[0] = null;
                aLater[0] = null;
                return false;
            }

            if ((((OhDataPack)_dataPackArray[_numberOfDataPacks - 1]).DataTime).CompareTo(_dataTime) < 0)
                //f[^pbN̍Ō̗vf̎Aw肵ꍇ
            {
                aLater[0] = null;

                if ((aMode == 'b') || (aMode == 'l'))
                {
                    aFormer[0] = null;
                    return false;
                }

                aFormer[0] = _dataPackArray[_numberOfDataPacks - 1];
                return true;
            }
            else if ((((OhDataPack)_dataPackArray[_numberOfDataPacks - 1]).DataTime).CompareTo(_dataTime) == 0)
                // ꍇ
            {
                aFormer[0] = aLater[0] = _dataPackArray[_numberOfDataPacks - 1];
                return true;
            }

            //ȊȌꍇAT
            for (int k = _numberOfDataPacks - 2; k >= 0; k--)
                if ((((OhDataPack)_dataPackArray[k]).DataTime).CompareTo(_dataTime) <= 0)
                {
                    aFormer[0] = _dataPackArray[k];
                    aLater[0] = (((OhDataPack)aFormer[0]).DataTime.CompareTo(_dataTime) == 0) ? aFormer[0] : _dataPackArray[k + 1];
                    return true;
                }
            //f[^pbN̍ŏ̗vf̎Aw肵傫ꍇ
            aFormer[0] = null;
            aLater[0] = _dataPackArray[0];

            if ((aMode == 'b') || (aMode == 'f'))
            {
                aLater[0] = null;
                return false;
            }
            return true;
        }


        /// <summary> 
        /// wɂf[^pbN𑗐M(擾)܂B<p/>
        /// Sends(Gets) the datapacks at the appointed "datatime".
        /// </summary>
        /// <remarks>
        /// NX
        /// <a href="OhSenderPort.html">OhSenderPort</a>
        /// ̒ۃ\bhłB<p/>
        /// 
        /// _sender  null łȂꍇA_sender  getDataPack() s܂B
        /// ̎A͂̂܂ܓn܂B<p/>
        /// 
        /// _sender  null ̏ꍇA_dataPackArray Ĉȉ̏sȂ܂B<p/>
        /// 
        /// aFormer ɂ́Af[^L^ _dataTime ȑO _dataTime ɍł߂
        /// ^f[^pbN擾Ai[܂B<p/>
        /// 
        /// aLater ɂ́Af[^L^ _dataTime ȍ~ _dataTime ɍł߂
        /// ^f[^pbN擾Ai[܂B<p/>
        /// 
        /// f[^L^x _dataTime łf[^pbN^Ăꍇ́A
        /// aFormer, aLater Ƃi[܂B<p/>
        /// 
        /// aFormer, aLater ̗K擾܂B擾łȂꍇ͗Ƃ null ɐݒ肵܂B
        /// </remarks>
        /// 
        /// <param name="aFormer">an <var>Object[]</var> value<p/>
        /// </param>
        /// <param name="_dataTime">an <var>OhTimePoint</var> value<p/>
        /// </param>
        /// <param name="aLater">an <var>Object[]</var> value<p/>
        /// </param>
        /// <returns> a <var>bool</var> value<p/>
        /// </returns>
        public virtual bool getDataPack(Object[] aFormer, OhTimePoint _dataTime, Object[] aLater)
        {
            //; (*6-2)
            if (_numberOfDataPacks <= 0)
            {
                aFormer[0] = null;
                aLater[0] = null;
                return false;
            }

            if ((((OhDataPack)_dataPackArray[_numberOfDataPacks - 1]).DataTime).CompareTo(_dataTime) < 0)
            {
                aLater[0] = null;
                aFormer[0] = null;

                return false;
            }
            else if ((((OhDataPack)_dataPackArray[_numberOfDataPacks - 1]).DataTime).CompareTo(_dataTime) == 0)
            {
                aFormer[0] = aLater[0] = _dataPackArray[_numberOfDataPacks - 1];
                return true;
            }

            for (int k = _numberOfDataPacks - 2; k >= 0; k--)
                if ((((OhDataPack)_dataPackArray[k]).DataTime).CompareTo(_dataTime) <= 0)
                {
                    aFormer[0] = _dataPackArray[k];
                    aLater[0] = (((OhDataPack)aFormer[0]).DataTime.CompareTo(_dataTime) == 0) ? aFormer[0] : _dataPackArray[k + 1];
                    return true;
                }

            aFormer[0] = null;
            aLater[0] = null;

            return false;
        }


        /// <summary> 
        /// svf[^pbN܂B<p/>
        /// Deletion of an unnecessary datapacks.
        /// </summary>
        /// 
        /// NX
        /// <a href="OhSenderPort.html">OhSenderPort</a>
        /// ̒ۃ\bhłB<p/>
        /// 
        /// <a href="OhSendPort.html#getNecessaryTimeFrom()">OhSendPort.NecessaryTimeFrom</a>
        /// O̎^f[^pbN _bufferList A
        /// _dataPackArray, _numberOfDataPacks XV܂B <p/>
        /// 
        /// 
        /// <p/>
        /// 
        public override void reduceDataPackStock()
        {
            //; (*9)
            if (_protectPastDataFlag == true)
                return;

            if (_numberOfDataPacks <= 0)
                return;

            IOhTimePointImmutable reserve = NecessaryTimeFrom;

            int k = 0;
            for (k = _numberOfDataPacks - 1; k >= 0; k--)
                if ((((OhDataPack)_dataPackArray[k]).DataTime).CompareTo(reserve) <= 0)
                    break;

            if (k <= 0)
                return; // No data to be deleted.

            _dataPackArray.removeHeadRange(k);
            setDataPackArray();
        }


        /// <summary> 
        /// wɂsvf[^pbN܂B<p/>
        /// Delete past datapack before "aTFrom".
        /// </summary>
        /// <remarks>
        /// aTFrom (arg) O̎^f[^pbN _bufferList A
        /// _dataPackArray, _numberOfDataPacks XV܂B
        /// <p/>
        /// Delete past datapack before "aTFrom",
        /// and renew "_dataPackArray" and "_numberOfDataPacks".
        /// </remarks>
        /// <param name="aTFrom">an <var>OhTimePointImmutable</var> value<p/>
        /// </param>
        public virtual void forgetDataPackStock(IOhTimePointImmutable aTFrom)
        {
            //; (*10)
            if (_protectPastDataFlag == true)
                return;

            if (_numberOfDataPacks <= 0)
                return;

            int k = 0;
            for (k = _numberOfDataPacks - 1; k >= 0; k--)
                if ((((OhDataPack)_dataPackArray[k]).DataTime).CompareTo(aTFrom) <= 0)
                    break;

            if (k <= 0)
                return; // No data to be deleted.

            _dataPackArray.removeHeadRange(k);

            setDataPackArray();
        }


        /// <summary> 
        /// S^f[^pbN܂B<p/>
        /// Deletion of all recorded datapacks.
        /// </summary>
        /// <remarks>
        /// _bufferList ̑S^f[^pbNA_dataPackArray ܂B
        /// ̌A_dataPackArray  null ɁA_numberOfDataPacks  -1 ɐݒ肳܂B
        /// </remarks>
        public virtual void clearDataPack()
        {
            //; (*11)
            _dataPackArray = null;
            _numberOfDataPacks = -1;
        }


       

        // 3. Function to save the recorded datapacks at a file.

        /// <summary> 
        /// f[^pbNXg[ aSw ɏ݂܂B <p/>
        /// Saves the recorded datapacks at the file, "aSw".
        /// </summary>
        /// <remarks>
        /// ^Ăf[^pbNo̓Xg[ aSw Ŏw肳t@Cɏ݂܂B<p/>
        /// 
        /// f[^ׂ͂ ( ... ) ̂悤Ɋʂň݂͂܂B
        /// ŏ̃f[^́A^Ăf[^pbŇłB
        /// f[^pbŇȂA
        /// ̂ƂɃf[^pbN𕶎ɕϊAʂň͂񂾂݂̂܂B
        /// </remarks>
        /// <param name="aSw">a <var>PrintWriter</var> value<p/>
        /// </param>
        public virtual void saveSendPortStock(StreamWriter aSw)
        {
            //; (*7)
            _numberOfDataPacks = _dataPackArray.Count;

            aSw.Write("(" + _numberOfDataPacks + ") # _numberOfDataPacks" + NEWLINE);

            if (_numberOfDataPacks <= 0)
                return;

            for (int k = 0; k < _numberOfDataPacks; k++)
            {
                aSw.Write(NEWLINE);
                ((OhDataPack)_dataPackArray[k]).dpack2File(aSw);
            }
        }

        // @end {methods} ------------------------------------------------------

       
    } // OhSendPort
}