// OhSenderPort; class to express a sender port. </(#)>
//                    Made from "OhSenderPort.java" by Ohshima.
//                     Last update : 2008/02/27 12:07:04
//
using System;
using System.Collections;
using System.IO;
using System.Text;
using OhymosNet;

namespace OhymosNet
{


    /// <summary>
    /// {^Mn[qf\NXłB
    /// ̃NX<a href = "OhymosNet.OhPort.html">OhPort</a>
    /// pĂ܂B<p/>
    /// OhSenderPort;
    /// 
    /// Abstract class for creating sender ports. 
    /// It extends <a href = "OhymosNet.OhPort.html">OhPort</a> class.<p/>
    /// </summary>
    /// <remarks>
    /// ̃NX́AMn[q쐬邽߂̒ۃNXłB
    /// Mn[q͑M@\[qłB<p/>
    /// 
    /// ̒ۃNX OhSenderPort A
    /// ŎĂf[^𑗐M <a href="OhymosNet.OhSendPort.html">OhSendPort</a> 
    /// ̒[q瓾f[^𒆌p <a href="OhymosNet.OhRelayPort.html">OhRelayPort</a> h܂B<p/>
    /// 
    /// 
    /// ŁA<a href="OhymosNet.OhSendPort.html">OhSendPort</a> ́AgŃf[^Ă鑗M[qłB
    /// <a href="OhymosNet.OhRelayPort.html">OhRelayPort</a> ́A
    /// ł̓f[^ĂȂAM[q̑Mv󂯂A
    /// ̒[qf[^ē][qłB
    /// 
    /// ɂĂAM炷΁Af[^𑗐MĂ@\Ă̂ŁA
    /// ̋ʕ̃C^[tF[X OhSenderPort Œ`Ă܂B<p/>
    /// 
    /// OhSenderPort ɂ͕̑M[qif[^M[qjڑ邱Ƃł܂B
    /// <p/>
    /// <br/>
    /// 
    /// By inheritance from this OhSenderPort class,
    /// the classes <a href="OhymosNet.OhSendPort.html">OhSendPort</a>
    /// and <a href="OhymosNet.OhRelayPort.html">OhRelayPort</a> are created.
    /// </remarks>
     public abstract class OhSenderPort : OhPort
    {
        // @begin {fields} ---------------------------------------------------

        /// <summary> 
        /// Ɨp̐`XgłB
        /// 
        /// <p/>
        /// The list for work.
        /// 
        /// </summary>
        protected internal OhLinkedList _bufferList;


        /// <summary> 
        /// M̎M[qL邽߂ Object ^złB
        /// 
        /// <p/>
        /// Array for memorizing the ports of sending place.
        /// 
        /// </summary>
        protected internal Object[] _receiverArray;

        /// <summary> 
        /// _receiverArray ̗vfłB
        /// 
        /// <p/>
        /// The number of elements of "_receiverArray".
        /// 
        /// </summary>
        protected internal int _numberOfReceivers;

        /// <summary> 
        /// f[^łB
        /// 
        /// <p/>
        /// Comment about data.
        /// 
        /// </summary>
        protected internal String _commentString;

        // @end {fields} -------------------------------------------------------


        // @begin{initialization} ----------------------------------------------

        /// <summary> 
        /// IuWFNgAIuWFNgԍ܂B
        /// 
        /// <p/>
        /// Initialization.
        /// 
        /// </summary>
        /// <param name="aPortName">a <var>String</var> value
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value
        /// </param>
        public override void init(String aPortName, int aPortNum)
        {
            base.init(aPortName, aPortNum);
        }

        // @end{initialization} ------------------------------------------------


        // @begin {constructors} -----------------------------------------------

        /// <summary>
        /// ftHgRXgN^łB<p/>
        /// Creates a new default <var>OhsenderPort</var> instance.
        /// </summary>
        /// <remarks>
        /// ftHgRXgN^
        /// <a href="OhSenderPort.html#init(String, int)">OhSenderPort.init(String, int)</a> s܂B
        /// ̌ʁAȉ̐ݒƂȂ܂B<p/>
        /// 
        /// <dl>
        /// <li> _objectName        : null</li>
        /// <li> _objectNumber      : -1</li>
        /// </dl>
        /// 
        /// ̑̃oϐɑ΂鏈͈RXgN^ƓłB
        /// ̏ꍇA<a href="OhSenderPort.html#init(String, int)">OhSenderPort.init(String, int)</a> 
        /// păoĉB
        /// </remarks>
        public OhSenderPort()
            : base()
        {

            _receiverArray = null;
            _numberOfReceivers = -1;
            _className = "OhSenderPort";
            _commentString = null;

            _bufferList = new OhLinkedList();
        }


        /// <summary>
        /// [qA[qԍw肵OhSenderPort̃CX^X𐶐܂B<p/>
        /// Creates a new default <var>OhsenderPort</var> instance.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̃ftHgRXgN^pA
        /// <a href="OhSenderPort.html#init(String, int)">OhSenderPort.init(String, int)</a> pāA
        /// oϐȉ̒ʂ菉܂B<p/>
        /// 
        /// <ul>
        /// <li> _className         : "OhSenderPort"</li>
        /// <li> _objectName        : aPortName</li>
        /// <li> _objectNumber      : aPortNum</li>
        /// <li> _owner             : null</li>
        /// <li> _bufferList        : ɊmۂBiڑƗpj</li>
        /// <li> _receiverArray     : null</li>
        /// <li> _numberOfReceivers : -1</li>
        /// </ul>
        /// </remarks>
        /// <param name="aPortName">a <var>String</var> value<p/>
        /// [q
        /// </param>
        /// <param name="aPortNum">an <var>int</var> value<p/>
        /// [qԍ
        /// </param>
        /// <exception cref="OhError">if an error occurs
        /// </exception>
        public OhSenderPort(String aPortName, int aPortNum)
            : base()
        {

            _receiverArray = null;
            _numberOfReceivers = -1;
            _className = "OhSenderPort";
            _commentString = null;

            init(aPortName, aPortNum);

            _bufferList = new OhLinkedList();
        }

        // @end {constructors} -------------------------------------------------

        // @begin{properties}--------------------------------------------------------------------
        /// <summary> 
        /// _commentString 擾Eݒ肵܂B
        /// <p/>
        /// Gets or sets"_commentString".
        /// 
        /// </summary>
        public virtual String CommentString
        {
            get
            {
                //; (*7)
                return _commentString;
            }

            set
            {
                //; (*6)
                _commentString = value;
            }

        }
        /// <summary>
        /// f[^Kv擾܂B<p/>
        /// The minimum thing is got 
        /// among <a href="OhElement.html#getNecessaryTimeFrom()">OhElement.getNecessaryTimeFrom()</a> of the "_owner"
        /// and <a href="OhPort.html#getNecessaryTimeFrom()">OhPort.getNecessaryTimeFrom()</a> of
        /// the port of a sending place. </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃvpeBĂ܂B<p/>
        /// 
        /// ̃vpeBł́A
        /// _owner  <a href="OhElement.html#getNecessaryTimeFrom()">OhElement.getNecessaryTimeFrom()</a>A
        /// M[q <a href="OhPort.html#getNecessaryTimeFrom()">OhPort.NecessaryTimeFrom</a> ̂A
        /// ŏ̂̂Ԃ܂B
        /// ̎A_owner  null Ȃ
        /// <a href="OhTimePoint.html#OhTimePointMin">OhTimePoint.OhTimePointMin</a> Ԃ܂B
        /// <p/>
        /// 
        /// If "_owner" is "null",
        /// Returns <a href="OhTimePoint.html#OhTimePointMin">OhTimePoint.OhTimePointMin</a>.
        /// </remarks>
        /// 
        public override IOhTimePointImmutable NecessaryTimeFrom
        {
            get
            {
                //; (*3)
                if (_owner == null || _numberOfReceivers <= 0)
                {
                    return OhTimePoint.OhTimePointMin;
                }

                IOhTimePointImmutable t0 = OhTimePoint.OhTimePointMax;
                IOhTimePointImmutable t1 = new OhTimePoint();

                for (int k = 0; k < _numberOfReceivers; k++)
                {
                    Object r = _receiverArray[k];
                    t1 = ((OhPort)r).NecessaryTimeFrom;
                    if (t1.CompareTo(t0) < 0)
                        t0 = t1;
                }
                return t0;
            }

        }
        /// <summary> 
        /// f[^Kv擾܂B<p/>
        /// The maxmum thing is got
        /// among <a href="OhElement.html#getNecessaryTimeTo()">OhElement.getNecessaryTimeTo()</a> of the "_owner"
        /// and <a href="OhPort.html#getNecessaryTimeTo()">OhPort.NecessaryTimeTo</a> of
        /// the port of a sending place. 
        /// </summary>
        /// 
        /// <remarks>
        /// If "_owner" is "null",
        /// Returns <a href="OhTimePoint.html#OhTimePointMax">OhTimePoint.OhTimePointMax</a>.
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃ\bhĂ܂B<p/>
        /// 
        /// ̃\bhł́A
        /// _owner  <a href="OhElement.html#getNecessaryTimeTo()">OhElement.getNecessaryTimeTo()</a>A
        /// M[q <a href="OhPort.html#getNecessaryTimeTo()">OhPort.getNecessaryTimeTo()</a> ̂A
        /// ő̂̂Ԃ܂B
        /// ̎A_owner  null Ȃ
        /// <a href="OhTimePoint.html#OhTimePointMax">OhTimePoint.OhTimePointMax</a> Ԃ܂B
        /// 
        /// <p/>
        /// </remarks>
        public override IOhTimePointImmutable NecessaryTimeTo
        {
            get
            {
                //; (*4)
                if (_owner == null || _numberOfReceivers <= 0)
                {
                    return OhTimePoint.OhTimePointMax;
                }

                IOhTimePointImmutable t0 = OhTimePoint.OhTimePointMin;
                IOhTimePointImmutable t1 = new OhTimePoint();

                for (int k = 0; k < _numberOfReceivers; k++)
                {
                    Object r = _receiverArray[k];
                    t1 = ((OhPort)r).NecessaryTimeTo;
                    if (t1.CompareTo(t0) > 0)
                        t0 = t1;
                }
                return t0;
            }

        }
        /// <summary> 
        /// f[^̌^Ԃ܂B<p/>
        /// Gets the datapack type string of this port.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃvpeBłB
        /// ̃NX OhSenderPort łۃvpeBƂĂ܂B
        /// 
        /// <p/>
        /// 
        /// Gets the datapack type string of this port.
        /// Because this is an abstract method, it should be implemented in derived classes.
        /// </remarks>
        /// <returns> a <var>String</var> value
        /// </returns>
        public abstract override String DataType { get;}

        // 1. Connection function.
        /// <summary> 
        /// ̑M[qf[^̃f[^Ԍ^z񃊃Xg擾Eݒ肵܂B
        /// ۃvpeBłB
        /// 
        /// <p/>
        /// 
        /// Abstract property.
        /// It should return the data connection vector.
        /// 
        /// </summary>
        /// <returns> a <var>ArrayList</var> value
        /// </returns>
        public abstract ArrayList DctVec{get; set;}

        /// <summary> 
        /// f[^pbNi[ꂽz񃊃Xg擾܂B
        /// ۃvpeBłB<p/>
        /// Abstract property.
        /// Gets the datapack array.
        /// 
        /// </summary>
        /// <returns> an <code>OhArrayList</code> value
        /// </returns>
        public abstract OhArrayList DataPackArray { get;}
		

        // @end {properties} -------------------------------------------

        // @begin {abstract methods} -------------------------------------------

        // 2. Function for sending datapacks.

        /// <summary> 
        /// f|^pbN̔z񃊃Xgݒ肵܂B <p/>
        /// Abstract method.
        /// Makes data pack array.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃ\bhłB
        /// ̃NX OhSenderPort łۃ\bhƂĂ܂B<p/>
        /// 
        /// ۂɂ́A
        /// _dataPackArray ̗vf _numberOfDataPacks ɐݒ肷邾łB
        /// <p/>
        /// </remarks>
        /// 
        public abstract override void setDataPackArray();


        /// <summary>
        /// 擾\f[^pbN̊mFsȂ܂B<p/>
        /// Abstract method.
        /// Checks the data time recorded.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃ\bhłB
        /// ̃NX OhSenderPort łۃ\bhƂĂ܂B<p/>
        /// 
        /// canYouGetData(OhTimePointImmutable aTFrom, OhTimePointImmutable aTTo) , aTFrom ȑOA
        /// aTTo ȍ~܂ł̃f[^pbN̒[q擾\Ȃ΁A
        /// true ԂAs\Ȃ false Ԃ悤ɊehNXŒ`܂.
        /// </remarks>
        /// 
        /// <param name="aTFrom">an <var>OhTimePointImmutable</var> value<p/>
        /// aTFrom ȑÕf[^pbN擾\ł邱ƂmF.
        /// </param>
        /// <param name="aTTo">an <var>OhTimePointImmutable</var> value<p/>
        /// aTTo ȍ~܂ł̃f[^pbN擾\ł邱ƂmF.
        /// </param>
        /// <returns> a <var>bool</var> value<p/><pre>
        /// Etrue       aTFrom ȑO aTTo ȍ~܂ł̃f[^pbN擾\ȏꍇ.
        /// t ɂf[^擾\ȏꍇ.
        /// Efalse      aTFrom ȑO aTTo ȍ~܂ł̃f[^pbN擾s\ȏꍇ.
        /// </pre>
        /// </returns>
        public abstract override bool canYouGetData(IOhTimePointImmutable aTFrom, IOhTimePointImmutable aTTo);

        /// <summary>
        /// f[^pbN̔z񃊃Xg𑗐M(擾)܂B<p/>
        /// Abstract method.
        /// Sends the datapack array.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃ\bhłB
        /// ̃NX OhSenderPort łۃ\bhƂĂ܂B<p/>
        /// 
        /// hNXɂāAf[^pbNz擾郁\bh`܂B
        /// aDpArray ɂ̓f[^pbNzi[AaNumOfDp ɂ́AaDpArray ̗vfi[܂B
        /// <p/>
        /// </remarks>
        /// <param name="aDpArray">an <var>OhArrayList[]</var> value<p/>
        /// </param>
        /// <param name="aNumOfDp">an <var>int[]</var> value<p/>
        /// </param>
        public abstract override void getDataPackArray(OhArrayList[] aDpArray, int[] aNumOfDp);

        

        /// <summary>
        /// wɂf[^pbN擾(M) ܂B<p/>
        /// Abstract method.
        /// Sends the datapacks.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃ\bhłB
        /// ̃NX OhSenderPort łۃ\bhƂĂ܂B<p/>
        /// 
        /// hNXɂāAw肵ăf[^pbN擾֐`܂B<p/>
        /// 
        /// aFormer ɂ́Af[^L^ aDataTime ȑO aDataTime ɍł߂^f[^pbN擾Ai[܂B<p/>
        /// 
        /// aLater ɂ́Af[^L^ aDataTime ȍ~ aDataTime ɍł߂^f[^pbN擾Ai[܂B<p/>
        /// 
        /// aFlag ͎擾̃[hI邽߂̃IvVŁAL̒ʂłB
        /// 
        /// <pre>
        /// E"b"       aFormer, aLater ̗K擾B
        ///             擾łȂꍇ́AƂ null ɐݒ肷B
        /// E"f"       aLater 擾łȂĂAaFormer ̂ݎ擾B
        ///             aLater 擾łȂꍇAnull ɐݒ肷B
        /// E"l"       aFormer 擾łȂĂAaLater ̂ݎ擾B
        ///             aFormer 擾łȂꍇAnull ɐݒ肷B
        /// Ȇ    aFormer, aLater ̂ȂƂ擾B
        ///             擾łȂ̂ null ɐݒ肷B
        /// </pre>
        /// 
        /// aFlag ̃ftHgĺA "b" łB<p/>
        /// ܂A  aLater nȂꍇ́A aFlag  f Ƃ aFormer ̂ݎ擾A
        ///  aFormer nȂꍇ́A aFlag  l Ƃ aLater ̂ݎ擾܂B<p/>
        /// 
        /// f[^L^x aDataTime łf[^pbN^Ăꍇ́A
        /// aFormer, aLater Ƃi[܂B<p/>
        /// 
        /// 𖞂f[^pbN擾łȂꍇAaFormer, aLater  null ɐݒ肳܂B<p/>
        /// 
        /// f[^擾łꍇ́Atrue Ԃ܂B
        /// </remarks>
        /// <p/>
        /// 
        /// <param name="aFormer">an <var>Object[]</var> value
        /// </param>
        /// <param name="aDataTime">an <var>OhTimePoint</var> value
        /// </param>
        /// <param name="aLater">an <var>Object[]</var> value
        /// </param>
        /// <param name="aMode">a <var>char</var> value
        /// </param>
        /// <returns> a <var>bool</var> value
        /// </returns>
        public abstract override bool getDataPack(Object[] aFormer, OhTimePoint aDataTime, Object[] aLater, char aMode);


        /// <summary>
        /// svf[^pbN܂B<p/>
        /// Abstract method.
        /// Deletion of an unnecessary datapacks.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃ\bhłB
        /// ̃NX OhSenderPort łۃ\bhƂĂ܂B<p/>
        /// 
        /// ̒[qŎ擾\ȃf[^pbN̂A
        /// getNecessaryTimeFrom() f[^L^f[^pbN悤A
        /// hNXŒ`܂B
        /// <p/>
        /// </remarks>
        public abstract override void reduceDataPackStock();

        // @end {abstract methods} ---------------------------------------------



        // @begin {methods} ----------------------------------------------------

        // 1. connection function

        /// <summary>
        /// M(M)[qo^܂B<p/>
        /// Registers a receiver.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̃\bhI[o[ChĂ܂B<p/>
        /// 
        /// ̃\bh́A[qԂ̐ڑ̍ۂɌĂяo܂B<p/>
        /// 
        /// <a href="OhLinkedList.html#add(Object)">OhLinkedList.Add(Object)</a> ɂ
        /// _bufferList  ł aReceiver o^܂
        /// 
        /// Ȁꍇ̓G[bZ[W\܂B<p/>
        /// 
        /// <ol>
        /// <li> _bufferList  null ̏ꍇB</li>
        /// <li> _receive_port_array 쐬ς݂̏ꍇB</li>
        /// <li> ̒[q aReceiver ƂŁA_dataPackType قȂꍇB</li>
        /// </ol>
        /// 
        /// ܂AaReceiver  _bufferList ɓo^ς݂̏ꍇ́Ado^ɖ߂܂B
        /// <p/>
        /// This function is an abstract method in the base class <a href="OhPort.html">OhPort</a>.
        /// Implemented in this class OhSenerPort.
        /// </remarks>
        /// <param name="aReceiver">an <var>OhObject</var> value
        /// </param>
        /// <exception cref="ArgumentException">̎M[qnull̏ꍇ</exception>
        /// <exception cref="OhError">
        /// <ul>
        /// <li>_receive_port_array 쐬ς݂̏ꍇ</li>
        /// <li>_bufferList  null ̏ꍇ</li>
        /// <li>̒[q aReceiver ƂŁA_dataPackType قȂꍇ</li>
        /// </ul>
        /// </exception>
        public override void registerReceiver(OhObject aReceiver)
        {
            //; (*1)
            if (aReceiver == null)
            {
                throw new ArgumentException("Cannot register 'receiver'" + NEWLINE + oPrintString(" > "));
            }

            if (_numberOfReceivers >= 0)
            {
                throw new OhError("\"_bufferList\" has already been switched.",
                                  aReceiver.oPrintString(" > ") + oPrintString(" > "));
            }

            if (_bufferList == null)
            {
                throw new OhError("Cannot register 'receiver'", oPrintString( " > "));
            }

            // Gets the datapack type which this port sends, and the datapack type which "aReceiver" receives.
            //
            String sType = DataType; //; Abstract method call.
            String rType = ((OhPort)aReceiver).DataType;

            if (!sType.Equals(rType))
            {
                throw new OhError("'dataType' of this port and  are different.",
                                  aReceiver.oPrintString("\"aReceiver\"(arg) > ") + oPrintString(" > "));
            }

            if (_bufferList.Contains(aReceiver) == true)
                return ;

            _bufferList.Add(aReceiver);
        }



        /// <summary>
        /// [q̐ڑƂ̏Iуf[^MJn̂߂̏Ƃs܂B<p/>
        /// Finish registration of receivers and count the number of receivers.
        /// 
        /// </summary>
        /// <remarks>
        /// NX OhPort ̒ۃ\bhĂ܂B<p/>
        /// 
        /// _bufferList ɓo^Ă鑗MM[q _receiverArray ɔz񉻂A
        /// _receiverArray ̗vf _numberOfReceivers ɐݒ肵܂B<p/>
        /// 
        /// _receiverArray 쐬ς݂̏ꍇ́AG[bZ[W\܂B<p/>
        /// 
        /// ڑƂ̏IA_owner ̌vZJnOɕKpĉB
        /// Ã\bh̎s͐ڑ֌WύXł܂B<p/>
        /// 
        /// <p/>
        /// 
        /// Makes "_receiverArray" from the port of the sending place registered into "_bufferList".
        /// And, the number of elements of "_receiverArray" is set as "_numberOfReceivers".
        /// </remarks>
        /// <exception cref="OhError">_receiverArray 쐬ς݂̏ꍇ
        /// </exception>
        public override void doSwitch()
        {
            //; (*2)
            if (_numberOfReceivers >= 0)
            {
               throw new OhError("\"_receiverArray\" has already been set.", oPrintString(" > "));
            }

            _receiverArray = (Object[])_bufferList.ToArray(typeof(Object));
            _numberOfReceivers = _bufferList.Count;

            _bufferList = null;
        }


        /// <summary> 
        /// vZƑO̊mFsȂ܂B<p/>
        /// Check that it is in the state where data packs can be transmitted.
        /// </summary>
        /// <remarks>
        /// NX <a href="OhPort.html">OhPort</a> ̒ۃ\bhĂ܂B<p/>
        /// 
        /// f[^pbN𑗐M\ȏԂł邱ƂmF܂B
        /// _numberOfReceivers  0 ȏȂ _receiverArray ݒς݂ŁA
        /// M[qɃf[^pbN𑗐M邱Ƃł܂B
        /// 
        /// <p/>
        /// Check that it is in the state where data packs can be transmitted.
        /// If _numberOfReceivers >= 0,
        /// _receiverArray is setting ending,
        /// and you can send data packs to a send port.
        /// </remarks>
        /// 
        /// <returns> a <var>bool</var> value<p/>
        /// <pre>
        /// [RETURN]
        /// Etrue      _receiverArray ݒς݂̏ꍇ
        /// Efalse     _receiverArray ݒ̏ꍇ
        /// </pre>
        /// 
        /// </returns>
        public override bool areYouReady()
        {
            //; (*8)
            return (_numberOfReceivers >= 0) ? true : false;
        }


        // 2. Function for sending datapacks.


        // 3. imformation output function.

        /// <summary> 
        /// ڑo͂܂B <p/>
        /// 
        /// ̒[q̐ڑ֌WɊւłXg[ aSw ɏo͂܂B<p/>
        /// The information about the connection relation of this port is outputted to "aSw". 
        /// 
        /// </summary>
        /// <param name="aSw">a <var>StreamWriter</var> value<p/>
        /// o͐̃Xg[
        /// </param>
        /// <param name="aHead">a <var>String</var> value<p/>
        /// õ͎wb_BftHgl͂SJ
        /// </param>
        public override void printConnection(StreamWriter aSw, String aHead)
        {
            //; (*5)
            oPrint(aSw, aHead);

            if (_numberOfReceivers <= 0)
            {
                aSw.Write(aHead + " Not connected." + NEWLINE);
                return;
            }

            StringBuilder sb = new StringBuilder("");

            if (aHead != null)
                sb.Append(aHead);

            sb.Append(" Connected > ");
            String str = sb.ToString();

            for (int k = 0; k < _numberOfReceivers; k++)
            {
                ((OhPort)_receiverArray[k]).oPrint(aSw, str);
            }
        }

        // @end {methods} ------------------------------------------------------

       
    } // OhSenderPort
}