/// <summary> OhStreamReader.java
/// Created: DATE
/// Tested and modified by Naoto Ohshima. Date:2007/09/14 22:52:59
/// 
/// </summary>
/// <author>  <a href="mailto:shiiba@toewin.kuciv.kyoto-u.ac.jp">shiiba</a>
/// </author>
/// <version>  $Revision: 1.5 $
/// 
/// </version>
/// <(#)>  </(#)>
using System;
using System.IO;
using System.Text;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary>
	/// NX StreamReader ɒP̓ǂݎ@\ǉNXłB<p/>
    /// </summary>
    /// <remarks>
	/// StreamReader ́As̓ǂݎ͂ł܂AP̓ǂݎ肪
	/// ł܂B OhStreamReader ́A
	/// 
	/// <ul>
	/// <li> readWord() ɂāA󔒕(p󔒁A^uAs)
	/// ؂蕶ƌȂāAP؂oƂł܂B</li>
	/// <li> Rgǂݔ΂悤Ɏwł܂Bw肷΁As
	/// # s͖܂Bs̓rɁA# ƁA
	/// s܂Ŗ܂B</li>
	/// </ul>
	/// 
    /// Rgsǂݔ΂悤Ɏw肷ꍇ́A
    /// <a href ="OhymosNet.OhStreamReaderConstructor.html">OhStreamReader̃RXgN^</a>
    /// ̂ARg[hwł̂ŁAtrueƎw肷邩A
    /// IuWFNg
    /// <a href ="OhymosNet.OhStreamReader.TreatCommentP.html">TreatCommentP{get; set;}</a>
    /// trueɐݒ肵܂B<p/>
    /// 
	///  OhStreamReader ́Af[^ǂݎ邽߂ɁAXg[
	/// 1s擾AɕێĂ܂B̕
	/// 𑖍āAP؂o܂B<p/>
	/// 
	/// RXgN^ȊOɒ`Ă֐́A
	/// 
	/// pushBack(), read(), readLine(), readWord(),
	/// skipWhites()
	/// 
	/// łBȊOɐeNXp֐Ŏgpėǂ̂́A
	/// close() łB
    /// </remarks>
	public class OhStreamReader:StreamReader
	{
		
        /// <summary>
        /// ̍s̕łB
        /// </summary>
		protected internal String _nextLine;

        /// <summary>
        /// index\܂B1ڂindex0łB
        /// </summary>
		protected internal int _ipos;

        /// <summary>
        /// Rg[hɂ邩ǂbooll\܂B
        /// 
        /// </summary>
		protected internal bool _treatCommentP = false;

        /// <summary>
        /// sindex\܂B1ڂindex1łB
        /// </summary>
		protected internal int _lineno = 0;

        /// <summary>
        /// s؂蕶\܂B
        /// </summary>
		protected internal static String NEWLINE = Environment.NewLine;

        /// <summary>
        /// GR[fBÕCfbNXłB
        /// GR[fBOindex͈ȉ̂悤ɂȂ܂B
        /// <li>0FVtgJIS</li>
        /// <li>1FJIS</li>
        /// <li>2F{EUC</li>
        /// <li>3FUTF-8</li>
        /// <li>4FUnicode(Big-Endian)</li>
        /// </summary>
        private static Encoding[] encodings = new Encoding[] 
        {
            Encoding.GetEncoding("shift_jis"),     // VtgJIS, 932
            Encoding.GetEncoding("iso-2022-jp"),   // JIS, 50222   
            Encoding.GetEncoding("euc-jp"),        // {EUC, 15932
            Encoding.GetEncoding("utf-8"),         // UTF-8, 65001
            Encoding.GetEncoding("unicodefffe")    // Unicode(Big-Endian). 1201
        };


        /// <summary>
        /// Rg[hɊւbooll̎擾EݒsvpeBłB
        /// ftHgłfalseɐݒ肳Ă܂B<br/>
        /// 
        /// <dt>Rg[hƂ</dt>
        /// <tt>#s܂ł̓̕RgƂ݂Ȃ</tt>
        /// ƂƂłB<br/>
        /// 
        /// 
        /// Returns the boolean flag about treat-comment-mode. 
        /// If this flag is true, treat-comment-mode is on.
        /// 
        /// Sets treat-comment-mode on.
        /// When treat-comment-mode is on,
        /// <ol>
        /// <li> lines which start with '#' are ignored;</li>
        /// <li> part string from '#' to the line end is ignored.</li>
        /// </ol>
        /// In default, treat-comment-mode is off.
        /// 
        /// </summary>
       
        public bool TreatCommentP
        {
            get { return _treatCommentP; }
            set { _treatCommentP = value; }
        }

        /// <summary>
        /// eXĝ߂̃vpeBłB_nextLine̒l擾܂B
        /// </summary>
        public String NextLine
        { 
            get { return _nextLine; } 
        }
        /// <summary>
        /// eXĝ߂̃vpeBłB_ipos̒l擾܂B
        /// </summary>
        public int Ipos
        {
            get { return _ipos; }
        }
        /// <summary>
        /// eXĝ߂̃vpeBłB_lineno̒l擾܂B
        /// </summary>
        public int LineNo 
        {
            get { return _lineno; }
        }

        /// <summary>
        /// w肵Xg[pOhStreamReaderNX̐VCX^X܂B
        /// GR[fBO̓VXě݂̃GR[fBOɂȂ܂B
        /// </summary>
        /// <param name="aIn">ǂݍ܂Xg[</param>
		public OhStreamReader(Stream aIn) 
            :base(aIn,Encoding.Default) 
		{
		}
        /// <summary>
        /// GR[fBOݒ肵āAw肵Xg[pOhStreamReaderNX
        /// VCX^X܂B<br/>
        /// 
        /// GR[fBOݒ肷ۂ͕GR[fBOindexw肵܂B
        /// GR[fBOindex͈ȉ̂ƂłB
        /// <li>0FVtgJIS</li>
        /// <li>1FJIS</li>
        /// <li>2F{EUC</li>
        /// <li>3FUTF-8</li>
        /// <li>4FUnicode(Big-Endian)</li>
        /// </summary>
        /// <param name="aIn">ǂݍ܂Xg[</param>
        /// <param name="encodingID">gpGR[fBOindex</param>
        public OhStreamReader(Stream aIn, int encodingID)
            :base(aIn, encodings[encodingID])
		{
		}
        /// <summary>
        /// GR[fBOARg[hݒ肵āAw肵Xg[p
        /// OhStreamReaderNX̐VCX^X܂B
        /// </summary>
        /// <param name="aIn">ǂݍ܂Xg[</param>
        /// <param name="encodingID">gpGR[fBOindex</param>
        /// <param name="aTreatCommentP"></param>
        public OhStreamReader(Stream aIn, int encodingID, bool aTreatCommentP)
            :base(aIn, encodings[encodingID])
		{
            _treatCommentP = aTreatCommentP;
		}
        /// <summary>
        /// Rg[hݒ肵āAw肵Xg[pOhStreamReaderNX
        /// VCX^X܂B
        /// </summary>
        /// <param name="aIn">ǂݍ܂Xg[</param>
        /// <param name="aTreatCommentP">Rg[h</param>
        public OhStreamReader(Stream aIn, bool aTreatCommentP)
            :base(aIn,Encoding.Default)
		{
			_treatCommentP = aTreatCommentP;
		}
        /// <summary>
        /// GR[fBOAуobt@TCYݒ肵āAw肵Xg[p
        /// OhStreamReaderNX̐VCX^X܂B
        /// </summary>
        /// <param name="aIn">ǂݍ܂Xg[</param>
        /// <param name="encodingID">gpGR[fBOindex</param>
        /// <param name="aSz">ŏobt@TCY</param>
		public OhStreamReader(Stream aIn, int encodingID, int aSz)
            :base(aIn, encodings[encodingID], false, aSz)
		{
        }
		/// <summary>
		/// GR[fBOAobt@TCYAуRg[hݒ肵āA
        /// w肵Xg[pOhStreamReaderNX̐VCX^X܂B
        /// </summary>
        /// <param name="aIn">ǂݍ܂Xg[</param>
        /// <param name="encodingID">gpGR[fBÕR[hy[W</param>
        /// <param name="aSz">ŏobt@TCY</param>
		/// <param name="aTreatCommentP">Rg[h</param>
		public OhStreamReader(Stream aIn, int encodingID, int aSz, bool aTreatCommentP)
            :base(aIn, encodings[encodingID], false, aSz)
		{
			_treatCommentP = aTreatCommentP;
		}

        /// ȉ̂S̃RXgN^̓t@CXg[ɑΉĂ܂B
        /// PɃt@C̃pXw肷邱ƂOhStreamReaderIuWFNg
        /// ܂B
        
        /// <summary>
        /// w肵t@COhStreamReaderNX̐VCX^X܂B
        /// GR[fBO̓VXě݂̃GR[fBOɂȂ܂B
        /// </summary>
        /// <param name="path">ǂݍ܂銮Sȃt@CpX</param>
        public OhStreamReader(string path)
            : base(path,Encoding.Default)
        {
        }
        /// <summary>
        /// GR[fBOݒ肵āA
        /// w肵t@COhStreamReaderNX̐VCX^X܂B
        /// </summary>
        /// <param name="path">ǂݍ܂銮Sȃt@CpX</param>
        /// <param name="encodingID">gpGR[fBOindex</param>
        public OhStreamReader(string path, int encodingID)
            : base(path, encodings[encodingID])
        {
        }
        /// <summary>
        /// GR[fBOAуRg[hݒ肵āA
        /// w肵t@COhStreamReaderNX̐VCX^X܂B
        /// </summary>
        /// <param name="path">ǂݍ܂銮Sȃt@CpX</param>
        /// <param name="encodingID">gpGR[fBOindex</param>
        /// <param name="aTreatCommentP">Rg[h</param>
        public OhStreamReader(string path, int encodingID, bool aTreatCommentP)
            : base(path, encodings[encodingID])
        {
            _treatCommentP = aTreatCommentP;
        }
        /// <summary>
        /// Rg[hݒ肵āA
        /// w肵t@COhStreamReaderNX̐VCX^X܂B
        /// GR[fBO̓VXě݂̃GR[fBOɂȂ܂B
        /// </summary>
        /// <param name="path">ǂݍ܂銮Sȃt@CpX</param>
        /// <param name="aTreatCommentP">Rg[h</param>
        public OhStreamReader(string path, bool aTreatCommentP)
            : base(path,Encoding.Default)
        {
            _treatCommentP = aTreatCommentP;
        }
        /// <summary>
        /// GR[fBOAуobt@ TCYݒ肵āA
        /// w肵t@COhStreamReaderNX̐VCX^X܂B
        /// </summary>
        /// <param name="path">ǂݍ܂銮Sȃt@CpX</param>
        /// <param name="encodingID">gpGR[fBÕR[hy[W</param>
        /// <param name="aSz">ŏobt@TCY</param>
        public OhStreamReader(string path, int encodingID, int aSz)
            : base(path, encodings[encodingID], false, aSz)
        {
        }
        /// <summary>
        /// GR[fBOAoCg}[NoIvVAуobt@TCYݒ肵āA
        /// w肵Xg[p OhStreamReader NX̐VCX^X܂B
        /// </summary>
        /// <param name="path">ǂݍ܂銮Sȃt@CpX</param>
        /// <param name="encodingID">gpGR[fBOindex</param>
        /// <param name="aSz">ŏobt@TCY</param>
        /// <param name="aTreatCommentP">Rg[h</param>
        public OhStreamReader(string path, int encodingID, int aSz, bool aTreatCommentP)
            : base(path, encodings[encodingID], false, aSz)
        {
            _treatCommentP = aTreatCommentP;
        }


		/// <summary> Sets _nextLine
        /// 
		/// 
		/// </summary>
		private void  setNextLine()
		{
			try
			{
				_nextLine = base.ReadLine();
				_lineno++;
				_ipos = 0;
				while (_nextLine != null && _nextLine.Length > 0 && _nextLine[0] == '#' && _treatCommentP)
				{
					_nextLine = base.ReadLine();
					_lineno++;
				}
				if (_nextLine != null && _nextLine.Length > 0)
				{
					bool incomment = false;
					char qMark = '\"'; //; "
					int i = _ipos;
					for (; i < _nextLine.Length; i++)
					{
						char c = _nextLine[i];
						if (incomment)
						{
							if (c == qMark)
							{
								incomment = false;
							}
							continue;
						}
						else
						{
							if (c == '\"' || c == '\'')
							{
								incomment = true;
								qMark = c;
								continue;
							}
							else if (_treatCommentP && c == '#')
							{
								_nextLine = _nextLine.Substring(0, i);
								break;
							}
						}
					} // end of for loop
					if (incomment)
					{
						String message = "Input data error. Unballanced quotation marks: " + NEWLINE + _lineno + ": " + _nextLine;
						// System.err.println(message);
						throw new IOException(message);
					}
				} // if (_nextLine != null && _nextLine.length() > 0)
			}
			// try
			catch (IOException e)
			{
				// e.printStackTrace();
				// System.err.println("IO error");
				throw e;
			}
		}
		
		/// <summary> Push back the last character which had been read in to this
		/// Reader. Only the character which bad been read in from the
		/// current line can be pushed back.
		/// 
		/// <japanese>
		/// <br/>
		///  Reader ɍŌɓǂݍ܂ꂽǂ܂ȂƂɂ
		/// āAɖ߂܂BA߂Ƃł̂́Aݓǂݍ
		/// ݂̑ΏۂɂȂĂsǂ܂ꂽłB
		/// </japanese>
		/// </summary>
		public void  pushBack()
		{
			if (_lineno == 0)
				return ;
			//; ܂1sǂłȂ̂ŁApushBack łȂ͂B
			if (_ipos > 0)
				_ipos--;
		}
		
		/// <summary> Read one character. When eof was deteced, return -1.
		/// When the reading pointer is at the line end, return '\n'.
		/// 
		/// </summary>
		/// <returns> an <code>int</code> value
		/// </returns>
		/// <exception cref="IOException">if an error occurs
		/// </exception>
		public  override int Read()
		{
			if (_lineno == 0)
				setNextLine();
			if (_nextLine == null)
				return - 1;
			if (_nextLine.Length == 0)
			{
				setNextLine();
				return '\n';
			}
			if (_ipos >= _nextLine.Length)
			{
				setNextLine();
				return '\n';
			}
			else
			{
				int k = (char) _nextLine[_ipos];
				_ipos++;
				return k;
			}
		}
		
		/// <summary> Reads a line of text.
		/// 
		/// <japanese>
		/// <br/>
		/// ݂̓ǂݎʒus܂œǂݎĕԂ܂B<p/>
		/// 
		/// ݂̓ǂ݂Ƃʒut@CI[ɗĂƂ́A
		/// readLine() ́Anull Ԃ܂B<p/>
		/// 
		/// ݂̓ǂݎʒusɂƂ́A󂫕Ԃ܂B
		/// <p/>
		/// 
		/// ̓ǂݎ|CǵÃ\bhœǎŝ
		/// ̍s̍sɂȂ܂B<p/>
		/// </japanese>
		/// 
		/// </summary>
		/// <returns> a <code>String</code> value
		/// </returns>
		/// <exception cref="IOException">if an error occurs
		/// </exception>
		public override String ReadLine()
		{
			if (_lineno == 0)
				setNextLine();
			String lastLine = _nextLine;
			String cline = lastLine;
            
            if (lastLine != null)
            {
                cline = lastLine.Substring(_ipos, lastLine.Length - _ipos);
                setNextLine();
            }
            
            else return null;

			return cline;
		}
		
		/// <summary> Read a word.
		/// 
		/// <japanese>
		/// <br/>
		/// Pǂ݂Ƃ܂BǂݎʒusȂA̍sP
		/// ǂ݂܂BPǂݎ낤ƂƂɁAs (sɂ
		/// ss) ɑA󂫕Ԃ܂B<p/>
		/// 
		/// PƂ́A
		/// 
		/// <ol>
		/// <li> pȊO̔󔒕̘A</li>
		/// <li> p (" ܂ ') p܂ł̕</li>
		/// </ol>
		/// 
		/// ܂B
		/// </japanese>
		/// 
		/// </summary>
		/// <returns> a <code>String</code> value
		/// </returns>
		/// <exception cref="IOException">if an error occurs
		/// </exception>
		public String readWord()
		{
			if (_lineno == 0)
				setNextLine();
			if (_nextLine == null)
				return null;
			int i = 0;
			char c = 'a';
			while (true)
			{
				// search a word
				if (_nextLine.Length == 0)
				{
					setNextLine();
					return "";
				}
				if (_ipos == _nextLine.Length)
				{
					// blank line or now at the line end
					setNextLine();
					if (_nextLine == null)
						return null;
					continue;
				}
				for (i = _ipos; i < _nextLine.Length; i++)
				{
					c = _nextLine[i];
					if (c != ' ' && c != '\t')
						break;
				}
				if (i < _nextLine.Length)
				{
					_ipos = i;
					break; //; find a word
				}
                setNextLine();
			}
			
			bool quotedStringP = false; 
            char qMark = '\"';
			if (c == '\"' || c == '\'')
			{
				quotedStringP = true;
				qMark = c;
				// System.out.println("_ipos = " + _ipos);
			}
			
			for (i = _ipos + 1; i < _nextLine.Length; i++)
			{
				c = _nextLine[i];
				if (quotedStringP)
				{
					if (c == qMark)
					{
						i++; break;
					}
				}
				else
				{
					if (c == ' ' || c == '\t' || c == '\"' || c == '\'')
						break;
				}
			}
			String word = _nextLine.Substring(_ipos, (i) - (_ipos));
			_ipos = i;
			// System.out.println("_nextLine: " + _nextLine);
			// System.out.println("word:      " + word);
			return word;
		}
		
		/// <summary> Skip white letters. The line end mark is also skipped.
		/// 
		/// <japanese>
		/// <br/>
		/// 󔒕 (p󔒁A^uAs) ǂݔ΂A
		/// ̏ɓǂݎ|Cgړ܂B
		/// 
		/// 󔒕ǂݔ΂ĂԂɁAt@C̏I[ɒBƂ
		/// ́A-1 Ԃ܂BȊÔƂ́Aǂݎ|Cg̕
		/// ̃R[hԂ܂B
		/// </japanese>
		/// </summary>
		public int skipWhites()
		{
			if (_lineno == 0)
				setNextLine();
			if (_nextLine == null)
			{
				return - 1;
			}
			int i = 0;
			char c = 'c';
			while (true)
			{
				// search a word
				if (_nextLine.Length == 0 || _ipos == _nextLine.Length)
				{
					// blank line or now at the line end
					setNextLine();
					if (_nextLine == null)
					{
						return - 1;
					}
					continue;
				}
				for (i = _ipos; i < _nextLine.Length; i++)
				{
					c = _nextLine[i];
					if (c != ' ' && c != '\t')
						break;
				}
				if (i < _nextLine.Length)
				{
					_ipos = i;
					break; //; find a word
				}
				setNextLine();
			}
            //_ipos++;
			return c;
		}
		
        ////UPGRADE_NOTE: \bh 'java.io.StreamReader.skip' ɑ郁\bh́Aoverride \bhł͂܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1143'"
        //public long skip(long n)
        //{
        //    IOException e = new IOException();
        //    throw e;
        //}
		
        //public  override int Read(Char[] cbuf, int off, int len)
        //{
        //    IOException e = new IOException();
        //    throw e;
        //}
		
        ////UPGRADE_NOTE: \bh 'java.io.StreamReader.mark' ɑ郁\bh́Aoverride \bhł͂܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1143'"
        //public void  mark(int a)
        //{
        //    IOException e = new IOException();
        //    throw e;
        //}
		
        ////UPGRADE_NOTE: \bh 'java.io.StreamReader.reset' ɑ郁\bh́Aoverride \bhł͂܂B "ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?index='!DefaultContextWindowIndex'&keyword='jlca1143'"
        //public void  reset()
        //{
        //    IOException e = new IOException();
        //    throw e;
        //}

    } // OhStreamReader
}