/// <(#)>  OhSubSystem; base class for creating subsystems. </(#)>
using System;
using System.Reflection;
using System.Collections.Generic;
using System.IO;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary>
    /// {^nf\NXłBۃNXłB
    /// ̃NX<a href = "OhymosNet.OhElement.html">OhElement</a>
    /// pĂ܂B<p/>
    /// 
    /// OhSubSystem is a class to express a subsystem which contains
	/// a number of elements.
    /// It extends <a href = "OhymosNet.OhElement.html">OhElement</a> class.
	/// <p/>
    /// </summary>
    /// <remarks>
    /// nf́AvfEnȂǁA
    /// ̃CX^XiȉA\vfA\IuWFNg; componentj ɂ
    /// \郂fłB
    /// {VXeł́Anf͌ƂĐvZs킸A
    /// f[^𒼐ڏƂ͓̗vfɂŝƂ܂B
    /// ]āAnf̌vZƂ͍\vfɏvZ߂𑗂邱ƂɂȂ܂B<p/>
    /// 
    /// ƂŁAnf́AMpp[qEMpp[qL܂A
    /// ̒p[qo^Eڑ葱́Avff̎M[qEM[q̏ꍇ
    /// ̎葱ƂĒ`ł܂B<p/>
    /// 
    /// ŁA{VXeł͕nfVɍ쐬̂ł͂ȂA
    /// vffpč쐬邱ƂƂ܂B
    /// nfł́AMpp[qEMpp[q
    /// <a href="OhymosNet.OhElement._receivePortArray.html">OhElement._receivePortArray</a>,
    /// <a href="OhymosNet.OhElement._sendPortArray.html">OhElement._sendPortArray</a> 
    /// ɋLĂ܂B
    /// ܂A[q̓o^Ɋւ <a href="OhymosNet.OhElement.html">OhElement</a> ̃\bh
    /// \vf̓o^ƂɂpA[q̓o^ƑS̎葱ō\vf̓o^sA
    /// nf쐬҂̗֐߂Ă܂B<p/>
    /// 
    /// nfł́AL̂悤ɓo^e\vfEp[qԂ̐ڑ
    /// `Ȃ΂Ȃ܂B
    /// A{^nfɐڑ̂߂̃\bhɒ`Ă̂ŁA
    /// {^nfpč쐬nfł́A
    /// ڑƂ͊{^nf̃\bhɈ^݂̂̍ƂɒPĂ܂B<p/>
    /// 
    /// ܂AvfEnǂڒʐMpĔvZs߂ɂ́A
    /// L镔nǗKv܂B<p/>
    /// 
    /// ŁAnfł͔vẐ߂̃\bh`Ă܂B
    /// </remarks>
	public abstract class OhSubSystem:OhElement
	{
		// @begin {instance variable or static variable} -------------
		
		/// <summary> Array for memorizing constituent elements.
		/// 
		/// 
		/// <p/>
		/// \vfLpz
		/// 
		/// </summary>
		internal Object[] _componentArray;
		
		/// <summary> Number of constituent elements.
		/// 
		/// 
		/// <p/>
		/// \vf̐
		/// 
		/// 
		/// </summary>
		internal int _numberOfComponents;
		
		
		/// <summary> Array for memorizing the costituent elements which carry
		/// out repeated calculation.
		/// 
		/// 
		/// <p/>
		/// vZsȂ\vfLpz
		/// 
		/// 
		/// </summary>
		internal Object[][] _iteratorArray;
		
		/// <summary> The number of the element groups which carry out repeated
		/// calculation.
		/// 
		/// 
		/// <p/>
		/// vZsȂvfQ̐
		/// 
		/// 
		/// </summary>
		internal int _numberOfIteratorSets;
		
		
		/// <summary> The number of the elements which constitute an element group.
		/// 
		/// 
		/// <p/>
		/// ꂼ̗vfQ\vf̐
		/// 
		/// </summary>
		internal int[] _numberOfIterators;

        // @end {instance variable or static variable} ---------------
		
		
		// @begin {abstract methods} ---------------------------------
		
		// 1. creation and reference of "_receivePortArray",
		// "_sendPortArray" and "_componentArray"
		
		/// <summary> 
		/// <p/>
		/// Mp[q̓o^ <p/>
		/// 
		/// Mp[qo^܂B
		/// hNXŒ`܂B
		/// (Ref "OhElement#construct()") Ă΂܂B
		/// o^ĂȂMp[q͐ڑł܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract override void  registerReceivePorts();
		
		/// <summary> 
		/// <p/>
		/// Mp[q̓o^ <p/>
		/// 
		/// Mp[qo^܂B
		/// hNXŒ`܂B
		/// construct() Ă΂܂B
		/// o^ĂȂMp[q͐ڑł܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract override void  registerSendPorts();
		
		/// <summary> 
		/// <p/>
		/// vZsȂȂ\IuWFNg _componentArray ɓo
		/// ^B<p/>
		/// 
		/// S\vf̂AvZsȂȂ\IuWFNg 
		/// _componentArray ɓo^܂B<p/>
		/// 
		/// o^ĂȂ\IuWFNgɂ͌vZs߂܂
		/// B<p/>
		/// 
		/// Ⴆ΁AhNXō\IuWFNg abc oϐƂ
		/// `ꍇÂ悤 abc o^܂B
		/// 
		/// <pre>
		/// public void registerComponents() {
		/// Register((Object) abc);
		/// }
		/// </pre>
		/// 
		/// ̎AK abc  Object ^ɃLXgĉB<p/>
		/// 
		/// ɂ abc ́AꎞI _objectList Ɏ^ꂽA
		/// ŏII Object ^z _componentArray ɋL܂B
		/// iOhSubconstruct() QƁj
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract void  registerComponents();
		
		/// <summary> 
		/// <p/>
		/// vZvf _iteratorArray ɓo^B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract void  registerIterators();
		
		
		// 2. connection of constituent elements
		
		/// <summary> Abstract method which is used for connecting ports of
		/// elements within this subsystem.  The programmer who
		/// provides a new OhSubSystem class or OhTotalSystem must
		/// define this method.  He can use various 
		/// (Ref "OhSubSystem#connect()") methods to write the
		/// connectPort() method.
		/// 
		/// 
		/// <p/>
		/// nf̒[qڑ邽߂Ɏgp钊ۃ\b
		/// hłBV OhSubSystem NX OhTotalSystem NX
		/// 񋟂悤ƂvO}́Ã\bh`Ȃ
		/// Ȃ܂B̃\bh߂ɁA(Ref "OhSubSystem") 
		/// Œ`ĂlX (Ref "OhSubSystem#connect()") \b
		/// hgpł܂B<p/>
		/// 
		/// : (Ref "OhScfSubSystem#connectPorts()") 
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract void  connectPorts();
		
		/// <summary> 
		/// <p/>
		/// nf̍\IuWFNg̐ڑ <p/>
		/// 
		/// nf̒ڒʐMڑ
		/// (Ref "OhElement#register(Object, int)")
		/// pĒ`܂B
		/// Ⴆ΁Â悤ɒ`܂B
		/// 
		/// <pre>
		/// public void connectComponents() {
		/// a.register(b, 0);
		/// b.register(a, 0);
		/// a.register(c, 1);
		/// c.register(a, 0);
		/// }
		/// </pre>
		/// 
		/// ŁAa, b, c ͂̕ñoϐłB
		/// ɂAvf a  _objectArray[0] ɗvf b i[A
		/// vf a  _objectArray[1] ɗvf c i[邱ƂɂȂ܂B
		/// vf b  _objectArray[0] ɗvf a i[܂B
		/// vf c  _objectArray[0] ɗvf a i[܂B<p/>
		/// 
		/// ۃ\bhȂ̂ŔhNXŕK`ĉB
		/// 
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract void  connectComponents();
		
		// @end {abstract methods} -----------------------------------
		
		
		// @begin {initialization} -----------------------------------
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aNumOfObjs"></param>
        /// <param name="aNumOfItr"></param>
        /// <param name="aLine"></param>
		public virtual void  init(String aObjName, int aObjNum, int aNumOfObjs, int aNumOfItr, String aLine)
		{
			if (aNumOfItr < 0)
			{
				throw new ArgumentException("Invalid argument for \"_numberOfIteratorSets\"." + NEWLINE + oPrintString(" > "));
			}
			
			_numberOfIteratorSets = aNumOfItr;
			base.init(aObjName, aObjNum, aNumOfObjs, aLine);
		}
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aNumOfObjs"></param>
        /// <param name="aNumOfItr"></param>
		public virtual void  init(String aObjName, int aObjNum, int aNumOfObjs, int aNumOfItr)
		{
			init(aObjName, aObjNum, aNumOfObjs, aNumOfObjs, null);
		}
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aNumOfObjs"></param>
        /// <param name="aLine"></param>
		public override void  init(String aObjName, int aObjNum, int aNumOfObjs, String aLine)
		{
			// Second init().
			init(aObjName, aObjNum, aNumOfObjs, 0, aLine);
		}
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aNumOfObjs"></param>
		public override void  init(String aObjName, int aObjNum, int aNumOfObjs)
		{
			init(aObjName, aObjNum, aNumOfObjs, 0, null);
		}
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aLine"></param>
		public override void  init(String aObjName, int aObjNum, String aLine)
		{
			init(aObjName, aObjNum, 0, 0, aLine);
		}
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
		public override void  init(String aObjName, int aObjNum)
		{
			init(aObjName, aObjNum, 0, 0, null);
		}
		
		// @end {initialization} -------------------------------------
		
		// @begin {constructors} -------------------------------------
		
		/// <summary> 
        /// ftHgRXgN^łB<p/>
        /// Creates a new default <code>OhSubSystem</code> instance.
		/// 
		/// </summary>
		public OhSubSystem():base()
		{
			_componentArray = null;
			_numberOfComponents = - 1;
            _className = "OhSubSystem";
		}
		
        /// <summary>
        /// OhSubSystem̐VCX^X𐶐܂B
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aNumOfObjs"></param>
        /// <param name="aNumOfItr"></param>
        /// <param name="aLine"></param>
		public OhSubSystem(String aObjName, int aObjNum, int aNumOfObjs, int aNumOfItr, String aLine):base()
		{
			_componentArray = null;
			_numberOfComponents = - 1;
            _className = "OhSubSystem";
			
			init(aObjName, aObjNum, aNumOfObjs, aNumOfItr, aLine);
		}
		
		/// <summary>
        /// OhSubSystem̐VCX^X𐶐܂B
		/// </summary>
		/// <param name="aObjName"></param>
		/// <param name="aObjNum"></param>
		/// <param name="aNumOfObjs"></param>
		/// <param name="aNumOfItr"></param>
		public OhSubSystem(String aObjName, int aObjNum, int aNumOfObjs, int aNumOfItr):base()
		{
			_componentArray = null;
			_numberOfComponents = - 1;
            _className = "OhSubSystem";
			
			init(aObjName, aObjNum, aNumOfObjs, aNumOfItr);
		}
		
        /// <summary>
        /// OhSubSystem̐VCX^X𐶐܂B
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aNumOfObjs"></param>
        /// <param name="aLine"></param>
		public OhSubSystem(String aObjName, int aObjNum, int aNumOfObjs, String aLine):base()
		{
			_componentArray = null;
			_numberOfComponents = - 1;
            _className = "OhSubSystem";
			
			init(aObjName, aObjNum, aNumOfObjs, aLine);
		}
		
        /// <summary>
        /// OhSubSystem̐VCX^X𐶐܂B
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aNumOfObjs"></param>
		public OhSubSystem(String aObjName, int aObjNum, int aNumOfObjs):base()
		{
			_componentArray = null;
			_numberOfComponents = - 1;
            _className = "OhSubSystem";
			
			init(aObjName, aObjNum, aNumOfObjs);
		}
		
        /// <summary>
        /// OhSubSystem̐VCX^X𐶐܂B
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
		public OhSubSystem(String aObjName, int aObjNum):base()
		{
			_componentArray = null;
			_numberOfComponents = - 1;
            _className = "OhSubSystem";
			
			init(aObjName, aObjNum);
		}
		
		// @end {constructors} ---------------------------------------
		
		
		// @begin {methods} ------------------------------------------
		
		// 1. creation and reference of "_receivePortArray",
		// "_sendPortArray" and "_componentArray"
		
		/// <summary> 
		/// <p/>
		/// _iteratorArray vf _numberOfIteratorAets ̔zɂB
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  initializeIteratorArray()
		{
			//; (*8)
			Object[][] tmpArray = new Object[256][];
			for (int i = 0; i < 256; i++)
			{
				tmpArray[i] = new Object[_numberOfIteratorSets];
			}
			if ((_iteratorArray = tmpArray) == null)
			{
				throw new OhError("Cannot get memory for \"_iteratorArray\"." + NEWLINE + oPrintString(" > "));
			}
			
			if ((_numberOfIterators = new int[_numberOfIteratorSets]) == null)
			{
				throw new OhError("Cannot get memory for \"_numberOfIterators\"." + NEWLINE + oPrintString(" > "));
			}
			
			for (int i = 0; i < _numberOfIteratorSets; i++)
			{
				_iteratorArray[i] = null;
				_numberOfIterators[i] = - 1;
			}
		}
		
		
		/// <summary> 
		/// <p/>
		/// [q̓o^AڒʐMvf̓o^
		/// 
		/// 
		/// </summary>
		/// <param name="aP">an <code>Object[]</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  register(Object[] aP)
		{
			//; (*9)
			
			// Look for "i" which is "_iteratorArray = null".
			// Exit if it is nothing.
			//
			int i = 0;
			bool flag = false;
			
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				if (_iteratorArray[i] == null)
				{
					flag = true;
					break;
				}
			}
			
			if (flag == false)
			{
				throw new OhError("_iteratorArray is already full. Please check " + NEWLINE + "\"_numberOfIteratorSets\"." + NEWLINE + oPrintString(" > "));
			}
			
			int j = 0;
			for (j = 0; j < aP.Length; j++)
			{
				register((OhObject) aP[j]);
			}
			
			int[] numberOfIteratorsArray = new int[]{_numberOfIterators[i]};
			
			_iteratorArray[i] = makeObjectArray(numberOfIteratorsArray); //; OhElement (*4)
			_numberOfIterators[i] = numberOfIteratorsArray[0];
			
			_objectList.Clear();
		}
		
		
		/// <summary> 
		/// <p/>
		/// [q̓o^AڒʐMvf̓o^
		/// 
		/// 
		/// </summary>
		/// <param name="aP">an <code>Object</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  register(OhObject aP)
		{
			base.register(aP);
		}
		
		
		/// <summary> 
		/// <p/>
		/// [q̓o^AڒʐMvf̓o^
		/// 
		/// 
		/// </summary>
		/// <param name="aP">an <code>Object</code> value
		/// </param>
		/// <param name="aObj">an <code>int</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  register(Object aP, int aObj)
		{
			register(aP, aObj);
		}
		
		
		/// <summary> 
		/// <p/>
		/// NXAIuWFNgAIuWFNgԍw肵āA_
		/// componentArray \IuWFNgiOhObject ^j擾
		/// ܂B<p/>
		/// 
		/// w肳ꂽIuWFNgo^ĂȂꍇ́Anull Ԃ
		/// ܂B<p/>
		/// 
		/// _numberOfComponents ̏ꍇA_componentArray 쐬
		/// ĂȂƔfAOhError  throw ܂B
		/// <p/>
		/// 
		/// 
		/// </summary>
		/// <param name="aClassName">a <code>String</code> value
		/// </param>
		/// <param name="aObjName">a <code>String</code> value
		/// </param>
		/// <param name="aObjNum">an <code>int</code> value
		/// </param>
		/// <returns> an <code>OhObject</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override OhObject getComponent(String aClassName, String aObjName, int aObjNum)
		{
			OhObject p = null;
			
			if ((p = getFromArray(aClassName, aObjName, aObjNum, _componentArray, _numberOfComponents)) != null)
				return p;
			
			
			for (int i = 0; i < _numberOfIteratorSets; i++)
			{
				if ((p = getFromArray(aClassName, aObjName, aObjNum, _iteratorArray[i], _numberOfIterators[i])) != null)
					return p;
			}
			
			throw new OhError("Cannot get component from array." + NEWLINE + "\tAsked > " + aClassName + " : " + aObjName + " : " + aObjNum + NEWLINE + oPrintString(" > "));
		}
		
		
		/// <summary> 
		/// <p/>
		/// IuWFNgAIuWFNgԍw肵āA
		/// _componentArray \IuWFNgiObject ^j擾܂B<p/>
		/// 
		/// w肳ꂽIuWFNgo^ĂȂꍇ́Anull Ԃ܂B<p/>
		/// 
		/// _numberOfComponents ̏ꍇA_componentArray 쐬ĂȂƔfA
		/// G[bZ[W\Anull Ԃ܂B<p/>
		/// 
		/// <pre>
		/// [ARGUMENT]
		/// EaObjName ---> 擾\IuWFNg̃IuWFNgB
		/// EaObjNum ----> 擾\IuWFNg̃IuWFNgԍB
		/// [RETURN]
		/// EObject -----> w肳ꂽ\IuWFNgBw̃IuWFNg擾łȂꍇ nullB
		/// [ACCIDENT]
		/// E_componentArray  Object ^ȊO̕ϐ^ĂꍇB
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aObjName">a <code>String</code> value
		/// </param>
		/// <param name="aObjNum">an <code>int</code> value
		/// </param>
		/// <returns> an <code>Object</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override Object getComponent(String aObjName, int aObjNum)
		{
			//; (*11)
			Object p = null;
			
			if ((p = getFromArray(aObjName, aObjNum, _componentArray, _numberOfComponents)) != null)
				return p;
			
			
			for (int i = 0; i < _numberOfIteratorSets; i++)
			{
				if ((p = getFromArray(aObjName, aObjNum, _iteratorArray[i], _numberOfIterators[i])) != null)
					return p;
			}
			
			throw new OhError("Cannot get component from array." + NEWLINE + "\tAsked > " + aObjName + " : " + aObjNum + NEWLINE + oPrintString(" > "));
		}
		
		
		// 2. connection of constituent elements
		
		/// <summary> 
		/// <p/>
		/// e\vfEp[qԂ̐ڑ <p/>
		/// 
		/// nf̒[qԂ̐ڑsȂ܂B<p/>
		/// 
		/// Mp[q܂͑Šn̓͒[qƁA
		/// \IuWFNg̎M[qƂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̎M[q́A_className, _objectName,
		/// _objectNumber 画ʂ܂B<p/>
		/// 
		/// Lp[qƕnfO̎M[qƂ̐ڑ _owner sȂ܂B
		/// 
		/// 
		/// 
		/// </summary>
		/// <param name="aMyP">an <code>Object</code> value
		/// </param>
		/// <param name="aElement">an <code>OhElement</code> value
		/// </param>
		/// <param name="aRpClassName">a <code>String</code> value
		/// </param>
		/// <param name="aRpName">a <code>String</code> value
		/// </param>
		/// <param name="aRpNum">an <code>int</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  connect(OhPort aMyP, OhElement aElement, String aRpClassName, String aRpName, int aRpNum)
		{
			//; (*1)
			
			// Gets the receiving port of an internal object.
			//
			OhPort rp = (OhPort) ((OhElement) aElement).getReceivePort(aRpClassName, aRpName, aRpNum);
			
			if (rp == null)
			{
				throw new OhError("Cannot connect ports. Cannot get '_receivePort' to connect." + NEWLINE + oPrintString("\t"));
			}
			
			rp.setSender(aMyP);
			aMyP.registerReceiver(rp);
		}
		
		
		/// <summary> 
		/// <p/>
		/// e\vfEp[qԂ̐ڑ <p/>
		/// 
		/// nf̒[qԂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̎M[qAM[q̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̎M[qAM[q́A_className,
		/// _objectName, _objectNumber 画ʂ܂B<p/>
		/// 
		/// Lp[qƕnfO̎M[qƂ̐ڑ _owner 
		/// sȂ܂B
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> ɐڑłꍇ.
		/// Efalse -> w肵\IuWFNg܂͒[q擾łȂꍇB
		/// OhPort.setSender() ̖߂l false ̏ꍇB
		/// OhPort.registerReceiver() ̖߂l false ̏ꍇB
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aS">an <code>OhElement</code> value
		/// </param>
		/// <param name="aSpClassName">a <code>String</code> value
		/// </param>
		/// <param name="aSpName">a <code>String</code> value
		/// </param>
		/// <param name="aSpNum">an <code>int</code> value
		/// </param>
		/// <param name="aR">an <code>OhElement</code> value
		/// </param>
		/// <param name="aRpClassName">a <code>String</code> value
		/// </param>
		/// <param name="aRpName">a <code>String</code> value
		/// </param>
		/// <param name="aRpNum">an <code>int</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  connect(OhElement aS, String aSpClassName, String aSpName, int aSpNum, OhElement aR, String aRpClassName, String aRpName, int aRpNum)
		{
			
			// Gets the sending port of an internal object.
			// ---------------------------------------------------------
			OhPort sp = (OhPort) aS.getSendPort(aSpClassName, aSpName, aSpNum);
			
			if (sp == null)
			{
				throw new OhError("Cannot get '_sendPort' to connect." + NEWLINE + oPrintString(" > "));
			}
			
			// Gets the receiving port of an internal object.
			//
			OhPort rp = (OhPort) aR.getReceivePort(aRpClassName, aRpName, aRpNum);
			
			if (rp == null)
			{
				throw new OhError("Cannot get '_receivePort' to connect." + NEWLINE + oPrintString(" > "));
			}
			
			rp.setSender(sp);
			sp.registerReceiver(rp);
		}
		
		/// <summary> 
		/// <p/>
		/// e\vfEp[qԂ̐ڑ <p/>
		/// 
		/// nf̒[qԂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̑M[qƁAMp[q܂͑Šn
		/// o͒[qƂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̑M[q́A_className, _objectName,
		/// _objectNumber 画ʂ܂B<p/>
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> ɐڑłꍇ.
		/// Efalse -> w肵\IuWFNg܂͒[q擾łȂꍇB
		/// OhPort.setSender() ̖߂l false ̏ꍇB
		/// OhPort.registerReceiver() ̖߂l false ̏ꍇB
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aS">an <code>Object</code> value
		/// </param>
		/// <param name="aSpClassName">a <code>String</code> value
		/// </param>
		/// <param name="aSpName">a <code>String</code> value
		/// </param>
		/// <param name="aSpNum">an <code>int</code> value
		/// </param>
		/// <param name="aMyP">an <code>Object</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  connect(OhElement aS, String aSpClassName, String aSpName, int aSpNum, OhPort aMyP)
		{
			// Gets the sending port to connect.
			//
			OhPort sp = (OhPort) aS.getSendPort(aSpClassName, aSpName, aSpNum);
			
			if (sp == null)
			{
				throw new OhError("Cannot connect ports. Cannot get '_sendPort' to connect." + NEWLINE + oPrintString(" > "));
			}
			
			aMyP.setSender(sp);
			sp.registerReceiver(aMyP);
		}
		
		
		/// <summary> 
		/// <p/>
		/// e\vfEp[qԂ̐ڑ <p/>
		/// 
		/// nf̒[qԂ̐ڑsȂ܂B<p/>
		/// 
		/// Mp[q܂͑Šn̓͒[qƁA\IuWFNg
		/// M[qƂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̎M[q́A_objectName, _objectNumber 
		/// 画ʂ܂B<p/> ܂ANX̃`FbNȗ܂B
		/// <p/>
		/// 
		/// Lp[qƕnfO̎M[qƂ̐ڑ _owner 
		/// sȂ܂B
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> ɐڑłꍇ.
		/// Efalse -> w肵\IuWFNg܂͒[q擾łȂꍇB
		/// OhPort.setSender() ̖߂l false ̏ꍇB
		/// OhPort.registerReceiver() ̖߂l false ̏ꍇB
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aMyP">an <code>OhPort</code> value
		/// </param>
		/// <param name="aR">an <code>OhElement</code> value
		/// </param>
		/// <param name="aRpName">a <code>String</code> value
		/// </param>
		/// <param name="aRpNum">an <code>int</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  connect(OhPort aMyP, OhElement aR, String aRpName, int aRpNum)
		{
			
			// Gets the receiving port of an internal object.
			//
			OhPort rp = (OhPort) aR.getReceivePort(aRpName, aRpNum);
			
			if (rp == null)
			{
				throw new OhError("Cannot connect ports. Cannot get '_receivePort' to connect." + NEWLINE + oPrintString(" > "));
			}
			
			rp.setSender(aMyP);
			aMyP.registerReceiver(rp);
		}
		
		
		/// <summary> 
		/// <p/>
		/// e\vfEp[qԂ̐ڑ <p/>
		/// 
		/// nf̒[qԂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̎M[qAM[q̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̎M[qAM[q́A_objectName,
		/// _objectNumber 画ʂ܂B܂ANX̃`FbN
		/// ȗ܂B<p/>
		/// 
		/// Lp[qƕnfO̎M[qƂ̐ڑ _owner 
		/// sȂ܂B
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> ɐڑłꍇ.
		/// Efalse -> w肵\IuWFNg܂͒[q擾łȂꍇB
		/// OhPort.setSender() ̖߂l false ̏ꍇB
		/// OhPort.registerReceiver() ̖߂l false ̏ꍇB
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aS">an <code>OhElement</code> value
		/// </param>
		/// <param name="aSpName">a <code>String</code> value
		/// </param>
		/// <param name="aSpNum">an <code>int</code> value
		/// </param>
		/// <param name="aR">an <code>OhElement</code> value
		/// </param>
		/// <param name="aRpName">a <code>String</code> value
		/// </param>
		/// <param name="aRpNum">an <code>int</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  connect(OhElement aS, String aSpName, int aSpNum, OhElement aR, String aRpName, int aRpNum)
		{
			
			// Gets the sending port of an internal object.
			//
			OhPort sp = (OhPort) aS.getSendPort(aSpName, aSpNum);
			
			if (sp == null)
			{
				throw new OhError("Cannot connect ports. Cannot get '_sendPort' to connect." + NEWLINE + oPrintString(" > "));
			}
			
			// Gets the receiving port of an internal object.
			//
			OhPort rp = (OhPort) aR.getReceivePort(aRpName, aRpNum);
			
			if (rp == null)
			{
				throw new OhError("Cannot connect ports. Cannot get '_receivePort' to connect." + NEWLINE + oPrintString(" > "));
			}
			
			rp.setSender(sp);
			sp.registerReceiver(rp);
		}
		
		
		/// <summary> 
		/// <p/>
		/// e\vfEp[qԂ̐ڑ <p/>
		/// 
		/// nf̒[qԂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̑M[qƁAMp[q܂͑Šn
		/// o͒[qƂ̐ڑsȂ܂B<p/>
		/// 
		/// \IuWFNg̑M[q́A_objectName, _objectNumber 
		/// 画ʂ܂B<p/> ܂ANX̃`FbNȗ܂B
		/// <p/>
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> ɐڑłꍇ.
		/// Efalse -> w肵\IuWFNg܂͒[q擾łȂꍇB
		/// OhPort.setSender() ̖߂l false ̏ꍇB
		/// OhPort.registerReceiver() ̖߂l false ̏ꍇB
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aS">an <code>OhElement</code> value
		/// </param>
		/// <param name="aSpName">a <code>String</code> value
		/// </param>
		/// <param name="aSpNum">an <code>int</code> value
		/// </param>
		/// <param name="aMyP">an <code>Object</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  connect(OhElement aS, String aSpName, int aSpNum, OhPort aMyP)
		{
			//; (*6)
			
			// Gets the sending port to connect.
			//
			OhPort sp = (OhPort) aS.getSendPort(aSpName, aSpNum);
			
			if (sp == null)
			{
				throw new OhError("Cannot connect ports. Cannot get '_sendPort' to connect." + oPrintString(" > "));
			}
			
			aMyP.setSender(sp);
			sp.registerReceiver(aMyP);
		}
		
		/// <summary> 
		/// <p/>
		/// e\vfEp[qԂ̐ڑ <p/>
		/// 
		/// nf̒[qԂ̐ڑ
		/// 
		/// 
		/// </summary>
		/// <param name="aMySp">an <code>OhPort</code> value
		/// </param>
		/// <param name="aMyRp">an <code>OhPort</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  connect(OhPort aMySp, OhPort aMyRp)
		{
			//; (*7)
			aMyRp.setSender(aMySp);
			aMySp.registerReceiver(aMyRp);
		}
		
		/// <summary> 
		/// <p/>
		/// _receivePortArray, _sendPortArray, _objectArray 쐬A
		/// ڑ֌W̒`ɏ]ĕn̐ڑsȂB<p/>
		/// 
		/// ̕nfA\IuWFNg̍\ݒ肵܂B
		/// ̓Iɂ́Aȉ̎葱sȂ܂B
		/// 
		/// <ol>
		/// <li> OhLinkedList ^IuWFNgq[vɍ쐬 _objectList ɐݒ肷B</li>
		/// <li> Element.registerReceivePorts(), OhElement.makeObjectArray() ɂ
        /// _receivePortArray 쐬B</li>
        /// <li> OhLinkedList.clear() ɂ _objectList ɂB</li>
		/// <li> OhElement.registerSendPorts(), OhElement.makeObjectArray() ɂ
        /// _sendPortArray 쐬B</li>
        /// <li> OhLinkedList.clear() ɂ _objectList ɂB</li>
		/// <li> OhSubSystem.registerComponents(), OhElement.makeObjectArray ɂ
        /// _componentArray 쐬B</li>
        /// <li> OhSubSystem.initializeIteratorArray() ɂ _iteratorArray ̑ꎟzmۂB</li>
        /// <li> OhSubSystem.registerIterators() ɂ _iteratorArray 쐬B</li>
        /// <li> _objectList  null ɐݒ肷B</li>
        /// <li> OhElement.construct() ɂA\IuWFNg̍\ݒ肷B</li>
        /// <li> OhSubSystem.connectComponents() ɂAnf̐ڑsB</li>
		/// </ol>
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> nf̍\ɐݒ肳ꂽꍇB
		/// Efalse -> ̃IuWFNg̍\ݒɈُ킪ꍇB
		/// \IuWFNg̍\ݒɈُ킪ꍇB
		/// nf̐ڑɈُ킪ꍇB
		/// </pre>
		/// 
		/// </summary>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  construct()
		{
			_objectList = new OhLinkedList();
			
			// --- Makes _receivePortArray. ---
			
			registerReceivePorts(); // Abstract method call.
			//; Throws "OhError".
			//; OhElement  (*3)canYouRegister() pāA
			//; ̌n̒[q _bufferList ɓo^B
			
			int[] numberOfReceivePortsArray = new int[]{_numberOfReceivePorts};
			
			_receivePortArray = makeObjectArray(numberOfReceivePortsArray);
			// (Ref "OhElement#makeObjectArray()")
			_numberOfReceivePorts = numberOfReceivePortsArray[0];
			
			_objectList.Clear();
			
			// --- Makes _sendPortArray. ---
			
			registerSendPorts(); // Abstract method call. Throws "OhError".
			
			int[] numberOfSendPortsArray = new int[]{_numberOfSendPorts};
			
			_sendPortArray = makeObjectArray(numberOfSendPortsArray);
			_numberOfSendPorts = numberOfSendPortsArray[0];
			
			_objectList.Clear();
			
			// --- Makes _componentArray. ---
			
			registerComponents();
			
			int[] numberOfComponentsArray = new int[]{_numberOfComponents};
			
			_componentArray = makeObjectArray(numberOfComponentsArray);
			_numberOfComponents = numberOfComponentsArray[0];
			
			
			_objectList.Clear();
			
			
			initializeIteratorArray(); //; (*8)
			registerIterators(); // Abstract method call.
			
			_objectList = null;
			
			bool flag = true;
			int i = 0;
			int k = 0;
			
			for (k = 0; k < _numberOfComponents; k++)
				((OhElement) _componentArray[k]).construct();
			
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				for (k = 0; k < _numberOfIterators[i]; k++)
				{
					((OhElement) _iteratorArray[i][k]).construct();
				}
			}
			
			if (flag != true)
			{
				throw new OhError("Cannot construct \"components\"." + NEWLINE + oPrintString(" > "));
			}
			
			connectPorts();
			connectComponents();
		}
		
		
		/// <summary> 
		/// <p/>
		/// MڑƂIɂ̃\bhĂяoA
		/// MJn̂߂̏Ƃ܂B<p/>
		/// 
		/// ܂ OhElement.doSwitch() sA̖߂l false 
		/// ̏ꍇAG[bZ[W\Afalse Ԃ܂B<p/>
		/// 
		/// ɁA\IuWFNg canYouSwitch () s܂B
		/// ŁA߂l false ̍\IuWFNg݂ꍇ́A
		/// S\IuWFNg canYouSwitch() sA
		/// G[bZ[W\ false Ԃ܂B<p/>
		/// 
		/// nfɑ݂S[q canYouSwitch() s
		/// ܂B<p/>
		/// 
		/// M[qł́A_receiverArray 쐬Af[^pbN^̏
		/// ܂B̓IɌ΁A_dataPackArray ̃mۂA_
		/// numberOfDataPacks ̒l -1  0 ɂ܂Bp[qł 
		/// _receiverArray 쐬邾łB<p/>
		/// 
		/// ܂Ƃ߂ƁAȉsȂƂɂȂ܂B
		/// 
		/// <ol>
        /// <li> _receiverArray 쐬B</li>
        /// <li> _numberOfDataPacks ̒l -1  0 ɕύXB</li>
		/// </ol>
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> nf̑S[q𐳏ɓ]łꍇB
		/// Efalse -> nf̒[q̓, ɓ]łȂ݂̂ꍇB
		/// </pre>
		/// 
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  doSwitch()
		{
			//; (*15)
			base.doSwitch();
			bool flag = true; // For judgment.
			int i = 0;
			int k = 0;
			
			for (k = 0; k < _numberOfComponents; k++)
				((OhElement) _componentArray[k]).doSwitch();
			
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				for (k = 0; k < _numberOfIterators[i]; k++)
				{
					((OhElement) _iteratorArray[i][k]).doSwitch();
				}
			}
			
			if (flag != true)
			{
				throw new OhError("Cannot switch those 'components'." + NEWLINE + oPrintString(" > "));
			}
		}
		
		
		/// <summary> 
		/// <p/>
		/// vZJnO̊mF <p/>
		/// 
		/// ̃\bh̖߂l true Ȃ OhSubSystem ͌vZJn
		/// ł܂B<p/>
		/// 
		/// ܂ OhElement.areYouReady() pďLMp[qA
		/// LMp[qɑ΂ČvZO̊mFƂs܂B̖
		/// l false ̏ꍇAG[bZ[W\ false Ԃ
		/// ܂B <p/>
		/// 
		/// ɁAS\IuWFNg areYouReady() pČvZO̊m
		/// FƂsȂ܂BŁA߂l false ̃IuWFNg
		/// ݂ꍇAS\IuWFNgareYouRedy() ŊmFG[
		/// bZ[W\ false Ԃ܂B
		/// 
		/// <pre>
		/// [RETURN]
		/// Etrue --> vZJnB
		/// Efalse -> vZJnsB
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool areYouReady()
		{
			if (base.areYouReady() != true)
			{
				throw new OhError(oPrintString(" > "));
			}
			
			bool flag = true; // For judgment.
			int i = 0;
			int k = 0;
			
			for (k = 0; k < _numberOfComponents; k++)
				if (((OhElement) _componentArray[k]).areYouReady() != true)
					flag = false;
			// The element model which cannot start calculating exists.
			
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				for (k = 0; k < _numberOfIterators[i]; k++)
				{
					if (((OhElement) _iteratorArray[i][k]).areYouReady() != true)
						flag = false;
				}
			}
			
			if (flag != true)
			{
				throw new OhError("These 'components' are not ready." + NEWLINE + oPrintString(" > "));
			}
			
			return flag;
		}
		
		
		
		// 3. initialization function
		
		/// <summary> Deletion of the string of components.
		/// 
		/// 
		/// <p/>
		/// \IuWFNg̃f[^̏
		/// 
		/// 
		/// </summary>
		public override void  clearDataString()
		{
			//; (*17)
			base.clearDataString();
			
			for (int k = 0; k < _numberOfComponents; k++)
				((OhElement) _componentArray[k]).clearDataString();
			
			for (int i = 0; i < _numberOfIteratorSets; i++)
			{
				for (int k = 0; k < _numberOfIterators[i]; k++)
				{
					((OhElement) _iteratorArray[i][k]).clearDataString();
				}
			}
		}
		
		
		/// <summary> 
		/// <p/>
		/// ̃\bh́A(Ref "OhElement") NX̒ۃ\bhłB
		/// WIȕnf́AI\IuWFNgɂ
		/// sȂ̂ŁAp[^AԗʂȂ̂ƍl܂B
		/// ŁÃNXł͉Ȃ悤ɒ`܂BKv
		/// ΔhNXŕύXĉB
		/// 
		/// 
		/// </summary>
		/// <param name="aSr">an <code>OhStreamReader</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  setParameter(OhStreamReader aSr)
		{
		}
		
		/// <summary> 
		/// <p/>
		/// ̃\bh́Ang̃p^ƁAn̍\vf̃p^ǂݎ܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aSr">an <code>OhStreamReader</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  getParameter(OhStreamReader aSr)
		{
			//; (*18)
			setParameter(aSr);
			
			try
			{
				if (aSr.skipWhites() == - 1)
				{
					OhError e = new OhError("Parameter file error.");
					throw e;
				}
				
				if ((char) aSr.Read() != '{')
				{
					throw new OhError("{ should come first" + NEWLINE + oPrintString(" > "));
				}
				
				aSr.ReadLine();
				
				
				String headLine = null;
				Tokenizer strToken = null;
				String className = "";
				String objName = "";
				int objNum = 0;
				Object obj = null;
				
				while (true)
				{
					if (aSr.skipWhites() == - 1)
					{
						OhError e = new OhError("Parameter file error.");
						throw e;
					}
					
					headLine = aSr.ReadLine();
					
					if (headLine.Substring(0, (1) - (0)).Equals("}"))
						break;
					
					String s = headLine;
					Tokenizer st = new Tokenizer(s);
					int i = 0;
					while (st.HasMoreTokens())
					{
						st.NextToken();
						i++;
					}
					
					strToken = new Tokenizer(headLine);
					
					if (i == 1)
					{
						objName = strToken.NextToken();
						obj = this.getComponent(objName, 0);
					}
					else if (i == 2)
					{
						objName = strToken.NextToken();
						objNum = Int32.Parse(strToken.NextToken());
						obj = this.getComponent(objName, objNum);
					}
					else if (i == 3)
					{
						className = strToken.NextToken();
						objName = strToken.NextToken();
						objNum = Int32.Parse(strToken.NextToken());
						obj = this.getComponent(className, objName, objNum);
					}
					else
					{
						throw new OhError(oPrintString("    "));
					}
					
					((OhElement) obj).getParameter(aSr);
				}
			}
			catch (IOException e)
			{
				throw new OhError("Error in parameter line." + NEWLINE + oPrintString("\t"));
			}
		}
		
		
		/// <summary> Initialization of the time of constituent objects. <p/>
		/// 
		/// "_currentTime" is read.
		/// If it is 0, "_currentTime" will not be changed.
		/// 
		/// 
		/// <p/>
		/// g _currentTime ƍ\IuWFNg _currentTime 
		/// w肵ɏ܂B<p/>
		/// 
		/// ʏAvZJnƂ̏́ÂƂ̂ŁA
		/// TuVXȅ̃TuVXe\vf̏
		/// Ƃ鑀Ă܂B<p/>
		/// 
		/// (Ref "OhElement#initialTime()") QƂĂB
		/// 
		/// 
		/// </summary>
		/// <param name="aInitTime">an <code>OhTimePoint</code> value
		/// </param>
		public override void  initialTime(OhTimePoint aInitTime)
		{
			base.initialTime(aInitTime);
			
			int i = 0;
			int k = 0;
			
			for (k = 0; k < _numberOfComponents; k++)
			{
				((OhElement) _componentArray[k]).initialTime(aInitTime);
			}
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				for (k = 0; k < _numberOfIterators[i]; k++)
				{
					((OhElement) _iteratorArray[i][k]).initialTime(aInitTime);
				}
			}
		}
		
		
		/// <summary> Sets the the initial state of sub systems itself.
		/// 
		/// 
		/// <p/>
		/// ng̏ԗʂ̐ݒ <p/>
		/// 
		/// ng̃NXAIuWFNgAIuWFNgԍǂݎA
		/// ԗʂĂs̐擪ɓǂݎʒuԂł̃\bhĂ΂܂B<p/>
		/// 
		/// ԗʂǂ݂ƂAt@C|C^͏ԂǂݎsɒuĂ܂B<p/>
		/// 
		/// ̃\bh́AgetInitialState() Ă΂܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aBr">an <code>OhStreamReader</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  setInitialState(OhStreamReader aBr)
		{
			//; (*19)
			
			int year = 0;
			long tsec = 0L;
			double frac = 0.0;
			
			try
			{
				aBr.skipWhites();
				year = Int32.Parse(aBr.readWord());
				tsec = Int64.Parse(aBr.readWord());
				frac = Double.Parse(aBr.readWord());
				//Console.Out.WriteLine("" + year + " " + tsec + " " + frac);
			}
			catch (IOException e)
			{
				throw new OhError("Error in setInitialState()." + NEWLINE + oPrintString("\t"));
			}
			catch (FormatException e)
			{
				throw new OhError("Error in setInitialState()." + NEWLINE + oPrintString("\t"));
			}
			
			if (year > 0)
			{
				_currentTime = new OhTimePoint(year, tsec, frac);
			}
		}
		
		
		/// <summary> Sets the the initial state of sub systems itself and components.
		/// 
		/// 
		/// <p/>
		/// ng̏ԗʂƍ\IuWFNg̏ԗʂ̐ݒ
		/// 
		/// 
		/// </summary>
		/// <param name="aBr">an <code>OhStreamReader</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  getInitialState(OhStreamReader aBr)
		{
			
			setInitialState(aBr);
			try
			{
				if (aBr.skipWhites() == - 1)
				{
					OhError e = new OhError("Initial file error in \"OhSubSystem\".");
					throw e;
				}
				
				char c = (char) aBr.Read();
				if (c != '{')
				{
					throw new OhError("{ should come first, but " + c + NEWLINE + oPrintString(" > "));
				}
				
				aBr.ReadLine();
				
				
				String headLine = null;
				Tokenizer strToken = null;
				String className = "";
				String objName = "";
				int objNum = 0;
				Object obj = null;
				
				while (true)
				{
					if (aBr.skipWhites() == - 1)
					{
						OhError e = new OhError("Parameter file error.");
						throw e;
					}
					
					headLine = aBr.ReadLine();
					
					if (headLine.Substring(0, 1).Equals("}"))
						break;
					
					String s = headLine;
					Tokenizer st = new Tokenizer(s);
					int i = 0;
					while (st.HasMoreTokens())
					{
						st.NextToken();
						i++;
					}
					
					strToken = new Tokenizer(headLine);
					
					if (i == 1)
					{
						objName = strToken.NextToken();
						obj = this.getComponent(objName, 0);
					}
					else if (i == 2)
					{
						objName = strToken.NextToken();
						objNum = Int32.Parse(strToken.NextToken());
						obj = this.getComponent(objName, objNum);
					}
					else if (i == 3)
					{
						className = strToken.NextToken();
						objName = strToken.NextToken();
						objNum = Int32.Parse(strToken.NextToken());
						obj = this.getComponent(className, objName, objNum);
					}
					else
					{
						throw new OhError(oPrintString("    "));
					}
					
					((OhElement) obj).getInitialState(aBr);
				}
			}
			catch (IOException e)
			{
				throw new OhError("Error in initial state line." + NEWLINE + oPrintString("\t"));
			}
		}
		
		
		/// <summary> Save to the file of the own last state of the subsystems.
		/// 
		/// 
		/// <p/>
		/// ng̍ŏIԂ̃t@Cւ̕ۑ
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <code>PrintWriter</code> value
		/// </param>
		public override void  saveTerminalState(StreamWriter aPw)
		{
			if (aPw != null)
				aPw.Write(_currentTime.Year + " " + _currentTime.Tsec);
		}
		
		
		
		
		/// <summary> Save the last state of the own subsystems and the components.
		/// 
		/// 
		/// <p/>
		/// ng̍ŏIԂƍ\vf̍ŏIԂ̕ۑ <p/>
		/// 
		/// ̃\bh́A\vfɍŏIԂo悤Ɏw߂𑗂܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <code>PrintWriter</code> value
		/// </param>
		public override void  terminalState(StreamWriter aPw)
		{
			//; (*24)
			int i = 0;
			int k = 0;
			
			if (aPw != null)
			{
				// Save the last state of the own subsystem.
				//
				aPw.Write(_className + " " + _objectName + " " + _objectNumber + NEWLINE);
				saveTerminalState(aPw);
				aPw.Write(NEWLINE);
				
				// Save the last state of the components.
				//
				aPw.Write("{" + NEWLINE);
				for (k = 0; k < _numberOfComponents; k++)
				{
					if (k > 0)
					{
						aPw.Write(NEWLINE);
					}
					((OhElement) _componentArray[k]).terminalState(aPw);
				}
				
				for (i = 0; i < _numberOfIteratorSets; i++)
				{
					for (k = 0; k < _numberOfIterators[i]; k++)
					{
						aPw.Write(NEWLINE);
						((OhElement) _iteratorArray[i][k]).terminalState(aPw);
					}
				}
				aPw.Write("}" + NEWLINE);
			}
		}
		
		
		/// <summary> 
		/// <p/>
		/// ̃\bh́A܂gɑ΂ doShareInfo() sA
		/// Ɏ̍\vfɑ΂ doShareInfo() s܂B
		/// ܂߂Ĉł doShareInfo() svf
		/// OperationFlag.E_DONE
		/// Ԃ܂B
		/// SĂ̗vfł doShareInfo sĂ
		/// OperationFlag.E_ALREADY
		/// Ԃ܂B
		/// ǂ̏ꍇłȂƂ
		/// OperationFlag.E_UNDONE
		/// Ԃ܂B
		/// 
		/// 
		/// </summary>
		/// <returns> an <code>OperationFlag</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override OperationFlag doShareInfo()
		{
			//; (*14)
			OperationFlag flag;
			
			bool calcany = false;
			bool calcall = true;
			
			if (_shareInfoDoneP == false)
			{
				if (shareInfo() == true)
				{
					_shareInfoDoneP = true;
					calcany = true;
				}
			}
			
			int i = 0;
			int k = 0;
			
			for (k = 0; k < _numberOfComponents; k++)
			{
				flag = ((OhElement) _componentArray[k]).doShareInfo();
				if (flag == OperationFlag.E_DONE)
					calcany = true;
				if (flag == OperationFlag.E_UNDONE)
					calcall = false;
			}
			
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				for (k = 0; k < _numberOfIterators[i]; k++)
				{
					flag = ((OhElement) _iteratorArray[i][k]).doShareInfo();
					if (flag == OperationFlag.E_DONE)
						calcany = true;
					if (flag == OperationFlag.E_UNDONE)
						calcall = false;
				}
			}
			
			if (calcany == true)
				return OperationFlag.E_DONE;
			if (calcall == true)
				return OperationFlag.E_ALREADY;
			
			return OperationFlag.E_UNDONE;
		}
		
		
		/// <summary> 
		/// <p/>
		/// n̍\vf̂ꂼɎw߂𑗂A
		/// Xg[ aPwijŎw肳Ăt@Cɏo܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <code>PrintWriter</code> value
		/// </param>
		public override void  saveSendPortStock(StreamWriter aPw)
		{
			//; (*21)
			int i = 0;
			int k = 0;
			
			if (aPw != null)
			{
				if (_numberOfComponents <= 0)
					return ;
				
				if (_numberOfComponents > 0)
				{
					aPw.Write(_className + " " + _objectName + " " + _objectNumber + NEWLINE);
					aPw.Write("{" + NEWLINE);
					
					for (k = 0; k < _numberOfComponents; k++)
					{
						((OhElement) _componentArray[k]).saveSendPortStock(aPw);
					}
					
					for (i = 0; i < _numberOfIteratorSets; i++)
					{
						for (k = 0; k < _numberOfIterators[i]; k++)
						{
							((OhElement) _iteratorArray[i][k]).saveSendPortStock(aPw);
						}
					}
					
					aPw.Write("}" + NEWLINE);
				}
			}
		}
		
		
		
		// 4. information output function
		
		/// <summary> Prints out the information on a constituent objects.
		/// 
		/// 
		/// <p/>
		/// \IuWFNg̏o͂܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <code>PrintWriter</code> value
		/// </param>
		/// <param name="aHead">a <code>String</code> value
		/// </param>
		public virtual void  printComponents(StreamWriter aPw, String aHead)
		{
			//; (*22 cpp)
			printObjects(aPw, aHead, "Components :", _componentArray, _numberOfComponents);
			
			for (int i = 0; i < _numberOfIteratorSets; i++)
				printObjects(aPw, aHead, "Components :", _iteratorArray[i], _numberOfIterators[i]);
		}
		
		
		/// <summary> Prints out the information on a constituent objects.
		/// 
		/// 
		/// <p/>
		/// \IuWFNg̏o͂܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <code>PrintWriter</code> value
		/// </param>
		public virtual void  printComponents(StreamWriter aPw)
		{
			//; (*22 h)
			printObjects(aPw, "    ", "Components :", _componentArray, _numberOfComponents);
			
			for (int i = 0; i < _numberOfIteratorSets; i++)
				printObjects(aPw, "    ", "Components :", _iteratorArray[i], _numberOfIterators[i]);
		}
		
		
		
		// 5. the execution function of calculation
		
		/// <summary> 
		/// <p/>
		/// ̏o <p/>
		/// 
		/// ԗʂ߂ɁA_currentTime ł̏o͂`܂B
		/// M[qɎƏo͒l݂܂B
		/// _currnet_time ł̏o͂vZłꍇ true Ԃ܂B
		/// Kvȓ̓f[^ĂȂȂǂāA
		/// _currentTime ̏o͂vZłȂꍇ false Ԃ܂B<p/>
		/// 
		/// ȂȀꍇ͕n̏̏o͂͂ȂƎv̂ŁA
		/// ł͏ true Ԃ悤ɒ`Ă܂B
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool initialOutput()
		{
			return true;
		}
		
		
		/// <summary> 
		/// <p/>
		///  <p/>
		/// 
		/// ɂāASf[^擾܂B
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool initialWork()
		{
			return true;
		}
		
		
		/// <summary> A first-time output.
		/// 
		/// 
		/// <p/>
		/// ̏o
		/// 
		/// 
		/// </summary>
		/// <returns> an <code>OperationFlag</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override OperationFlag doInitialWork()
		{
			//; (*13)
			OperationFlag flag;
			
			bool calcany = false;
			bool calcall = true;
			
			if (_initialWorkDoneP == false)
			{
				if (initialWork() == true)
				{
					_initialWorkDoneP = true;
					calcany = true;
				}
			}
			
			int i = 0;
			int k = 0;
			
			for (k = 0; k < _numberOfComponents; k++)
			{
				flag = ((OhElement) _componentArray[k]).doInitialWork(); //; Throws "OhError".
				if (flag == OperationFlag.E_DONE)
					calcany = true;
				if (flag == OperationFlag.E_UNDONE)
					calcall = false;
			}
			
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				for (k = 0; k < _numberOfIterators[i]; k++)
				{
					flag = ((OhElement) _iteratorArray[i][k]).doInitialWork(); //; Throws "OhError".
					if (flag == OperationFlag.E_DONE)
						calcany = true;
					if (flag == OperationFlag.E_UNDONE)
						calcall = false;
				}
			}
			
			if (calcany == true)
				return OperationFlag.E_DONE;
			if (calcall == true)
				return OperationFlag.E_ALREADY;
			
			return OperationFlag.E_UNDONE;
		}
		
		
		/// <summary> 
		/// <p/>
		/// vf̌vZɕKvȃf[^̂AaRp (arg) 󂯎ׂf[^̃f[^L^Ԃ܂B<p/>
		/// 
		/// getNecessaryTimeFrom()  getNecessaryTimeTo() ܂ł̃f[^pbN
		/// M[q aRp MĂȂ΁Avf͌vZJn邱Ƃł܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aRp">an <code>Object</code> value
		/// </param>
		/// <returns> an <code>OhTimePoint</code> value
		/// </returns>
		public virtual IOhTimePointImmutable getNecessaryTimeFrom(Object aRp)
		{
			//; (*25)
			int k = 0;
			int j = - 1;
			
			for (k = 0; k < _numberOfReceivePorts; k++)
			{
				if (aRp == _receivePortArray[k])
					j = k;
			}
			
			if (j == - 1)
				return _currentTime;
			
			return ((OhSenderPort) aRp).NecessaryTimeFrom;
		}
		
		
		/// <summary> 
		/// <p/>
		/// vf̌vZɕKvȃf[^̂AaRp (arg) 󂯎ׂf[^̃f[^L^Ԃ܂B<p/>
		/// 
		/// getNecessaryTimeFrom()  getNecessaryTimeTo() ܂ł̃f[^pbN
		/// M[q aRp MĂȂ΁Avf͌vZJn邱Ƃł܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aRp">an <code>Object</code> value
		/// </param>
		/// <returns> an <code>OhTimePoint</code> value
		/// </returns>
		public virtual IOhTimePointImmutable getNecessaryTimeTo(Object aRp)
		{
			//; (*26)
			int k = 0;
			int j = - 1;
			
			for (k = 0; k < _numberOfReceivePorts; k++)
			{
				if (aRp == _receivePortArray[k])
					j = k;
			}
			
			if (j == - 1)
				return _currentTime;
			
			return ((OhSenderPort) aRp).NecessaryTimeTo;
		}
		
		
		
		/// <summary> The check before calculation.
		/// 
		/// 
		/// <p/>
		/// vZO̊mF
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhCannotGetDataError">if an error occurs
		/// </exception>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool canYouCalculate()
		{
			return true;
		}
		
		
		/// <summary> Calculation of the time step.
		/// 
		/// 
		/// <p/>
		/// ^CXebv̌vZ
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>long</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override OhTime calculateTimeStep()
		{
			return new OhTime(0L, 0.0);
		}
		
		
		/// <summary> Calculation for 1 step.
		/// 
		/// 
		/// <p/>
		/// PXebv̌vZ
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhCannotGetDataError">if an error occurs
		/// </exception>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool calculate()
		{
			return true;
		}
		
		
		/// <summary> 
		/// <p/>
		/// vZvfQvZڕWɓBǂ`FbNB<p/>
		/// 
		/// ̃NXł́AwǗҁxƂĂ OhSubSystem ̗ꂩ`Ă܂B
		/// Ȃ킿A̓ɔvZsȂvfQƂƂOƂĂA
		/// gvZsȂꍇɑΉĒ`Ă킯ł͂܂B
		/// āAgvZsȂꍇ́Aꂪ\ł悤ɍĒ`ĉB
		/// 
		/// 
		/// </summary>
		/// <param name="aNum">an <code>int</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		public virtual bool hasReachedTargetTime(int aNum)
		{
			//; (*27)
			bool flag = true;
			
			for (int i = 0; i < _numberOfIterators[aNum]; i++)
				if (((OhElement) _iteratorArray[aNum][i]).hasReachedTargetTime() == false)
					flag = false;
			
			return flag;
		}
		
		
		/// <summary> 
		/// <p/>
		/// vZvfQ`FbNB<p/>
		/// 
		/// ̃NXł́AwǗҁxƂĂ OhSubSystem ̗ꂩ`Ă܂B
		/// Ȃ킿A̓ɔvZsȂvfQƂƂOƂĂA
		/// gvZsȂꍇɑΉĒ`Ă킯ł͂܂B
		/// āAgvZsȂꍇ́Aꂪ\ł悤ɍĒ`ĉB
		/// 
		/// 
		/// </summary>
		/// <param name="aNum">an <code>int</code> value
		/// </param>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual bool hasConverged(int aNum)
		{
			bool flag = true;
			
			for (int i = 0; i < _numberOfIterators[aNum]; i++)
				if (((OhElement) _iteratorArray[aNum][i]).hasConverged() == false)
					flag = false;
			
			return flag;
		}
		
		/// <summary> Renewal of the current time.
		/// 
		/// 
		/// <p/>
		/// ݎ̍XV <p/>
		/// 
		/// _componentArray ɓo^Ăvf _currentTime 
		/// _iteratorArray ɓo^Ăvf _fixedTime ̂A
		/// łxĂ _currentTime ƂB
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		public override void  renewCurrentTime()
		{
			int k = 0;
			OhTimePoint[] tp = new OhTimePoint[2];
			tp[0] = OhTimePoint.OhTimePointMax;
			
			// _componentArray
			//
			for (k = 0; k < _numberOfComponents; k++)
			{
				tp[1] = ((OhElement) _componentArray[k]).CurrentTime;
				if (tp[1].CompareTo(tp[0]) < 0)
				{
					OhTimePoint tP = new OhTimePoint();
					tP.copy(tp[1]);
					tp[0] = tP;
				}
			}
			
			// _iteratorArray
			//
			for (k = 0; k < _numberOfIteratorSets; k++)
			{
				tp[1] = ((OhElement) _iteratorArray[k][0]).FixedTime;
				if (tp[1].CompareTo(tp[0]) < 0)
				{
					OhTimePoint timeP = new OhTimePoint();
					timeP.copy(tp[1]);
					tp[0] = timeP;
				}
			}
			
			if (tp[0].CompareTo(_currentTime) < 0)
			{
				throw new OhError("error" + NEWLINE + "\tPut back _currentTime from " + _currentTime + " to " + tp[0] + NEWLINE + oPrintString(" > "));
			}
			_currentTime = tp[0];
		}
		
		
		/// <summary> This orders to perform "rewindCurrentTime()" to
		/// the element group which repeated calculation did not converge.
		/// 
		/// 
		/// <p/>
		/// vZȂvfQ(_iteratorArray[aNum])ɑ΂
		/// rewindCurrentTime() s悤߂B
		/// 
		/// 
		/// </summary>
		/// <param name="aNum">an <code>int</code> value
		/// </param>
		public virtual void  rewindCurrentTime(int aNum)
		{
			//; (*30)
			for (int i = 0; i < _numberOfIterators[aNum]; i++)
				((OhElement) _iteratorArray[aNum][i]).rewindCurrentTime();
		}
		
		/// <summary>
        /// SĂ̔vf̔ڕW܂ł̃f[^̏o͂ƁA
        /// f[^pbN̏s܂B
		/// </summary>
		/// <param name="aNum"></param>
		public virtual void  flushData(int aNum)
		{
			//; (*31)
			for (int i = 0; i < _numberOfIterators[aNum]; i++)
				((OhElement) _iteratorArray[aNum][i]).flushData();
		}
		
		/// <summary>
        /// SĂ̔vf_fixedTime  _currentTime ɐi߂܂B
		/// </summary>
		/// <param name="aNum"></param>
		public virtual void  renewFixedTime(int aNum)
		{
			//; (*32)
			for (int i = 0; i < _numberOfIterators[aNum]; i++)
				((OhElement) _iteratorArray[aNum][i]).renewFixedTime();
		}
		
		/// <summary>
        /// SĂ̔vf̔vZڕW _targetTime XV܂B
        /// ɔvZԊԊuƂ܂B
		/// </summary>
		/// <param name="aNum"></param>
		/// <param name="aItrs"></param>
		public virtual void  renewTargetTime(int aNum, IOhTimeImmutable aItrs)
		{
			//; (*33)
			for (int i = 0; i < _numberOfIterators[aNum]; i++)
				((OhElement) _iteratorArray[aNum][i]).renewTargetTime(aItrs);
		}
		
		/// <summary>
        /// SĂ̔vf̔vZڕW _targetTime XV܂B
		/// </summary>
		public override void  initializeTargetTime()
		{
			//; (*34)
			int i = 0;
			
			// _iteratorArray
			//
			for (i = 0; i < _numberOfIteratorSets; i++)
				renewTargetTime(i, calculateIterationStep(i));
			
			// _componentArray
			//
			for (i = 0; i < _numberOfComponents; i++)
				((OhElement) _componentArray[i]).initializeTargetTime();
		}
		
		
		/// <summary> 
        /// ̃\bh́A_iteratorArray[aNum]  calculateIterationStep() ̖߂l̂Aŏ̒lԂ܂B<p/>
        /// 
        /// This returns the minimum value among the return values of "calculateIterationStep()"
		/// of "_iteratorArray[aNum]".
		/// 
		/// 
		/// <p/>
		/// 
		/// 
		/// </summary>
		/// <param name="aNum">an <code>int</code> value
		/// </param>
		/// <returns> a <code>long</code> value
		/// </returns>
		public virtual OhTime calculateIterationStep(int aNum)
		{
			//; (*35)
			OhTime tmin = new OhTime(Int64.MaxValue, 0.0);
			OhTime time;
			
			for (int i = 0; i < _numberOfIterators[aNum]; i++)
			{
				time = ((OhElement) _iteratorArray[aNum][i]).calculateIterationStep();
				if (time.toDouble() < tmin.toDouble())
					tmin.copy(time);
			}
			return tmin;
		}
		
		
		/// <summary> Operation function.
		/// 
		/// 
		/// <p/>
		/// Z@\ <p/>
		/// 
		/// e\vfɏvZs߂𑗂B
		/// 
		/// 
		/// </summary>
		/// <returns> a <code>boolean</code> value
		/// </returns>
		public override bool work()
		{
			//; (*36)
			int i = 0;
			int j = 0;
			int k = 0;
			bool calc = false; // Whether the function was called and it calculated also at once.
			//; ֐Ă΂ĈxłvZǂB
			bool flagAll = false; // "true" when a component calculates at least one.
			//; \vfivZvf܂ށjPłvZ trueB
			bool flagItr = false; // "true" when a repeated calculation element calculates at least one.
			//; vZvfPłvZ trueB
			
			int[] itrCounter = new int[_numberOfIteratorSets];
			
			for (i = 0; i < _numberOfIteratorSets; i++)
				itrCounter[i] = 0;
			
			// Calculation of components.
			//
			do 
			{
				flagAll = false;
				
				// _componentArray
				//
				for (k = 0; k < _numberOfComponents; k++)
				{
					if (((OhElement) _componentArray[k]).work() == true)
					{
						//; Throws "OhCannotGetDataError".
						calc = flagAll = true;
						break;
					}
				}
				while (++k < _numberOfComponents)
					((OhElement) _componentArray[k]).work(); //; Throws "OhCannotGetDataError".
				
				// _iteratorArray
				//
				for (i = 0; i < _numberOfIteratorSets; i++)
				{
					do 
					{
						flagItr = false;
						for (j = 0; j < _numberOfIterators[i]; j++)
						{
							if (((OhElement) _iteratorArray[i][j]).work() == true)
							{
								calc = flagAll = flagItr = true;
								break;
							}
						}
						while (++j < _numberOfIterators[i])
							((OhElement) _iteratorArray[i][j]).work(); //; Throws "OhCannotGetDataError".
					}
					while (flagItr == true);
					
					if (hasReachedTargetTime(i) == true)
					{
						if (hasConverged(i) == true)
						{
							flushData(i);
							renewFixedTime(i);
							renewTargetTime(i, calculateIterationStep(i));
							itrCounter[i] = 0;
						}
						else
						{
							rewindCurrentTime(i);
							if (++itrCounter[i] >= 1000)
							{
								throw new OhError("Iterative calculation cannot converge" + NEWLINE + "tin group [" + i + "]." + NEWLINE + oPrintString(" > "));
							}
						}
					}
				}
			}
			while (flagAll == true);
			
			if (calc == false)
			{
				return false;
			}
			
			renewCurrentTime();
			return true;
		}

        //// ȉAǉ

        //public virtual void makeInitialDic()
        //{
        //}
        //public virtual void registerAssembly()
        //{
        //}

	} // OhSubSystem
}