/// <(#)>  Base class for creating total systems. </(#)>
using System;
using System.IO;
using System.Text;
using OhymosNet;
namespace OhymosNet
{
    /// <summary>
    /// {^Šnf\NXłBۃNXłB
    /// ̃NX<a href = "OhymosNet.OhSubSystem.html">OhSubSystem</a>
    /// pĂ܂B<p/>
    /// 
    /// OhTotalSystem is a class to express a totalsystem which contains
    /// a number of elements.
    /// It extends <a href = "OhymosNet.OhSubSystem.html">OhSubSystem</a> class.
    /// <p/>
    /// </summary>
    /// <remarks>
    /// Šnf́At@CóAf[^x[XóAL[{[h́ACRT o͂ȂǁA
    /// XGȃf[^̓o͂ɑΉ܂B
    /// Šnf́AGȃf[^n̓Ɏ荞ގ́AS
    /// <a href="OhymosNet.OhDataPack.html">OhDataPack</a> ^̃f[^ɕϊA
    /// V~[VʂV~[Vs҂ɒ񋟂鎞́A
    /// <a href="OhymosNet.OhDataPack.html">OhDataPack</a> ^Œ~ςĂf[^
    /// V~[Vs҂̖]ރf[^`ɕϊ܂B
    /// ŁAf[^̕ϊɊւ̓ÍAVɍ쐬͒[qAo͒[qōsA
    /// Šnfł́A͒[qEo͒[q̎葱ő삷̂Ƃ܂B<p/>
    /// 
    /// ܂A<a href="OhymosNet.OhDataPack.html">OhDataPack</a> ^ɕϊ̓f[^̑ɁA
    /// Šnf́AŠnɊ܂܂Svf̃p[^Eԗʂ̏l
    /// V~[Vs҂pӂf[^t@Cǂݎ@\Ă܂B
    /// ܂AV~[Vs҂Ƃ̑ΘbɂA
    /// V~[VڕW肷@\Ă܂B<p/>
    /// 
    /// Šnf́AvfEnɂ\AƂĐvZs킸A
    /// nfƓl̍\Ă܂B
    /// Ŗ{VXeł́AnfpđŠnf쐬܂B<p/>
    /// 
    /// Anfnɑ΂Cvbgf[^𕔕nOMē̂ɑ΂A
    /// ŠńA͒[qpăCvbgf[^琶A\vfɑM܂B
    /// ܂A\vfAnOɃAEgvbgf[^A
    /// nf͒PɊOɑM邾łA
    /// Šnf͏o͒[qpāAႦ΁Ao̓t@CɋL^Ƃs܂B
    /// </remarks>
	public abstract class OhTotalSystem:OhSubSystem
	{
		/// <summary> Returns "_newestDataTimeCol".
		/// 
		/// </summary>
		/// <returns> a <var>String</var> value
		/// </returns>
		virtual public String NewestDataTimeCol
		{
			get
			{
				return _newestDataTimeCol;
			}
			
		}
		/// <summary> Returns "_terminalTime".
		/// 
		/// </summary>
		/// <returns> an <var>OhTimePoint</var> value
		/// </returns>
		override public OhTimePoint TerminalTime
		{
			get
			{
				return _terminalTime;
			}
			
		}
		/// <summary> Returns "_mediumTermTargetTime"
		/// 
		/// </summary>
		/// <returns> an <var>OhTimePoint</var> value
		/// </returns>
		override public OhTimePoint MediumTermTargetTime
		{
			get
			{
				return _mediumTermTargetTime;
			}
			
		}
		
		// @begin {instance variable or static variable} -------------
		
		/// <summary> terminal time.
		/// 
		/// 
		/// <p/>
		/// ڕWB
		/// 
		/// </summary>
		protected internal OhTimePoint _terminalTime;
		
		/// <summary> Medium-term target time.
		/// 
		/// 
		/// <p/>
		/// ԖڕWB
		/// 
		/// </summary>
		internal OhTimePoint _mediumTermTargetTime;
		
		
		/// <summary> The string which contains the list of the newest data times
		/// of data packs which are obtained through the input
		/// ports. This information will be given to the user of the
		/// program, wheh the user is asked to enter the target time.<p/>
		/// 
		/// 
		/// <p/>
		/// ͒[q瓾f[^̍ŐVf[^Ԃ̃Xg^
		/// B(Ref "#calculateTimeStep()") ̒ŁAsɁAv
		/// ZڕW̓͂߂ƂɁA[Uւ̏ƂĒ񋟂
		/// ܂B<p/>
		/// 
		/// 
		/// </summary>
		internal String _newestDataTimeCol;
		
		// @end {instance variable or static variable} ---------------
		
		
		// @begin {abstract methods} ---------------------------------
		
		// 1. registration of possession ports, possession element
		// objects and possession subsystem objects.
		
		/// <summary> 
		/// <p/>
		/// ͒[qo^܂B<p/>
		/// 
		/// ۃ\bhłB
		/// Šnf̃vO}`Kv܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract void  registerInputPorts();
		
		/// <summary> 
		/// <p/>
		/// o͒[qo^܂B<p/>
		/// 
		/// ۃ\bhłB
		/// Šnf̃vO}`Kv܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract void  registerOutputPorts();
		
		/// <summary> 
		/// <p/>
		/// Šn̍\vfo^钊ۃ\bhłB<p/>
		/// 
		/// ̃NXpđŠn쐬vO}́A
		/// ̃\bh`Kv܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract override void  registerComponents();
		
		/// <summary> 
		/// <p/>
		/// vZvf _iteratorArray ɓo^B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract override void  registerIterators();
		//;
		//; Added by Y.Satoh (2003.12.10)
		
		/// <summary> 
		/// <p/>
		/// Šnf̒[q̐ڑ (Ref "OhSubSystem#connect()")
		/// pĒ`܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract override void  connectPorts();
		
		/// <summary> Abstract method which is used for connecting ports of
		/// elements within the OhTotalSystem.  The programmer who
		/// provides a new OhTotalSystem class must define this method.
		/// He can use various (Ref "OhSubSystem#connect()") methods to
		/// write the connectPort() method.
		/// 
		/// 
		/// <p/>
		/// Šnf̒[qڑ邽߂Ɏgp钊ۃ\b
		/// hłBV OhTotalSystem NX񋟂悤ƂvO
		/// }́Ã\bh`Ȃ΂Ȃ܂B̃\b
		/// h߂ɁA(Ref "OhSubSystem") Œ`ĂlX 
		/// (Ref "OhSubSystem#connect()") \bhgpł܂B<p/>
		/// 
		/// : (Ref "OhScfTotalSystem#connectPorts()") 
		/// 
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public abstract override void  connectComponents();
		
		// @end {abstract methods} -----------------------------------
		
		
		// @begin {initialization} -----------------------------------
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName">IuWFNg</param>
        /// <param name="aObjNum">IuWFNgԍ</param>
        /// <param name="aNumOfItr">vf̐</param>
		public override void  init(String aObjName, int aObjNum, int aNumOfItr)
		{
			base.init(aObjName, aObjNum, 0, aNumOfItr, null);
		}
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName">IuWFNg</param>
		public virtual void  init(String aObjName)
		{
			base.init(aObjName, 0, 0, 0, null);
		}
		/// <summary>
        /// qłB
		/// </summary>
		/// <param name="aObjNum">IuWFNgԍ</param>
		/// <param name="aNumOfItr">vf̐</param>
		public virtual void  init(int aObjNum, int aNumOfItr)
		{
			base.init("OhTotalSystem", aObjNum, 0, aNumOfItr, null);
		}
		
        /// <summary>
        /// qłB
        /// </summary>
		public virtual void  init()
		{
			base.init("OhTotalSystem", 0, 0, 0, null);
		}
		
		
		// @end {initialization} -------------------------------------
		
		// @begin {constructors} -------------------------------------
		
		/// <summary> Creates a new default <var>OhTotalSystem</var> instance.
		/// 
		/// </summary>
		public OhTotalSystem():base()
		{
			_terminalTime = OhTimePoint.OhTimePointMin;
			_newestDataTimeCol = "";
			_className = "OhTotalSystem";
		}
		
		// @end {constructors} ---------------------------------------
		
		
		// @begin {methods} ------------------------------------------
		
		/// <summary> Add aStr to _newestDataTimeCol.
		/// 
		/// </summary>
		/// <param name="aStr">a <var>String</var> value
		/// </param>
		public virtual void  addNewestDataTime(String aStr)
		{
			_newestDataTimeCol = _newestDataTimeCol + aStr;
		}
		
		// 0-2. Simulation option.
		
		/// <summary> 
		/// [UƂ̑ΘbɂAOHyMoS.NET IvV肷B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  setOhymosNetOption()
		{
			
			//int opt;
			
			StringWriter sw = new StringWriter();
			
			sw.Write("# Key in simulation option." + NEWLINE);
			sw.Write("# TimeControlOption" + NEWLINE);
			
			// ---------------------------------------------------------
			
			if (OhOption.Default.TimeControlOption == TimeControl.GO_BEYOND_TERMINAL_TIME)
			{
				sw.Write("#   current selection: " + "GO_BEYOND_TERMINAL_TIME" + NEWLINE);
			}
			else if (OhOption.Default.TimeControlOption == TimeControl.DO_NOT_GO_BEYOND_TERMINAL_TIME)
			{
				sw.Write("#   current selection: " + "DO_NOT_GO_BEYOND_TERMINAL_TIME" + NEWLINE);
			}
			
			sw.Write("#   select 1 or 2" + NEWLINE);
			sw.Write("    1. GO_BEYOND_TERMINAL_TIME (Default)" + NEWLINE);
			sw.Write("    2. DO_NOT_GO_BEYOND_TERMINAL_TIME" + NEWLINE);
			
			String message = sw.ToString();
			
			sw.Close();
			
			String textLine = OhInterface.getReply(message, "1");
			
			if (textLine.Equals(null))
				throw new OhError("Quit");
			
			
			StringReader sr = new StringReader(textLine);
			
			try
			{
				//    opt = sr.read();    //; Wrong!!! (2003.12.05)
				
				int c = sr.Read();
                int opt = c-48;
				//opt = SupportClass.NumericValue((char) c);
				
				//;   ͂ꂽlȂꍇ -1 ԂB
				//;   l𕉂łȂƂĕ\łȂꍇilȂǁj́A-
				//;   2 ԂB
				
				switch (opt)
				{
					case 1: 
						OhOption.Default.TimeControlOption = TimeControl.GO_BEYOND_TERMINAL_TIME;
						break;
					
					
					case 2: 
						OhOption.Default.TimeControlOption = TimeControl.DO_NOT_GO_BEYOND_TERMINAL_TIME;
						break;
					
					
					default: 
						OhOption.Default.TimeControlOption = TimeControl.GO_BEYOND_TERMINAL_TIME;
						break;
					
				}
			}
			catch (IOException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
		}
		
		
		// 1. registration of possession ports, possession element
		// objects and possession subsystem objects.
		
		/// <summary> 
		/// <p/>
		/// Šn registerSendPorts() ́A
		/// Šn̒ۃ\bh
		/// (Ref "OhTotalSystem#registerInputPorts()")
		/// s悤ɒ`܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  registerSendPorts()
		{
			registerInputPorts();
		}
		
		
		/// <summary> 
		/// <p/>
		/// Šn registerReceivePorts() ́A
		/// Šn̒ۃ\bh
		/// (Ref "OhTotalSystem#registerOutputPorts()")
		/// s悤ɒ`܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  registerReceivePorts()
		{
			registerOutputPorts();
		}
		
		
		// 2. initialization of total systems.
		
		//; 5 ̔{ɂȂĂ邩ǂ͂ł͊m߂ĂȂB
		
		/// <summary> 
		/// f[^쐬܂B
		/// 
		/// <pre>
		/// (
		/// (0)
		/// (1)
		/// (2000)
		/// (38600)
		/// (2.19956e+07)
		/// )
		/// </pre>
		/// 
		/// ̃tH[}bgŋLqĂf[^t@ĆA
		/// f[^ "0 1 2000 38600 2.19956e+07" 擾ł܂B
		/// 
		/// 
		/// 
		/// </summary>
		/// <param name="aSr">an <var>OhStreamReader</var> value
		/// </param>
		/// <returns> a <var>String</var> value
		/// </returns>
		public virtual String makeDataString(OhStreamReader aSr)
		{
			String dataString = null;
			String[] data = new String[1024];
			int i = 0;
			int k = 0;
			try
			{
				while ((data[i] = aSr.readWord()).Equals(")") != true)
				{
					if ((data[i].StartsWith("(")) == false)
					{
						Console.Error.WriteLine("Data file format error.");
						Environment.Exit(1);
					}
					int length = data[i].Length;
					data[i] = data[i].Substring(1, (length - 1) - (1));
					if (aSr.skipWhites() == - 1)
					{
						Console.Error.WriteLine("Data file format error.");
						Environment.Exit(1);
					}
					i++;
				}
				
				StringBuilder sb = new StringBuilder();
				
				for (k = 0; k < i; k++)
				{
					sb.Append(data[k]);
					sb.Append(" ");
				}
				
				dataString = sb.ToString();
			}
			catch (IOException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
			
			return dataString;
		}
		
		
		/// <summary> 
		/// <p/>
		/// evfɕ^ăp^܂͏l̐ݒB<p/>
		/// 
		/// f[^t@C͂āAevfɕ^ăp^
		/// ݒ肷邩lݒ肷B
		/// 
		/// content == PARSET ̂ƂAp^ݒA
		/// content == INITIAL ̂ƂAlݒA
		/// content == SDPDATA ̂ƂAM[qɎcĂf[^̍Đ
		///  <p/>
		/// 
		/// ̃NX readSendPortFile() ŎgpĂB
		/// 
		/// 
		/// </summary>
		/// <param name="aFileName">a <var>String</var> value
		/// </param>
		/// <param name="aContent">a <var>DataFileContent</var> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  deliverDataString(String aFileName, DataFileContent aContent)
		{
			OhStreamReader sr;
			
			try
			{
				sr = new OhStreamReader(aFileName, true);
			}
			catch (FileNotFoundException e)
			{
				if (aContent == DataFileContent.SDPDATA)
				{
					return ;
				}
				throw new OhError("File open error.", oPrintString("\t"));
			}
			
			int current;
			char currentChar;
			
			int paren = 0; //; ʁop̐[B
			
			Object element = null;
			Object owner = null;
			
			String dataStr;
			
			String[] objArray = new String[3];
			// objArray[0] = className, objArray[1] = objName.
			int objNum;
			
			try
			{
				
				while (true)
				{
					// ------------------- "LOOP" loop starts.
					current = sr.skipWhites();
                    if (current == -1)
                        break;
					
                    currentChar = (char) current;
					switch (current)
					{
						
						// ---------------- switch starts.
						case '{':  //; owner ̕ύXBiPցj
							sr.Read(); //; ۂ '{' ǂݎB
							paren++;
							if ((owner = element) == null)
							{
								Console.Error.WriteLine("Trouble about '{' in data file.");
								Environment.Exit(1);
							}
							element = this;

                            continue;
						
						case '}':  //; owner ̕ύXBiPOցj
							sr.Read(); //; ۂ '}' ǂݎB
							if ((--paren) < 0)
							{
								Console.Error.WriteLine("Trouble about '}' in data file.");
								Environment.Exit(1);
							}
							element = owner;

                            continue;
						
						case '(':  //; element  _dataString ^B
							sr.Read(); //; ۂ '(' ǂݎB
							if (sr.skipWhites() == - 1)
							{
								Console.Error.WriteLine("Trouble about '(' in data file.");
								Environment.Exit(1);
							}
							
							if (current == - 1)
							{
								Console.Error.WriteLine("Trouble about '(' in data file.");
								Environment.Exit(1);
							}
							
							dataStr = makeDataString(sr); //(*Original)
							
							((OhElement) element).DataString = dataStr;
							if (aContent == DataFileContent.SDPDATA)
								((OhElement) element).restoreSendPortStock();
							
							((OhElement) element).clearDataString();

                            continue;
						
						case ')': 
							Console.Error.WriteLine("Trouble about ')' in data file.");
							Environment.Exit(1);
                            break;
						
						default: 
							objArray[0] = sr.readWord();
							objArray[1] = sr.readWord();
							objArray[2] = sr.readWord();
							
							if (objArray[1].Equals("(") || objArray[1].Equals(")") || objArray[1].Equals("{") 
                                || objArray[1].Equals("}") || objArray[1].Equals(""))
							{
								
								Console.Error.WriteLine("Trouble about ')' in data file.");
								Environment.Exit(1);
							}
							
							if (objArray[2].Equals("(") || objArray[2].Equals(")") || objArray[2].Equals("{") 
                                || objArray[2].Equals("}") || objArray[2].Equals(""))
							{
								objNum = 0;
								sr.pushBack();
								//; '(' ȂǂǂݎȂƂɂăt@C|C
								//; ^P߂B
							}
							else
							{
								objNum = Int32.Parse(objArray[2]);
							}
							
							if (objCompare(objArray[0], objArray[1], objNum) == true)
							{
								element = this;
								owner = this;
							}
							else if ((element = ((OhElement) owner).getComponent(objArray[0], objArray[1], objNum)) == null)
							{
								Console.Error.WriteLine("Trouble about ')' in data file.");
								Environment.Exit(1);
							}
							
							continue;
					} // ----------------------------------- switch ends.
				} // -------------------------------- "LOOP" loop ends.
				
				if (paren != 0)
				{
					Console.Error.WriteLine("Trouble in data file.");
					Environment.Exit(1);
				}
				
				sr.Close();
				return ;
			}
			catch (OhError e)
			{
				Console.Error.WriteLine("Trouble in data file.");
			}
			catch (IOException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
			catch (FormatException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
		}

        /// <summary>
        /// ϐOHYMOS_LIB烆[Upӂvffǂݍ݂܂B
        /// </summary>
        public void readAssembly()
        {

        }
		
		/// <summary> 
		/// <p/>
		/// p^̓ǂݍ <p/>
		/// 
		/// Ŏw肳ꂽp^t@Cp^ǂݎ܂B
		/// p^́AꊇĂP̃t@Cɏ܂ĂƂ
		/// B<p/>
		/// 
		/// yp^t@C̗z
		/// <pre>
		/// # data for test
		/// #
		/// TestOfElement totalSystem 0 
		/// 3
		/// {
		/// Mountain ibuki 0 
		/// 1.5 2
		/// 
		/// Lake biwa 0 
		/// 5
		/// {
		/// Sky sky 0 
		/// foo 2
		/// 
		/// Outlet outlet 0 
		/// 3.5 2
		/// 3.1 8.0
		/// }
		/// }
		/// </pre>
		/// 
		/// PsQŝ悤ɁA# Ŏn܂s̓RgsłB
		/// 
		/// <pre>
		/// TestOfElement totalSystem 0 
		/// Mountain ibuki 0 
		/// Lake biwa 0 
		/// Sky sky 0 
		/// Outlet outlet 0
		/// </pre>
		/// 
		/// ̂悤ȍśAnfvffʂ邽߂̏
		/// łBNXAIuWFNgAIuWFNgԍ̂R̏
		/// 󔒂ŋ؂ď܂B<p/>
		/// 
		/// fʂ邽߂̂̏ɑāA󔒍sԂɒu
		/// ɁÃfǂ݂Ƃׂ܂B̕
		/// ́AsetParameter(OhStreamReader) ǂݍޕłBs
		/// ̃f[^Kv́Aǂݍ݃vO 
		/// setParameter(OhStreamReader) ɂČ܂܂Bf
		/// ʂ邽߂̏sƁAǂ݂Ƃׂf[^̊ԂɁA
		/// Ŏn܂RgsuƂł܂B<p/>
		/// 
		/// fʂ邽߂̏sƂɑf[^s
		/// ł܂Ƃčl΁Ǎł܂ƕʂ̌ł܂Ƃ̊Ԃɂ́A
		/// 󔒍s # Ŏn܂sĂ\܂B<p/>
		/// 
		/// Lake biwa 0 ̂悤ɁA\vfnf́A{ } 
		/// ͂ŁA̍\vfɊւf[^܂Bnł
		/// ĂA\vf̃p^ݒ̂߂̃f[^ǂݍ݂sv
		/// A{ } ̕Kv͂܂B
		/// 
		/// 
		/// 
		/// </summary>
		/// <param name="aParamFile">a <var>String</var> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  readParameterFile(String aParamFile)
		{
			
			OhStreamReader sr;
			
			try
			{
				sr = new OhStreamReader(aParamFile, true);
			}
			catch (FileNotFoundException e)
			{
				throw new OhError("cannot open \"" + aParamFile + "\"!");
			}
			
			try
			{
				
				String headLine = null;
				Tokenizer strToken = null;
				String className = "";
				String objName = "";
				int objNum = 0;
				Object obj = null;
				
				if (sr.skipWhites() == - 1)
				{
					OhError e = new OhError("Parameter file error.");
					throw e;
				}
				
				headLine = sr.ReadLine();
				
				String str = headLine; //; For work.
				Tokenizer st = new Tokenizer(str);
				int i = 0;
				while (st.HasMoreTokens())
				{
					st.NextToken();
					i++;
				}
				
				strToken = new Tokenizer(headLine);
				
				if (i == 1)
				{
					objName = strToken.NextToken();
					
					if (objCompare(objName, 0) == false)
					{
						throw new OhError("readParameterFile(): unmatched element" + NEWLINE 
                            + "  " + className + "  " + objName + "  " + objNum + NEWLINE + oPrintString("    "));
					}
				}
				else if (i == 2)
				{
					objName = strToken.NextToken();
					objNum = Int32.Parse(strToken.NextToken());
					
					if (objCompare(objName, objNum) == false)
					{
						throw new OhError("readParameterFile(): unmatched element" + NEWLINE 
                            + "  " + className + "  " + objName + "  " + objNum + NEWLINE + oPrintString("    "));
					}
				}
				else if (i == 3)
				{
					className = strToken.NextToken();
					objName = strToken.NextToken();
					objNum = Int32.Parse(strToken.NextToken());
					
					if (objCompare(className, objName, objNum) == false)
					{
						throw new OhError("readParameterFile(): unmatched element" + NEWLINE 
                            + "  " + className + "  " + objName + "  " + objNum + NEWLINE + oPrintString("    "));
					}
				}
				else
				{
					throw new OhError("illegal line" + NEWLINE + "  " + className + "  " + objName + "  " 
                        + objNum + NEWLINE + oPrintString("      "));
				}
				
				base.getParameter(sr);
			}
			catch (OhError e)
			{
				throw new OhError("readParameterFile() method detected an OhError." + NEWLINE 
                    + "when reading \"" + aParamFile + "\"" + NEWLINE + e.what(" > "));
			}
			catch (IOException e)
			{
				StringWriter sr2 = new StringWriter();
				sr2.Write("readParameterFile() method detected " + "an IOExeption." + NEWLINE);
				sr2.Write("when reading \"" + aParamFile + "\"");
				String errStr = sr2.ToString();
				sr2.Close();
				throw new OhError(errStr);
			}
			finally
			{
				if (sr != null)
				{
					try
					{
						sr.Close();
					}
					catch (Exception e)
					{
					}
				}
			}
		}
		
		
		/// <summary> 
		/// <p/>
		/// l̓ǂݍ <p/>
		/// 
		/// Ŏw肳ꂽlt@C珉lǂݎ܂B
		/// ĺAꊇĂP̃t@Cɏ܂ĂƂ܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aInitStateFile">a <var>String</var> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  readInitialStateFile(String aInitStateFile)
		{
			OhStreamReader sr;
			
			try
			{
				sr = new OhStreamReader(aInitStateFile, true);
			}
			catch (FileNotFoundException e)
			{
				throw new OhError("cannot open " + aInitStateFile);
			}
			
			try
			{
				
				String headLine = null;
				Tokenizer strToken = null;
				String className = "";
				String objName = "";
				int objNum = 0;
				Object obj = null;
				
				if (sr.skipWhites() == - 1)
				{
					OhError e = new OhError("Initial State file error.");
					throw e;
				}
				
				headLine = sr.ReadLine();
				
				String str = headLine; //; For work.
				Tokenizer st = new Tokenizer(str);
				int i = 0;
				while (st.HasMoreTokens())
				{
					st.NextToken();
					i++;
				}
				
				strToken = new Tokenizer(headLine);
				
				if (i == 1)
				{
					objName = strToken.NextToken();
					
					if (objCompare(objName, 0) == false)
					{
						throw new OhError("readInitialStateFile(): unmatched element" + NEWLINE 
                            + "  " + className + "  " + objName + "  " + objNum + NEWLINE + oPrintString("    "));
					}
				}
				else if (i == 2)
				{
					objName = strToken.NextToken();
					objNum = Int32.Parse(strToken.NextToken());
					
					if (objCompare(objName, objNum) == false)
					{
						throw new OhError("readInitialStateFile(): unmatched element" + NEWLINE 
                            + "  " + className + "  " + objName + "  " + objNum + NEWLINE + oPrintString("   "));
					}
				}
				else if (i == 3)
				{
					className = strToken.NextToken();
					objName = strToken.NextToken();
					objNum = Int32.Parse(strToken.NextToken());
					
					if (objCompare(className, objName, objNum) == false)
					{
						throw new OhError("readInitialStateFile(): unmatched element" + NEWLINE 
                            + "  " + className + "  " + objName + "  " + objNum + NEWLINE + oPrintString("   "));
					}
				}
				else
				{
					throw new OhError("illegal line" + NEWLINE + "  " + className + "  " 
                        + objName + "  " + objNum + NEWLINE + oPrintString("      "));
				}
				
				base.getInitialState(sr);
			}
			catch (OhError e)
			{
				throw new OhError("readInitialStateFile() method detected an error" + NEWLINE 
                    + "when reading \"" + aInitStateFile + "\"" + NEWLINE + e.what(" > "));
			}
			catch (IOException e)
			{
				throw new OhError("readInitialStateFile() method detected an error" + NEWLINE 
                    + "when reading \"" + aInitStateFile + "\"");
			}
			finally
			{
				if (sr != null)
				{
					try
					{
						sr.Close();
					}
					catch (Exception e)
					{
					}
				}
			}
		}
		
		/// <summary> Read the data of the sending port recorded on the file.
		/// 
		/// 
		/// <p/>
		/// t@CɎ^ĂM[q̃f[^ǂݍ݂܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aSendFile">a <var>String</var> value
		/// </param>
		public virtual void  readSendPortFile(String aSendFile)
		{
			deliverDataString(aSendFile, DataFileContent.SDPDATA);
		}
		
		
		// Setting of initial state.
		
		/// <summary> 
		/// <p/>
		/// _currentTime ̓ǂݍ <p/>
		/// 
		/// t@C _currentTime ǂ݂Ƃ܂B
		/// KvȂApĂŠnfŕύXĂB
		/// 
		/// 
		/// </summary>
		/// <param name="aSr">an <var>OhStreamReader</var> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  setInitialState(OhStreamReader aSr)
		{
			int year = 0;
			long tsec = 0L;
			double frac = 0.0;
			
			try
			{
				aSr.skipWhites();
				year = Int32.Parse(aSr.readWord());
				tsec = Int64.Parse(aSr.readWord());
				frac = Double.Parse(aSr.readWord());
			}
			catch (IOException e)
			{
				throw new OhError("Error in setInitialState()." + NEWLINE + oPrintString("\t"));
			}
			catch (FormatException e)
			{
				throw new OhError("Error in setInitialState()." + NEWLINE + oPrintString("\t"));
			}
			
			if (year > 0)
			{
				_currentTime = new OhTimePoint(year, tsec);
			}
			
			base.initialTime(_currentTime);
		}
		
		
		/// <summary> 
		/// <p/>
		/// (Ref "OhElement#shareInfo()") sB
		/// 
		/// 
		/// </summary>
		/// <returns> an <var>OperationFlag</var> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override OperationFlag doShareInfo()
		{
			OperationFlag flag;
			
			bool calcany = false;
			bool calcall = true;
			
			
			if (_shareInfoDoneP == false)
			{
				if (shareInfo() == false)
				{
					throw new OhError(oPrintString("    "));
				}
				_shareInfoDoneP = true;
			}
			
			int i = 0;
			int k = 0;
			
			do 
			{
				calcany = false;
				calcall = true;
				
				for (k = 0; k < _numberOfComponents; k++)
				{
					flag = ((OhElement) _componentArray[k]).doShareInfo();
					if (flag == OperationFlag.E_DONE)
						calcany = true;
					if (flag == OperationFlag.E_UNDONE)
						calcall = false;
				}
				
				for (i = 0; i < _numberOfIteratorSets; i++)
				{
					for (k = 0; k < _numberOfIterators[i]; k++)
					{
						flag = ((OhElement) _iteratorArray[i][k]).doShareInfo();
						if (flag == OperationFlag.E_DONE)
							calcany = true;
						if (flag == OperationFlag.E_UNDONE)
							calcall = false;
					}
				}
			}
			while (calcany == true);
			
			
			if (calcall == true)
				return OperationFlag.E_ALREADY;
			
			
			for (k = 0; k < _numberOfComponents; k++)
			{
				if (((OhElement) _componentArray[k]).doShareInfo() == OperationFlag.E_UNDONE)
				{
					StreamWriter temp_writer;
					temp_writer = new StreamWriter(Console.OpenStandardError(), Encoding.Default);
					temp_writer.AutoFlush = true;
					((OhElement) _componentArray[k]).oPrint(temp_writer, "\t");
				}
			}
			
			for (i = 0; i < _numberOfIteratorSets; i++)
			{
				for (k = 0; k < _numberOfIterators[i]; k++)
				{
					if (((OhElement) _iteratorArray[i][k]).doShareInfo() == OperationFlag.E_UNDONE)
					{
						StreamWriter temp_writer2;
						temp_writer2 = new StreamWriter(Console.OpenStandardError(), Encoding.Default);
						temp_writer2.AutoFlush = true;
						((OhElement) _iteratorArray[i][k]).oPrint(temp_writer2, "\t");
					}
				}
			}
			
			return OperationFlag.E_UNDONE;
		}
		
		
		// 3. Calculation of the total system model.
		
		
		
		/// <summary> Inputs data time.
		/// 
		/// </summary>
		/// <param name="aInputFrom">an <var>OhTimePoint</var> value
		/// </param>
		/// <param name="aInputTo">an <var>OhTimePoint</var> value
		/// </param>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		public virtual bool canYouInputDataTime(OhTimePoint aInputFrom, OhTimePoint aInputTo)
		{
			IOhTimePointImmutable inputFrom = OhTimePoint.OhTimePointMin;
			IOhTimePointImmutable inputTo = OhTimePoint.OhTimePointMax;
			
			OhArrayList dpArray = null;
			int numOfDps = 0;
			
			IOhTimePointImmutable buf = null;
			
			OhArrayList[] dpArrayArray = new OhArrayList[]{dpArray};
			int[] numOfDpsArray = new int[]{numOfDps};
			
			for (int k = 0; k < _numberOfSendPorts; k++)
			{
				((OhInputPort) _sendPortArray[k]).getDataPackArray(dpArrayArray, numOfDpsArray);
				dpArray = dpArrayArray[0];
				numOfDps = numOfDpsArray[0];
				
				if (numOfDps <= 0)
					return false;
				
				buf = ((OhDataPack) dpArray[0]).DataTime;
				
				inputFrom = (aInputFrom.CompareTo(buf) > 0)?inputFrom:buf;
				
				buf = ((OhDataPack) dpArray[numOfDps - 1]).DataTime;
				
				inputTo = (aInputTo.CompareTo(buf) > 0)?inputTo:buf;
			}
			
			aInputFrom.copy(inputFrom);
			aInputTo.copy(inputTo);
			
			return true;
		}
		
		
		/// <summary> Orders all input ports to read data.
		/// 
		/// 
		/// <p/>
		/// O̓ <p/>
		/// 
		/// ׂĂ̓͒[qɃf[^ǂݍނ悤Ɏw߂܂B
		/// (Ref "OhTotalSystem#initialWork()"), 
		/// (Ref "OhTotalSystem#work()")
		/// Ă΂܂B
		/// 
		/// 
		/// </summary>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  inputData()
		{
			for (int k = 0; k < _numberOfSendPorts; k++)
			{
				((OhInputPort) _sendPortArray[k]).inputData();
				// (Ref "OhInputFile#inputData()") will be called. 
			}
		}
		
		
		/// <summary> Orders all output ports to write out their data.
		/// 
		/// 
		/// <p/>
		/// o͒[qւ̃f[^̏o <p/>
		/// 
		/// ׂĂ̏o͒[qɃf[^o悤Ɏw߂܂B
		/// ʂ́At@Cɏo͂܂B̃\bh́A
		/// (Ref "OhTotalSystem#work()") 
		/// Ă΂܂B̃\bh̓ŁA
		/// (Ref "OhOutputPort#outputData()") Ăł܂B
		/// <p/>
		/// 
		/// 
		/// 
		/// </summary>
		/// <exception cref="IOException">if an error occurs
		/// </exception>
		public virtual void  outputData()
		{
			for (int k = 0; k < _numberOfReceivePorts; k++)
			{
				((OhOutputPort) _receivePortArray[k]).outputData();
			}
		}
		
		
		/// <summary> Usually there is no output from total system.
		/// 
		/// 
		/// <p/>
		/// ̏o <p/>
		/// 
		/// ԗʂ߂ɁA_currentTime ł̏o͂`܂B
		/// M[qɎƏo͒l݂܂B_currnet_time ł̏o
		/// ͂vZłꍇ true Ԃ܂BKvȓ̓f[^
		/// ĂȂȂǂāA_currentTime ̏o͂vZłȂ
		/// ꍇ false Ԃ܂B<p/>
		/// 
		/// ȂȀꍇ͕n̏̏o͂͂ȂƎv
		/// ̂ŁAł͏ true Ԃ悤ɒ`Ă܂B
		/// 
		/// 
		/// </summary>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		public override bool initialOutput()
		{
			return true;
		}
		
		
		/// <summary> 
		/// <p/>
		///  <p/>
		/// 
		/// ɂāASf[^擾܂B
		/// 
		/// 
		/// </summary>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool initialWork()
		{
			//(*11)
			
			if (_initialWorkDoneP == false)
			{
				if (initialOutput() == false)
				{
					throw new OhError("Cannot do initialOutput() for total system.");
				}
				_initialWorkDoneP = true;
			}
			
			inputData();
			
			bool calCall;
			
			while (true)
			{
				
				int i;
				int k;
				OperationFlag flag = (OperationFlag)(-1);
				bool calcany = false;
				bool calcall = true;
				
				for (k = 0; k < _numberOfComponents; k++)
				{
					flag = ((OhElement) _componentArray[k]).doInitialWork();
					
					if (flag == OperationFlag.E_DONE)
						calcany = true;
					if (flag == OperationFlag.E_UNDONE)
						calcall = false;
				}
				
				for (i = 0; i < _numberOfIteratorSets; i++)
				{
					for (k = 0; k < _numberOfIterators[i]; k++)
					{
						flag = ((OhElement) _iteratorArray[i][k]).doInitialWork();
						
						if (flag == OperationFlag.E_DONE)
							calcany = true;
						if (flag == OperationFlag.E_UNDONE)
							calcall = false;
					}
				}
				
				if (calcany == true)
					continue;
				
				calCall = calcall;
				break;
			}
			
			if (calCall == true)
			{
				initializeTargetTime(); // Initialize "_targetTime".
				return true;
			}
			
			// Error process.
			//
			int i2 = 0;
			int k2 = 0;
			for (k2 = 0; k2 < _numberOfComponents; k2++)
			{
				if (((OhElement) _componentArray[k2]).doInitialWork() == OperationFlag.E_UNDONE)
				{
					StreamWriter temp_writer;
					temp_writer = new StreamWriter(Console.OpenStandardError(), Encoding.Default);
					temp_writer.AutoFlush = true;
					((OhElement) _componentArray[k2]).oPrint(temp_writer, "\t");
				}
			}
			
			for (i2 = 0; i2 < _numberOfIteratorSets; i2++)
			{
				for (k2 = 0; k2 < _numberOfIterators[i2]; k2++)
				{
					if (((OhElement) _iteratorArray[i2][k2]).doInitialWork() == OperationFlag.E_UNDONE)
					{
						StreamWriter temp_writer2;
						temp_writer2 = new StreamWriter(Console.OpenStandardError(), Encoding.Default);
						temp_writer2.AutoFlush = true;
						((OhElement) _iteratorArray[i2][k2]).oPrint(temp_writer2, "\t");
					}
				}
			}
			
			Console.Out.WriteLine("OhTotalSystem.initialWork()");
			
			return false;
		}
		
		
		
		/// <summary> 
		/// <p/>
		/// _currentTime ԂB<p/>
		/// 
		/// getNecessaryTimeFrom()  getNecessaryTimeTo() ܂ł̃f[
		/// ^pbNM[q aRp MĂȂ΁Avf͌vZ
		/// Jn邱Ƃł܂B
		/// 
		/// 
		/// </summary>
		/// <returns> an <var>OhTimePoint</var> value
		/// </returns>
		public virtual OhTimePoint getNecessaryTimeFrom()
		{
			return _currentTime;
		}
		
		/// <summary> 
		/// <p/>
		/// _terminalTime ԂB<p/>
		/// 
		/// getNecessaryTimeFrom()  getNecessaryTimeTo() ܂ł̃f[
		/// ^pbNM[q aRp MĂȂ΁Avf͌vZ
		/// Jn邱Ƃł܂B
		/// 
		/// 
		/// </summary>
		/// <returns> an <var>OhTimePoint</var> value
		/// </returns>
		public virtual OhTimePoint getNecessaryTimeTo()
		{
			return _terminalTime;
		}
		
		
		/// <summary> 
		/// <p/>
		/// V~[VڕWV~[Vs҂ƑΘb
		/// 肷B
		/// 
		/// 
		/// </summary>
		/// <returns> a <var>long</var> value
		/// </returns>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override OhTime calculateTimeStep()
		{
			long timeStep;
			OhTime ts;
			
			while (true)
			{
				// -------------------- while loop starts.
				
				StringWriter sw = new StringWriter();
				
				sw.Write(_newestDataTimeCol + "# Key in time step or terminal time for \'total system\'.");
				sw.Write(NEWLINE);
				sw.Write("# current time (year sec frac) = " + _currentTime.Year + " " + _currentTime.Tsec + " " + _currentTime.Frac);
				sw.Write(NEWLINE);
				sw.Write("# time step (day hour min sec frac) or terminal time (year sec frac)");
				sw.Write(NEWLINE);
				
				StringWriter dsw = new StringWriter();
				
				dsw.Write(_currentTime.Year + " " + _currentTime.Tsec + " " + _currentTime.Frac);
				
				String message = sw.ToString();
				String reply = dsw.ToString();
				
				sw.Close();
				dsw.Close();
				
				String textLine = OhInterface.getReply(message, reply);
				
				if (textLine == null)
					throw new OhError("Quit.");
				
				String str = textLine;
				Tokenizer st = new Tokenizer(str);
				int i = 0;
				while (st.HasMoreTokens())
				{
					st.NextToken();
					i++;
				}
				
				Tokenizer strToken = new Tokenizer(textLine);
				
				if (i == 5)
				{
					int day = Int32.Parse(strToken.NextToken());
					int hour = Int32.Parse(strToken.NextToken());
					long min = Int64.Parse(strToken.NextToken());
					long sec = Int64.Parse(strToken.NextToken());
					double frac = Double.Parse(strToken.NextToken());
					timeStep = sec + 60 * (min + 60 * (hour + 24 * day));
					ts = new OhTime(timeStep, frac);
					
					if (ts.toDouble() <= 0.0)
					{
						StringWriter sw2 = new StringWriter();
						sw2.Write("OHyMoSj pause:" + NEWLINE);
						sw2.Write("You inputed:   " + textLine + NEWLINE);
						sw2.Write("But this produces non-positive time step");
						String pauseComment = sw.ToString();
						sw2.Close();
						
						OhInterface.pause(pauseComment);
						
						continue;
					}
					break;
				}
				else if (i == 4)
				{
					int hour = Int32.Parse(strToken.NextToken());
					long min = Int64.Parse(strToken.NextToken());
					long sec = Int64.Parse(strToken.NextToken());
					double frac = Double.Parse(strToken.NextToken());
					timeStep = sec + 60 * (min + 60 * hour);
					ts = new OhTime(timeStep, frac);
					
					if (ts.toDouble() <= 0.0)
					{
						StringWriter sw3 = new StringWriter();
						sw3.Write("OHyMoSj pause:" + NEWLINE);
						sw3.Write("You inpupted:   " + textLine + NEWLINE);
						sw3.Write("But this produces non-positive time step");
						String pauseComment = sw.ToString();
						sw3.Close();
						
						OhInterface.pause(pauseComment);
						
						continue;
					}
					
					break;
				}
				else if (i == 3)
				{
					int year = Int32.Parse(strToken.NextToken());
					long tsec = Int64.Parse(strToken.NextToken());
					double frac = Double.Parse(strToken.NextToken());
					OhTimePoint tp = new OhTimePoint(year, tsec, frac);
					ts = OhTimePoint.sub(tp, _currentTime);
					
					if (ts.toDouble() <= 0)
					{
						OhInterface.pause("OHyMoS.NET pause:" + NEWLINE 
                            + "You inputed:   " + textLine + NEWLINE + "But this produces non-positive time step");
						
						continue;
					}
					
					break;
				}
				else
				{
					OhInterface.pause("# Invalid input" + NEWLINE);
					continue;
				}
			} // ----------------------------------- while loop ends.
			
			return ts;
		}
		
		
		/// <summary> 
		/// <p/>
		/// PXebv̌vZ
		/// 
		/// 
		/// </summary>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		/// <exception cref="OhCannotGetDataError">if an error occurs
		/// </exception>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool calculate()
		{
			return true;
		}
		
		/// <summary> 
		/// <p/>
		/// o͗p[qpāAŠnɑ΂o͂sȂB
		/// ܂A\vfɌvZs߂𑗂B
		/// 
		/// 
		/// </summary>
		/// <returns> a <var>boolean</var> value
		/// </returns>
		/// <exception cref="OhCannotGetDataError">if an error occurs
		/// </exception>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override bool work()
		{
			bool calc = false;
			bool flagAll = false;
			bool flagItr = false;
			int i = 0;
			int j = 0;
			int k = 0;
			char reply;
			int[] itrCounter = new int[_numberOfIteratorSets];
			OhTime mtti;
			// "Medium Term Target Time" increment.
			
			try
			{
				
				while (true)
				{
					// ----------------------- LOOP starts.
					
					_timeStep = calculateTimeStep();
					
					while (true)
					{
						// -------------- Infinite loop starts.
						
						StringWriter sw = new StringWriter();
						
						sw.Write("# _timeStep = " + _timeStep + " (sec)");
						sw.Write(NEWLINE);
						sw.Write("# Key in \"Medium Term Target Time\" increment");
						sw.Write(NEWLINE);
						sw.Write("#   (sec frac) or (min sec frac) or " + "(hour min sec frac) " + "or (day hour min sec frac) ");
						sw.Write(NEWLINE);
						
						
						StringWriter dsw = new StringWriter();
						
						dsw.Write(_timeStep);
						
						String message = sw.ToString();
						String defaultMessage = dsw.ToString();
						
						sw.Close();
						dsw.Close();
						
						String textLine = OhInterface.getReply(message, defaultMessage);
						
						mtti = new OhTime(0, 0.0);
						
						if (textLine == null)
							throw new OhError("Quit.");
						
						String str = textLine; // For work.
						Tokenizer st = new Tokenizer(str);
						int a = 0;
						while (st.HasMoreTokens())
						{
							// "n_words(textLine)"
							st.NextToken();
							a++;
						}
						
						Tokenizer strToken = new Tokenizer(textLine);
						
						if (a == 5)
						{
							int day = Int32.Parse(strToken.NextToken());
							int hour = Int32.Parse(strToken.NextToken());
							long min = Int64.Parse(strToken.NextToken());
							long sec = Int64.Parse(strToken.NextToken());
							double frac = Double.Parse(strToken.NextToken());
							mtti = new OhTime(sec + 60 * (min + 60 * (hour + 24 * day)), frac);
						}
						else if (a == 4)
						{
							int hour = Int32.Parse(strToken.NextToken());
							long min = Int64.Parse(strToken.NextToken());
							long sec = Int64.Parse(strToken.NextToken());
							double frac = Double.Parse(strToken.NextToken());
							mtti = new OhTime(sec + 60 * (min + 60 * hour), frac);
						}
						else if (a == 3)
						{
							long min = Int64.Parse(strToken.NextToken());
							long sec = Int64.Parse(strToken.NextToken());
							double frac = Double.Parse(strToken.NextToken());
							mtti = new OhTime(sec + 60 * min, frac);
						}
						else if (a == 2)
						{
							long sec = Int64.Parse(strToken.NextToken());
							double frac = Double.Parse(strToken.NextToken());
							mtti = new OhTime(sec, frac);
						}
						
						if (mtti.toDouble() > 0.0)
						//; Escapes from an infinite loop.
							break;
						
						OhInterface.pause("# Invalid input : " + "\"Medium Term Target Time\" increment <= 0");
					} // ---------------------------- Infinite loop ends.
					
					_terminalTime = OhTimePoint.add(_currentTime, _timeStep);
					_mediumTermTargetTime = new OhTimePoint(_currentTime);
					
					
					long start = DateTime.Now.Ticks; // V~[VԌvp

					try
					{
                        while (true) // ------------------------- WORK starts.
						{
							calc = false;
							for (i = 0; i < _numberOfIteratorSets; i++)
								itrCounter[i] = 0;
							
							// Increments _mediumTermTargetTime by mtti
							_mediumTermTargetTime.add(mtti);
							
							if (_currentTime.CompareTo(_mediumTermTargetTime) > 0)
							{
                                if (_currentTime.CompareTo(_terminalTime) >= 0)
                                    break;
                                else
                                    continue;
							}
							
							do 
							{
								flagAll = false;
								
								for (k = 0; k < _numberOfComponents; k++)
								{
									if (((OhElement) _componentArray[k]).work() == true)
									{
										// Abstract method call. "OhCannotGetDataError".
										calc = flagAll = true;
										break; // Escapes from this for loop.
									}
								}
								
								while (++k < _numberOfComponents)
									((OhElement) _componentArray[k]).work();
								// Abstract method call. Throws "OhCannotGetDataError".
								
								
								// _iteratorArray
								//
								for (i = 0; i < _numberOfIteratorSets; i++)
								{
									// ---------------------------- for loop 1 starts.
									
									do 
									{
										flagItr = false;
										
										for (j = 0; j < _numberOfIterators[i]; j++)
										{
											if (((OhElement) _iteratorArray[i][j]).work() == true)
											{
												// Abstract method call."OhCannotGetDataError"
												calc = flagAll = flagItr = true;
												break; // Escapes from this for loop.
											}
										}
										
										while (++j < _numberOfIterators[i])
											((OhElement) _iteratorArray[i][j]).work();
										// abstract method call which may throw
										// (Ref "OhCannotGetDataError").
									}
									while (flagItr == true);
									
									if (hasReachedTargetTime(i) == true)
									{
										if (hasConverged(i) == true)
										{
											flushData(i);
											renewFixedTime(i);
											renewTargetTime(i, calculateIterationStep(i));
											itrCounter[0] = 0;
										}
										else
										{
											rewindCurrentTime(i);
											
											if (++itrCounter[i] >= 1000)
											{
												throw new OhError("\tin group [" + i + "]." + NEWLINE + oPrintString("\t"));
											}
										}
									}
								} // --------------------------- for loop 1 ends.
							}
							while (flagAll == true);
							
							
							if (calc == false)
							{
								Console.Out.Write(NEWLINE);
								Console.Out.Write("# No object has worked." + NEWLINE);
								break;
							}
							
							renewCurrentTime();
							
							if (_currentTime.CompareTo(_mediumTermTargetTime) < 0)
							{
								Console.Error.WriteLine(NEWLINE);
								Console.Error.WriteLine("# Error : Stopped before \"MediumTermTargetTime\"." + NEWLINE);
								break;
							}
							
							if (_mediumTermTargetTime.CompareTo(_terminalTime) < 0)
							{
								continue;
							}
							
							outputData();
							
							break;
                        } // --------------------------------------- WORK ends.
						
					}
					catch (OhCannotGetDataError e)
					{
						OhInterface.pause("# ERROR : Now in catch block. ");
						outputData();
					}

                    long end = DateTime.Now.Ticks; // V~[VԌvp
                    long calculationTime = (end - start) / 10000;@// V~[Vv
					
					while (true) //----------------------------------- ASK starts.
					{
						
						StringWriter sw = new StringWriter();

						sw.Write(NEWLINE);
                        sw.WriteLine("# The time which simulation calculation took is " + calculationTime + "[msec].");
                        sw.WriteLine("# Now : _currentTime = " + _currentTime + " : _terminalTime = " + _terminalTime);
						sw.WriteLine("# Quit? Key in [Y(y)] or [N(n)]");
						
						String message = sw.ToString();
						
						sw.Close();
						
						String textLine = OhInterface.getReply(message, "y");
						
						if (textLine == null)
							throw new OhError("Quit.");
						
						OhStringReader br = new OhStringReader(textLine);
						
						int c = br.Read();
						//; 󂫕i""ĵƂ -1 ԂB
						
						reply = (char) c;
						
						switch (reply)
						{
							
							case 'y': 
							case 'Y': 
								break;
							
							case 'n': 
							case 'N': 
								inputData();
                                break;

							default: 
								Console.Out.Write("# Invalid input : Key in \'Y\' or \'N\'" + NEWLINE + NEWLINE);
                                continue;
						}

                        break; // reply=='Y' or 'y'

                    } //----------------------------------- ASK ends.

                    if (reply == 'Y' || reply == 'y')
                        break;

				} // ----------------------------------------- LOOP ends.
				 
			} // -------------------------------------------- try ends.
			
			catch (IOException e)
			{
				OhInterface.pause("# Error : Now in catch block" + NEWLINE);
			}
			
			return true;
		}
		
		
		// 4. Save function of the last state.
		
		/// <summary> Write "_currentTime".
		/// 
		/// 
		/// <p/>
		/// _currentTime ̏ <p/>
		/// 
		/// _currentTime ݂܂B
		/// KvȂApĂŠnfŕύXĂB
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <var>PrintWriter</var> value
		/// </param>
		public override void  saveTerminalState(StreamWriter aPw)
		{
			aPw.Write(_currentTime);
		}
		
		/// <summary> Saves to the file of the last state.
		/// 
		/// 
		/// <p/>
		/// ŏIԂ̃t@Cւ̕ۑ <p/>
		/// 
		/// t@C aFimeName ijVKɃI[vāAŠn̍
		/// IԂۑ܂Bt@C aFimeName łɑ݂ꍇ
		/// ͏㏑܂B<p/>
		/// 
		/// ŁA
		/// (Ref "OhSubSystem#terminalState(PrintWriter)")
		/// ǂł܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aFileName">a <var>String</var> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  writeTerminalState(String aFileName)
		{
			StreamWriter sw = null;
			
			try
			{
				sw = new StreamWriter(aFileName, false, Encoding.Default);
				
				sw.Write("# terminal state of " + _objectName + " " + NEWLINE);
				sw.Write("# _currentTime =    " + _currentTime + " " + NEWLINE);
				
				base.terminalState(sw);
				
				sw.Close();
			}
			catch (IOException e)
			{
				throw new OhError(oPrintString("\t"));
			}
		}
		
		
		/// <summary> Stores the data packs which remain in send ports into a
		/// file withe the specified file name.  If the file with the
		/// file name has been created already, it will be
		/// overwritten.<p/>
		/// 
		/// 
		/// <p/>
		/// o͒[qɎcĂf[^̕ۑ <p/>
		/// 
		/// t@C aFileName ijVKɃI[vāA
		/// o͒[qɎcĂf[^t@Cɕۑ܂B
		/// t@C aFilefName łɑ݂ꍇ͏㏑܂B<p/>
		/// 
		/// ŁA
		/// (Ref "OhElement#saveSendPortStock(PrintWriter)")
		/// (Ref "OhSubSystem#saveSendPortStock(PrintWriter)")
		/// Ăł܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aFileName">a <var>String</var> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public virtual void  writeSendPortStock(String aFileName)
		{
			StreamWriter sw = null;
			
			try
			{
				sw = new StreamWriter(aFileName, false, Encoding.Default);
				
				sw.Write("# send port data of  " + _objectName + " " + NEWLINE);
				sw.Write("# _currentTime =     " + _currentTime + " " + NEWLINE + "# " + NEWLINE);
				
				((OhElement) this).saveSendPortStock(sw);
				
				int i = 0;
				int k = 0;
				
				if ((_numberOfComponents > 0) || (_numberOfIteratorSets > 0))
				{
					sw.Write("{" + NEWLINE);
					
					for (k = 0; k < _numberOfComponents; k++)
					{
						((OhElement) _componentArray[k]).saveSendPortStock(sw);
					}
					
					for (i = 0; i < _numberOfIteratorSets; i++)
					{
						for (k = 0; k < _numberOfIterators[i]; k++)
						{
							((OhElement) _iteratorArray[i][k]).saveSendPortStock(sw);
						}
					}
					
					sw.Write("}" + NEWLINE);
				}
				
				sw.Close();
			}
			catch (IOException e)
			{
				throw new OhError(oPrintString("\t"));
			}
		}
		
		
		// 5. Information display function.
		
		/// <summary> The input of output port information.
		/// 
		/// 
		/// <p/>
		/// ͒[q̏o
		/// 
		/// <pre>
		/// [ARGUMENT]
		/// EaPw ---> o͐̃t@CXg[B
		/// EaHead -> õ͎wb_B
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <var>PrintWriter</var> value
		/// </param>
		/// <param name="aHead">a <var>String</var> value
		/// </param>
		public virtual void  printInputs(StreamWriter aPw, String aHead)
		{
			printObjects(aPw, aHead, "Inputs :", _sendPortArray, _numberOfSendPorts);
		}
		
		/// <summary> The input of output port information.
		/// 
		/// 
		/// <p/>
		/// ͒[q̏o
		/// 
		/// <pre>
		/// [ARGUMENT]
		/// EaPw ---> o͐̃t@CXg[B
		/// </pre>
		/// 
		/// õ͎wb_͂SJɂȂ܂BB
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <var>PrintWriter</var> value
		/// </param>
		public virtual void  printInputs(StreamWriter aPw)
		{
			printObjects(aPw, "    ", "Inputs :", _sendPortArray, _numberOfSendPorts);
		}
		
		/// <summary> The output of output port information.
		/// 
		/// 
		/// <p/>
		/// o͒[q̏o
		/// 
		/// <pre>
		/// [ARGUMENT]
		/// EaPw ---> o͐̃t@CXg[B
		/// EaHead -> õ͎wb_B
		/// </pre>
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <var>PrintWriter</var> value
		/// </param>
		/// <param name="aHead">a <var>String</var> value
		/// </param>
		public virtual void  printOutputs(StreamWriter aPw, String aHead)
		{
			printObjects(aPw, aHead, "Outputs :", _receivePortArray, _numberOfReceivePorts);
		}
		
		/// <summary> 
		/// <p/>
		/// o͒[q̏o
		/// 
		/// <pre>
		/// [ARGUMENT]
		/// EaPw ---> o͐̃t@CXg[B
		/// </pre>
		/// 
		/// õ͎wb_͂SJɂȂ܂B
		/// 
		/// 
		/// </summary>
		/// <param name="aPw">a <var>PrintWriter</var> value
		/// </param>
		public virtual void  printOutputs(StreamWriter aPw)
		{
			printObjects(aPw, "    ", "Outputs :", _receivePortArray, _numberOfReceivePorts);
		}
	} // OhTotalSystem
}