/// <(#)>   SimpleDam.java </(#)>
/// <summary> 
/// </summary>
using System;
using System.IO;
using OhymosNet;
namespace OhymosNet
{
	
	
	/// <summary> 
    /// SimpleDam NX́AȒPȃ_rfłB<p/>
    /// vffłB<p/>
    /// Simple dam model.<p/>
    /// </summary>
    /// <remarks>
    /// <b>M[q</b>:
    /// ̃_rf́A̗ʂ󂯂Ƃ邽߂̎M
    /// [qĂ܂BM[q̌ nrp ́ACӂɕύXł܂B
    /// M[q́A
    /// 
    /// <code>
    /// OhReceiveDouble("rp", i), i = 0, ..., nrp-1
    /// </code>
    /// 
    /// łi<a href = "OhymosNet.OhReceiveDouble.html">OhReceiveDouble</a>QƁjB
    /// M[qMf[^ɏ搔 cRp(i) |̂AʂƂȂ܂BcRp(i)*rpi 
    /// ̒PʂAm^3/sec ł悤ɂ܂BArpi ́AiԖڂ
    /// M[q擾lłB
    /// <p/>
    /// 
    /// <b>M[q</b>:
    /// M[q́A2A
    /// 
    /// <code>
    /// OhSendDouble("sp", i), i = 0, 1
    /// </code>
    /// 
    /// łi<a href = "OhymosNet.OhSendDouble.html">OhSendDouble</a>QƁjB
    /// A
    /// <a href = "OhymosNet.DataConnectionType.html">DataConnectionType</a>́Abrokenline łB
    /// M[q("sp", 0) 瑗Mf[^̓_̕ʂŁAPʂ́A
    /// m**3/sec łBM[q ("sp", 1) 瑗Mf[^́A_
    /// ̒ʂŁAPʂ́Am**3 łB
    /// <p/>
    /// 
    /// <b>p^</b>:
    /// <dl>
    /// <dt> qPass</dt> 
    /// <dd>
    /// ʉߗ (m^3/sec)B_ւ̗ʂ̑aA̒ʉߗʂ
    /// Ƃ̂܂ܕ܂B_ւ̗ʂ̑aAqPass 
    /// 傫ƁAqPass + ratio * (qsum - qPass) ܂B
    /// Aqsum ͗ʂ̑ałB
    /// </dd>
    /// <dt> ratio </dt>
    /// <dd>
    /// 0  1 ̊Ԃ̖̒萔B_̕ʂvẐɎg
    /// p܂B
    /// </dd>
    /// <dt> dt</dt>
    /// <dd>
    /// vZԃXebv (sec)</dd>
    /// <dt> cRp[i], i=0, ..., nrp-1</dt> 
    /// <dd>
    /// M[q ("rp", i) Mf[^ւ̏搔B
    /// </dd></dl>
    /// 
    /// <b>ԗ</b>:
    /// <a href ="OhymosNet.OhTimePoint.html">OhTimePoint</a>^̎ƒr̒ (m**3)<p/>
    /// 
    /// nrp ́A
    /// <a href ="OhymosNet.SimpleDam.init_overload_1.html">init(String, int, OhStreamReader)</a> Őݒ
    /// ܂Bp^́A<a href ="OhymosNet.SimpleDam.setParameter.html">setParameter(OhStreamReader)</a>œǂ
    /// ܂܂Bԗʂ́A<a href ="OhymosNet.SimpleDam.setInitialState.html">setInitialState(OhStreamReader)</a>
    /// ǂݍ܂܂B
    /// <br/><br/>
    /// 
	/// <b>Receiveports</b>: <br/>
	/// OhReceiveDouble("rp", i), i = 0, ..., nrp-1. nrp is variable.
	/// Inflow from upstream channels into the dam. The dimension of
	/// cRp[i]*rpi must be m**3/sec where rpi is the value obtained
    /// from the port ("rp", i). See: <a href = "OhymosNet.OhReceiveDouble.html">OhReceiveDouble</a> <p/>
	/// 
	/// <b>Sendports</b>: <br/>
	/// OhSendDouble("sp", 0) -- discharge (m**3/sec) from the dam,
	/// brokenline. <br/>
	/// OhSendDouble("sp", 1) -- storage (m**3) of the dam, brokenline.
	/// <br/>
    /// See: <a href = "OhymosNet.OhSendDouble.html">OhSendDouble</a> <p/>
	/// 
	/// <b>parameters</b>: 
	/// <dl>
	/// <dt> qPass </dt>
    /// <dd>
	/// pass discharge (m^3/sec)
	/// </dd>
    /// <dt> ratio </dt>
    /// <dd>
	/// discharge rate to surpass from qPass (-)
	/// </dd>
    /// <dt> dt </dt>   
    /// <dd>
	/// time step (sec)
	/// </dd>
    /// <dt> cRp[i], i=0, ..., nrp</dt> 
    /// <dd>
	/// multiplier to inflow dischage to port ("rp", i), i = 0, ...,
	/// nrp-1.
	/// </dd></dl>
	/// 
	/// <b>state variables</b>:<br/>
	/// the OhTimePoint variable and the storage in the dam reservoir
	/// (m**3)
	/// <p/>
	/// 
	/// The <b>init(String, int, OhStreamReader)</b> method looks like:
	/// 
	/// <code>
	/// public void init(String aObjName, int aObjNum, OhStreamReader aSr) 
    /// {
	///     int nrp;
	///     try 
    ///     {
	///         nrp = Integer.parseInt(aSr.readWord());
	///     }
	///     catch (IOException e) { ...; }
	///     catch (Exception e) { ...; }
	///     ...
	/// }
	/// </code>
	/// 
	/// The <b>setParemeter(OhStreamReader)</b> method used for
	/// reading parameters from a file looks like:
	/// 
	/// <code>
	/// public void setParameter(OhStreamReader aSr)
	/// {
	///     double dt = 0.0;
	///     try 
    ///     {
	///         _qPass = Double.Parse(aSr.readWord());
	///         _ratio = Double.Parse(aSr.readWord());
	///         dt = Double.Parse(aSr.readWord());
	///         _dt = new OhTime(dt);
	///     }
	///     catch (IOException e) 
    ///     { 
    ///         ...; 
    ///         throw new OhError(str); 
    ///     }
	///     catch (Exception e) 
    ///     {
	///         ...; 
    ///         throw new OhError(str); 
    ///     }
	///     
    ///     if (_qPass &lt; 0.0) 
    ///     { 
    ///         ...; 
    ///         throw new OhError(str); 
    ///     }
    ///     if (_ratio &lt; 0.0 || _ratio &gt; 1.0)  
    ///     { 
    ///         ...; 
    ///         throw new OhError(str); 
    ///     }
    ///     if (_dt.toDouble() &lt; OhTime.NEGLIGIBLY_SMALL_TIME) 
    ///     {
	///         ...; 
    ///         throw new OhError(str); 
    ///     }
	///     if (_numberOfRp &gt; 0) 
    ///     {  
    ///            //; Weights for inflow receive ports.
    ///         for (int i = 0; i &lt; _numberOfRp; i++) 
    ///         {
	///             try 
    ///             {
	///                 _cRp[i] = Double.Parse(aSr.readWord());
	///             }
	///             catch (IOException e) 
    ///             { 
    ///                 ...; 
    ///                 throw new OhError(str); 
    ///             }
	///             catch (Exception e) 
    ///             {
	///                 ...; 
    ///                 throw new OhError(str); 
    ///             }
	///         }
	///     }
	/// }
	/// </code>
    /// Note: <a href = "OhymosNet.OhTime.NEGLIGIBLY_SMALL_TIME.html">NEGLIGIBLY_SMALL_TIME</a><p/>
	/// 
	/// The <b>setInitialState(OhStreamReader)</b> method used for
	/// reading initial states from a file looks like:<p/>
	/// 
	/// <code>
	/// public void setInitialState(OhStreamReader aSr)
	/// {
	///     int  year = 0; long tsec = 0L; frac = 0.0;
	///     try 
    ///     {
	///         year = Int32.Parse(aSr.readWord());
	///         tsec = Int64.Parse(aSr.readWord());
	///         frac = Double.Parse(aSr.readWord());
	///     }
	///     catch (IOException e) { ...; }
	///     catch (Exception e) { ...; }
	///     if (year > 0) 
    ///     {
	///         _currentTime = new OhTimePoint(year, tsec, frac);
	///     }
	///     try 
    ///     {
	///         _storageCrnt = Double.Parse(aSr.readWord());
	///     }
	///     catch (IOException e) { ...; }
	///     catch (Exception e) { ...; }
	/// }
	/// </code>
    /// </remarks>
	public class SimpleDam:OhElement
	{
		// @begin {instance variable or static variable} -----------------------
		
		// 1. Receive ports and send ports.
		
		internal OhReceiveDouble[] _rP;
	
		internal OhSendDouble _sP0;
		internal OhSendDouble _sP1;
		
		// 2. Structural parameters.
		
		internal int _numberOfRp;
		
		// 3. Parameters.
		
		internal double _qPass;
		
		internal double _ratio;
		
		internal OhTime _dt;
		
		internal double[] _cRp;
		
		// 4. State variables.
		
		internal double _storageCrnt;
		
		internal double _qCrnt;
		
		// 5. Working variable.
		
		internal double _storageNext;
		
		internal double _qNext;
		
		internal double _qInCrnt;
		
		internal double _qInNext;
		
		
		// @end {instance variable or static variable} -------------------------
		
		// @begin {initialization} ---------------------------------------------
		
        /// <summary>
        /// qłB
        /// </summary>
        /// <param name="aObjName"></param>
        /// <param name="aObjNum"></param>
        /// <param name="aDataStr"></param>
        /// <param name="aNrp"></param>
		public virtual void  init(String aObjName, int aObjNum, String aDataStr, int aNrp)
		{
			_numberOfRp = aNrp;
			
			if (_numberOfRp < 1)
				_numberOfRp = 1;
			
			_rP = new OhReceiveDouble[_numberOfRp];
			_cRp = new double[_numberOfRp];
			
			for (int i = 0; i < _numberOfRp; i++)
			{
				_rP[i] = new OhReceiveDouble(); //; Added by Satoh. (2003.12.10)
				_rP[i].init("rp", i);
			}
			
			base.init(aObjName, aObjNum, 0, aDataStr);
		}
		
		/// <summary>
        /// qłB
		/// </summary>
		/// <param name="aObjName"></param>
		/// <param name="aObjNum"></param>
		/// <param name="aSr"></param>
		public override void  init(String aObjName, int aObjNum, OhStreamReader aSr)
		{
			int nrp;
			try
			{
				nrp = Int32.Parse(aSr.readWord());
			}
			catch (IOException e)
			{
				throw new OhError(oPrintString("\t"));
			}
			catch (FormatException e)
			{
				throw new OhError(oPrintString("\t"));
			}
			
			init(aObjName, aObjNum, null, nrp);
		}
		
		// @end {initialization} -----------------------------------------------
		
		// @begin {constructors} -----------------------------------------------
		
        /// <summary>
        /// ftHgRXgN^łB
        /// </summary>
		public SimpleDam():base()
		{
			
			_rP = null;
			_sP0 = new OhSendDouble("sp", 0);
			_sP1 = new OhSendDouble("sp", 1);
			_numberOfRp = 0;
			_cRp = null;
			
			_className = "SimpleDam";
		}
		
		public SimpleDam(String aObjName, int aObjNum, String aDataStr, int aNrp):base()
		{
			
			_rP = null;
			_sP0 = new OhSendDouble("sp", 0);
			_sP1 = new OhSendDouble("sp", 1);
			_cRp = null;
			
			_className = "SimpleDam";
			
			init(aObjName, aObjNum, aDataStr, aNrp);
		}
		
		// @end {constructors} -------------------------------------------------
		
		// @begin {methods} ----------------------------------------------------
		
		// 1. Methods about receive ports and send ports.
		
		public override void  registerReceivePorts()
		{
			//(*1)
			for (int i = 0; i < _numberOfRp; i++)
			{
				register(_rP[i]); // might throw an OhError.
			}
		}
		
		public override void  registerSendPorts()
		{
			register(_sP0); // might throw an OhError.
			register(_sP1); // might throw an OhError.
		}
		
		
		// 2. Parameter setting and initialization of states.
		
		
		/// <summary> Read the values of the parameters from the specified
		/// stream.<p/>
		/// 
		/// <japanese>
		/// w肳ꂽXg[Ap^̒lǂݎ܂B
		/// ǂݎp^̒ĺA̒ʂłB<p/>
		/// 
		/// <dl>
		/// <dt> qPass <dd>
		/// ʉߗ (m^3/sec)B_ւ̗ʂ̑aA̒ʉߗʂ
		/// Ƃ̂܂ܕ܂B_ւ̗ʂ̑aAqPass 
		/// 傫ƁAqPass + ratio * (qsum - qPass) ܂B
		/// Aqsum ͗ʂ̑ałB
		/// 
		/// <dt> ratio <dd>
		/// 0  1 ̊Ԃ̖̒萔B_̕ʂvẐɎg
		/// p܂B
		/// 
		/// <dt> dt    <dd>
		/// vZԃXebv (sec)
		/// <dt> cRp[i], i=0, ..., nrp-1 <dd>
		/// M[q ("rp", i) Mf[^ւ̏搔B
		/// </dl>
		/// 
		/// </japanese>
		/// 
		/// </summary>
		/// <param name="aSr">an <code>OhBufferedReader</code> value
		/// </param>
		/// <exception cref="OhError">if an error occurs
		/// </exception>
		public override void  setParameter(OhStreamReader aSw)
		{
			//(*2)
			
			double dt = 0.0;
			try
			{
				_qPass = Double.Parse(aSw.readWord());
				_ratio = Double.Parse(aSw.readWord());
				dt = Double.Parse(aSw.readWord());
				_dt = new OhTime(dt);
			}
			catch (IOException e)
			{
				throw new OhError(oPrintString("\t"));
			}
			catch (FormatException e)
			{
				throw new OhError(oPrintString("\t"));
			}
			
			if (_qPass < 0.0)
			{
				throw new OhError("_qPass should be non-negative but is " + _qPass);
			}
			
			if (_ratio < 0.0 || _ratio > 1.0)
			{
				throw new OhError("_ratio should be in [0.0, 1.0] but it is " + _ratio);
			}
			
			if (_dt.toDouble() < OhTime.NEGLIGIBLY_SMALL_TIME)
			{
				throw new OhError("_dt should be greater than or equal to " + OhTime.NEGLIGIBLY_SMALL_TIME 
                    + " but it is " + _dt);
			}
			
			if (_numberOfRp > 0)
			{
				//; Weights for inflow receive ports.
				for (int i = 0; i < _numberOfRp; i++)
				{
					try
					{
						_cRp[i] = Double.Parse(aSw.readWord());
					}
					catch (IOException e)
					{
						throw new OhError(oPrintString("\t"));
					}
                    //{
                    //    throw new OhError(oPrintString("\t"));
                    //}
				}
			}
		}
		
		
		public virtual void  saveParameter(StreamWriter aSw)
		{
			aSw.Write(_qPass + " " + _ratio + " " + _dt + NEWLINE);
			for (int i = 0; i < _numberOfRp; i++)
			{
				aSw.Write(_cRp[i] + " ");
			}
			aSw.Write(NEWLINE);
		}
		
		public override void  setInitialState(OhStreamReader aSr)
		{
			//(*3)
			int year = 0;
			long tsec = 0L;
			double frac = 0.0;
			
			try
			{
				year = Int32.Parse(aSr.readWord());
				tsec = Int64.Parse(aSr.readWord());
				frac = Double.Parse(aSr.readWord());
				
				//    System.out.println("year = " + year);  ł́u2000v
			}
			catch (IOException e)
			{
				throw new OhError("Error in setInitialState()." + oPrintString("\t"));
			}
			catch (FormatException e)
			{
				throw new OhError("Error in setInitialState().", oPrintString("\t"));
			}
           			
			if (year > 0)
			{
				_currentTime = new OhTimePoint(year, tsec, frac);
			}
			
			try
			{
				_storageCrnt = Double.Parse(aSr.readWord());
			}
			catch (IOException e)
			{
				throw new OhError(oPrintString("\t"));
			}
			catch (FormatException e)
			{
				throw new OhError(oPrintString("\t"));
			}
        }
		
		
		public override void  saveTerminalState(StreamWriter aSw)
		{
			aSw.Write(_currentTime + " # _currentTime");
			aSw.Write(NEWLINE);
			aSw.Write(_storageCrnt + " # _storageCrnt (m^3)");
			aSw.Write(NEWLINE);
		}
		
		
		// 3. Calculation.
		
		public override bool initialOutput()
		{
			_qInCrnt = 0.0;
			
			if (_numberOfRp > 0)
			{
				int j = 0;
				
				for (j = 0; j < _numberOfRp; j++)
				{
					if (_rP[j].canYouGetData(_currentTime) == false)
					{
						return false;
					}
					
					_qInCrnt += _cRp[j] * (_rP[j].getData(_currentTime));
				}
			}
			
			if (_qInCrnt <= _qPass)
			{
				_qCrnt = _qInCrnt;
			}
			else
			{
				_qCrnt = _qPass + _ratio * (_qInCrnt - _qPass);
			}
			
			
			_sP0.CommentString = "OhTimePoint.Year OhTimePoint.Tsec(sec) " + "OhTimePoint.Frac(sec) discharge(m**3/sec)";
			_sP0.sendData(_currentTime, _qCrnt);
			
			_sP1.CommentString = "OhTimePoint.Year OhTimePoint.Tsec(sec) " + "OhTimePoint.Frac(sec) storage(m**3)";
			_sP1.sendData(_currentTime, _storageCrnt);
			
			return true;
		}
		
		
		public override OhTime calculateTimeStep()
		{
			return _dt; //; "_dt" is read from pmt file.
		}
		
		public override bool canYouCalculate()
		{
			return canYouCalculate0();
		}
		
		public override bool work()
		{
			return work0();
		}
		
		
		
		
		public override bool calculate()
		{
			//(*6)
			double dta;
			dta = _timeStep.toDouble(); //; "_timeStep" equals "_dt";
			
			_qInNext = 0.0;
			
			OhTimePoint nextTime = OhTimePoint.add(_currentTime, _timeStep);
			
			if (_numberOfRp > 0)
			{
				int j = 0;
				for (j = 0; j < _numberOfRp; j++)
				{
					if (_rP[j].canYouGetData(nextTime) == false)
					{
						return false;
					}
					_qInNext += _cRp[j] * (_rP[j].getData(nextTime));
				}
			}
			
			if (_qInNext <= _qPass)
			{
				_qNext = _qInNext;
			}
			else
			{
				_qNext = _qPass + _ratio * (_qInNext - _qPass);
			}
			
			_storageNext = _storageCrnt + dta * (_qInCrnt + _qInNext) * 0.5 - dta * (_qCrnt + _qNext) * 0.5;
			
			
			//; Output.
			//;
			_sP0.sendData(nextTime, _qNext);
			_sP1.sendData(nextTime, _storageNext);

            //Console.WriteLine(nextTime.ToString() + " " + _qNext);
			
			//; Standard output. (This is not especially required.)
			//;
			
			//; Update state variables.
			//;
			_storageCrnt = _storageNext;
			_qCrnt = _qNext;
			_qInCrnt = _qInNext;
			
			return true;
		}
		
		
		public override String basicInfo()
		{
			return "Simple dam model";
		}
		

    
		// @begin {methods} ----------------------------------------------------
	} // SimpleDam
}