/// <(#)>  Main.java </(#)>
/// <summary> 
/// Created: 2004/01/30
/// 
/// </summary>
/// <author>  shiiba
/// </author>
/// <version>  $Revision$
/// 
/// </version>
using System;
using System.Text;
using System.Text.RegularExpressions;
using System.IO;
using OhymosNet;

namespace OhymosNet
{
	
	/// <summary> Main class of OHyMoS.NET.<p/>
	/// 
	/// Main NX́AOHyMoS.NET ̃CNXłBOHyMoS.NET ́Aʏ 
	/// OhymosNet.dll ɃpbP[W܂B
	/// <p/>
	/// </summary>
    /// <remarks>
	/// <li> OhymosNet.dllƃ[U̗pӂdllt@CɊ܂܂Ă钊ۃNX\Ƃ́A</li>
	/// <code>
	/// $ ./OhymosNet -a
	/// </code>
	/// Ƃ܂B<p/>
	/// 
	/// <li> [qf\Ƃ́A</li>
	/// <code>
    /// $ ./OhymosNet -p
	/// </code>
	/// Ƃ܂B<p/>
	/// 
	/// <li> vff\Ƃ́A</li>
	/// <code>
    /// $ ./OhymosNet -e
	/// </code>
	/// Ƃ܂B<p/>
	/// 
    /// <li> SNX\Ƃ́A</li>
    /// <code>
    /// $ ./OhymosNet -c
    /// </code>
    /// Ƃ܂B<p/>
    /// 
    /// <li> ovZsɂ́A</li>
	/// <code>
    /// $ ./OhymosNet scfFileName fileBasePart
	/// </code>
	/// Ƃ܂BscfFileName ́A\`t@C̃t@CłB
	/// fileBasePart ́AvZs邽߂ɕKvȓ̓t@C̃t@
	/// C̊łB\`t@C̒ɋLqt@C
	/// ̃t@ĆAfileBasePart Ŏw肷镶t@C̊
	/// ɂȂ悤ɂ܂B
	/// <p/>
	/// 
	/// Ⴆ΁A
	/// <code>
    /// $ ./OhymosNet totalkinArakura.scf tplkinArakura
	/// </code>
	/// ̂悤ɂ܂BtotalkinArakura.scf ̍\`t@C
	/// łB\`t@CɋLq鏉lt@CAp^t@
	/// C̃t@ĆAtplkinArakura.i, tplkinArakura.pmt,
	/// ... Ƃ܂B
	/// 
    /// </remarks>
	public class OhymosNetMain
	{
		internal static String _version = "1.0";
		
		[STAThread]
		private static void  Main(String[] args)
		{
			OhOption op = OhOption.Default;
			
			bool a_flag = false;
			bool p_flag = false;
			bool e_flag = false;
            bool c_flag = false;
            //String assemblyName = "";
			char c;
			int i = 0;
			while (i < args.Length && args[i][0] == '-')
			{
				if ((Object) args[i] == (Object) "--")
					break;
				c = args[i][1];
				switch (c)
				{

                    case 'c':
                        c_flag = true;
                        break;
                    
                    case 'a': 
						a_flag = true;
						break;
					
					case 'e': 
						e_flag = true;
						break;
					
					case 'p': 
						p_flag = true;
						break;
					
					case 'w': 
						op.UseWinP = true;
						break;
					
					default: 
						Console.Error.WriteLine("Unknown option character " + c);
						usage();
						Environment.Exit(1);
						break;
					
				}
				i++;
			}
            int nstart = i;
            
            OhAssembly ohAsm = OhAssembly.Default;

            if (c_flag)
            {
                Console.Out.WriteLine("List of all classes contained in OHyMoS.NET");
                Console.Out.WriteLine("");
                ohAsm.listAllClasses();
                Environment.Exit(0);
            }
			if (a_flag)
			{
				Console.Out.WriteLine("List of abstract classes contained in OHyMoS.NET");
				Console.Out.WriteLine("");
                ohAsm.listAbstractClasses();
                Environment.Exit(0);
			}
			if (e_flag)
			{
				Console.Out.WriteLine("List of element classes contained in OHyMoS.NET");
				Console.Out.WriteLine("");
                ohAsm.listElements();
				Environment.Exit(0);
			}
			if (p_flag)
			{
				Console.Out.WriteLine("List of port classes contained in OHyMoS.NET");
				Console.Out.WriteLine("");
                ohAsm.listPorts();
				Environment.Exit(0);
			}
			
			
				Console.Out.WriteLine("OHyMoS.NET " + "version " + _version);
			
			try
			{
               
					Console.Out.WriteLine("܂vZ܂BReturn L[ĂB");
					StreamReader isr = new StreamReader(Console.OpenStandardInput(), Encoding.Default);
					StreamReader br = new StreamReader(isr.BaseStream, isr.CurrentEncoding);
					String ignore = br.ReadLine();
					Console.Out.WriteLine("Wait. Now, I am working.");
                
				OhScfTotalSystem totalSystem = new OhScfTotalSystem(args[nstart]);
				
				String fileBasepart = args[nstart + 1];
				
				totalSystem.setOhymosNetOption();
				
				totalSystem.construct();
				
				totalSystem.doSwitch();
				
				if (totalSystem.areYouReady() != true)
				{
					Console.Out.Write(NEWLINE);
					Console.Out.Write("# Failure : areYouReady().");
					Console.Out.Write(NEWLINE);
					Environment.Exit(1);
				}
				
				String pmtFileName = fileBasepart + ".pmt";
				totalSystem.readParameterFile(pmtFileName);
				
				String istFileName = fileBasepart + ".ist";
				totalSystem.readInitialStateFile(istFileName);
				
				String isdFileName = fileBasepart + ".isd";
				totalSystem.readSendPortFile(isdFileName);
				
				//;   totalSystem.doShareInfo();  //; KvH
				
				totalSystem.initialWork();
				
				//;   System.out.println("Finish initialWork().");
				
				totalSystem.work();
				
				//      System.out.println("Finish simulation!");  //; mFpWo
				
				
				String tstFileName = fileBasepart + ".tst";
				totalSystem.writeTerminalState(tstFileName);
				
				String tsdFileName = fileBasepart + ".tsd";
				totalSystem.writeSendPortStock(tsdFileName);
				
				//      out.println("Finish saving!");  //; mFpWo
			}
			//  catch (InterruptedException ignored) {
			//  }
			catch (OhCannotGetDataError e)
			{
                OhError.WriteStackTrace(e, Console.Error);
                Console.WriteLine();
				Console.Out.WriteLine(e.Message);
			}
			catch (OhError e)
			{
                OhError.WriteStackTrace(e, Console.Error);
                Console.WriteLine();
                OhInterface.pause(e.Message);
			}
			catch (IOException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
			catch (ArgumentException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
			catch (InvalidCastException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
			catch (NullReferenceException e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
			catch (Exception e)
			{
				OhError.WriteStackTrace(e, Console.Error);
			}
			
			
		}

        private static string NEWLINE
        {
            get { return Environment.NewLine; }
        }

		/// <summary> 
		/// 
		/// </summary>
		private static void  usage()
		{
			Console.Out.WriteLine("usage: ./OhymosNet [-a -e -p -c] \n" + "      or\n" + "       ./OhymosNet ScfFileName fileBasePart\n" + "sample:\n" + "   ./OhymosNet -e\n" + "   ./OhymosNet foo.scf arakura\n");
		}
	} // Main
}