//
//	C++/CLIɂSimpleDam\NX̃wb_[t@CłB
//

#include "stdafx.h"

namespace OhymosNet
{

	using namespace System;
	using namespace System::IO;
	using namespace OhymosNet;


	public ref class SimpleDamC : OhElement
	{

		// @begin {instance variable or static variable} -----------------------

	private :		

		// 1. Receive ports and send ports.
		
		array<OhReceiveDouble^>^ _rP;
		
		OhSendDouble^ _sP0;
		OhSendDouble^ _sP1;
		
		
		// 2. Structural parameters.
		
		int _numberOfRp;


		// 3. Parameters.
		
		double _qPass;
		double _ratio;
		OhTime^ _dt;
		double* _cRp;
		
		
		// 4. State variables.
		
		double _storageCrnt;
		double _qCrnt;
		
		
		// 5. Working variable.
		
		double _storageNext;
		double _qNext;
		double _qInCrnt;
		double _qInNext;
		
		
		// @end {instance variable or static variable} -------------------------
		
		
		// @begin {initialization} ---------------------------------------------
		
	public :

		void init(String^ aObjName, int aObjNum, String^ aDataStr, int aNrp);
		
		virtual void init(String^ aObjName, int aObjNum, OhStreamReader^ aSr) override;

		// @end {initialization} -----------------------------------------------
		

		// @begin {constructors} -----------------------------------------------
		
		SimpleDamC();

		SimpleDamC(String^ aObjName, int aObjNum, String^ aDataStr, int aNrp);
		
		// @end {constructors} -------------------------------------------------
		

		// @begin {methods} ----------------------------------------------------
		
		// 1. Methods about receive ports and send ports.
		
		virtual void  registerReceivePorts() override;

		virtual void  registerSendPorts() override;

		
		// 2. Parameter setting and initialization of states.
		
		virtual void  setParameter(OhStreamReader^ aSw) override;

		virtual void  saveParameter(StreamWriter^ aSw);

		virtual void  setInitialState(OhStreamReader^ aSr) override;

		virtual void  saveTerminalState(StreamWriter^ aSw) override;
		
		
		// 3. Calculation.
		
		virtual bool initialOutput() override;

		virtual OhTime^ calculateTimeStep() override;

		virtual bool canYouCalculate() override;
	
		virtual bool work() override;
		
		virtual bool calculate() override;

		virtual String^ basicInfo() override;

    
		// @begin {methods} ----------------------------------------------------

	};
}
